﻿function BackgroundEngine() {
};

/**
 * Fires a Reload event on tabs that have addresses that are specified in the list below
 * @returns {} 
 */
BackgroundEngine.prototype.ReloadTabs = function () {

    var websitesToReload = [
        "mail.google.com",
        "google.com/calendar",
        "contacts.google.com",
        ".google.com/contacts",
        ".linkedin.com",
        ".salesforce.com",
        ".force.com"
    ];

    chrome.tabs.getAllInWindow(null, function(tabs) {
        for (var i = 0; i < tabs.length; i++) {
            if (websitesToReload.findIndex(website => tabs[i].url.indexOf(website) > -1) > -1) {
                chrome.tabs.reload(tabs[i].id);
            }
        }
    });
}


BackgroundEngine.prototype.SendMessageToGmailAndLinkedinTabs = function (message) {
    chrome.tabs.getAllInWindow(null, function (tabs) {
        for (var i = 0; i < tabs.length; i++) {
            if (tabs[i].url.indexOf("mail.google.com") != -1 || tabs[i].url.indexOf(".linkedin.com") !== -1) {
                chrome.tabs.sendMessage(parseInt(tabs[i].id), message);
            }
        }
    });
};