﻿/** Core Javascript file needed when injected Campaigns as an iframe */ 

var webUserId = GetParameterByName("wb"),
    gCampaignManagementObject = null;

/**
 * Message handler when receiving messages
 * @param {any} event - MessageEvent object
 */
function ReceiveMessage(event) {
    if (event.data !== null && event.data.Message === "OPENCAMPAIGN") {
        gCampaignManagementObject = createCampaignMgrObject();

        if (gCampaignManagementObject) {
            gCampaignManagementObject.Initialize();
            gCampaignManagementObject.SetCampaignSendLimit(globalCampaignLimit);
            gCampaignManagementObject.Open(null, false, event.data.RecordsSelected);
            gCampaignManagementObject.SetCloseCampaignFunction(function () {
                CloseCampaignManagerIFrame();
            });
        }
    }
}

/** What we should do when we want to close the Iframe down */
function CloseCampaignManagerIFrame() {
    DeleteCampaignMgrDom();
    HideCampaignIFrame();
}

/** Remove the created Campaign Manager DOM */
function DeleteCampaignMgrDom() {
    const deleteDom = document.getElementById("sfEbSendCampaignMgrMainModel");
    deleteDom !== null ? deleteDom.remove() : null;
}

/** Sends a message to Bar.js to hide the iframe*/
function HideCampaignIFrame() {
    chrome.tabs.getCurrent(function (tab) {
        chrome.tabs.executeScript(tab.id, { code: "HideCampaignIFrame()" });
    });
}

if (typeof window.addEventListener != 'undefined') {
    window.addEventListener("message", ReceiveMessage, false);
}

/** Ensure when the background overlay is clicked we hide the iframe */
const backgroundOverLay = document.getElementById("backgroundOverlay");
if (backgroundOverLay) {
    backgroundOverLay.addEventListener("click",
        function (event) {
            event.stopPropagation();
            if (event && event.target && event.target.id === "backgroundOverlay") {
                CloseCampaignManagerIFrame();
            }
        });
}