﻿/// <reference path="background.js" />

var lastSearchDate = new Date();
var gmailInboxLastSearchTime = new Date();
var gmailEmailLastSearchTime = new Date();
var gmailSearchStringTime = new Date();


var currentUrl = "";
var initialSearch = true;

/**
 * We keep a cached copy when doing inbox searches in Gmail. This will search that
 * object to find any match on an email address and return that object which will save having to fire another request off to our servers.
 * @param {any} emailAddress
 */
function SearchLocalStorageForSingleEmail(emailAddress) {
    if (localStorage.LastEmailSearchResult0) {
        var cachedEmailSearchResponse = JSON.parse(localStorage.LastEmailSearchResult0);
        if (cachedEmailSearchResponse != null
            && cachedEmailSearchResponse.d != null) {
            var cachedValues = cachedEmailSearchResponse.d.Values;
            if (cachedValues != null) {
                for (var r = 0; r < cachedValues.length; r++) {
                    var emailResult = JSON.parse(cachedValues[r]);
                    // How many email address are for this result?
                    // Loop through all of them to see if they match the email address we're looking for
                    var countEmail = parseInt(emailResult.Fc);
                    for (var ec = 0; ec < countEmail; ec++) {
                        var emailAddressFoundString = emailResult["Email-" + ec];
                        if (emailAddress.toLowerCase() == emailAddressFoundString.toLowerCase()) {
                            return emailResult;
                        }
                    }
                }
            }
        }
    }

    return null;
}

/**
 * Fires an single email address search 
 * @param {any} emailaddress
 * @param {any} successCallBack
 * @param {any} failureCallBack
 */
function FireEmailSearchRequest(emailaddress, successCallBack, failureCallBack) {
    var searchFields = "[";
    searchFields += GenerateEntityField('SearchType', 'auto', '', 'false');
    searchFields += ',' + GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
    searchFields += ',' + GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
    searchFields += ',' + GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false')
    searchFields += "]";

    var varData = '{"sessionId": "' + localStorage.SessionCode + '",' +
        '"userKey": "' + localStorage.WebUserId + '",' +
        '"crmId": "' + localStorage.CrmId + '",' +
        '"searchName": ' + JSON.stringify(emailaddress) + ',' +
        '"entityToSearch": "emailsearch",' +
        '"orderBy": "0",' +
        '"pageNumber": 1,' +
        '"amountonPage": 10,' +
        '"filters": "",' +
        '"searchFields":' + JSON.stringify(searchFields) + '}';

    MakeAjaxCallToSecure("POST", localStorage.CrmUrl + "/SearchV2", varData, "application/json; charset=utf-8", "json", successCallBack, failureCallBack);
}

function RunBackgroundEmailSearch(searchArry, tabId, messageOnly, url, sendbackBarResults, searchType) {

    //console.log('run background email search...');

    var entityname = 'emailsearch';

    if (searchType == "ComplexAdd") {
        entityname = 'searchtypecomplexadd';
        messageOnly = 2;
    }
        //If we're only searching 1 email and its blacklisted then just show the 
        //blacklisted message to save sending a new search request up
        if (searchArry.length === 1) {
            if (IsEmailAddressBlacklisted(searchArry[0])) {
                //Only do this search if we're using Default Bar settings, not for the Custom Bar
                var defaultBarSearch = true;
                var defaultLocalStorage = localStorage.UseDefaultBarSearch;

                if (defaultLocalStorage + "" === "false") {
                    defaultBarSearch = false;
                }

                if (defaultBarSearch) {
                    ProcessResults(null, searchArry, messageOnly, tabId, url, true, 1, searchType);
                    return true;
                }
            }
        }

        var searchString = "";
        for (var d = 0; d < searchArry.length; d++) {

            if (d == 0) {
                searchString = searchArry[d];
            } else {
                searchString = searchString + " OR " + searchArry[d];
            }
        }

        if (localStorage.LastEmailSearchResult0 == null) {
            localStorage.LastEmailSearchResult0 = "";
        }

        if (localStorage.LastEmailSearchResult1 == null) {
            localStorage.LastEmailSearchResult1 = "";
        }

        if (localStorage.LastEmailSearch1 == null) {
            localStorage.LastEmailSearch1 = "";
        }

        if (localStorage.LastEmailSearch0 == null) {
            localStorage.LastEmailSearch0 = "";
        }

        if (messageOnly == 0) {

            //console.log('messageOnly is 0.');

            var lastSearch = localStorage.LastEmailSearch0;
            if (searchString == lastSearch) {
                if (localStorage.LastEmailSearchResult0.length != 0) {
                    var msgcache = JSON.parse(localStorage.LastEmailSearchResult0);
                    ProcessResults(msgcache, searchArry, messageOnly, tabId, url, sendbackBarResults, 1, searchType);

                    return true;
                }
            }
        }

        if (messageOnly == 1) {

            //console.log('messageOnly is 1.');

            var lastSearch = localStorage.LastEmailSearch1;

            if (searchString == lastSearch) {
                if (localStorage.LastEmailSearchResult1.length != 0) {
                    var msgcache = JSON.parse(localStorage.LastEmailSearchResult1);
                    ProcessResults(msgcache, searchArry, messageOnly, tabId, url, sendbackBarResults, 1, searchType);


                    return true;
                }
            } else {
                // We already got results from the main search lets have a look there. 
                var lastSearchMain = localStorage.LastEmailSearch0;

                if (localStorage.LastEmailSearchResult0.length != 0) {

                    if (lastSearchMain.indexOf(searchString) != -1 && searchType.indexOf("ComplexAdd") == -1) {

                        var msgcache1 = JSON.parse(localStorage.LastEmailSearchResult0);
                        ProcessResults(msgcache1, searchArry, messageOnly, tabId, url, sendbackBarResults, 1, searchType);

                        return true;
                    }
                }


            }
        }

        if (searchString.length > 0)
        {
            var searchFields = "[" + GenerateEntityField('SearchType', 'auto', '', 'false');
            searchFields = searchFields + ',' + GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
            searchFields = searchFields + ',' + GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
            searchFields = searchFields + ',' + GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
            searchFields = searchFields + "," + GenerateEntityField('EmailList', '' + JSON.stringify(searchArry), '', 'false') + "]";

            var strFields = JSON.stringify(searchFields);

            var varData = '{"sessionId": "' + localStorage.SessionCode + '","userKey": "' + localStorage.WebUserId + '","crmId": "' + localStorage.CrmId + '","searchName": ' + JSON.stringify(searchString) + ',"entityToSearch": "' + entityname + '","orderBy": "0","pageNumber": 1,"amountonPage":  10 ,"filters": "" ,"searchFields": ' + strFields + '}';


            $.ajax({
                type: "POST", //GET or POST or PUT or DELETE verb
                url: localStorage.CrmUrl + "/SearchV2", // Location of the service
                data: varData, //Data sent to server
                contentType: "application/json; charset=utf-8", // content type sent to server
                dataType: "json", //Expected data format from server
                processdata: true, //True or False
                timeout: 30000,
                success: function(msg) { //On Successfull service call
                    var authFail = false;

                    if (msg.d != null) {
                        if (msg.d.ErrorMessage != null) {
                            if (msg.d.ErrorMessage.indexOf('REAUTH:') != -1) {

                                chrome.tabs.sendMessage(parseInt(tabId), { MessageType: "BarSearchResults", SearchTerm: "", Result: "0", SearchType: "MissingAuth", CrmDBType: localStorage.CrmDBType, Url: localStorage.LastPageUrl }, function (response) {
                                });
                                chrome.tabs.sendMessage(parseInt(tabId), { MessageType: "HideGmailButtons" }, function (response) { });
                                ClearCacheAndLogout();
                                authFail = true;
                            }

                            if (msg.d.ErrorMessage.indexOf('Unauthorized') != -1) {

                                chrome.tabs.sendMessage(parseInt(tabId), { MessageType: "BarSearchResults", SearchTerm: "", Result: "0", SearchType: "MissingAuth", CrmDBType: localStorage.CrmDBType, Url: localStorage.LastPageUrl }, function (response) {
                                });
                                chrome.tabs.sendMessage(parseInt(tabId), { MessageType: "HideGmailButtons" }, function (response) { });
                                ClearCacheAndLogout();
                                authFail = true;
                            }
                        }
                    }
              
                    if (!authFail) {
                        if (messageOnly == 0) {
                            localStorage.LastEmailSearchResult0 = JSON.stringify(msg);
                            localStorage.LastEmailSearch0 = searchString;
                            ProcessResults(msg, searchArry, messageOnly, tabId, url, sendbackBarResults, 0, searchType);
                        }

                        if (messageOnly == 1) {
                            localStorage.LastEmailSearchResult1 = JSON.stringify(msg);
                            localStorage.LastEmailSearch1 = searchString;
                            ProcessResults(msg, searchArry, messageOnly, tabId, url, sendbackBarResults, 0, searchType);
                        }
                    }
            
                    

                },
                error: function(xhr,status,error) {
                    //console.log("Error out");
                }
            });
        }
    
}

function FoundOutCountFromSingleAddress(emailaddress, msg) {

    var counter = 0;

    for (var r = 0; r < msg.d.Values.length; r++) {
        
        var emailResult = JSON.parse(msg.d.Values[r]);

        var countEmail = parseInt(emailResult.Fc);

        var found = false; 
        for (var ec = 0; ec < countEmail; ec++) {

            var itemLookup = "Email-" + ec;
            var emailAddressFoundString = emailResult[itemLookup];

            if (emailAddressFoundString != null && emailaddress != null) {
                if(emailAddressFoundString.toLowerCase() == emailaddress.toLowerCase()) {
                    found = true;
                }
            }
        }

        if (found) {
            counter++; 
        }
    }
    
    for (var em = 0; em < cacheEmailAdress.length; em++) {

        var cacheInfo = cacheEmailAdress[em];
        var found1 = false;
        var splitEmailAddress = cacheInfo.EmailAddress.split(',');

        for (var et = 0; et < splitEmailAddress.length; et++) {

            var emailFound = splitEmailAddress[et];

            if (emailFound != null) {
                if (emailaddress != null) {
                    if (emailFound.toLowerCase() == emailaddress.toLowerCase()) {
                        found1 = true;
                        //counter++;
                    }
                }
            }
        }
        
        if (found1) {
            counter++;
        }
    }

    return counter; 
}

function SendBackBarResults(resultCount, tabId, tabUrl, search, entityname, resultData) {
    if (resultCount == 0) {
        AddUpdateCache(search, "", "Main.html?action=Picker", tabId, tabUrl);
    } else {
        AddUpdateCache(search, "", "Main.html?action=Search&search=" + search, tabId, tabUrl);
    }

    if (storeFirstRecipient) {
        localStorage.FirstRecipientResult = JSON.stringify(resultData);
    }

    chrome.tabs.sendMessage(parseInt(tabId), { MessageType: "BarSearchResults", SearchTerm: "" + search, Result: "" + resultCount, SearchType: "" + entityname, CrmDBType: localStorage.CrmDBType, Url: localStorage.LastPageUrl, EmailDataObject: resultData }, function (response) {
        // This should be results.. ?
    });
}

function include(arr, obj) {
    return (arr.indexOf(obj) != -1);
}

function ProcessResults(msg, searchArry, messageOnly, tabId, url, sendbackBarResults, usingCache, searchType) {
    //console.log('');
    //console.log("Process Results: ");
    //console.log('searchArry: ' + searchArry);
    //console.log('messageOnly: ' + messageOnly);
    //console.log('sendbackBarResults: ' + sendbackBarResults);
    //console.log('usingCache: ' + usingCache);
    //console.log('searchType: ' + searchType);

    //console.log(tabId);
    //console.log(msg);
    //console.log(searchArry); 
    
    localStorage.LastPageUrl = url;

    if (usingCache == 1) {
        LogEventShort("Search-emailsearch-auto-2");
    }

    if (searchType == "ComplexAdd") {
        searchType = 'elookup-' + searchType;
        chrome.tabs.executeScript(tabId, { code: "PassDataBack('" + searchType + "'," + JSON.stringify(msg) + ",'" + msg.d.SearchTermUsed + "')" });

        return false;
    }
    
    //url = currentUrl;
    var resultApplied = new Array();

    var instanceUrl = localStorage.InstanceUrl;

    var objectFound = null;
    var objectsFoundArray = new Array();
    var objectsEmailSent = new Array();

    var googleIds = GetGmailIdsFromLocalStorage();
    for (var d = 0; d < searchArry.length; d++) {
        var lookEmailAddress = searchArry[d];

        var emailResultFound = false;
        if (msg != null) {
            for (var r = 0; r < msg.d.Values.length; r++) {

                var emailResult = JSON.parse(msg.d.Values[r]);

                var countEmail = parseInt(emailResult.Fc);

                for (var ec = 0; ec < countEmail; ec++) {

                    var itemLookup = "Email-" + ec;
                    var emailAddressFoundString = emailResult[itemLookup];

                    if (lookEmailAddress.toLowerCase() == emailAddressFoundString.toLowerCase()) {
                        //if (include(resultApplied, lookEmailAddress.toLowerCase())) {
                        // if (url == currentUrl) {
                        emailResultFound = true;

                        objectsFoundArray.push(emailResult);

                        var foundMultipleRecords = CheckForMultipleEmail(lookEmailAddress, msg);

                        var resultObject = {
                            LookEmailAddress: lookEmailAddress,
                            Id: emailResult.Id,
                            Type: emailResult.Type,
                            FoundMultipleRecords: foundMultipleRecords,
                            Server: instanceUrl + "/",
                            Url: url,
                            Name: emailResult.Name,
                            Account: emailResult.Account,
                            GoogleIds: googleIds
                        };

                        var resultJson = JSON.stringify(resultObject);

                        if (searchType.indexOf("slookup") != -1) {
                            chrome.tabs.executeScript(parseInt(tabId), { code: "ApplySlookup_ConvertObject(" + resultJson + ")" });
                            break;
                        } else {

                            if (messageOnly == 0) {

                                //console.log("Apply 1nbox Icons 3: ");

                                try {
                                    if (objectsEmailSent.indexOf(lookEmailAddress) == -1) {
                                        objectsEmailSent.push(lookEmailAddress);

                                        if (localStorage.HideInboxIcons + "" !== "true") {
                                            chrome.tabs.executeScript(parseInt(tabId), { code: "ApplyStyleEmailStyle_ConvertObject(" + resultJson + ")" });
                                        }
                                    }
                                } catch (err) {
                                    //console.log(err);
                                }
                            } else {

                                //console.log("Apply 1nbox Icons 4: ");

                                try {
                                    if (objectsEmailSent.indexOf(lookEmailAddress) == -1) {
                                        objectsEmailSent.push(lookEmailAddress);
                                        chrome.tabs.executeScript(parseInt(tabId), { code: "ApplyStyleEmailStyleMsg_ConvertObject(" + resultJson + ")" });
                                    }

                                } catch (err) {
                                    //console.log(err);
                                }
                            }
                        }
                        break;
                    }
                }
            }
        }

        //Look in the cache too
        for (var em = 0; em < cacheEmailAdress.length; em++) {
           
            var cacheInfo = cacheEmailAdress[em];

            var splitEmailAddress = cacheInfo.EmailAddress.split(',');

            for (var et = 0; et < splitEmailAddress.length; et++) {

                var emailFound = splitEmailAddress[et];
                        
                if (lookEmailAddress.toLowerCase() == emailFound.toLowerCase() && cacheInfo.Name.length > 0) {
                    emailResultFound = true;

                    var name = JSON.stringify(cacheInfo.Name);

                    var cacheResultObject = {
                        LookEmailAddress: lookEmailAddress,
                        Id: cacheInfo.CrmId,
                        Type: cacheInfo.Entityname,
                        FoundMultipleRecords: foundMultipleRecords,
                        Server: instanceUrl + "/",
                        Url: url,
                        Name: cacheInfo.Name,
                        GoogleIds: googleIds
                    };

                    var cacheResultJson = JSON.stringify(cacheResultObject);

                    var carh = new CreateCacheObjResult(cacheResultObject.Type, cacheResultObject.Id, lookEmailAddress, 1, name);
                    carh["Email-0"] = lookEmailAddress;

                    objectsFoundArray.push(carh);

                    if (searchType.indexOf("slookup") != -1) {
                        chrome.tabs.executeScript(parseInt(tabId), { code: "ApplySlookup_ConvertObject(" + cacheResultJson + ")" });
                        break;
                    } else {
                        if (messageOnly == 0) {

                            //console.log("Apply 1nbox Icons 1: ");

                            try {
                                if (objectsEmailSent.indexOf(lookEmailAddress) == -1) {
                                    objectsEmailSent.push(lookEmailAddress);

                                    if (localStorage.HideInboxIcons + "" !== "true") {
                                        chrome.tabs.executeScript(parseInt(tabId), { code: "ApplyStyleEmailStyle_ConvertObject(" + cacheResultJson + ")" });
                                    }
                                }
                            } catch (err) {

                            }
                        } else {

                            //console.log("Apply 1nbox Icons 2: ");
                                    
                            try {
                                if (objectsEmailSent.indexOf(lookEmailAddress) == -1) {
                                    objectsEmailSent.push(lookEmailAddress);
                                    chrome.tabs.executeScript(parseInt(tabId), { code: "ApplyStyleEmailStyleMsg_ConvertObject(" + cacheResultJson + ")" });
                            }
                                } catch (err) {

                            }
                        }
                    }
                }
            }                

            if (emailResultFound) {
                break;
            }
        }
    
    //only if we haven't found any matches in the entire results list...
    if (!emailResultFound) {
        if (messageOnly == 0) { //display spacing on the main inbox overview...
            //  chrome.tabs.executeScript(tabId, { code: "ApplyStyleEmailStyleSpacing('" + lookEmailAddress + "','" + url + "')" });
        } else { //display dulled icons in the email view page...

            var noResultObject = {
                LookEmailAddress: lookEmailAddress,
                Id: '',
                Type: 'nocontact',
                FoundMultipleRecords: foundMultipleRecords,
                Server: '',
                Name: '',
                Url: url,
                GoogleIds: googleIds
            };

            var noResultJson = JSON.stringify(noResultObject);

            chrome.tabs.executeScript(parseInt(tabId), { code: "ApplyStyleEmailStyleMsg_ConvertObject(" + noResultJson + ")" });
        }
    }
    }

    if (sendbackBarResults) {
        var term = searchArry[0];

        var count1 = 0;
        if (msg) {
            count1 = FoundOutCountFromSingleAddress(term, msg);
        }

        if (usingCache == 1) {
            LogEventShort("Bar-Dropped");
        }
        localStorage.LastSearchWord = term;
        SendBackBarResults(count1, tabId, url, term, "Contact", objectsFoundArray);
    }
    
    chrome.tabs.executeScript(parseInt(tabId), { code: "SetGoogleClickEvent()" });
   // chrome.tabs.executeScript(tabId, { code: "NewEmailEventSetup()" });
}

function CreateCacheObjResult(_type, _id,_fc, _name) {
    this.Type = _type;
    this.Id = _id;
    this.Fc = _fc;
    this.Name = _name;
}

function GetNumberOfResults(emailAddress, msg) {
    var multiResult = false;

    var resultCounter = 0;

    for (var r = 0; r < msg.d.Values.length; r++) {

        var emailResult = JSON.parse(msg.d.Values[r]);

        var countEmail = parseInt(emailResult.Fc);

        for (var ec = 0; ec < countEmail; ec++) {

            var itemLookup = "Email-" + ec;
            var emailAddressFound = emailResult[itemLookup];

            if (emailAddress.toLowerCase() == emailAddressFound.toLowerCase()) {
                resultCounter++;
            }
        }
    }

    for (var em = 0; em < cacheEmailAdress.length; em++) {

        var cacheInfo = cacheEmailAdress[em];

        var splitEmailAddress = cacheInfo.EmailAddress.split(',');

        for (var et = 0; et < splitEmailAddress.length; et++) {

            var emailFound = splitEmailAddress[et];

            if (emailAddress.toLowerCase() == emailFound.toLowerCase()) {
                resultCounter++;
            }
        }
    }

    return resultCounter;
}

function CheckForMultipleEmail(emailAddress, msg) {        
    var multiResult = false;

    var resultCounter = 0;

    for (var r = 0; r < msg.d.Values.length; r++) {

        var emailResult = JSON.parse(msg.d.Values[r]);

        var countEmail = parseInt(emailResult.Fc);

        for (var ec = 0; ec < countEmail; ec++) {

            var itemLookup = "Email-" + ec;
            var emailAddressFound = emailResult[itemLookup];

            if (emailAddress.toLowerCase() == emailAddressFound.toLowerCase()) {
                resultCounter++;

                if (resultCounter > 1) {                    
                    return true;
                }
            }
        }
    }

    return multiResult;
}



function FormatTimeFromGoogle(time) {
    //2014 - 03 - 14
    //Fri, Mar 14, 2014 at 12:43 AM

    var arr = time.split(' at ');
    var mth = "";
    var day = "";
    var year = "";

    if (arr.length == 2) {
        var splitter = ',';
        
        if (arr[0].indexOf(',') == -1) {
            splitter = ' ';
            var firstpart = arr[0].split(splitter);

            if (firstpart.length > 2) {


                mth = firstpart[1].trim().substring(0, 3);
                day = firstpart[0].trim();
                year = firstpart[2].trim();
                mth = mth.toLowerCase();
            }
        } else {
            var firstpart = arr[0].split(splitter);

            if (firstpart.length > 2) {


                mth = firstpart[1].trim().substring(0, 3);
                day = firstpart[1].trim().substr(3).trim();
                year = firstpart[2].trim();
                mth = mth.toLowerCase();
            }
        }
        
        
    }
    else
    {
        //Format -- 21 July 2014 18:03
        var dateSplit = time.split(" ");

        if (dateSplit.length > 2) {
            day = dateSplit[0];
            if (dateSplit[1].length > 2)
            {
                mth = dateSplit[1].substring(0, 3).toLowerCase();
            }
            year = dateSplit[2];
        }
    }

        switch (mth) {
            case "jan":
                mth = "01";
                break;
            case "feb":
                mth = "02";
                break;
            case "mar":
                mth = "03";
                break;
            case "apr":
                mth = "04";
                break;
            case "may":
                mth = "05";
                break;
            case "jun":
                mth = "06";
                break;
            case "jul":
                mth = "07";
                break;
            case "aug":
                mth = "08";
                break;
            case "sep":
                mth = "09";
                break;
            case "oct":
                mth = "10";
                break;
            case "nov":
                mth = "11";
                break;
            case "dec":
                mth = "12";
                break;
        }

    //2014-03-14
    return year + "-" + mth + "-" + day; 
}

function GetLookupValue(Name, valueToCheck) {
    var returnVal = "";

    var lgm = JSON.parse(localStorage.LayoutManager);

    for (var lk = 0; lk < lgm.d.DropDowns.length; lk++) {
        var drop = lgm.d.DropDowns[lk];

        if (drop.Name.toLowerCase() == Name.toLowerCase()) {

            for (var l = 0; l < drop.Values.length; l++) {

                if (valueToCheck == drop.Values[l].Name || valueToCheck == drop.Values[l].Value) {
                    returnVal = drop.Values[l].Name;
                }
            }
        }
    }


    return returnVal;
}

//Finds the values for a drop down object/entity by name
function GetLookupMultiDetailsForDropDown(Name, lgm) {

    var rtrStr = [];
    var first = 0;

    for (var lk = 0; lk < lgm.d.DropDowns.length; lk++)
    {
        var drop = lgm.d.DropDowns[lk];

        if (drop.Name == Name)
        {
            for (var l = 0; l < drop.Values.length; l++)
            {
                rtrStr.push(new ValueLabel(drop.Values[l].Value, drop.Values[l].Name));
            }
        }
    }

    return rtrStr;
}

function ValueLabel(value, label) {
    this.value = value;
    this.label = label;
}

function AddTaskEmail(request, tabId) {

    localStorage.TagAssociatedEmail = '' + request.EmailText;

    var ownerId;
    if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null) {
        ownerId = localStorage.UserId;
    } else {
        var lgmObj = JSON.parse(localStorage.LayoutManager);
        ownerId = lgmObj.d.SaleforceUserId;
    }

    var fields = '[';
    // We should look at layout. 
    fields = fields + GenerateEntityField("OwnerId", ownerId, '', false, '');
    fields = fields + "," + GenerateEntityFieldNoFilter("Status", 'Completed', '', 'false', '');
    fields = fields + "," + GenerateEntityFieldNoFilter("Subject", request.Title, '', 'false', '');
    if (request.FoundDate) {
        fields = fields + "," + GenerateEntityFieldNoFilter("ActivityDate", request.Time, '', 'false', '');
    } else {

        fields = fields + "," + GenerateEntityFieldNoFilter("ActivityDate", FormatTimeFromGoogle(request.Time), '', 'false', '');
    }
    fields = fields + "," + GenerateEntityFieldNoFilter("Priority", 'Normal', '', 'false', '');
    fields = fields + "," + GenerateEntityFieldNoFilter("Description", request.Msg, '', 'false', '');
    
    //Set the task type to what the user has defined
    if (typeof request.TaskType != "undefined") {
        if (request.TaskType != null) {
            if (request.TaskType != "") 
            {
                fields = fields + "," + GenerateEntityFieldNoFilter("Type", '' + request.TaskType, '', 'false', '');
            }
        }
    }
    
    //Finds if a user has 'Email' as a type on task and sets the field to task
    else if (GetLookupValue("Task-Types", "Email") == "Email")
    {
        fields = fields + "," + GenerateEntityFieldNoFilter("Type", 'Email', '', 'false', '');
    }

    var whoId = -1;
    var whatId = -1;

    if (request.Email == "NEW") {
        whoId = request.WhoId;
        whatId = request.WhatId;
    } else {
        var useWhoId = false;

        if (request.SFType == "Contact") {
            useWhoId = true;
            whatId = GetWhatId(request.Email);
        }

        if (request.SFType == "Lead") {
            useWhoId = true;
        }

        if (useWhoId) {
            whoId = request.Email;
        } else {
            whatId = request.Email;
        }

    }
    
    fields = fields + "," + GenerateEntityFieldNoFilter("WhatId", whatId, '', 'false', '');
    fields = fields + "," + GenerateEntityFieldNoFilter("WhoId", whoId, '', 'false', '');

    fields = fields + ',' + GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
    fields = fields + ',' + GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
    fields = fields + ',' + GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
    fields = fields + "]";

    var strFields = JSON.stringify(fields);
    
    AddEntityNew("TaskEmail", strFields, tabId,request.Name);
}

function GetWhatId(id) {

    var accountId = '';
    
    var background = chrome.extension.getBackgroundPage();
   
    var keyfields = background.GenerateBHKeyField(id);
   

    var fields = '[';
    fields = fields + background.GenerateEntityField("AccountId", '', '', 'false', '');
    fields = fields + ']';

    var fields = JSON.stringify(fields);

    //background.SelectEntity("Task", fieldsStr, background.GenerateBHKeyField(id), localTabId.innerText);
    
    var entityname = 'Contact';
    
    var varData = '{"sessionId": "' + localStorage.SessionCode + '","userKey": "' + localStorage.WebUserId + '","crmId": "' + localStorage.CrmId + '","entityName": "' + entityname + '","fieldsExpected": ' + fields + ',"ids": ' + keyfields + '}';


    $.ajax({
        type: "POST", //GET or POST or PUT or DELETE verb
        url: localStorage.CrmUrl + "/SelectEntity", // Location of the service
        data: varData, //Data sent to server
        contentType: "application/json; charset=utf-8", // content type sent to server
        dataType: "json", //Expected data format from server
        processdata: true, //True or False
        timeout: 30000,
        async: false,
        success: function (msg) { //On Successfull service call

            if (msg.d.ErrorMessage != null) {
                if (db.d.ErrorMessage.indexOf("REAUTH:") != -1) {
                    background.ClearKey();
                }
            }

            if (msg.d.ErrorMessage == null) {
                for (var linkLooper = 0; linkLooper < msg.d.Fields.length; linkLooper++) {
                    var accId = '' + msg.d.Fields[linkLooper].Name;

                    if (accId == "AccountId") {
                        accountId = '' + msg.d.Values[linkLooper];

                        if (accountId == '') {
                            accountId = '-1'; 
                        }
                    }
                }
            }
        }
    });

    return accountId; 
}

function GiveBackEmailResult(msg, tabId, extraInformation) {

    if (msg.d.Success) {
        LogEventShort("TaskAdd-Success");
        chrome.tabs.executeScript(parseInt(tabId), { code: "TaskEmailAdded()" });
        DisplayGoogleInboxMessage('Email successfully added to ' + extraInformation, tabId,"");
    }
    else {
        LogEventShort("TaskAdd-Failure");
        DisplayGoogleInboxMessage('Error adding: ' + msg.d.ErrorMessage,tabId,"failure");
    }
}

// Takes a list of ids and checks if we've already searched or got them in localstorage
// if we don't find them then send a request to the server to search the ones we didn't already have
function SearchForGoogleMessageIds(listOfIds, tabId)
{
    //Comma delimited strings seprating id's e.g. 14f079b4886f1f6c,14f079b4876f1f6c,14f0uyb4886f1f6c,
    var lastIdSearch = localStorage.LastEmailIdSearch;
    var savedGmailIds = localStorage.EmailIdResults;

    if (lastIdSearch) {
        //See what id's were in our last search as these should already be in localstorage so doesn't need a fresh search
        var splitString = lastIdSearch.split(',').filter(Boolean);

        newlistOfIds = new Array();
        for (var i = 0; i < listOfIds.length; i++) {
            var doWeNeedToSearchForThisId = true;

            //Check if we've already got this id in localstorage as we don't need to go talk to the DB to find out if it's already here
            if (savedGmailIds) {
                if (savedGmailIds.indexOf(listOfIds[i]) != -1) {
                    continue;
                }
            }

            //If this id was in the last search then skip this as it will be picked up in localStorage.EmailIdResults if it did exist in the DB
            for (var x = 0; x < splitString.length; x++) {
                if (listOfIds[i] == splitString[x]) {
                    doWeNeedToSearchForThisId = false;
                    continue;
                }
            }           

            if (doWeNeedToSearchForThisId) {
                newlistOfIds.push(listOfIds[i]);
            }
        }

        listOfIds = newlistOfIds;
    }

    if (listOfIds.length > 0) {

        //Update local storage with last search 
        var localStorageString = "";
        for (var i = 0; i < listOfIds.length; i++) {
            localStorageString += listOfIds[i] + ",";
        }

        localStorage.LastEmailIdSearch = localStorageString;

        //Send server request to check for id's
        var pagefields = '[' + GenerateEntityField("googleIds", JSON.stringify(listOfIds), '', 'false', '') + '] ';
        var pageStr = JSON.stringify(pagefields);
        SelectEntity("SelectGoogleEmailIds", "", pageStr, tabId);
    }
}

// Takes an array of ids and puts them into localStorage.EmailIdResults either a new creation or appended onto the previous value
// We'll keep track of 100 ids in localstorage to help speed the process up and save service requests
function InsertGmailIdsIntoLocalStorage(emailIdArray) {
   
    var localStorageStringRecreate = "";

    //if there is already a string there append onto and if it's already containing a certain number of id's the remove enough so we don't store too many
    if (localStorage.EmailIdResults) {
        var maxStorageAmount = 100;
        var currentAmountOfStoredIds = localStorage.EmailIdResults.split(',').filter(Boolean);
        if (currentAmountOfStoredIds.length >= maxStorageAmount) {
            //console.time("splice");
            //Find the offset so we know how many records from the array to remove including the amount we're about to insert on top
            var offset = currentAmountOfStoredIds.length - maxStorageAmount + emailIdArray.length;
            currentAmountOfStoredIds.splice(0, offset);

            //Recreate the string with the sliced list
            var localStorageStringRecreate = "";
            for (var i = 0; i < currentAmountOfStoredIds.length; i++) {
                localStorageStringRecreate += currentAmountOfStoredIds[i] + ",";
            }
            //console.timeEnd("splice");
        } else {
            localStorageStringRecreate = localStorage.EmailIdResults;
        }
    }

    //Create the new string from the new values to append onto localstorage value
    var emailResultsString = "";
    for (var i = 0; i < emailIdArray.length; i++) {
        if (localStorageStringRecreate.indexOf(emailIdArray[i]) == -1) {
            if (emailResultsString.indexOf(emailIdArray[i]) == -1) {
                emailResultsString += emailIdArray[i] + ",";
            }
        }
    }

    //Put the string back into localstorage
    localStorage.EmailIdResults = localStorageStringRecreate + emailResultsString;
}

//Returns the array of id's in localstorage
function GetGmailIdsFromLocalStorage() {
    if (localStorage.EmailIdResults) {
        return localStorage.EmailIdResults.split(',').filter(Boolean);
    }

    return null
}

//Takes an email address and compares to the blacklist values to see if it indeed blacklisted
function IsEmailAddressBlacklisted(emailAddress) {
    var emailSplit = emailAddress.split('@');
    if (emailSplit.length > 1) {
        if (localStorage.EmailBlacklist) {
            if (localStorage.EmailBlacklist.indexOf(emailSplit[1]) != -1) {
                return true;
            }
        }
    }
    return false;
}