﻿
/**
 * Module to contain generic functions we use in Ebsta Modals such as (Complex Add, Templates and Campaigns)
 */
var EbstaModalTools = (function EbstaModalTools() {

    /**
     * Returns a DOM Element which is used to create Help Icons
     * @param {} className 
     * @param {} href 
     * @param {} title 
     * @returns {} 
     */
    function CreateHelpIcon(className, href, title) {
        var helpIcon = CreateElement("a", "ebsta-help-icon " + className, null, null);

        if (href) {
            helpIcon.href = href;
        }

        if (title) {
            helpIcon.title = title;
        }

        // Use FontAwesome questionmark icon
        var faQuestionIcon = document.createElement("i");
        faQuestionIcon.className = 'fa fa-question-circle fa-2x';

        // Append the fontawesome icon to the hyperlink
        helpIcon.appendChild(faQuestionIcon);

        return helpIcon;
    }

    return {
        CreateHelpIcon: CreateHelpIcon
    };
})();