﻿$("body").delegate("#btSave", "click", function () {
    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Options-Save', '1']);
    Save();
});

var background = chrome.extension.getBackgroundPage();

//Look for Battery Venture customisation and insert an option just for them to turn the bar off on all websites
if (background.gBatteryVentureCustomisation !== "undefined" && background.gBatteryVentureCustomisation.IsCustomBarEnabled()) {
    var optionsTable = document.getElementById("optionsTable");
    if (optionsTable) {
        var tableBody = optionsTable.getElementsByTagName("tbody")[0];
        if (tableBody) {
            var haltAllWebsitesRow = CreateElement("tr");
            var firstCell = CreateElement("td");
            firstCell.appendChild(CreateElement("input", null, null, "option_haltAllWebsites", { type: "checkbox" }));

            var secondCell = CreateElement("td");
            secondCell.appendChild(CreateTextNode("Halt Bar Drop on all Websites"));

            haltAllWebsitesRow.appendChild(firstCell);
            haltAllWebsitesRow.appendChild(secondCell);
            Prepend(haltAllWebsitesRow, tableBody);
        }
    }
}

Load(); 
function Save() {
    

    //Check if the setting has actually changed, if so log it
    if (localStorage.SwitchbarOffInGmail != "" + option_GmailOff.checked) {
        if (option_GmailOff.checked) {
            background.LogEventShort("Options-GmailBarOff");
        } else if (!option_GmailOff.checked) {
            background.LogEventShort("Options-GmailBarOn");
        }
    }
    
    //Store value
    localStorage.GmailGo = option_Gmail.checked;
    localStorage.SwitchbarOffInGmail = option_GmailOff.checked;

    UpdateSwitchOffBarWebsites();

    $("#savedMessage").fadeIn("slow");
    $("#savedMessage").text("Settings Saved");
    $("#savedMessage").fadeOut("slow");
}

/**
 * Updates the local storage flag SwitchOffBarWebsites which contains a list of websites the bar shouldn't appear on
 */
function UpdateSwitchOffBarWebsites() {
    var websites = [];
    if (localStorage.SwitchOffBarWebsites != null) {
        websites = JSON.parse(localStorage.SwitchOffBarWebsites);
    }

    if (option_LinkedInOff != null && option_LinkedInOff.checked) {
        websites.push(".linkedin.");
    } else {
        var index = websites.findIndex(x => ".linkedin.".indexOf(x) > -1);
        if (index != -1) {
            websites.splice(index, 1);
        }
    }

    if (typeof option_haltAllWebsites !== "undefined" && option_haltAllWebsites !== null && option_haltAllWebsites.checked) {
        if (websites.findIndex(x => "ALL_WEBSITES_WILL_BE_BLOCKED".indexOf(x) > -1) === -1) {
            websites.push("ALL_WEBSITES_WILL_BE_BLOCKED");
        }
    } else {
        for (var i = 0; i < websites.length; i++) {
            if (websites[i] === "ALL_WEBSITES_WILL_BE_BLOCKED") {
                websites.splice(i, 1);
            }
        }
    }

    localStorage.SwitchOffBarWebsites = JSON.stringify(websites);
}

function Load() {
    if (localStorage.GmailGo == null) {
        localStorage.GmailGo = true;
    }

    if (localStorage.SwitchbarOffInGmail == null) {
        localStorage.SwitchbarOffInGmail = false; 
    }
    
    if (localStorage.SwitchbarOffInGmail == 'false') {
        option_GmailOff.checked = false;
    } else {
        option_GmailOff.checked = true;
    }
    
        if (localStorage.GmailGo == 'false') {
            option_Gmail.checked = false;
        } else {
            option_Gmail.checked = true;
        }

    //Check local storage for other flags to make sure the checkboxes are set correctly
    if (localStorage.SwitchOffBarWebsites) {
        var parsedList = JSON.parse(localStorage.SwitchOffBarWebsites);
        if (parsedList.indexOf(".linkedin.") > -1) {
            option_LinkedInOff.checked = true;
        } else {
            option_LinkedInOff.checked = false;
        }

        if (typeof option_haltAllWebsites !== "undefined" && option_haltAllWebsites != null) {
            if (parsedList.indexOf("ALL_WEBSITES_WILL_BE_BLOCKED") > -1) {
                option_haltAllWebsites.checked = true;
            } else {
                option_haltAllWebsites.checked = false;
            }
        }
    }
}