﻿/**
 * GLOBAL LISTENER FOR ALL HTML FILES USED IN THE POPUP EXTENSION 
 * TO SHARE SO WE CAN SEND GENERIC MESSAGES TO ALL OF THEM 
 */
chrome.extension.onMessage.addListener(
    function(request, sender, sendResponse) {
        if (request.Action === "MovePageToUrl") {
            var pageDirector = new PopUpPageRedirector();
            if (request.LoginPage === true) {
                pageDirector.LoginPage();
            } else if (request.LoadingPage === true) {
                pageDirector.LoadingPage();
            } else if (request.MainPage === true) {
                pageDirector.MainPage();
            }
        }
    }
);

/**
 * Redirects the popup window the a html file
 * @returns {} 
 */
function PopUpPageRedirector() {
    return {
        LoginPage: function () {
            window.location = "../html/Login.html";
        },
        LoadingPage: function () {
            window.location = "../html/Loading.html";
        },
        MainPage: function () {
            window.location = "../html/Main.html?chk=1";
        }
    }
}