﻿//** Hover over record functionality for Ebsta
//** Created by Rob 06/06/2016
var instanceUrl = "";

//fires the request to get details for hovered over object
function FireHoverOverRequestForObject(recordType, recordId, hoverOverState) {
    chrome.extension.sendMessage({
        MessageType: "FireHoverOverRequest",
        RecordType: recordType,
        RecordId: recordId,
    }, function response(request) {
        InsertDataIntoHoverOver(JSON.parse(request.ObjJson), request.InstanceUrl, hoverOverState);
    });
}

//Creates the hover base hover over element before we put put data into it
function CreateHoverOverDiv(complexAddObjectDiv, recordType, recordId, recordName, randomNo, hoverOverState) {
    //Remove previous created mouse over before creating new one
    var sfRecordHoverDivArray = document.getElementsByClassName("sfRecordHoverDiv");
    if (sfRecordHoverDivArray) {
        if (sfRecordHoverDivArray.length > 0) {
            for (var i = 0; i < sfRecordHoverDivArray.length; i++) {
                sfRecordHoverDivArray[i].remove();
            }
        }
    }

    var mainHoverDiv = CreateDiv("", "sfRecordHoverDiv");
    mainHoverDiv.style.display = 'none';
    if (hoverOverState === HoverOverStates.BubbleSearch) {
        $(mainHoverDiv).addClass("sfBubbleRecordHoverDiv");
    }
    $(mainHoverDiv).attr("recordId", recordId);
    $(mainHoverDiv).addClass("sfRecordHoverDiv" + recordType);
    $(mainHoverDiv).attr("trackerId", randomNo);

    var mainHoverTable = document.createElement('table');
    mainHoverTable.className = "sfRecordHoverTable";

    //Set header of table to be the name of object
    var headerDiv = document.createElement('th');
    headerDiv.className = "sfRecordHoverTableHeader";
    headerDiv.colSpan = 2;

    if(!instanceUrl) {
        instanceUrl = localStorage.InstanceUrl;
    }

    var recordTypeLink = document.createElement("a");
    recordTypeLink.appendChild(document.createTextNode(recordName));
    recordTypeLink.href = instanceUrl + "/" + recordId;
    recordTypeLink.target = "_blank";
    recordTypeLink.className = "sfRecordHoverTableLink";
    headerDiv.appendChild(recordTypeLink);
    mainHoverTable.appendChild(headerDiv);

    //Set Loading Gif
    var loadingRowTrDiv = document.createElement('tr');
    var loadingRowTdDiv = document.createElement('td');
    loadingRowTdDiv.appendChild(document.createTextNode("Loading...  "));
    loadingRowTdDiv.className = "sfRecordHoverTableLoadingRow";
    loadingRowTdDiv.colSpan = 2;
    var loadingGif = CreateImg(chrome.extension.getURL("/images/ajax-loader.gif"), "Loading...");
    loadingRowTdDiv.appendChild(loadingGif);
    loadingRowTrDiv.appendChild(loadingRowTdDiv);
    mainHoverTable.appendChild(loadingRowTrDiv);
    mainHoverDiv.appendChild(mainHoverTable);

    //Append new hover over div to the body and show it relevant to the hovered over div
    $('body').append(mainHoverDiv);

    //Delay the show so user must be on the div for a good protion of time
    setTimeout(function () {
        if ($(mainHoverDiv).hasClass("userSelecting")) {
            $(mainHoverDiv).fadeIn(250);
        }
    }, 750);

    var heightOfHoverOver = $(mainHoverDiv).outerHeight();

    //Move Hover over div to right of complex add div
    if (hoverOverState === HoverOverStates.ComplexAdd) {
        $(mainHoverDiv).css({
            "top": $(complexAddObjectDiv).offset().top - $(complexAddObjectDiv).outerHeight() - (heightOfHoverOver / 2),
            "left": complexAddObjectDiv.getBoundingClientRect().right - 10
        });
    } else if(hoverOverState === HoverOverStates.BubbleSearch){
        $(mainHoverDiv).css({
            "top": $(complexAddObjectDiv).offset().top,
            "left": 10
        });
    }

    $(mainHoverDiv).mouseenter(function () {
        $(this).addClass("userSelecting"); //Set a flag to know that the user is currently hovering over the pop out
    });

    //Helps close the hover pop up when a user isn't selecting it
    $(mainHoverDiv).mouseleave(function () {
        $('.sfRecordHoverDiv').removeClass("userSelecting");
        setTimeout(function () {
            if (!$(mainHoverDiv).hasClass("userSelecting")) {
                $(mainHoverDiv).fadeOut();
            }
        }, 500);
    });
}


////Inserts the data received back from the response
function InsertDataIntoHoverOver(objJson, instanceUrlLocal, hoverOverState) {
    //Helps resets the global variable within bar.js if we need to
    if (instanceUrlLocal) {
        instanceUrl = instanceUrlLocal;
    }

    // console.time("InsertDataIntoHoverOver");
    //Get the record file from the Entity Result return from the server
    if (objJson.d.Values) {
        objJson = JSON.parse(objJson.d.Values);
    }

    var recordType = "", recordId = "";

    //Get Record Type and Id
    if (objJson.Name) {
        recordType = objJson.Name;
    }

    if (objJson.Id) {
        recordId = objJson.Id;
    }

    var didWeShowResults = true;

    if ($('.sfRecordHoverDiv').attr('recordid') == recordId) {
        //Removes any data or loading gifs within the table
        $('.sfRecordHoverTableLoadingRow').remove();
        $('.sfRecordHoverTable > tbody > tr').remove();

        //Find the fields which tally with the users compact layout fields
        var fieldsArray;

        if (objJson.details) {
            fieldsArray = objJson.details;
        }

        if (fieldsArray) {
            if (fieldsArray.length > 0) {
                if ($('.sfRecordHoverTable').length > 0) {

                    //Loop through all the field we need to try to find the values
                    for (var i = 0; i < fieldsArray.length; i++) {
                        //Find the attribute field within the hidden div
                        var rowDiv = document.createElement('tr');
                        rowDiv.className = "sfRecordHoverTableRow";

                        //Name Div
                        if (fieldsArray[i].ControlName) {
                            var columnDiv = document.createElement('td');
                            columnDiv.appendChild(document.createTextNode(fieldsArray[i].ControlName));
                            columnDiv.className = "sfRecordHoverTableRowName";
                            rowDiv.appendChild(columnDiv);
                        }

                        //Value Div
                        var columnDiv = document.createElement('td');
                        // console.time("ProcessFieldInHoverOver");
                        columnDiv.appendChild(ProcessFieldInHoverOver(fieldsArray[i]));
                        // console.timeEnd("ProcessFieldInHoverOver");
                        columnDiv.className = "sfRecordHoverTableRowValue";
                        rowDiv.appendChild(columnDiv);

                        $('.sfRecordHoverTable').append(rowDiv);
                    }
                } else {
                    didWeShowResults = false;
                }
            } else {
                didWeShowResults = false;
            }
        } else {
            didWeShowResults = false;
        }        

        if (hoverOverState == HoverOverStates.ComplexAdd) {
            var heightOfHoverOver = $('.sfRecordHoverDiv').outerHeight();
            $('.sfRecordHoverDiv').css({
                "top": $('.sfRecordHoverDiv').offset().top - (heightOfHoverOver / 2) + 23,
            });
        } else if (hoverOverState == HoverOverStates.BubbleSearch) {
            var heightOfHoverOver = $('.sfRecordHoverDiv').outerHeight(true);
            //Lets check if the hover over element is too big to be position where it is, if so move it upwards so we can see the entire hover over
            var currentHoverPosition = $('.sfRecordHoverDiv').offset();
            if (heightOfHoverOver + currentHoverPosition.top >= window.outerHeight - 10) {
                $('.sfRecordHoverDiv').css({
                    "top": $('.sfRecordHoverDiv').offset().top - heightOfHoverOver - 10
                });
            }
        }
    }

    if (!didWeShowResults) {
        $('.sfRecordHoverTableLoadingRow').remove();

        //Display a simple error message to show we were unable to get the details
        var rowDiv = document.createElement('tr');
        rowDiv.className = "sfRecordHoverTableRow";

        var columnDiv = document.createElement('td');
        columnDiv.colSpan = 2;
        columnDiv.appendChild(document.createTextNode("Sorry, we were unable to get details"));
        columnDiv.className = "sfRecordHoverTableRowError";
        rowDiv.appendChild(columnDiv);

        $('.sfRecordHoverTable').append(rowDiv);
    }

    // console.timeEnd("InsertDataIntoHoverOver");
}

//Creates the correct element depending on what type of field it is
function ProcessFieldInHoverOver(field) {

    var fieldDiv = document.createElement("a");
    fieldDiv.className = "sfRecordHoverTableLink";

    if (field.TypeOfField == "reference") {
        //LogThis(field);
        // The Values for these fields will be displayed like "Owner.name, Owner.id" 
        // so we need to split and find these fields within the value field
        //var splitName = field.Name.split(','); 

        if (field.Value) {
            var valueJson = JSON.parse(field.Value);

            if (valueJson) {
                var name = "", id = "";
                if (valueJson.Name) name = valueJson.Name;
                if (valueJson.Id) id = valueJson.Id;

                fieldDiv.href = instanceUrl + "/" + id;
                fieldDiv.target = "_blank";
                fieldDiv.appendChild(document.createTextNode(name));
            }
        }
    }
    else if (field.TypeOfField == "url") {
        if (field.Value) {
            fieldDiv.href = "http://" + field.Value;
            fieldDiv.appendChild(document.createTextNode(field.Value));
        }
    }
    else if (field.TypeOfField == "datetime") {
        if (field.Value) {
            var d = Date.parse(field.Value);
            if (isNaN(d) == false) {
                d = new Date(d);
                fieldDiv.appendChild(document.createTextNode(d.toLocaleString()));
            }
            else {
                fieldDiv.appendChild(document.createTextNode(field.Value));
            }

            fieldDiv.className = "sfRecordHoverTableDateTime";
        }
    }
    else {
        fieldDiv = document.createTextNode(field.Value);
    }

    //Remove any fields which are null
    if (fieldDiv.textContent == "null" || fieldDiv.textContent == "undefined") {
        fieldDiv = document.createTextNode("");
    }

    return fieldDiv;
}

//Helper class to find the id of the record that we've selected
function FindIdFromDivInComplexAdd(divObject) {
    if ($(divObject).attr('sfwhoid')) {
        return $(divObject).attr('sfwhoid');
    }
    else if ($(divObject).attr('whoid')) {
        return $(divObject).attr('whoid');
    }
    else if ($(divObject).attr('whatid')) {
        return $(divObject).attr('whatid');
    }
    else if ($(divObject).attr('sfwhatid')) {
        return $(divObject).attr('sfwhatid');
    }
    else if ($(divObject).attr('recordid')) {
        return $(divObject).attr('recordid');
    }

    return null;
}

//Helper class to find the name of the record that we've selected
function FindNameFromDivInComplexAdd(divObject) {
    if ($(divObject).attr('recordname')) {
        return $(divObject).attr('recordname');
    }
    else if ($(divObject).attr('sfname')) {
        return $(divObject).attr('sfname');
    }

    return null;
}

//Searches for the information we need to fire off a search for the hover over in Complex Add
function Get_Hover_Over_Information_For_Complex_Add(complexAddObjectDiv) {
    var hoverOverInfoObject = new Object();

    hoverOverInfoObject.recordType = $(complexAddObjectDiv).attr('recordtype'); // Find the record Type
    hoverOverInfoObject.recordId = FindIdFromDivInComplexAdd(complexAddObjectDiv); //Find the record Id
    hoverOverInfoObject.recordName = FindNameFromDivInComplexAdd(complexAddObjectDiv);

    //If we didn't find it in the current div we may need to look at its parent
    if (!hoverOverInfoObject.recordId || !hoverOverInfoObject.recordType) {
        var parentDiv = $(complexAddObjectDiv).parent();
        hoverOverInfoObject.recordType = $(parentDiv).attr('recordtype'); // Find the record Type
        hoverOverInfoObject.recordId = FindIdFromDivInComplexAdd(parentDiv); //Find the record Id
        hoverOverInfoObject.recordName = FindNameFromDivInComplexAdd(parentDiv); //Find the record Id
    }

    //We're naming some of the opporunities 'opp'
    if (hoverOverInfoObject.recordType) {
        if (hoverOverInfoObject.recordType.toLowerCase() == "opp") {
            hoverOverInfoObject.recordType = "Opportunity";
        }
    }

    return hoverOverInfoObject;
}

//Searches for the information we need to fire off a search for the hover over in Complex Add
function Get_Hover_Over_Information_For_Bubble_Search(resultDiv) {
    var hoverOverInfoObject = new Object();

    hoverOverInfoObject.recordType = $(resultDiv).attr('entity'); // Find the record Type

    //Somestimes the entity contains the recordtype so lets split this up and just take the entity
    if (hoverOverInfoObject.recordType) {
        hoverOverInfoObject.recordType = hoverOverInfoObject.recordType.split("-")[0];
    }

    hoverOverInfoObject.recordId = $(resultDiv).attr('sfid'); //Find the record Id
    if (!hoverOverInfoObject.recordId) {
        hoverOverInfoObject.recordId = $(resultDiv).attr('id');
    }

    hoverOverInfoObject.recordName = $(resultDiv).attr('recordname');
    if (!hoverOverInfoObject.recordName) {
        hoverOverInfoObject.recordName = $(resultDiv).attr('name');
    }

    return hoverOverInfoObject;
}

function CreateHoverOverEvent(resultDiv, hoverOverState) {
    $(resultDiv).mouseenter(function () {
        var hoverOverInfoObject = null;
        
        if (hoverOverState === HoverOverStates.BubbleSearch) {
            hoverOverInfoObject = Get_Hover_Over_Information_For_Bubble_Search(resultDiv);
        } else if (hoverOverState === HoverOverStates.ComplexAdd) {
            hoverOverInfoObject = Get_Hover_Over_Information_For_Complex_Add(resultDiv);
        }

        if (hoverOverInfoObject) {
            if (hoverOverInfoObject.recordId && hoverOverInfoObject.recordType && hoverOverInfoObject.recordName) {
                //This is to track the current hover over and stop multiple selects firing off
                //This will get put as an attribute on the hover over div and will confirm if the selection is the current one then fire the request
                var randomNo = Math.floor(Math.random() * 10000);

                //Delay the call to make sure the user is hovering over the div for n amount of milliseconds
                setTimeout(function () {
                    if ($('.sfRecordHoverDiv').hasClass("userSelecting")
                        && $('.sfRecordHoverDiv').attr('recordid') == hoverOverInfoObject.recordId
                        && $('.sfRecordHoverDiv').attr('trackerId') == randomNo) {
                        FireHoverOverRequestForObject(hoverOverInfoObject.recordType, hoverOverInfoObject.recordId, hoverOverState);
                    }
                }, 1000);

                CreateHoverOverDiv(resultDiv, hoverOverInfoObject.recordType, hoverOverInfoObject.recordId, hoverOverInfoObject.recordName, randomNo, hoverOverState);

                $('.sfRecordHoverDiv').addClass("userSelecting");
            }
        }
    });

    $(resultDiv).mouseleave(function () {
        //Helps close the hover pop up when a user isn't selecting it
        $('.sfRecordHoverDiv').removeClass("userSelecting");
        setTimeout(function () {
            if (!$('.sfRecordHoverDiv').hasClass("userSelecting")) {
                $('.sfRecordHoverDiv').fadeOut();
            }
        }, 500);
    });
}