﻿//Ebsta Tools for generic purposes

//http://stackoverflow.com/questions/19176024/how-to-escape-special-characters-in-building-a-json-string
function EscapeCharactersForJsonParsing(stringToEscape) {
    stringToEscape = stringToEscape.replace(/"/g, "\\\"");
    return stringToEscape;
}

/**
 * Shared LinkedIn helper module
 * @returns {} 
 */
var sharedLinkedInHelper = (function () {

    return {
        /**
        * Compares specific parts of 2 urls and returns true/false on match of those two parts
        * e.g on linkedin (free) look for match in profile id parts: /in/{profileId}/ vs /in/{profileId}/detail/contact-info/
        * @param {string} urlOne - current url
        * @param {string} urlTwo - cached url
        * @returns {boolean} - Whether two urls actually share the same profile ID of a LinkedIn user 
        */
        DoUrlsContainTheSameId: function (urlOne, urlTwo) {
            if (urlOne && urlTwo) {
                //on linkedin (free) we need to be able to check if the only change in the url is one from
                //displaying or hiding a modal, e.g "See Contact Info" changes the url to contain
                //detail/contact-info/ i.e changes url from /in/{profileId}/ to /in/{profileId}/detail/contact-info/
                //this compares the url and checks if the profile id stays the same
                if (urlOne.indexOf("linkedin.com/in/") > -1 && urlTwo.indexOf("linkedin.com/in/") > -1) {

                    var linkedInpageProfileId = urlOne.split("/");
                    var linkedIncacheProfileId = urlTwo.split("/");
                    //linkedIn profile id will stay in 4th index even when the url changes. 
                    //only the '/' after the userid in the url changes when navigating to different parts of page
                    return linkedIncacheProfileId[4] === linkedInpageProfileId[4];
                }

                // Comparing 2 LinkedIn Recruiter Ids
                if (urlOne.indexOf("linkedin.com/talent/hire") !== -1 || urlOne.indexOf("linkedin.com/talent/profile") !== -1) {
                    const urlOneWithoutParameters = urlOne.split('?')[0];
                    const urlTwoWithoutParameters = urlTwo.split('?')[0];

                    return urlOneWithoutParameters === urlTwoWithoutParameters;
                }
            }

            return false;
        }

    }

})();