﻿/**
 * Set a timer on the loading page so that it keeps looking for a layoutmanager as it should really find one in the end
 */
var layoutManagerCheckInterval = window.setInterval(CheckLocalStorageForLayoutManager, 1000);

/**
 * Checks for a layout manager, if it finds something which isn't a json then 
 * something has gone wrong and we need to redirect the page back to the login screen
 * @returns {} 
 */
function CheckLocalStorageForLayoutManager() {
    if (localStorage.LayoutManager != null) {
        var pageRedirector = new PopUpPageRedirector();
        if (IsValidJSON(localStorage.LayoutManager)) {
            pageRedirector.MainPage();
        } else {
            //Safety check to kick user out if we fail to find a valid layoutmanager
            pageRedirector.LoginPage();
            localStorage.removeItem("LayoutManager");
            background.ClearCacheAndLogout();           
        }
        clearInterval(layoutManagerCheckInterval);
    }
}
    