﻿
/**
 * object for managing sort of list of of objects by number property
 * @param {} objectList 
 * @returns {} 
 */
function ObjectListSortManager(objectList) {
    var currentSortField = null;
    var asc = true;

    function sortAscFunc(a, b) {
        return parseFloat(a[currentSortField]) - parseFloat(b[currentSortField]);
    }

    function sortDescFunc(a, b) {
        return parseFloat(b[currentSortField]) - parseFloat(a[currentSortField]);
    }

    return {
        /**
         * we can force a direction into sort function otherwise, it will switch back and forth if we are sorting by the same field
         * @param {} sortField 
         * @param {} ascForce 
         * @returns {} 
         */
        sort: function (sortField) {

            if (currentSortField === sortField) {
                asc = !asc;
            } else {
                currentSortField = sortField;
                asc = true;
            }

            if (asc) {
                objectList.sort(sortAscFunc);
            } else {
                objectList.sort(sortDescFunc);
            }
        }
    }
}