﻿/// <reference path="background.js" />
/// <reference path="modules/googleaccount.js" />

// Global Values. 
var background = chrome.extension.getBackgroundPage();
var abRules = JSON.parse(background.GetAbTestingRules(localStorage.ABTester));
//Global Ends

//Check we have a session before anything if we don't send straight to the login page
if (localStorage.SessionCode != null && localStorage.SessionCode !== "00000000-0000-0000-0000-000000000000" && localStorage.SessionCode !== "null") {
    sessionKey.innerHTML = localStorage.SessionCode;
} else {
    PopUpPageRedirector().LoginPage();
}

Date.prototype.addHours = function(h) {
    this.setHours(this.getHours() + h);
    return this;
};

background.SetLastActivity();

function openURL(uri) {    

    if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
        var id = getParameterByName("id");
  
        uri = localStorage.InstanceUrl + "/" + id;
 
    }    

    background.LogEventShort("Record-Opened-CRM");
    chrome.tabs.create({"url":uri});
}

function GetRecentlistBuild(recentObject) {

    ////console.log(recentObject);
    var html = "";
    var len = recentObject.length;

    if (len > 5) {
        len = 5;
    }
    var recList = document.getElementById("recentListInput");
    for (var i = 0; i < len; i++) {
       
        if (recentObject[i].title != null) {
            if (recentObject[i].title.trim().length > 0) {
                var obj = recentObject[i].entityType;

                var classNeeded = "";

                if (obj.indexOf("Account") > -1) {
                    classNeeded = "homepageaccount";
                }

                if (obj.indexOf("Lead") > -1) {
                    classNeeded = "homepagelead";
                }

                if (obj.indexOf("Contact") > -1) {
                    classNeeded = "homepagecontact";
                }

                if (obj.indexOf("Opportunity") > -1) {
                    classNeeded = "homepageopportunity";
                }


                var pElem = document.createElement("p");
                pElem.setAttribute("class", "homepage");

                var span1 = CreateSpan("", 'ebstahome-recent-item-link ' + classNeeded);

                var ar = document.createElement("a");
                ar.setAttribute("href", "Main.html?action=LinkJumper&ObjectName=" + recentObject[i].entityType + "&id=" + recentObject[i].id);

                var txtNode = document.createTextNode(recentObject[i].title);
                ar.appendChild(txtNode);
                pElem.appendChild(span1);

                pElem.appendChild(ar);

                recList.appendChild(pElem);
            }
        }

    }
    
    if (len == 0) {
        var pElem = document.createElement("p");
        pElem.setAttribute("class", "homepage");
        var txtNode = document.createTextNode("No recently viewed items");
        pElem.appendChild(txtNode);
        recList.appendChild(pElem);
    }


   
    

}

// Obtains the current date and formats and returns it in this date format yyyy-mm-dd
function GetDateToday() {
    var date = new Date();
    var dateToday = date.getFullYear() + "-" + ('0' + (date.getMonth() + 1)).slice(-2) + "-" + ('0' + date.getDate()).slice(-2);
    return dateToday;
};

//added this function becasue we need to construct a different URI for convert lead - could maybe have passed in the object type and done an if
//but felt it safer to separate this out into it's own function for now
function openURLConvertLead(uri) {

    if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
        var id = getParameterByName("id");      
        uri = localStorage.InstanceUrl + "/" + "lead/leadconvert.jsp?retURL=%2F" + id + "&id=" + id;
    }

    background.LogEventShort("Record-Opened-CRM");
    chrome.tabs.create({ "url": uri });
}

function openURLNewTab(uri) {
    background.LogEventShort("Record-Opened-CRM");
    chrome.tabs.create({ "url": uri });
}

function openURLTab(uri) {
    chrome.tabs.getSelected(null, function (tab) {
        background.LogEventShort("Record-Opened-CRM");
        chrome.tabs.update(tab.id, { url: uri });
        });
 }

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    if (results == null)
        return "";
    else
        return decodeURIComponent(results[1].replace(/\+/g, " "));
}


function emailCheck(email) {
    //var emailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
    var emailReg = /^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,6}$/i;
    if (!emailReg.test(email)) {
        return false;
    } else {
        return true;
    }
}

$("body").delegate(".popupTrigger", "mouseleave", function () {     
    var popupId = $(this).attr('popupId');
    $("#" + popupId).fadeOut();
});

$("body").delegate(".dd-Opportunity-StageName, .lb-Opportunity-StageName", "change", function () {
    var probabilityValue = "";

    var val = $(this).val();
    if (localStorage.OpportunityStageList) {
        var stageList = JSON.parse(localStorage.OpportunityStageList);
        for (var i = 0; i < stageList.length; i++) {
            var obj = stageList[i];
            if (obj.Name) {
                if (obj.Name === val) {
                    if (obj.Value) {
                        probabilityValue = obj.Value;
                    }
                }
            }
        }
    }

    $("#txt-Opportunity-Probability").val(probabilityValue);
});

var savePressed = false;
var reloadAgain = true;
var moveFromLinkJumper = false;

$("body").delegate(".closePopupLink", "click", function () {
    

    var popupId = $(this).attr('popupName');
    $("#" + popupId).fadeOut();
});

$("body").delegate(".popupTrigger", "mouseenter", function (event) {


    var popupId = $(this).attr('popupId');

    var xpos = event.clientX;
    var ypos = event.clientY;


    var xposition = xpos + 10;
    var yposition = ypos - 140;

    if (xposition > 242) {
        xposition = 242;
    }


    $("#" + popupId).css('left', (xpos + 10));
    $("#" + popupId).css('top', (ypos - 95));
    $("#" + popupId).fadeIn();
    $("#" + popupId).addClass('popupElementVisible');
});

//render the footer...

var divBottomBar = document.createElement('div');
divBottomBar.className = 'buttonsbar';
divBottomBar.id = 'databaseTypeBottomBar-' + localStorage.CrmDBType;
divBottomBar.setAttribute('style.display', 'none');

var ulTabList = document.createElement('ul');
ulTabList.setAttribute('role', 'tablist');
ulTabList.className = 'left';

var li1 = document.createElement('li');
li1.id = 'AddListSF';
li1.className = 'noImage';

var spanAdd = document.createElement('span');
spanAdd.className = 'btAdd';
var txtSpan = document.createTextNode('+ Add');
spanAdd.appendChild(txtSpan);
li1.appendChild(spanAdd);
ulTabList.appendChild(li1);

var li2 = document.createElement('li');
li2.setAttribute('role', 'tab');
li2.title = 'Chatter';
li2.id = 'ChatterSF';
var txtLi2 = document.createTextNode('Chatter');
li2.appendChild(txtLi2);
ulTabList.appendChild(li2);
divBottomBar.appendChild(ulTabList);

var trialUsedFlag = 0;

if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
    trialUsedFlag = parseInt(localStorage.TrialUsed);
}

var ulTabList2 = document.createElement('ul');
ulTabList2.setAttribute('role', 'tablist');
ulTabList2.className = 'right';

var li5 = document.createElement('li');
li5.setAttribute('role', 'tab');
li5.title = 'Email Tracking';
li5.id = 'EmailTrackingSF';
li5.style.display = "none";

var spn1 = document.createElement('span');
spn1.className = 'emailTrackingSFSpan';
li5.appendChild(spn1);

var li3 = document.createElement('li');
li3.setAttribute('role', 'tab');
li3.title = 'Home';
li3.id = 'HomeSF';

var li4 = document.createElement('li');
li4.setAttribute('role', 'tab');
li4.title = 'Settings';
li4.id = 'SettingsSF';


ulTabList2.appendChild(li5);
ulTabList2.appendChild(li3);
ulTabList2.appendChild(li4);

divBottomBar.appendChild(ulTabList2);

$("#footerpanel").append(divBottomBar);

// Key Events. 
$("body").delegate("#btSearch", "click", function () {
    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonTop-SearchBigButton', '1']);
    Search();

});

$('#txt_search').keypress(function (e) {
    if (e.which == 13) {
        //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonTop-SearchBigButtonEnter', '1']);

        if (localStorage.ChatterOnly != "1") {
            Search();
        }
    }
});

$('#txt_search').change(function (e) {
    
    if ($('#txt_search').val().length == 0) {
        $('#txt_search').addClass('magnify');
    } else {
        $('#txt_search').removeClass('magnify');
    }

});

if ($('#txt_search').val().length == 0) {
    $('#txt_search').addClass('magnify');
} else {
    $('#txt_search').removeClass('magnify');
}


$("body").delegate("#btBack", "click", function () {
    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Generic-Back', '1']);
     
    
});

// Save/Edit Button
$("body").delegate(".save", "click", function () {

    //
    Save();

    ////if (localStorage.LicenceFound != 'Free') {
    ////    if (localStorage.LicenceFound != 'Chatter') {
    ////        Save();
    ////    }
    ////} else {
    ////    if (localStorage.LastPageUrl.indexOf(".linkedin.co") != -1)
    ////    {           
    ////        Save();
    ////    }
    ////}
});

function CheckAddLicence() {
    var retVal = true;
    if (localStorage.LastPageUrl.indexOf("www.linkedin.com") != -1) {
        retVal = true;
    } else {
        if (localStorage.LicenceFound != 'Free') {
            retVal = false;
        }

        if (localStorage.LicenceFound != 'Chatter') {

            retVal = false; 
        }
    }
    return retVal;
}

// Back Buttons
$("body").delegate(".back", "click", function () {
    var tabId = localTabId.innerText;
    var location = background.HistoryGoBack(tabId);
    
    window.location = location; 

});

$("body").delegate(".fireChatterAction", "click", function () {
    $('.chatterLoader').css('display', 'block');
});

$("body").delegate(".email", "click", function () {
    openURLTab($(this).attr('href'));
});

$("body").delegate(".extlink", "click", function () {
    openURLNewTab($(this).attr('href'));
});

$("body").delegate(".exLink", "click", function () {
    openURLNewTab($(this).attr('href'));
});

$("body").delegate(".itemLink", "click", function () {
    MoveMe($(this).attr('href'));
});

var $confirmSnooze = null;
var $confirmReject = null;

$("body").delegate(".move, .snooze, .reject, .emailJsCandidate, .schedule, .forward, .editJsCandidate, .details, .resume, .match", "click", function () {
    openURLNewTab($(this).attr('jslink'));
});


$("body").delegate(".chatterPostTextArea", "click", function () {
   
    $(this).text('');
    $(this).toggleClass("textBoxExpand", 1000);
});

// Selects a Bar to attach events to . 

$("body").delegate(".btAdd", "mouseover", function () {
    $('#topMenuPopUp').show();
});

$("body").delegate("#topMenuPopUp", "mouseleave", function () {
    $('#topMenuPopUp').hide();
});

$("#databaseTypeBottomBar-" + localStorage.CrmDBType).show();
// SF
if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
    //BOTTOM BAR EVENTS
    $("#settingswrapper .buttonsbar").delegate("#ContactSF", "click", function () {
        //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonBottom-ContactSF', '2']);

        MoveMe('Main.html?action=Contact-Add');
    });

    $("#settingswrapper .buttonsbar").delegate("#LeadSF", "click", function () {
        //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonBottom-Leads', '1']);

        MoveMe('Main.html?action=Lead-Add');
    });
    
    $("#settingswrapper .buttonsbar").delegate("#HomeSF", "click", function () {
        MoveMe('Main.html?action=Welcome');
    });


    $("#settingswrapper .buttonsbar").delegate("#EmailTrackingSF", "click", function () {
        
        ShowEmailTrackingSummaryFromMain();
    });


    $("#settingswrapper .buttonsbar").delegate("#HelpSF", "click", function () {
        openURLTab("https://ebsta.zendesk.com/categories/20091122-Ebsta-for-Salesforce");
    });

    $("#settingswrapper .buttonsbar").delegate("#ChatterSF", "click", function () {
        MoveMe('Main.html?action=WelcomeChatter');
    });

    

    $("body").delegate(".clear", "click", function () {

        ClearForm();
    });

    $("#settingswrapper .buttonsbar").delegate("#AccountSF", "click", function () {
        //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonBottom-Contacts', '1']);

        MoveMe('Main.html?action=Account-Add');
    });

    $("#settingswrapper .buttonsbar").delegate("#SettingsSF", "click", function () {
        //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonBottom-Settings', '1']);

        //if we are a Gmail or Pro user, give me the settings page wiht the Gmail Settings button
        //if (localStorage.gMailGo || localStorage.LicenceFound.toLowerCase() == "pro") {
        //    MoveMe('Main.html?action=SettingsG');
        //}
        //else
        //{
            MoveMe('Main.html?action=Settings');
        //}
    });

}

function SaveSnooze(ownerId, jobOrderId) {
    var id = getParameterByName("id");
    var inputDate = $("#SnoozeDate").val();

    //validate date input...
    

    //build json for tasks against contact...
    var fields = '[';

    fields = fields + background.GenerateEntityField('URLAdd', localStorage.LastPageUrl, '', false, '#UrlAdd');
    fields = fields + ',' + background.GenerateEntityField('LinkedInStatus', '', '', 'false', '#LinkedInStatus');
    fields = fields + ',' + background.GenerateEntityField('OwnerId', '' + ownerId, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Subject', 'Reminder to Review Candidate', '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Status', 'Not Started', '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Priority', 'Normal', '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('WhoId', '' + id, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('WhatId', '' + jobOrderId, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('ActivityDate', '' + inputDate, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
    fields = fields + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
    fields = fields + ',' + background.GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
    fields = fields + ']';

    var fields3 = '[';

    fields3 = fields3 + background.GenerateEntityField('URLAdd', localStorage.LastPageUrl, '', false, '#UrlAdd');
    fields3 = fields3 + ',' + background.GenerateEntityField('LinkedInStatus', '', '', 'false', '#LinkedInStatus');
    fields3 = fields3 + ',' + background.GenerateEntityField('OwnerId', '' + ownerId, '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('Subject', 'Application Snoozed', '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('Status', 'Not Started', '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('Priority', 'Normal', '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('WhoId', '' + id, '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('WhatId', '' + jobOrderId, '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('ActivityDate', '' + inputDate, '', 'false', '');
    fields3 = fields3 + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
    fields3 = fields3 + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
    fields3 = fields3 + ',' + background.GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
    fields3 = fields3 + ']';

    var strFields = JSON.stringify(fields);
    var strFields3 = JSON.stringify(fields3);

    //submit tasks...
    var tabId = localTabId.innerText;
    var entityName = 'Task';

    background.AddEntity(entityName, strFields, tabId);
    background.AddEntity(entityName, strFields3, tabId);
}

function RejectApplication(ownerId, jobOrderId, appStage, appId) {

    var id = getParameterByName("id");
    var currentDate = $.datepicker.formatDate('yy-mm-dd', new Date());
    var comment = $("#rejectReason").val();

    var fields = '[';

    fields = fields + background.GenerateEntityField('URLAdd', localStorage.LastPageUrl, '', false, '#UrlAdd');
    fields = fields + ',' + background.GenerateEntityField('LinkedInStatus', '', '', 'false', '#LinkedInStatus');
    fields = fields + ',' + background.GenerateEntityField('OwnerId', '' + ownerId, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Subject', 'Rejected at ' + appStage, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Status', 'Completed', '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Priority', 'Normal', '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('WhoId', '' + id, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('WhatId', '' + jobOrderId, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('ActivityDate', '' + currentDate, '', 'false', '');
    fields = fields + ',' + background.GenerateEntityField('Description', '' + comment, '', 'false', '');

    fields = fields + ']';

    var strFields = JSON.stringify(fields);

    var tabId = localTabId.innerText;
    var entityName = 'Task';

    background.AddEntity(entityName, strFields, tabId);
    
    //update the application...
    var updateEntity = 'ts2__Application__c';

    var updateFields = '[';

    updateFields = updateFields + background.GenerateEntityField('URLAdd', localStorage.LastPageUrl, '', false, '#UrlAdd');
    updateFields = updateFields + ',' + background.GenerateEntityField('LinkedInStatus', '', '', 'false', '#LinkedInStatus');
    updateFields = updateFields + ',' + background.GenerateEntityField('userID', '' + appId, '', 'true', '');
    updateFields = updateFields + ',' + background.GenerateEntityField('ts2__Application_Status__c', 'Rejected', '', 'false', '');
    updateFields = updateFields + ',' + background.GenerateEntityField('ts2__Reject_Reason__c', '' + comment, '', 'false', '');    

    updateFields = updateFields + ']';

    var strFieldsUpdate = JSON.stringify(updateFields);


    background.UpdateEntity(updateEntity, strFieldsUpdate, tabId);
}

//END OF BOTTOM BAR EVENTS

function SaveComplete(entityName, objJson, messageType) {

    var res = JSON.parse(objJson);

    if (res.d.Success.toString().toLowerCase() + '' == 'true') {

        if (localStorage.LastPageUrl.indexOf("mail.google.com") != -1) {
            //localStorage.LastEmailSearchResult0 = '';
            //localStorage.LastEmailSearchResult1 = '';

            if (entityName.toLowerCase() == "task") {
                localStorage.LastEmailSearch0 = '';
            }
        }  

        var objectType = '';

        if (entityName == 'chatternewtopic') {
            $("#RemoveTopicList").val('');

            return false;
        }

        if (entityName == 'Account' && messageType == 'Added') {
            var action = getParameterByName("action");      

            if (action == 'Contact-Add') {
                CompanySaveComplete(res.d.CrmId);
                return false; 
            } else {
                localStorage.Message = 'Sucessfully ' + messageType;
                background.ReRunTabSearch();
                //window.location = 'Main.html?action=Account&id=' + res.d.CrmId;
                objectType = 'Account';                                
                MoveMe('Main.html?action=LinkJumper&ObjectName=' + objectType + '&id=' + res.d.CrmId);

                return false;
            }
        }

        if (entityName == 'Contact' && messageType == 'Added') {

            localStorage.Message = 'Sucessfully ' + messageType;
            background.ReRunTabSearch();
            //window.location = 'Main.html?action=Contact&id=' + res.d.CrmId;

            objectType = 'Contact';            
            MoveMe('Main.html?action=LinkJumper&ObjectName=' + objectType + '&id=' + res.d.CrmId);

            return false;
        }

        if (entityName == 'Event' && messageType == 'Added') {
            localStorage.Message = 'Sucessfully ' + messageType;
            //window.location = 'Main.html?action=Contact&id=' + res.d.CrmId;
            //objectType = 'Event';
            //MoveMe('Main.html?action=LinkJumper&ObjectName=' + objectType + '&id=' + res.d.CrmId);

            var tabId = localTabId.innerText;
            var location = background.HistoryGoBack(tabId);
            window.location = location;

            return false;
        }

        if (entityName.indexOf('Event-Edit') != -1 && messageType == 'Updated') {
            localStorage.Message = 'Sucessfully ' + messageType;
            
            var tabId = localTabId.innerText;
            var location = background.HistoryGoBack(tabId);
            window.location = location;

            return false;
        }

        if (entityName == 'Opportunity' && messageType == 'Added') {
            localStorage.Message = 'Sucessfully ' + messageType;
            background.ReRunTabSearch();
            //window.location = 'Main.html?action=Opportunity&id=' + res.d.CrmId;

            objectType = 'Opportunity';
            MoveMe('Main.html?action=LinkJumper&ObjectName=' + objectType + '&id=' + res.d.CrmId);

            return false;
        }
        
        if (entityName == 'Lead' && messageType == 'Added') {
            localStorage.Message = 'Sucessfully ' + messageType;
            background.ReRunTabSearch();
            //window.location = 'Main.html?action=Lead&id=' + res.d.CrmId;

            objectType = 'Lead';
            MoveMe('Main.html?action=LinkJumper&ObjectName=' + objectType + '&id=' + res.d.CrmId);

            return false;
        }
        if (entityName.indexOf('Task') != -1 && messageType == 'Updated') {
            localStorage.Message = 'Sucessfully ' + messageType;
            objectType = "Task";

            //var tabId = localTabId.innerText;
            //var location = background.HistoryGoBack2(tabId);
            //window.location = location;

            //Change rediect when closing tasks...
            var setClosed = getParameterByName("SetClosed");
            if (setClosed == 1) {
                var tabId = localTabId.innerText;
                var location = background.HistoryGoBack2(tabId);
                window.location = location;
            } else {
                var tabId = localTabId.innerText;
                var location = background.HistoryGoBack(tabId);
                window.location = location;
            }

            return false;
        }
        if (entityName == 'Task' && messageType == 'Added') {
            localStorage.Message = 'Sucessfully ' + messageType;
            //objectType = "Task";
            //MoveMe('Main.html?action=LinkJumper&ObjectName=' + objectType + '&id=' + res.d.CrmId);

            var tabId = localTabId.innerText;
            var location = background.HistoryGoBack(tabId);
            window.location = location;

            return false;
        }

        if (entityName.toLowerCase() == 'chatteruser' && messageType == 'Added') {
            // reload SF. 
            window.location = 'Main.html?action=Chatter';
            return false; 
        }

        if (entityName.toLowerCase() == 'chatterusersmall' && messageType == 'Added') {
            // reload SF. 
            window.location = 'Main.html?action=Chatter';
            // Guessing we want to clear the boxes also.
            return false; 
        }

        if (entityName.toLowerCase() == 'chatterfollow' && messageType == 'Added') {
            var id = getParameterByName("id");
            background.SelectEntity("chatterfollow", "", background.GenerateBHKeyField(id), localTabId.innerText);
            return false; 
        }

        if (entityName.toLowerCase() == 'chattergroup' && messageType == 'Added') {
            var id = getParameterByName("id");

            $(".postLoader").empty(); 
            $(".publishercontainer").val('');

            $("#tabs").tabs('select', 0);

            background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);

            AssignLoader(".chatsFollowsSection");

            return false;
        }

        if (entityName.toLowerCase() == 'saveactivecalendars') {
     
            $(".calendarSaveLoader").html('Calendar settings saved.');
            localStorage.DoubleTap = "";
            return false;
        }

        if (entityName.toLowerCase() == 'updategoogleaccounts') {

            localStorage.DoubleTap = "";

            var span = CreateSpan("Your changes have been saved. Please refresh your Gmail page.", "gmailAccountUpdatedMessage");

            $('.gmailAccountsSave').find('img').hide();
            $('.gmailAccountsSave').append(span);

            return false;
        }
        
        if (entityName.toLowerCase() == 'chatterfollowers' && messageType == 'Added') {

            var id = getParameterByName("id");

            $(".postLoader").empty();
            $(".publishercontainer").val('');
                        
            $("#tabs").tabs('select', 0);

            background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
           
            AssignLoaderWithText(".chatsFollowsSection","Loading Chatter...");
            return false;
        }

        if (entityName.toLowerCase() == 'chatterfeed' && messageType == 'Added') {
            // reload SF. 
            
            var action = getParameterByName("action");
            //var pageType = getParameterByName("action");
            //window.location = 'Main.html?action=' + pageType + '&id=' + id;
            var id = getParameterByName("id");
            
            if (action.toLowerCase() == 'chatter') {
                background.SelectEntity("chatteruser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatteruser", "Loading Chatter...");
            }
            else if (action.toLowerCase() == 'welcomechatter' ^ action == '') {
                if ($(".chatsAllCompany").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedallcompany", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");

                } else if ($(".chatsBookmarksSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedbookmarked", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsBookmarksSection", "Loading Chatter...");

                } else if ($(".chatsFollowsSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsFollowsSection", "Loading Chatter...");
                } else {
                    background.SelectEntity("chatterfeedtome", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                }
            } else {
                background.SelectEntity("chatterfeed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatterfeed", "Loading Chatter...");
            }
            return false; 
        }

        if (entityName.toLowerCase() == 'chatterlike' && messageType == 'Added') {
       

            var action = getParameterByName("action");
            var id = getParameterByName("id");
              
            if (action.toLowerCase() == 'chatter') {
                background.SelectEntity("chatteruser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatteruser", "Loading Chatter...");

            }
            else if (action.toLowerCase() == 'welcomechatter' ^ action == '') {

                if ($(".chatsAllCompany").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedallcompany", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                } else if ($(".chatsBookmarksSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedbookmarked", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsBookmarksSection", "Loading Chatter...");
                } else if ($(".chatsFollowsSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsFollowsSection", "Loading Chatter...");
                } else {
                    background.SelectEntity("chatterfeedtome", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                }

            } else {
                background.SelectEntity("chatterfeed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatterfeed", "Loading Chatter...");
            }
            return false;
        }

        if (entityName.toLowerCase() == 'chatterlikecomment' && messageType == 'Added') {
            //window.location = 'Main.html?action=Chatter';
            //return false;

            //var id = getParameterByName("id");
            //var pageType = getParameterByName("action");
            //window.location = 'Main.html?action=' + pageType + '&id=' + id;
            var action = getParameterByName("action");
            //var pageType = getParameterByName("action");
            //window.location = 'Main.html?action=' + pageType + '&id=' + id;
            var id = getParameterByName("id");


            if (action.toLowerCase() == 'chatter') {
                background.SelectEntity("chatteruser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatteruser", "Loading Chatter...");
            }
            else if (action.toLowerCase() == 'welcomechatter' ^ action == '') {
                
                if ($(".chatsAllCompany").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedallcompany", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                } else if ($(".chatsBookmarksSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedbookmarked", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsBookmarksSection", "Loading Chatter...");
                } else if ($(".chatsFollowsSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsFollowsSection", "Loading Chatter...");

                } else {
                    background.SelectEntity("chatterfeedtome", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                }

            } else {
                background.SelectEntity("chatterfeed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatterfeed", "Loading Chatter...");
            }
            return false;
        }

        if (entityName == 'chattercomment' && messageType == 'Added') {
            //window.location = 'Main.html?action=Chatter';
            //return false;

            //var id = getParameterByName("id");
            //var pageType = getParameterByName("action");
            //window.location = 'Main.html?action=' + pageType + '&id=' + id;
            var action = getParameterByName("action");
            //var pageType = getParameterByName("action");
            //window.location = 'Main.html?action=' + pageType + '&id=' + id;
            var id = getParameterByName("id");


            if (action.toLowerCase() == 'chatter') {
                background.SelectEntity("chatteruser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatteruser", "Loading Chatter...");
            }
            else if (action.toLowerCase() == 'welcomechatter' ^ action == '') {
                
                if ($(".chatsAllCompany").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedallcompany", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                } else if ($(".chatsBookmarksSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedbookmarked", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsBookmarksSection", "Loading Chatter...");
                } else if ($(".chatsFollowsSection").parent().attr("aria-hidden") == "false") {
                    background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsFollowsSection", "Loading Chatter...");
                } else {
                    background.SelectEntity("chatterfeedtome", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    AssignLoaderWithText(".chatsToMeSection", "Loading Chatter...");
                }

            } else {
                background.SelectEntity("chatterfeed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssignLoaderWithText("#chatterfeed", "Loading Chatter...");
            }
            return false;
        }

        var customObjectFound = false;
        
        var lgm = JSON.parse(localStorage.LayoutManager);
      
        var counter = 0;
        for (var d = 0; d < lgm.d.CrmEntities.length; d++) {

            
            if (lgm.d.CrmEntities[d].Name == entityName) {
                
                if (lgm.d.CrmEntities[d].Custom == 1) {
                    customObjectFound = true; 
                }

            }
        }
        

        if (customObjectFound) {
            var id = res.d.CrmId;
            var pageType = getParameterByName("action");
            var recordTypeId = getParameterByName("recordTypeId");
            window.location = 'Main.html?action=' + entityName + '-' + recordTypeId + '&id=' + id + '&RecordTypeId=' + recordTypeId;
            return false;
        }

        if (window.location != localStorage.lastKnown) {
            localStorage.Message = 'Sucessfully ' + messageType;
            window.location = localStorage.lastKnown;
            return false;
        }         

    } else
    {
        if (res.d.ErrorMessage != null) {            
            if (res.d.ErrorMessage.indexOf("API_CURRENTLY_DISABLED") != -1) {
                ShowApiErrorWithMessage();
            }else if (res.d.ErrorMessage.indexOf("OVERLIMIT:") != -1) {
                //DisplayNoAddMessage(0);
                //DisplayFreeProductMessage();
                background.ValidateSessionLicence(1, 0,0);
            }
            else if (res.d.ErrorMessage.indexOf("NOADD:") != -1) {
                //DisplayNoAddMessage(0);
                //DisplayFreeProductMessage();
                background.ValidateSessionLicence(1, 0,0);
            }
            else if (res.d.ErrorMessage.indexOf("NOADDINDUSTRY:") != -1) {
                //DisplayNoAddMessage(1);
                //DisplayFreeProductMessage();
                background.ValidateSessionLicence(1, 0,0);
            }
            else if (res.d.ErrorMessage.indexOf("NOLINKEDINPRO:") != -1) {
                //DisplayNoAddMessage(1);
                //DisplayFreeProductMessage();
                background.ValidateSessionLicence(1, 0,0);
            }
            else {
               
                DisplayNormalError(messageType, res);

                if (entityName == "Event" && messageType == "Added") {
                    ClearTimesFromDates(); 
                }
                
                if (entityName == "Event-Edit" && messageType == "Updated") {
                    ClearTimesFromDates();
                }
            }
        } else {
            DisplayNormalError(messageType, res);
        }
                
        $("body").delegate(".refreshSettingsLink", "click", function () {
            reloadAgain = true;
        });

        return false;
    }

    if (entityName.toLowerCase() == "task" && messageType.toLowerCase() == "updated") {
        messageType = "Edit";
    }
    if ((entityName.toLowerCase() == "event-edit" | entityName.toLowerCase() == "event") && messageType.toLowerCase() == "updated") {
        entityName = "Event";
        messageType = "Edit";
    }

    return false; 
}


function DisplayNormalError(messageType, res) {

    //can't change MessageType as it is used all over - if we find it here in the error message, change it to 'update' so the error message reads correctly.
    if (messageType == "Updated")
    {
        messageType = "update";
    }

    if (messageType == "Added")
    {
        messageType = "add";
    }

    if (res.d.ErrorMessage != null && res.d.ErrorMessage != "") {

        SetErrorMessage('Failed to ' + messageType + ' (' + res.d.ErrorMessage + ')', 'If the problem persists, try refreshing your settings');

    } else {
        SetErrorMessage('Failed to ' + messageType + ' (' + res.d.Message + ')', 'If the problem persists, try refreshing your settings');
    }

    $('#failureMessage').css('visibility', 'visible');
    $("#failureMessage").addClass('showMe');

    //jump to the top of the page where we display error messages...
    //$('#entityfields').scrollTop();
    
    RecoverOutofError();
}

function ValidateInt(val) {

    if (val.length != 0) {
        var reg = /^\d+$/;

        return reg.test(val.trim());
    } else {
        return true;
    }
}

function ValidateDouble(val) {
    if (val.length != 0) {
        var reg = /^(\d|\.)+$/;

        return reg.test(val.trim());
    } else {
        return true;
    }
}

function Validate(context,msgText) {

    //Remove old Red borders off before we set them again
    $('.invalid').removeClass('invalid');

    var msg = '';    

    if (context == "#entityfields ") {
        if ($("#CoId").val() == -1 && $("#CompanyId").val().length != 0) {
            $("#CompanyId").addClass('invalid');
            msg = AddCommaSeperator(msg) + 'You must lookup and select a valid Account or clear the Account field';
            //passed = 1;
        }
        else {
            $("#CompanyId").removeClass('invalid');
        }
    }

    $(context + ".valid-email").each(function () {
        var val = $(this).val().trim();
        var msgControl = $(this).attr('msg');
        
        var emailValid = true;

        if (val != '') {
            emailValid = validateEmail(val);
        } 

        if (emailValid == false) {

            msg = AddCommaSeperator(msg) + 'Email is invalid';

            $(this).addClass('invalid');
        } else {
            $(this).removeClass('invalid');
        }
    });

    //We're only picking enabled fields when validating to stop any issues when dependancy picklists which aren't activated due to user selection
    $(context + ".required:enabled").each(function () {

        var val = $(this).val();
        var id = $(this).attr('id');
        var msgControl = $(this).attr('msg');

        //Skip validating resume fields
        if ($(this).hasClass('hiddenResumeField')) {
            return;
        }

        var passed = 0;
        if (id.indexOf("chk-") == -1) {

            //Check required Multi Picklists fields for values
            if (id.toLowerCase().indexOf("lm-") != -1) {
                //Get the name attribute as this is the id of the field which contains the values of the selected piclist values
                var fieldName = $(this).attr('name');

                //Check for any 'tag' classes as this will mean that the user has chosen values
                if ($("#" + fieldName).find('.tag').length > 0) {
                    val = "Found";
                } else {
                    val = "";
                }
            }

            if (val.length == 0) {
                // Missing field. 
                $(this).addClass('invalid');

                msg = AddCommaSeperator(msg) + msgControl;

                if (msgControl == "Must be a valid company") {
                    $("#CompanyId").addClass('invalid');
                }
                passed = 1;
            } else {

                if (val == '-1') {
                    $(this).addClass('invalid');
                    passed = 1;
                    if (msgControl == "Must be a valid company") {
                        $("#CompanyId").addClass('invalid');
                    }

                    msg = AddCommaSeperator(msg) + msgControl;
                }

                if (val == "Company lookup") {
                    $(this).addClass('invalid');
                    if (msgControl == "Must be a valid company") {
                        $("#CompanyId").addClass('invalid');
                    }
                    passed = 1;

                    msg = AddCommaSeperator(msg) + msgControl;
                }

                // lookup field that's required, check we actually selected a lookup properly
                if (id.toLowerCase().indexOf('txtlookup-') !== -1) {

                    var dashIndex = id.indexOf('-');

                    var objectName = id.substring(dashIndex + 1);

                    var lookupValue = $('#' + objectName).val();

                    if (lookupValue !== undefined && lookupValue !== null) {
                        if (lookupValue === '-1' || lookupValue.length === 0) {
                            passed = 1;
                            $(this).addClass('invalid');
                            msg = AddCommaSeperator(msg) + ' Must select a valid lookup';
                        }
                    }
                }
            }

            if (passed == 0) {
                if (msgControl == "Must be a valid company") {
                    $("#CompanyId").removeClass('invalid');
                }
                $(this).removeClass('invalid');
            }
        }
    });

    $(context + ".group").each(function () {
        var val = $(this).val();
        var id = $(this).attr('id');
        var msgControl = $(this).attr('msg');
        var grpId = $(this).attr('GrpId');

        var splGrp = grpId.split(' '); // Gives a list of ids. 

        var foundGrp = 0;

        for (var t = 0; t < splGrp.length; t++) {
            var passed = 0;
            var val = '' + $(splGrp[t]).val();
           
            if (val.length == 0) {
                passed = 1;
            }
            else {
                if (val == '-1') {
                    passed = 1;
                }

                if (val == 'undefined') {
                    passed = 1;
                }
            }

            if (passed == 0) {
                foundGrp = 1;
                break;
            }

        }


        if (foundGrp == 0) {
            // we did not find anybody in the grp.
            msg = msg + msgControl + ',';

            for (var t = 0; t < splGrp.length; t++) {
                $(splGrp[t]).addClass('invalid');
            }

        }
        else {
            for (var t = 0; t < splGrp.length; t++) {
                $(splGrp[t]).removeClass('invalid');
            }
        }



    });

    $(context + ".valid-percent").each(function () {
        var val = $(this).val().trim();
        var msgControl = $(this).attr('msg');

        var emailValid = true;

        if (val != '') {
            emailValid = ValidateInt(val);
        }

        if (emailValid == false) {

            msg = AddCommaSeperator(msg) + 'Not a valid Percentage';

            $(this).addClass('invalid');
        } else if (val < 0 && val > 100 && val != '') {

            msg = AddCommaSeperator(msg) + 'Not a valid Percentage';

            $(this).addClass('invalid');
        }else{
            $(this).removeClass('invalid');
        }
    });


    $(context + ".valid-int").each(function () {
        var val = $(this).val().trim();
        var msgControl = $(this).attr('msg');


        var emailValid = true;

        if (val != '') {
            emailValid = ValidateInt(val);
        }

        if (emailValid == false) {

            msg = AddCommaSeperator(msg) + 'Not a valid Int';

            $(this).addClass('invalid');
        } else {
            $(this).removeClass('invalid');
        }
    });

    $(context + ".valid-percent").each(function () {
        var val = $(this).val().trim();
        var msgControl = $(this).attr('msg');


        var emailValid = true;

        if (val != '') {
            emailValid = ValidateDouble(val);
        }

        if (emailValid == false) {

            msg = AddCommaSeperator(msg) + 'Not a valid Int';

            $(this).addClass('invalid');
        } else {
            $(this).removeClass('invalid');
        }
    });


    $(context + ".valid-currency").each(function () {
        var val = $(this).val().trim();
        var msgControl = $(this).attr('msg');


        var emailValid = true;

        if (val != '') {
            var lastChar = val.substr(val.length - 1);

            if (lastChar.toLowerCase() == "m") {
                var startVal = val.substr(0, val.length - 1);

                emailValid = ValidateDouble(startVal);

                if (emailValid) {
                    var million = parseFloat(startVal);

                    if (million != null && typeof million != "undefined") {
                        million = (million * 1000000);

                        $(this).val('' + million);
                    } else {
                        emailValid = false;
                    }
                }
            } else {
                emailValid = ValidateDouble(val);
            }
        }

        if (emailValid == false) {
            
            msg = AddCommaSeperator(msg) + 'Not a valid Currency';

            $(this).addClass('invalid');
        } else {
            $(this).removeClass('invalid');
        }
    });

    //Give user some readable error if the date fields are wrong as SF error message isn't detailed or clear enough
    $(context + '.valid-date,' + context + '.valid-datetime').each(function ()
    {
        if ($(this).val().length > 0)
        {
            var unFormattedDate = unFormatDateLocal($(this).val());

            var date = new Date(unFormattedDate);

            //If the date hasn't been picked up correctly and the field is enabled lets inform the user that there is a problem with this value
            if (!date.getDate() && $(this).is(':enabled'))
            {
                msg = AddCommaSeperator(msg) + $(this).attr('name') + ' does not have a valid Date';
                $(this).addClass('invalid').val('');
            }
            else
            {
                $(this).removeClass('invalid');
            }
        }
        else if(!$(this).hasClass('required'))
        {
            $(this).removeClass('invalid');
        }
    });

    if (msg.length != 0) {
        if (context != '#companyCreate')  {
            SetErrorMessage("Please complete the fields outlined in red", 'You were unable to successfully ' + msgText + ' because: ' + msg + '.');
        }
        else 
        {
            SetErrorMessageCompany("Please complete the fields outlined in red", 'You were unable to successfully ' + msgText + ' because: ' + msg + '.');
        }
        //msg = '<div id="messageName"><p>Please complete the fields outlined in red<br />You were unable to successfully ' + msgText + ' because:<br /> ' + msg + '</p></div>';
        $("#failureMessage").addClass('showMe');
        savePressed = false;

        //jump to the top of the page where we display error messages...
        //$('.scrolling').scrollTop();
    }
    else {
        $("#failureMessage").removeClass('showMe');
        savePressed = true;
    }

    return msg;
}

function AddCommaSeperator(input) {
    if (input.length > 0) {
        input = input + ', ';
    }

    return input;
}

/**
 * Gets all the fields and their current values
 * @param {} action 
 * @returns {} 
 */
function GetFormsData() {
    var formsData = '';
    var action = getParameterByName("action");

    if (action == 'Candidate-Add') {
        return SaveEntityValues("Candidate");
    }

    if (action == 'Candidate-Edit') {
        return SaveEntityValues("Candidate");
    }
    
    if (action == 'Contact-Add') {
        return SaveEntityValues("Contact");
    }

    if (action.indexOf('-Add') != -1) {
        var entityPos = action.indexOf('-Add');
        var entity = action.substring(0, entityPos);
        
        return SaveEntityValues(entity);
    }

    if (action.indexOf('-Edit') != -1) {
        var entity = action.replace('-Edit', '');

        return SaveEntityValues(entity);
    }

    return formsData;
}

    function SaveEntityValues(entityName) {

        var textboxes = $("body").find(".data");
        var textHidden = $("body").find(".lm");
        var lookupName = $("body").find(".autofire");

        if (entityName == "Contact") {
            if (document.getElementById("pageTitle").innerHTML == "Add Contact") {
                textboxes = $("#entityfields").find(".data");
                textHidden = $("#entityfields").find(".lm");
                lookupName = $("#entityfields").find(".autofire");
            }
            else {
                textboxes = $("#companyCreate").find(".data");
                textHidden = $("#companyCreate").find(".lm");
                lookupName = $("#companyCreate").find(".autofire");
            }
        }

    
        var fields = '{"values":[';
        var counter = 1;
        var fldLink = background.GenerateEntityField('URLAdd', localStorage.LastPageUrl, '', false, '#UrlAdd');
    
        fields = fields + fldLink;
    
        textboxes.each(function () {
            var fld = background.GenerateEntityField(this.name, this.value, '', false, '#' + this.id);

            if (counter == 0) {
                fields = fields + fld;
            }
            else {
                fields = fields + "," + fld;
            }

            counter++;
        });

        var textHidden = $("body").find(".key");
        textHidden.each(function () {

            var fld = background.GenerateEntityField(this.name, this.value, '', true,'#' + this.id);

            if (counter == 0) {
                fields = fields + fld;
            }
            else {
                fields = fields + "," + fld;
            }

            counter++;
        });

 

        textHidden.each(function () {
            var strid = $(this).attr("id");
            var strLookup = $(this).attr("name");
            var ids = '';
            var first = 0;
            var idTags = $("#" + strid).find(".tag");
            idTags.each(function () {
                if (first == 0) {
                    ids = '' + $(this).attr("tv");
                    first = 1;
                }
                else {
                    ids = ids + ',' + $(this).attr("tv");
                }
            });


            fields = fields + ',' + background.GenerateEntityField(strid, ids, '', false, '#' + this.id);
        });

        lookupName.each(function () {
            var fld = background.GenerateEntityField(this.name, this.value, '', false, '#' + this.id);

            if (counter == 0) {
                fields = fields + fld;
            }
            else {
                fields = fields + "," + fld;
            }

            counter++;
        });

        fields = fields + ']}';
   
        return fields;
    }

    function ClearForm() {

        var textboxes = $("body").find(".data");
    
        textboxes.each(function () {
            $('.data').val('');
        });

        var textHidden = $("body").find(".lm");

        textHidden.each(function() {
            var strid = $(this).attr("id");
            var strLookup = $(this).attr("name");
            var ids = '';
            var first = 0;
            var idTags = $("#" + strid).find(".tag").remove();
        });

        $("#dedupe").empty();
        $("#dedupeContact").empty();

    }

    function ReloadData(fields) {    
        if (fields != null) {
            if (fields.length != 0) {
                var action = localAction.innerText;

                var objData = JSON.parse(fields);            

                if (objData != null) {
                    for (var dt = 0; dt < objData.values.length; dt++) {
                        try {
                            
                            var val = objData.values[dt].Value;

                            if (val.length != 0) {
                                $(objData.values[dt].ControlName).val(val);
                            }

                        } catch (error) {
                        }

                    }
                }
            }
        }

        // Reset we want to hold this for a very short amount of time. 
        localStorage.DataForReload = null; 

    }

    function SaveMessage() {
        $('.save').text('Saving');
        $('#messageSuccess').show();
        $('#messageName').text('Saving'); 
    }
    //var savePressed = false;
 

    function Save() {

        var action = localAction.innerText;
        var tabId = '1';
        var id = getParameterByName("id");
        var foundSaved = false; 

        if (action.indexOf("Account-Add") != -1) {            

            foundSaved = true;
            savePressed = true;
            //var msg = Validate("#companyCreate ", "add an account");
            var msg = Validate("#entityfields ", "add an account");

            if (msg.length == 0) {
                ConfirmSave('Account');
            } 
        }
                
        if (action == 'Account-Edit') {

            savePressed = true;
            foundSaved = true; 
            var msg = Validate('', 'edit an account');
            if (msg.length == 0) {
                SaveMessage();
                EditEntity('Account');
            }
        }
        
        if (action.indexOf("Contact-Add") != -1) {

            foundSaved = true;

            if (document.getElementById("pageTitle").innerHTML == "Add Contact") {

                var msg = Validate("#entityfields ", "add a contact");

                if (msg.length == 0) {
                    ConfirmSave('Contact');
                } 
            }
            else {
                var msg = Validate("#companyCreate ", "add a account");
               
                if (msg.length == 0) {
                    SaveMessage();
                    SaveEntity('Account');
                } 

            }
        }


        if (action == 'Contact-Edit') {
            foundSaved = true; 
            var msg = Validate('', 'edit a contact');
            if (msg.length == 0) {
                SaveMessage();
                EditEntity('Contact');
            }
            
        }
        

        if (action == "Task-Add") {
            savePressed = true;
            foundSaved = true;

            var msg = Validate('', 'add a task');
            if (msg.length == 0) {
                SaveMessage();
                SaveEntity('Task');
            }
           
        }

        if (action == "Task-Edit") {

            savePressed = true;
            foundSaved = true;

            var msg = Validate('', 'edit a task');
            if (msg.length == 0) {
                SaveMessage();
                EditEntity('Task');
            }
            
        }

        if (action == "Campaign-Add") {
            savePressed = true;
            foundSaved = true;
            var msg = Validate('', 'add a campaign');
            if (msg.length == 0) {
                SaveMessage();
                SaveEntity('CampaignMember');
            }
            
        }

        if (action == "Lead-Add") {
            savePressed = true;


            foundSaved = true; 
            var msg = Validate('', 'add a lead');

 

            if (msg.length == 0) {
                ConfirmSave('Lead');
            }
            
        }
        
        if (action == "Lead-Edit") {
            savePressed = true;
            foundSaved = true; 
            var msg = Validate('', 'edit a lead');
            if (msg.length == 0) {
                SaveMessage();
                EditEntity('Lead');
            }
        }



        if (action == "Event-Add") {
            savePressed = true;


            foundSaved = true;
            var msg = Validate('', 'add a Event');



            if (msg.length == 0) {
                SaveMessage();
                SaveEntity('Event');
            }

        }

        
        if (foundSaved == false) {
            
            if (action.indexOf("-Edit") != -1)
            {
                savePressed = true;              

                

                var msg = Validate('', 'edit a entity');
                if (msg.length == 0) {
                    SaveMessage();
                    EditEntity(action);
                }
            }   

            if (action.indexOf("-Add") != -1) {

                savePressed = true;
                var entityName = action.replace("-Add", "");
                var posEntity = action.indexOf("-Add"); 
                entityName = action.substring(0, posEntity); 
                var msg = Validate('', 'add a entity');
                if (msg.length == 0) {
                    var dupeFields = $("body").find(".dupe");
                    if (dupeFields && dupeFields.length > 0) {
                        ConfirmSave(entityName);
                    } else {
                        SaveMessage();
                        SaveEntity(entityName);
                    }
                }
            }

            
        }
    
    
    }

    function validateEmail(email) {
        var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    }

/**
 * Creates the dialog that appears before you're about to save a record
 * @param {string} entityType - The type of record it is
 */
function CreateConfirmationDialog(entityType) {
    if ($confirmCreated === null) {

        $confirmCreated = $('<div id="confirmCreateDialog"></div>')
            .dialog({
                height: 300,
                width: 300,
                modal: true,
                autoOpen: false,
                title: 'Confirmation',
                closeText : '',
                buttons: {
                    'Add as New': function () {

                        var msg = Validate("#entityfields ", "add a record");
                        if (msg.length == 0) {
                            SaveMessage();
                            SaveEntity(entityType);
                        }  
                        
                        $(this).dialog("close");
                    },
                    Cancel: function () {
                        savePressed = false;
                        $(this).dialog("close");
                    }
                }
            })
            .on('dialogclose', function () {
                savePressed = false;
            });

        if (savePressed == true) {
            $confirmCreated.dialog('open');
        }
    }
}

/**
 * Shows the confirmation dialog when you're about to save a record
 * @param {string} entityName - The name of the object about to be saved
 */
function ConfirmSave(entityName) {
    CreateConfirmationDialog(entityName);
    if ($('#possibleMatch').attr('count') !== '0') {
        savePressed = false;            
        $confirmCreated.dialog('open');
    }
    else {
        savePressed = false;

        var pTag = document.createElement('p');
        pTag.appendChild(document.createTextNode('Please confirm that you wish to create this ' + entityName + ' in Salesforce and have permissions to do so'));

        $confirmCreated.html(pTag)
            .on('dialogclose', function() {
                savePressed = false;
            });
        $confirmCreated.dialog('open');
    }
}


    function ReloadLayoutSetup() {
        background.ValidateSessionLicence(0, 0, 0);

        background.GetFormLayout();
        localStorage.Message = 'Settings reloaded';
    }

    function ReloadSettingsPage() {
        background.GetFormLayout();
        //localStorage.Message = 'Settings reloaded';
    }


    function ClearKey() {
        background.ClearCacheAndLogout();
        PopUpPageRedirector().LoginPage();
    }

    function Search(amountOnPage, page, orderBy, filters) {

        if (typeof amountOnPage === 'undefined') { amountOnPage = ''; }
        if (typeof filters === 'undefined') { filters = ''; }

        var searchTerm = txt_search.value;
        //_gaq.push(['_trackEvent', 'Search', 'Button','' + searchTerm]);
        if (searchTerm.trim() != '') {

            if (searchTerm != 'null') {
                MoveMe('../html/Main.html?action=Search&search=' + encodeURIComponent(searchTerm) + '&amountonpage=' + amountOnPage);
            }
        } 
    }

    function SetReadOnlyOnReference(valueField) {

        var nameFieldName = '#TxtLookup-' + valueField;
        var checkValue = '#' + valueField;

        if ($(checkValue).val() != '-1') {

            if ($(nameFieldName).val() != null && typeof $(nameFieldName).val() != "undefined") {
                if ($(nameFieldName).val().length != 0) {
                    var btName = '#CoLookup-' + valueField;

                    $(btName).text('Change');

                    $(nameFieldName).attr('readonly', true);
                    $(nameFieldName).addClass('readonlyTextBox');
                }
            }
        }
        else {

            // For the moment just do this with AccountId. 
            if (valueField == "AccountId") {
                var search = $(nameFieldName).val();

                if (search + "".trim() != "") {

                    // HERE 123
                    var btName = '#CoLookup-' + valueField;

                    var entityName = $(btName).attr("datasource");

                    background.Search("dlookupone-" + entityName, search, localTabId.innerText, null, null, null, null, 0, PassData, function (responseObject) {
                        if (responseObject && responseObject.errormessage) {
                            ShowSearchError(responseObject.errormessage);
                        }
                    });

                }
            }
        }
    }

    function FormatTime(time) {
        time = '' + time;

        if (time == '1') {
            time = '01';
        }
        else if (time == '2') {
            time = '02';
        }
        else if (time == '3') {
            time = '03';
        }
        else if (time == '4') {
            time = '04';
        }
        else if (time == '5') {
            time = '05';
        }
        else if (time == '6') {
            time = '06';
        }
        else if (time == '7') {
            time = '07';
        }
        else if (time == '8') {
            time = '08';
        }
        else if (time == '9') {
            time = '09';
        }

        return time; 
    }

    function FormatDateSF(baseDate,timezone) {
        var year = baseDate.substring(0, 4);
        var month = baseDate.substring(5, 7);
        var day = baseDate.substring(8, 10);
        var hour = baseDate.substring(11, 13);
        var minutes = baseDate.substring(14, 16);
        var seconds = baseDate.substring(17, 19);
        var milliseconds = "0";


        var mathMonth = parseInt(month);
        mathMonth = mathMonth - 1;

        var d = new Date(year, mathMonth, day, hour, minutes, seconds, milliseconds);

        if (timezone != '' && timezone != null) {
            d = d.addHours(timezone);
        }
    
        var today = new Date();
        var yesterday = new Date(today.getFullYear(), today.getMonth(), today.getUTCDate() - 1, 0, 0, 0);
        var twodays = new Date(today.getFullYear(), today.getMonth(), today.getUTCDate() - 2, 0, 0, 0);

        var firstPartDate = d.toDateString();

    
        if (d.toDateString() == today.toDateString()) {
            firstPartDate = "Today"; 
        }
    
        if (d.toDateString() == yesterday.toDateString()) {
            firstPartDate = "Yesterday";
        }
    
        if (d.toDateString() == twodays.toDateString()) {
            firstPartDate = "Two days ago ";
        }

        // Date with Timezone.
    
        var h = d.getHours();
        var m = d.getMinutes();


        var dateString = '' + firstPartDate + ' at ' + FormatTime(h) + ":" + FormatTime(m);

        return dateString;
    }

    var $dialogCreated = null;
    var $confirmCreated = null;

    function DisplayNoAddMessage(flag) {

        //ShowUpgradeMessage();
   
    }

    function DisplayFreeProductMessage() {
        //$("#freeMessDiv").show();
        $("#messageSuccess").hide();
        $("body").delegate("#btProLicence", "click", function () {
            var url = localStorage.LastPageUrl;                        
            var origin = "gmail";
            if (url.indexOf('mail.google.') != -1)
            {
                origin = "gmail";
            }
            else
            {
                origin = "premsite";
            }

            var trialUsedStorage = 0;

            if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
                trialUsedStorage = parseInt(localStorage.TrialUsed);
            }

            if (trialUsedStorage == -1) {
                background.CheckTrial2(origin);

                AssignLoaderWithText("#btProLicence", "Loading Free Trial...");

                //background.CheckTrial();
            } else {
                //background.CheckTrial();
                background.CheckTrial2(origin);
                background.LogEventShort('Clicked-Upgrade-After-Trial');
            }

        });
    }

    function CanIAddEdit() {
        var canI = true;

        if (localStorage.LicenceFound == "Free") {
            canI = false; 
        }
        
        if (localStorage.LastPageUrl.indexOf('linkedin.com') != -1) {
            canI = true;
        }

        //
        return canI;
    }

    function RenderGmailFreeMessage() {
        var FreeHtml = '';

        var messageHeaderText = '';
        var messageText = '';
        var messageHeaderClass = '';
        var buttonName = '';
        var buttonClass = '';

        var trialUsed = 0;

        if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
            trialUsed = parseInt(localStorage.TrialUsed);
        }

        if (trialUsed < 0) {
            messageHeaderText = 'Your trial of Ebsta has expired';
            messageText = 'Click <span style="font-weight:bold;">Upgrade</span> to continue using Ebsta inside Gmail.';
            buttonName = 'Upgrade';
            buttonClass = 'blueStyle';
            messageHeaderClass = "proTrialNotAvailable";
        }

        if (localStorage.TrailLicenceFound != "true") {
            messageHeaderText = 'Start a FREE trial of Ebsta for Gmail';
            messageText = 'Click <span style="font-weight:bold;">Get Started</span> to begin a 14-day FREE trial of Ebsta for Gmail.';
            buttonName = 'Get Started';
            buttonClass = 'blueStyle startFreeTrial';
            messageHeaderClass = "proTrialAvailable";
        }

        FreeHtml = '<div class="freeMessage" style="margin-top:45px;">';
        FreeHtml = FreeHtml + '<div id="freeMessageContent">';
        FreeHtml = FreeHtml + '<span id="btProBack" class="closeFreeMes back">« Back</span><h1 class="' + messageHeaderClass + '">' + messageHeaderText + '</h1>';
        FreeHtml = FreeHtml + '<p>' + messageText + '</p><br>';
        FreeHtml = FreeHtml + '<p><a target="_blank" href="https://console.ebsta.com/account/Default.aspx">Click here for a full list of features and benefits.</a></p><br><br>';

        FreeHtml = FreeHtml + '<div class="messageItemWithImage"><img src="/images/30px_alert_option1.png"><p>Get alerted to Salesforce records</p></div>';

        FreeHtml = FreeHtml + '<div class="messageItemWithImage"><img src="/images/30px_create.png"><p>View, edit and update Salesforce records</p></div>';

        FreeHtml = FreeHtml + '<div class="messageItemWithImage"><img src="/images/30px_add_email.png"><p>Add emails to Salesforce in just one click</p></div>';

        FreeHtml = FreeHtml + '<div class="messageItemWithImage"><img src="/images/30px_calendar_option1.png"><p>Sync your Salesforce and Google Calendars</p></div>';

        FreeHtml = FreeHtml + '<br>';

        FreeHtml = FreeHtml + '<center><button id="btProLicence" class="' + buttonClass + '">' + buttonName + '</button></center>';

        FreeHtml = FreeHtml + '</div>';
        FreeHtml = FreeHtml + '</div>';

        $("body").delegate("#optListLink", "click", function () {
            openURLNewTab("https://ebsta.zendesk.com/entries/40875758-What-websites-is-Ebsta-optimized-for");
        });

        $("body").delegate("#custReadMore", "click", function () {
            openURLNewTab("https://ebsta.zendesk.com/entries/25825118-How-do-I-change-Salesforce-fields-in-Ebsta-");
        });

        return FreeHtml;
    }

    function ShowFreeMessage2() {

        var productVersion = background.WhatVersion();

        //

        var FreeHtml = '';

        var lastPageUrl = '';

        if (localStorage.LastPageUrl != null && typeof localStorage.LastPageUrl != "undefined") {
            lastPageUrl = localStorage.LastPageUrl;
        }

        if (lastPageUrl.toLowerCase().indexOf("mail.google.com/mail") != -1 && lastPageUrl.toLowerCase().indexOf("accounts.google.com") == -1) {
            FreeHtml = RenderGmailFreeMessage();
        } else {

            var messageHeaderText = '';
            var messageText = '';
            var messageHeaderClass;
            var buttonName = '';
            var buttonClass = '';

            var trialUsed = 0;

            if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
                trialUsed = parseInt(localStorage.TrialUsed);
            }

            if (trialUsed < 0) {
                messageHeaderText = 'Your Pro trial has expired';
                messageText = 'You need to have an Ebsta Pro account to fully integrate Ebsta with your favourite sites.';
                buttonName = 'Upgrade';
                buttonClass = 'blueStyle';
                messageHeaderClass = "proTrialNotAvailable";
            }

            if (localStorage.TrailLicenceFound != "true") {
                messageHeaderText = 'Start a 14-day FREE Trial of Ebsta Pro';
                messageText = "The trial really is FREE. No sign-up. No credit card.";
                buttonName = 'Get Started';
                buttonClass = 'blueStyle startFreeTrial';
                messageHeaderClass = "proTrialAvailable";
            }

            FreeHtml = '<div class="freeMessage">';
            FreeHtml = FreeHtml + '<div id="freeMessageContent">';
            FreeHtml = FreeHtml + '<span id="btProBack" class="closeFreeMes back">« Back</span><h1 class="' + messageHeaderClass + '">' + messageHeaderText + '</h1>';
            FreeHtml = FreeHtml + '<p>' + messageText + '</p><br>';
            FreeHtml = FreeHtml + '<p class="upgradeMessaging">With Ebsta Pro you can:</p><br>';
            //Pro features table
            FreeHtml = FreeHtml + '<table id="upgradeMessaging">';
            //Integrate with SF
            FreeHtml = FreeHtml + '<tr>';
            FreeHtml = FreeHtml + '<td><img src="/images/30px_integrate.png"></td>'; //td1
            FreeHtml = FreeHtml + '<td><p class="messagingRowHeader">Put Salesforce inside your favorite websites</p>';
            FreeHtml = FreeHtml + '<p>Including LinkedIn, Gmail, Xing, Data.com, Monster, Zoominfo and many, many more.</p>';
            FreeHtml = FreeHtml + '</td>'; //td2
            FreeHtml = FreeHtml + '</tr>';
            //Add records
            FreeHtml = FreeHtml + '<tr>';
            FreeHtml = FreeHtml + '<td><img src="/images/30px_create.png"></td>'; //td1
            FreeHtml = FreeHtml + '<td><p class="messagingRowHeader">Create new Salesforce records</p>';
            FreeHtml = FreeHtml + '<p>Create new records in two clicks on 50+ websites. ';
            FreeHtml = FreeHtml + '<span id="optListLink"><strong>Click here for a full list of integrated websites.</strong></span>';
            FreeHtml = FreeHtml + '</p></td>'; //td2
            FreeHtml = FreeHtml + '</tr>';
            //Customise fields
            FreeHtml = FreeHtml + '<tr>';
            FreeHtml = FreeHtml + '<td><img src="/images/30px_settings.png"></td>'; //td1
            FreeHtml = FreeHtml + '<td><p class="messagingRowHeader">Customize your Salesforce fields</p>';
            FreeHtml = FreeHtml + '<p>Change the Salesforce fields displayed in Ebsta to reflect your own requirements. ';
            FreeHtml = FreeHtml + '<span id="custReadMore"><strong>Read more.</strong?</span>';
            FreeHtml = FreeHtml + '</p></td>'; //td2
            FreeHtml = FreeHtml + '</tr>';
            //Create Tasks/Event
            FreeHtml = FreeHtml + '<tr>';
            FreeHtml = FreeHtml + '<td><img src="/images/30px_cal.png"></td>'; //td1
            FreeHtml = FreeHtml + '<td><p class="messagingRowHeader">Log Calls and Create Tasks and Events</p>';
            FreeHtml = FreeHtml + '<p>View daily tasks and events. Create, edit and update activites against any Salesforce record.</p>';
            FreeHtml = FreeHtml + '</td>'; //td2
            FreeHtml = FreeHtml + '</tr>';
            FreeHtml = FreeHtml + '</table>';
            //End pro features table
            FreeHtml = FreeHtml + '<br>';

            FreeHtml = FreeHtml + '<center><button id="btProLicence" class="' + buttonClass + '">' + buttonName + '</button></center>';

            FreeHtml = FreeHtml + '</div>';
            FreeHtml = FreeHtml + '</div>';

            $("body").delegate("#optListLink", "click", function () {
                openURLNewTab("https://ebsta.zendesk.com/entries/40875758-What-websites-is-Ebsta-optimized-for");
            });

            $("body").delegate("#custReadMore", "click", function () {
                openURLNewTab("https://ebsta.zendesk.com/entries/25825118-How-do-I-change-Salesforce-fields-in-Ebsta-");
            });
        }

        return FreeHtml;
    }

    function ShowFreeMessage() {
        var MessageHeaderText = '';
        var buttonName = '';
        var buttonClass = '';

        var trialUsedStorage = 0;

        if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
            trialUsedStorage = parseInt(localStorage.TrialUsed);
        }

        if (trialUsedStorage == -2) {
            MessageHeaderText = 'Your Pro trial has expired';
            buttonName = 'Upgrade';
            buttonClass = '';
        }
        else {
            MessageHeaderText = '14-day Free Trial of Ebsta Pro';
            buttonName = 'Get Started';
            buttonClass = 'blueStyle startFreeTrial';
        }
        //Create Page div
        var freeMessageDiv = document.createElement('div');
        freeMessageDiv.setAttribute('class', 'freeMessage');

        //Create yellow container for message
        var messageContainer = document.createElement('div');
        messageContainer.setAttribute('class', 'messageSuccess');

        //Create header
        var messagingHeader = document.createElement('h1');
        var headerText = document.createTextNode(MessageHeaderText);
        messagingHeader.appendChild(headerText);
        messageContainer.appendChild(messagingHeader); //add messaging title to container

        //Create message body
        var paraOne = document.createElement('p');
        var paraOneText = document.createTextNode("Don't worry, the trial really is FREE. No sign-up. No credit card.");
        paraOne.appendChild(paraOneText);
        var b1 = document.createElement('b');
        messageContainer.appendChild(paraOne); //add 1st <p> to container
        messageContainer.appendChild(b1); //add line break after 1st <p> 

        var paraTwo = document.createElement('p');
        var paraTwoText = document.createTextNode('With Ebsta Pro you can:');
        paraTwo.setAttribute('class', 'upgradeMessaging');
        paraTwo.appendChild(paraTwoText);
        var b2 = document.createElement('b');
        messageContainer.appendChild(paraTwo); //add 2nd <p> to container
        messageContainer.appendChild(b2); //add line break after 2nd <p> 

        //Create Pro features tabel
        var proTable = document.createElement('table');
        proTable.setAttribute('id', 'upgradeMessaging');
        //Create Table rows
        //Row 1 - Integrate SF ---------------------------------------------------------
        var sfIntRow = document.createElement('tr');

        //Row logo element
        var sfIntImgDet = document.createElement('td'); //image <td>
        var sfIntImg = document.createElement('img');
        sfIntImg.setAttribute('src', '/images/30px_integrate.png'); //Set logo source
        sfIntImgDet.appendChild(sfIntImg); //add logo <img> to image <td>
        sfIntRow.appendChild(sfIntImgDet); //add image <td> to sf Int row <tr>

        //Row desc element
        var sfIntDescDet = document.createElement('td');

        //Row desc title
        var sfIntDescHead = document.createElement('p');
        var sfIntDescHeadTxt = document.createTextNode('Integrate Salesforce with your favorite websites');
        sfIntDescHead.setAttribute('class', 'messagingRowHeader');
        sfIntDescHead.appendChild(sfIntDescHeadTxt); //add header text to header <p>

        //Row desc body
        var sfIntRowBody = document.createElement('p');
        var sfIntRowBodyTxt = document.createTextNode('Including LinkedIn, Gmail, Xing, Data.com, Monster, Zoominfo and many, many more.');
        sfIntRowBody.appendChild(sfIntRowBodyTxt); //add row body text to sf Int desc <p>

        sfIntDescDet.appendChild(sfIntDescHead); //add Row desc title to sfInt desc <td>
        sfIntDescDet.appendChild(sfIntRowBody); //add Row desc body to sf Int desc <td>
        sfIntRow.appendChild(sfIntDescDet); //add Row desc <td> to sf Int <tr>

        proTable.appendChild(sfIntRow); //add Row to table
        //------------------------------------------------------------------------------

        //Row 2 - Add Records --------------------------------------------------------
        var addRecRow = document.createElement('tr');

        //Row logo element
        var addRecImgDet = document.createElement('td');
        var addRecImg = document.createElement('img');
        addRecImg.setAttribute('src', '/images/30px_create.png'); //Set logo source
        addRecImgDet.appendChild(addRecImg); //add image to <td>
        addRecRow.appendChild(addRecImgDet); //add image <td> to <tr>

        //Row desc element
        var addRecDescDet = document.createElement('td');

        //Row desc title
        var addRecRowHeader = document.createElement('p');
        var addRecDescRowHeaderTxt = document.createTextNode('Create new Salesforce records');
        addRecRowHeader.setAttribute('class', 'messagingRowHeader');
        addRecRowHeader.appendChild(addRecDescRowHeaderTxt); //add text to header <p>
    
        //Row desc body
        var addRecRowBody = document.createElement('p');
        var addRecRowBodyTxt = document.createTextNode('Create new records in two clicks on 50+ websites.');
        addRecRowBody.appendChild(addRecRowBodyTxt); //add text to <p>

        //Link to list of optimised sites
        var optListLink = document.createElement('a');
        var optListLinkText = document.createTextNode('Click here for a full list of integrated websites');
        optListLink.setAttribute('href', 'https://ebsta.zendesk.com/entries/40875758-What-websites-is-Ebsta-optimized-for'); //set link destiniation
        optListLink.appendChild(optListLinkText); //add link text to <a>

        addRecRowBody.appendChild(optListLink); //add <a> to body <p>

        addRecDescDet.appendChild(addRecRowHeader); //add row desc head <p> to desc <td>
        addRecDescDet.appendChild(addRecRowBody); //add desc body <p> to <td>

        addRecRow.appendChild(addRecDescDet); //add desc <td> to  create <tr>
        proTable.appendChild(addRecRow); //Add create <tr> to  pro <table>
        //------------------------------------------------------------------------------

        //Row 3 - Customise SF fields --------------------------------------------------
        var customRow = document.createElement('tr');

        //Create row logo <td>
        var customLogo = document.createElement('td'); //logo <td>
        var customLogoImg = document.createElement('img'); //logo <img>
        customLogoImg.setAttribute('src', '/images/30px_settings.png'); //set image source
        customLogo.appendChild(customLogoImg); //add logo <img> to logo <td>
        customRow.appendChild(customLogo); //add logo <td> to row <tr>

        //Row row desc <td>
        var customDesc = document.createElement('td'); //desc <td>
        var customDescTitle = document.createElement('p'); //title <p>
        var customDescTitleTxt = document.createTextNode('Customize your Salesforce fields'); //desc title text
        customDescTitle.appendChild(customDescTitleTxt); //add title text to title <p>

        var customDescBody = document.createElement('p'); //body <p>
        var customDescBodyTxt = document.createTextNode('Change the Salesforce fields displayed in Ebsta to reflect your own requirements.'); //desc body text
        var customDescBodyLink = document.createElement('a'); //custom desc link <a>
        var customDescBodyLinkTxt = document.createTextNode('Read more'); //link text
        customDescBodyLink.setAttribute('href', 'https://ebsta.zendesk.com/entries/25825118-How-do-I-change-Salesforce-fields-in-Ebsta-'); //set link destination
        customDescBodyLink.appendChild(customDescBodyLinkTxt); //add link text to <a>
        customDescBody.appendChild(customDescBodyTxt); //add body text to body <p>
        customDescBody.appendChild(customDescBodyLink); //add link <a> to body <p>

        customDesc.appendChild(customDescTitle); //add title <p> to desc <td>
        customDesc.appendChild(customDescBody); //add body <p> to desc <td>

        customRow.appendChild(customDesc); //add desc <td> to row <tr>
        proTable.appendChild(customRow); //add <tr> to <table>

        //------------------------------------------------------------------------------

        //Row 4 - Create Tasks/Events --------------------------------------------------
        var createRow = document.createElement('tr');

        //Create row logo <td>
        var createLogo = document.createElement('td'); //logo <td>
        var createLogoImg = document.createElement('img'); //logo <img>
        createLogoImg.setAttribute('src', '/images30px_cal.png'); //set image source
        createLogo.appendChild(createLogoImg); //add logo <img> to logo <td>
        createRow.appendChild(createLogo); //add logo <td> to row <tr>

        //Row row desc <td>
        var createDesc = document.createElement('td'); //desc <td>
        var createTitle = document.createElement('p'); //title <p>
        var createTitleTxt = document.createTextNode('Log Calls and Create Tasks and Events'); //title text
        createTitle.appendChild(createTitleTxt); //add title text to title <p>

        //Row row desc body <p>
        var createBody = document.createElement('p'); //body <p>
        var createBodyText = document.createTextNode('View daily tasks and events. Create, edit and update activites against any Salesforce record.'); //body text
        createBody.appendChild(createBodyText); //add body text to body <p>

        createDesc.appendChild(createTitle); //add title <p> to desc <td>
        createDesc.appendChild(createBody); //add body <p> to desc <td>

        createRow.appendChild(createDesc); //add desc <td> to row <tr>
        proTable.appendChild(createRow); //add <tr> to <table>
        //------------------------------------------------------------------------------

        var b3 = document.createElement('b');
        messageContainer.appendChild(proTable); //add features table to container
        messageContainer.appendChild(b3); //add line break after features table

        var button = document.createElement('button'); //create button
        button.setAttribute('id','btProLicence'); //set button id
        button.setAttribute('class', buttonClass); //set button class
        var buttonText = document.createTextNode(buttonName); //create button text
        button.appendChild(buttonText); //add button text to button
        messageContainer.appendChild(button); //add button to container

        return freeMessageDiv.toString();
    }

    function ShowUpgradeMessage() {

        var header = '';
        var buttonName = '';
        var message = '';
        var messageHeight = '';
        var messageTopMargin = '';

        var trialUsedStorage = 0;

        if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
            trialUsedStorage = parseInt(localStorage.TrialUsed);
        }

        if (trialUsedStorage == -2) {
            messageHeight = '260';
            messageTopMargin = '180';
            header = 'Your Ebsta Pro trial has now expired';
            buttonName = 'Upgrade Now';
            //message = '<h1 style="font-weight:bold;font-size: 10pt;margin-bottom:6px"><strong>' + header + '</strong></h1>';
            //message = message + '<p>Upgrade now to continue using all the Ebsta Pro features.</p><br />';
            //message = message + '<p class="upgradeMessaging">With Ebsta Pro you can:</p><br />';
            //message = message + '<table id="upgradeMessaging">';
            //message = message + '<tr><td><img src="/images/30px_create.png"/></td><td>Create Salesforce records.</td></tr>';
            //message = message + '<tr><td><img src="/images/30px_settings.png"/></td><td>Customize fields in the Ebsta window.</td></tr>';
            //message = message + '<tr><td><img src="/images/30px_edit.png"/></td><td>Edit and update records, activities and opportunities.</td></tr></table><br />';
            //message = message + '<p><span id="btPlansPricing"><strong>Click here to compare Plans and Pricing</strong></span>.</p><br />';
            //message = message + '<center><div><button id="btProBack" class="blueStyle back">Back</button><button class="blueStyle startFreeTrial" id="btProLicence" >' + buttonName + '</button></div></center></div>';

            var divMessage = document.createElement('div');
            var hMessage = document.createElement('h1');
            hMessage.setAttribute('style', 'font-weight:bold;font-size: 10pt;margin-bottom:6px');
            var strongMessage = document.createElement('strong');
            var txtHeader = document.createTextNode(header);
            strongMessage.appendChild(txtHeader);
            hMessage.appendChild(strongMessage);
            divMessage.appendChild(hMessage);

            var pMessage1 = document.createElement('p');
            var txtP1 = document.createTextNode('Upgrade now to continue using all the Ebsta Pro features.');
            pMessage1.appendChild(txtP1);
            divMessage.appendChild(pMessage1);
            var brMessage1 = document.createElement('br');
            divMessage.appendChild(brMessage1);

            var pMessage2 = document.createElement('p');
            pMessage2.className = 'upgradeMessaging';
            var txtP2 = document.createTextNode('With Ebsta Pro you can:');
            pMessage2.appendChild(txtP2);
            divMessage.appendChild(pMessage2);

            var tableMessage = document.createElement('table');
            tableMessage.id = 'upgradeMessaging';
            var trMessage1 = document.createElement('tr');
            var tdMessage1 = document.createElement('td');
            var imgMessage1 = document.createElement('img');
            imgMessage1.src = '/images/30px_create.png';
            tdMessage1.appendChild(imgMessage1);
            trMessage1.appendChild(tdMessage1);
            var tdMessage2 = document.createElement('td');
            var txtTd2 = document.createTextNode('Create Salesforce records.');
            tdMessage2.appendChild(txtTd2);
            trMessage1.appendChild(tdMessage2);
            tableMessage.appendChild(trMessage1);

            var trMessage2 = document.createElement('tr');
            var tdMessage3 = document.createElement('td');
            var imgMessage2 = document.createElement('img');
            imgMessage2.src = '/images/30px_settings.png';
            tdMessage3.appendChild(imgMessage2);
            trMessage2.appendChild(tdMessage3);
            var tdMessage4 = document.createElement('td');
            var txtTd4 = document.createTextNode('Customize Salesforce fields in the Ebsta window.');
            tdMessage4.appendChild(txtTd4);
            trMessage2.appendChild(tdMessage4);
            tableMessage.appendChild(trMessage2);

            var trMessage3 = document.createElement('tr');
            var tdMessage5 = document.createElement('td');
            var imgMessage3 = document.createElement('img');
            imgMessage3.src = '/images/30px_edit.png';
            tdMessage5.appendChild(imgMessage3);
            trMessage3.appendChild(tdMessage5);
            var tdMessage6 = document.createElement('td');
            var txtTd6 = document.createTextNode('Edit and update records, activities and opportunities.');
            tdMessage6.appendChild(txtTd6);
            trMessage3.appendChild(tdMessage6);
            tableMessage.appendChild(trMessage3);
            divMessage.appendChild(tableMessage);

            var brMessage2 = document.createElement('br');
            divMessage.appendChild(brMessage2);

        
            var pMessage3 = document.createElement('p');
            var spanMessage = document.createElement('span');
            spanMessage.id = 'btPlansPricing';
            var strongMessage2 = document.createElement('strong');
            var txtP3 = document.createTextNode('Click here to compare Plans and Pricing');
            strongMessage2.appendChild(txtP3);
            spanMessage.appendChild(strongMessage2);
            pMessage3.appendChild(spanMessage);
            divMessage.appendChild(pMessage3);

            var brMessage3 = document.createElement('br');
            divMessage.appendChild(brMessage3);
        
            var centerMessage = document.createElement('center');
            var divMessage2 = document.createElement('div');
            divMessage2.id = 'btPro';

            var bMessage1 = document.createElement('button');
            bMessage1.id = 'btProBack';
            bMessage1.className = 'blueStyle back';
            var txtButton1 = document.createTextNode('Back');
            bMessage1.appendChild(txtButton1);
            var bMessage2 = document.createElement('button');
            bMessage2.id = 'btProLicence';
            bMessage2.className = 'blueStyle startFreeTrial';
            var txtButton2 = document.createTextNode(buttonName);
            bMessage2.appendChild(txtButton2);

            divMessage2.appendChild(bMessage1);
            divMessage2.appendChild(bMessage2);
            centerMessage.appendChild(divMessage2);
            divMessage.appendChild(centerMessage);

            $('#messageName').empty();
            $('#messageName').append(divMessage);
        }
        else {
            messageHeight = '245';
            messageTopMargin = '150';
            header = 'Start a 14-day FREE trial of Ebsta Pro';
            buttonName = 'Get Started';
            message = '';
            //message = message + '<h1 style="font-weight:bold;font-size: 10pt;margin-bottom:6px"><strong>' + header + '</strong></h1>';
            //message = message + '<p>Don\'t worry, the trial really is FREE. No sign-up. No credit card.</p><br />';
            //message = message + '<p class="upgradeMessaging">With Ebsta Pro you can:</p>';
            //message = message + '<table id="upgradeMessaging">';
            //message = message + '<tr><td><img src="/images/30px_create.png"/></td><td>Create Salesforce records.</td></tr>';
            //message = message + '<tr><td><img src="/images/30px_settings.png"/></td><td>Customize Salesforce fields in the Ebsta window.</td></tr>';
            //message = message + '<tr><td><img src="/images/30px_edit.png"/></td><td>Edit and update records, activities and opportunities.</td></tr></table><br />';
            //message = message + '<p>Ebsta will automatically revert back to Ebsta Free after your trial.</p>';
            //message = message + '<center><div id="btPro"><button id="btProBack" class="blueStyle back">Back</button><button class="blueStyle startFreeTrial" id="btProLicence" >' + buttonName + '</button></div></center></div>';

            var divMessage = document.createElement('div');
            var hMessage = document.createElement('h1');
            hMessage.setAttribute('style', 'font-weight:bold;font-size: 10pt;margin-bottom:6px');
            var strongMessage = document.createElement('strong');
            var txtHeader = document.createTextNode(header);
            strongMessage.appendChild(txtHeader);
            hMessage.appendChild(strongMessage);
            divMessage.appendChild(hMessage);

            var pMessage1 = document.createElement('p');
            var txtP1 = document.createTextNode('Don\'t worry, the trial really is FREE. No sign-up. No credit card.');
            pMessage1.appendChild(txtP1);
            divMessage.appendChild(pMessage1);
            var brMessage1 = document.createElement('br');
            divMessage.appendChild(brMessage1);

            var pMessage2 = document.createElement('p');
            pMessage2.className = 'upgradeMessaging';
            var txtP2 = document.createTextNode('With Ebsta Pro you can:');
            pMessage2.appendChild(txtP2);
            divMessage.appendChild(pMessage2);

            var tableMessage = document.createElement('table');
            tableMessage.id = 'upgradeMessaging';
            var trMessage1 = document.createElement('tr');
            var tdMessage1 = document.createElement('td');
            var imgMessage1 = document.createElement('img');
            imgMessage1.src = '/images/30px_create.png';
            tdMessage1.appendChild(imgMessage1);
            trMessage1.appendChild(tdMessage1);
            var tdMessage2 = document.createElement('td');
            var txtTd2 = document.createTextNode('Create Salesforce records.');
            tdMessage2.appendChild(txtTd2);
            trMessage1.appendChild(tdMessage2);
            tableMessage.appendChild(trMessage1);

            var trMessage2 = document.createElement('tr');
            var tdMessage3 = document.createElement('td');
            var imgMessage2 = document.createElement('img');
            imgMessage2.src = '/images/30px_settings.png';
            tdMessage3.appendChild(imgMessage2);
            trMessage2.appendChild(tdMessage3);
            var tdMessage4 = document.createElement('td');
            var txtTd4 = document.createTextNode('Customize Salesforce fields in the Ebsta window.');
            tdMessage4.appendChild(txtTd4);
            trMessage2.appendChild(tdMessage4);
            tableMessage.appendChild(trMessage2);

            var trMessage3 = document.createElement('tr');
            var tdMessage5 = document.createElement('td');
            var imgMessage3 = document.createElement('img');
            imgMessage3.src = '/images/30px_edit.png';
            tdMessage5.appendChild(imgMessage3);
            trMessage3.appendChild(tdMessage5);
            var tdMessage6 = document.createElement('td');
            var txtTd6 = document.createTextNode('Edit and update records, activities and opportunities.');
            tdMessage6.appendChild(txtTd6);
            trMessage3.appendChild(tdMessage6);
            tableMessage.appendChild(trMessage3);
            divMessage.appendChild(tableMessage);

            var brMessage2 = document.createElement('br');
            divMessage.appendChild(brMessage2);

            var pMessage3 = document.createElement('p');
            var txtP3 = document.createTextNode('Ebsta will automatically revert back to Ebsta Free after your trial.');
            pMessage3.appendChild(txtP3);
            divMessage.appendChild(pMessage3);

            var centerMessage = document.createElement('center');
            var divMessage2 = document.createElement('div');
            divMessage2.id = 'btPro';

            var bMessage1 = document.createElement('button');
            bMessage1.id = 'btProBack';
            bMessage1.className = 'blueStyle back';
            var txtButton1 = document.createTextNode('Back');
            bMessage1.appendChild(txtButton1);
            var bMessage2 = document.createElement('button');
            bMessage2.id = 'btProLicence';
            bMessage2.className = 'blueStyle startFreeTrial';
            var txtButton2 = document.createTextNode(buttonName);
            bMessage2.appendChild(txtButton2);

            divMessage2.appendChild(bMessage1);
            divMessage2.appendChild(bMessage2);
            centerMessage.appendChild(divMessage2);
            divMessage.appendChild(centerMessage);
            $('#messageName').empty();
            $('#messageName').append(divMessage);
        }
    
        $('#messageName').css('height', messageHeight + 'px');
        $('#messageSuccess').css('display', 'inline');
        $('#messageSuccess').css('top', messageTopMargin + 'px');
        $('#btPlansPricing').css('cursor', 'pointer');
        $('#btPlansPricing').css('text-decoration', 'underline');

        $('#btUpgrade').css('cursor', 'pointer');
        $('#btUpgrade').css('text-decoration', 'underline');    
    
        $("body").delegate("#btProLicence", "click", function () {
            var url = localStorage.LastPageUrl;
            var origin = "gmail";                        
            if (url.indexOf('mail.google.') != -1)
            {
                origin = "gmail";
            }
            else
            {
                origin = "premsite";
            }

            var trialUsedStorage2 = 0;

            if (localStorage.TrialUsed != null && typeof localStorage.TrialUsed != "undefined") {
                trialUsedStorage2 = parseInt(localStorage.TrialUsed);
            }

            if (trialUsedStorage2 == -1) {

                AssignLoaderWithText("#btProLicence", "Loading Free Trial...");
                background.CheckTrial2(origin);
                //background.CheckTrial();
            } else {
                background.CheckTrial2(origin);
                //background.CheckTrial();
                background.LogEventShort('Clicked-Upgrade-After-Trial');
                //openURLNewTab('https://console.ebsta.com/account/');
            }

        });

        $("body").delegate("#btProBack", "click", function () {
            background.LogEventShort('Pro-Cancel-Click');

            //var tabId = localTabId.innerText;
            //var location = background.HistoryGoBack(tabId);
            //window.location = location;
        });

        $("body").delegate("#btPlansPricing", "click", function () {
            openURLNewTab('https://console.ebsta.com/account/');
        });
    }

    function ShowTrialUpgradeMessage()
    {
        localStorage.LicenceUpgraded = false;

        $("#messageName").css("height", "");
        $("#messageSuccess").addClass("startTrialMessageSuccess");
   
        $("#messageName").html('Congratulations!<br /><br />You have successfully started your 14 day free trial of Ebsta Pro.');
        $("#messageSuccess").show();
        $("#messageSuccess").fadeOut(5000);
    }


    function SetupTrial() {

        localStorage.LicenceUpgraded = true;
        window.location = window.location;  
    }

    function AlreadyUsedTrial() {

        localStorage.TrialUsed = -2; 
        $("#btPro").empty();
        openURLNewTab('https://console.ebsta.com/account/');
    }

    function GetNameFieldValue(objResult) {
        var result = "";
        var counter = 0;
    
        for (var key in objResult) {

            if (counter == 2) {
                result = "" + objResult[key];
                break;
            }
            counter++;
        }

        return result; 
    }

    function DisplayOverLimitMessage() {
        ShowUpgradeMessage(); 
    }
    
    //Set attributes for results returned back with address elements
    function AttachAddressFieldsOntoResults(element, record) {
        if (record.ShippingStreet) {
            element.setAttribute("street", record.ShippingStreet);
        } else if (record.BillingStreet) {
            element.setAttribute("street", record.BillingStreet);
        }

        if (record.ShippingCity) {
            element.setAttribute("city", record.ShippingCity);
        } else if (record.BillingCity) {
            element.setAttribute("city", record.BillingCity);
        }

        if (record.ShippingState) {
            element.setAttribute("state", record.ShippingState);
        } else if (record.BillingState) {
            element.setAttribute("state", record.BillingState);
        }

        if (record.ShippingPostalCode) {
            element.setAttribute("postcode", record.ShippingPostalCode);
        } else if (record.BillingPostalCode) {
            element.setAttribute("postcode", record.BillingPostalCode);
        }

        if (record.ShippingCountry) {
            element.setAttribute("country", record.ShippingCountry);
        } else if (record.BillingCountry) {
            element.setAttribute("country", record.BillingCountry);
        }
    }
    
    //Appends details onto search results when using the lookup search box
    function AppendAdditionalDetailsOntoSearchResearch(currentVal, rtnObject, entityType) {
        if (rtnObject) {
            if (entityType) {
                switch (entityType.toLowerCase()) {
                    case "account":
                        currentVal = GetAddressInfoForSearchResults(currentVal, rtnObject);
                        break;
                    case "case":
                    case "solution":
                    case "contract":
                    case "order":
                        currentVal = GetMoreInfoFromLookupSearchResult(rtnObject);
                    default:
                        if (rtnObject.Email) {
                            if (rtnObject.Email.length > 0) {
                                currentVal += " (" + rtnObject.Email + ")";
                            }
                        }
                        break;
                }
            }
        }
        return currentVal;
    }

    //Takes a result from the lookup search results and creates a new string with more details
    function GetMoreInfoFromLookupSearchResult(rtnObject) {
        var details = "";

        if (rtnObject != null) {
            if (rtnObject.ContractNumber != null) {
                details += rtnObject.ContractNumber + ", ";
            }

            if (rtnObject.CaseNumber != null) {
                details += rtnObject.CaseNumber + ", ";
            }

            if (rtnObject.Subject != null) {
                details += rtnObject.Subject + ", ";
            }

            if (rtnObject.SolutionName != null) {
                details += rtnObject.SolutionName + ", ";
            }

            if (rtnObject.SolutionNumber != null) {
                details += rtnObject.SolutionNumber + ", ";
            }

            if (rtnObject.OrderNumber != null) {
                details += rtnObject.OrderNumber + ", ";
            }

            details = details.slice(0, -2);

            if (rtnObject.Status != null) {
                details += " (Status = " + rtnObject.Status + ")";
            } 
        }

        return details;
    }
    
    //Takes a results object and appends some values onto the return value
    function GetAddressInfoForSearchResults(currentVal, rtnObject) {
        //City Information
        if (rtnObject.ShippingCity) {
            currentVal += ", " + rtnObject.ShippingCity;
        }
        else if (rtnObject.BillingCity) {
            currentVal += ", " + rtnObject.BillingCity;
        }
        else if (rtnObject.MailingCity) {
            currentVal += ", " + rtnObject.MailingCity;
        }

        //State information
        if (rtnObject.BillingState) {
            currentVal += ", " + rtnObject.BillingState;
        }
        else if (rtnObject.ShippingState) {
            currentVal += ", " + rtnObject.ShippingState;
        }
        else if (rtnObject.MailingState) {
            currentVal += ", " + rtnObject.MailingState;
        }

        //PostCode
        if (rtnObject.BillingPostalCode) {
            currentVal += ", " + rtnObject.BillingPostalCode;
        }
        else if (rtnObject.ShippingPostalCode) {
            currentVal += ", " + rtnObject.ShippingPostalCode;
        }
        else if (rtnObject.MailingPostalCode) {
            currentVal += ", " + rtnObject.MailingPostalCode;
        }
        return currentVal;
    }

    var contactJobApplicationCounter = 0;

    function PassData(entityType, data, searchUsed, filters) {  

        //console.time("PassData");
        //console.log("PassData");
        //console.log(entityType);
        //console.log(data);
        //console.log(searchUsed);

        var db = JSON.parse(data);

        if (db.d.ErrorMessage != null) {
            if (db.d.ErrorMessage.indexOf("REAUTH:") != -1) {
                ClearKey();
            }
            if (db.d.ErrorMessage.indexOf("Unauthorized") != -1) {
                ClearKey();
                
            }
        }

        if (db.d.ErrorMessage != null) {
            if (db.d.ErrorMessage.indexOf("OVERLIMIT:") != -1) {
                //DisplayOverLimitMessage();
                //DisplayFreeProductMessage();
            } else if (db.d.ErrorMessage.indexOf("NOADD:") != -1) {
                //DisplayNoAddMessage(0);
                //DisplayFreeProductMessage();
            } else if (db.d.ErrorMessage.indexOf("NOADDINDUSTRY:") != -1) {
                //DisplayNoAddMessage(1);
                //DisplayFreeProductMessage();
            } else if (db.d.ErrorMessage.indexOf("NOLINKEDINPRO:") != -1) {
                //DisplayNoAddMessage(1);
                //DisplayFreeProductMessage();
            } else if (db.d.ErrorMessage.indexOf("CHATTERINACTIVE:") != -1) {
                var inactiveHeader1 = document.createElement('h1');
                inactiveHeader1.appendChild(document.createTextNode('Chatter is inactive for this user.'));
                inactiveHeader1.className = 'inactiveChatterMessage';

                var inactiveHeader2 = document.createElement('h1');
                inactiveHeader2.appendChild(document.createTextNode('Chatter is inactive for this user.'));
                inactiveHeader2.className = 'inactiveChatterMessage';

                var chatterDisabledSpan = document.createElement('span');
                chatterDisabledSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

                var chatterfeed = document.getElementById('chatterfeed');
                var homeChatter = document.getElementById('homeChatter');
                var chatterCounter = document.getElementById('chatterCounter');

                if (chatterfeed != null) {
                    chatterfeed.appendChild(inactiveHeader1);
                }
                if (homeChatter != null) {
                    homeChatter.appendChild(inactiveHeader2);
                }

                if (chatterCounter != null) {
                    chatterCounter.appendChild(chatterDisabledSpan);
                }
                if (chatterCounter != null) {
                    chatterCounter.appendChild(document.createTextNode('Chatter (Disabled)'));
                }
                return;
            } else if (db.d.ErrorMessage.indexOf("CAMPAIGNINACTIVE:") != -1) {
                $('#campaignfeedlead, #campaignfeedcontact').html('<h1 class="inactiveChatterMessage">Cadences are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("TASKINACTIVE:") != -1 || db.d.ErrorMessage.indexOf("ACTIVITYINACTIVE:") != -1) {
                $('#taskopportunityopen, #taskopportunityclosed, #taskaccountopen, #taskaccountclosed, #taskcontactopen, #taskcontactclosed, #taskleadopen, #taskleadclosed, #allTasks').html('<h1 class="inactiveChatterMessage">Activities are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("OPPORTUNITYINACTIVE:") != -1) {
                $('#opportunityaccount, #opportunitycontact').html('<h1 class="inactiveChatterMessage">Opportunities are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("OPPORTUNITYCONTACTROLEINACTIVE:") != -1) {
                $('#contactopportunity').html('<h1 class="inactiveChatterMessage">Opportunity Contact Roles are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("JOBINACTIVE:") != -1) {
                $('#contactJobs').html('<h1 class="inactiveChatterMessage">*Jobs are inactive for this user.</h1>');
                $('#accountJobs, #accountJobsTalentRover').html('<h1 class="inactiveChatterMessage">Jobs are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("CONTACTINACTIVE:") != -1) {
                $('#accountcontacts, #accountContactsTalentRover').html('<h1 class="inactiveChatterMessage">Contacts are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("APPLICATIONINACTIVE:") != -1) {
                $('#contactApplications').html('<h1 class="inactiveChatterMessage">*Applications are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("HIRINGMANAGERINACTIVE:") != -1) {
                $('#contactJobsTalentRover').html('<h1 class="inactiveChatterMessage">Hiring Managers are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("OPPORTUNITIESDISCUSSEDINACTIVE:") != -1) {
                $('#contactOpportunitiesDiscussed').html('<h1 class="inactiveChatterMessage">Discussed Opportunities are inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("JOBSTATUSINACTIVE:") != -1) {
                $('#contactCandidateJobStatus').html('<h1 class="inactiveChatterMessage">Job Status is inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("HOMETASKINACTIVE:") != -1) {
                $('#homepageTaskInnerDiv').html('<h1 class="inactiveChatterMessage">Task Management is inactive for this user.</h1>');
                return;
            } else if (db.d.ErrorMessage.indexOf("API_CURRENTLY_DISABLED") != -1) {
                ShowApiErrorWithMessage();
            } else if (db.d.ErrorMessage.indexOf("Error: Not Found") != -1) {
                var objectType = getParameterByName("ObjectName");
                if (objectType.length == 0) {
                    objectType = getParameterByName("action");
                }
                MoveMe("../html/Main.html?action=Error&errorType=NotFound&objectType="+objectType);
                return;
            }
            else {
                ShowSearchError(db.d.ErrorMessage);
                return;
            }
        }

        var lgm = JSON.parse(localStorage.LayoutManager);

        // Open in SF is on everything. 
        $("body").undelegate(".entityclick", "click");
        $("body").delegate(".entityclick", "click", function () {

            //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-OpenExternal', '1']);

            openURL(entityUri);
        });

        //set up the button for 'Convert Lead'
        $("body").undelegate(".entityclickconvertlead", "click");
        $("body").delegate(".entityclickconvertlead", "click", function () {
            //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-OpenExternal', '1']);

            openURLConvertLead();
        });




        var action = getParameterByName("action");

        //caps fix on opportunity entity...
        if (entityType == "OPPORTUNITY") {
            entityType = 'Opportunity';
        }

        if (action.toLowerCase() == "task-edit") {
            var isCall = getParameterByName("iscall");

            if (isCall.toString() == "1") {
                $("#pageTitle").text('Edit Logged Call');
            }
        }

        var rtId = getParameterByName("RecordTypeId");
        var editCheck = '' + entityType;
        var userRt = false;


        if (rtId != null) {
            if (rtId != '') {
                if (rtId != 'Master') {
                    editCheck = entityType + "-" + rtId;
                    userRt = true;
                }
            }
        }

        if (action == editCheck) {

            $("body").delegate(".edit", "click", function () {
                var id = getParameterByName("id");

                var rtId1 = getParameterByName("RecordTypeId");

                var userRt1 = false;

                if (rtId1 != null) {
                    if (rtId1 != '') {
                        if (rtId1 != 'Master') {
                            userRt1 = true;
                        }
                    }
                }

                if (userRt1 + '' == 'true') {
                    MoveMe('Main.html?action=' + entityType + '-Edit-' + rtId + '&id=' + id + '&RecordTypeId=' + rtId);
                } else {
                    MoveMe('Main.html?action=' + entityType + '-Edit&id=' + id + '&RecordTypeId=Master');
                }
            });

            $("body").delegate(".customizeField", "click", function () {
                openURLNewTab('https://console.ebsta.com/LoginSalesforce.aspx?k=' + localStorage.WebUserId + '&j=crmintegration&objectLinker=' + entityType + "&recordTypeId=" + rtId);
            });
        }

        if (entityType.indexOf("dlookupone-") != -1) {
            //            var res = JSON.parse(strJson);
            // For the moment this only works for account. 
            if (db.d.Values.length != 0) {
                //                var entity = entityType.replace("dlookupone-", "");
                var res1 = JSON.parse(db.d.Values[0]);
                var idItem = res1.Id;
                //var nameItem = GetNameFieldValue(res);
                $("#TxtLookup-AccountId").val(res1.Name);
                $("#AccountId").val(idItem);
                SetReadOnlyOnReference("AccountId");

            }
        }

        if (entityType.indexOf("lookup-") != -1) {
            var entity = entityType.replace("lookup-", "");


            var listOl = document.createElement('ol');
            listOl.id = "allLogins1";
            listOl.setAttribute("class", "itemlist");


            for (var dt = 0; dt < db.d.Values.length; dt++) {
                var strJson = db.d.Values[dt];
                var res = JSON.parse(strJson);


                for (var dt = 0; dt < db.d.Values.length; dt++) {

                    var res = JSON.parse(db.d.Values[dt]);

                    if (res.Id + '' != 'null') {
                        var nameField = GetNameFieldValue(res);
                        var liItem = document.createElement('li');
                        liItem.setAttribute("role", "listitem");
                        liItem.setAttribute("class", "lookup pointer");
                        liItem.setAttribute("id", res.Id);

                        //Orders are handled a little differently due to less fields being requested
                        if (nameField.length === 0 && entity.toLowerCase() === "order") {
                            if (res.OrderNumber != null) {
                                nameField = res.OrderNumber;
                            }
                        }

                        liItem.setAttribute("name", nameField);
                        liItem.setAttribute("entity", entity);

                        nameField = AppendAdditionalDetailsOntoSearchResearch(nameField, res, entity);
                       
                        liItem.innerText = CharacterSupport(nameField);
                        AttachAddressFieldsOntoResults(liItem, res);
                        liItem.appendChild(CreateIconForHoverOver(res.Id, entity, nameField));
                        listOl.appendChild(liItem);
                    }
                }
            }

            if (db.d.Values.length == 0) {
                var liItemEmpty = document.createElement('li');
                liItemEmpty.className = "";
                liItemEmpty.innerText = "No matches. Please search again";
                listOl.appendChild(liItemEmpty);

                //                htmlStr += '<li>No matches. Please search again</li>';
            }

            var searchResplaceHolder = document.getElementById('entityResults');
            if (searchResplaceHolder != null) {
                searchResplaceHolder.innerHTML = '';
                searchResplaceHolder.appendChild(listOl);
            }

            $("#entityResults").show();

            var textHidden = $("body").find(".lookup");
            textHidden.each(function () {
                $(this).click(function () {

                    SelectEntityLookup($(this).attr("id"), $(this).attr("name"), $("#btEntitySearchName").val());
                    PrePopulateAddressFields($(this));
                });
            });
        }

        if (entityType.indexOf("dupesearch-") != -1) {

            var entity = entityType.replace("dupesearch-", "");
            CreateConfirmationDialog(entity);

            var pMatchItemOuter = document.createElement('p');
            var pMatchItem = document.createElement('div');

            pMatchItem.setAttribute("id", "possibleMatch");
            pMatchItem.setAttribute("count", "" + db.d.Values.length);
            pMatchItem.innerText = 'Possible Matches found: ' + db.d.Values.length;

            pMatchItemOuter.appendChild(pMatchItem);

            var htmlStrDialogDiv = document.createElement('div');
            htmlStrDialogDiv.setAttribute("id", "matchResults");
            htmlStrDialogDiv.setAttribute("title", "Matches Found 123");

            var pMatchResultsPlease = document.createElement('p');
            var pMatchResultsPleaseMessage = "Please verify that the record you are adding does not already exist. Click names to view.";
            if (db.d.Values.length === 0) {
                pMatchResultsPleaseMessage = "Please confirm that you wish to create this " + entity + " in Salesforce and have permissions to do so";
            }
            pMatchResultsPlease.innerText = pMatchResultsPleaseMessage;

            var hr1 = document.createElement('hr');

            htmlStrDialogDiv.appendChild(pMatchResultsPlease);
            htmlStrDialogDiv.appendChild(hr1);


            for (var dt = 0; dt < db.d.Values.length; dt++) {
                var strJson = db.d.Values[dt];
                var res = JSON.parse(strJson);
                var display1 = '';
                var display2Name = '';
                var display2 = '';
                var display3Name = '';
                var display3 = '';
                var display4 = '';

                var foundEntity = false;

                if (res.attributes.type == "Contact") {
                    display1 = '' + GetNameFieldValue(res);
                    display2 = '';
                    display2Name = 'Account';
                    if (res.Account != null) {
                        display2 = '' + CharacterSupport(res.Account.Name);

                    }
                    foundEntity = true;
                }

                if (res.attributes.type == "Lead") {
                    display1 = '' + GetNameFieldValue(res);
                    display2 = '';
                    display2Name = 'Company';
                    if (res.Company != null) {
                        display2 = '' +CharacterSupport(res.Company);

                    }
                    foundEntity = true;
                }


                if (res.attributes.type == "Account") {
                    display1 = '' + CharacterSupport(GetNameFieldValue(res));
                    display2 = '';
                    display2Name = '';

                    foundEntity = true;
                }


                if (foundEntity == false) {

                    var counter = 0;
                    for (var d = 0; d < lgm.d.CrmEntities.length; d++) {

                        if (lgm.d.CrmEntities[d].Name == res.attributes.type) {

                            // Loop Fields. 
                            for (var f = 0; f < lgm.d.CrmEntities[d].Fields.length; f++) {

                                var fldLayout = lgm.d.CrmEntities[d].Fields[f];

                                if (fldLayout.DisplayInDupe) {

                                    if (counter == 0) {
                                        display1 = '' + CharacterSupport(res[fldLayout.ValueField]);

                                    }

                                    if (counter == 1) {
                                        display2 = '' + CharacterSupport(res[fldLayout.ValueField]);
                                    }
                                    counter++;

                                }
                            }

                        }
                    }
                }

                var icon = '';
                var type1 = res.attributes.type;

                var icon = document.createElement('span');

                if (type1 == 'Contact') {
                    icon.setAttribute("class", "candidate");
                } else if (type1 == 'Lead') {
                    icon.setAttribute("class", "lead");

                } else if (type1 == 'Account') {
                    icon.setAttribute("class", "company");

                } else if (type1 == 'Opportunity') {
                    icon.setAttribute("class", "opportunity");

                } else {
                    icon.setAttribute("class", "customObject");
                }

                var depdupeTextElem = document.createElement('p');
                depdupeTextElem.setAttribute("class", "dedupeText");
                depdupeTextElem.appendChild(icon);

                var depdupeLinkElem = document.createElement('a');
                depdupeLinkElem.setAttribute("href", 'Main.html?action=' + res.attributes.type + '&id=' + res.Id);
                depdupeLinkElem.innerText = CharacterSupport(display1);
                depdupeTextElem.appendChild(depdupeLinkElem);

                var depdupebrElem = document.createElement('br');
                depdupeTextElem.appendChild(depdupebrElem);

                var depdupebrElem1 = document.createElement('hr');
                depdupeTextElem.appendChild(depdupebrElem1);


                htmlStrDialogDiv.appendChild(depdupeTextElem);
            }

            if (localAction.innerText.indexOf('Contact') != -1) {
                if (document.getElementById("pageTitle").innerHTML == "Add Account") {
                    var searchResplaceHolder = document.getElementById('dedupeContact');
                    if (searchResplaceHolder != null) {
                        searchResplaceHolder.innerHTML = '';
                        searchResplaceHolder.appendChild(pMatchItemOuter);
                    }
                } else {

                    var searchResplaceHolder = document.getElementById('dedupe');
                    if (searchResplaceHolder != null) {
                        searchResplaceHolder.innerHTML = '';
                        searchResplaceHolder.appendChild(pMatchItemOuter);
                    }
                }
            } else {
                var searchResplaceHolder = document.getElementById('dedupe');
                if (searchResplaceHolder != null) {
                    searchResplaceHolder.innerHTML = '';
                    searchResplaceHolder.appendChild(pMatchItemOuter);
                }
            }

            var searchResplaceHolder = document.getElementById('confirmCreateDialog');
            if (searchResplaceHolder != null) {
                searchResplaceHolder.innerHTML = '';
                searchResplaceHolder.appendChild(htmlStrDialogDiv);
            }
            
            if (db.d.Values.length > 0) {
                $("body").delegate("#possibleMatch", "click", function () {
                    $(function () {
                        $confirmCreated.dialog('open');
                    });
                });
            }

            if (filters == true || savePressed == true) {

                $confirmCreated.dialog('open');
            }

            return;

        }


        if (entityType.toLowerCase() == 'coresearch') {


            var resultCount = db.d.ResultCounter;

            var listOl = document.createElement('ol');
            listOl.id = "allLogins1";
            listOl.className = "itemlist";

            var group = '';


            for (var dt = 0; dt < db.d.Values.length; dt++) {


                var res = JSON.parse(db.d.Values[dt]);

                var type = res.attributes.type;

                var objName = GetNameFieldValue(res);

                var objNameLength = GetNameFieldValue(res).length;

                var displayText = '';

                var friendlyType = res.attributes.type.replace("_", " ").replace("__c", "");

                //Find if this is a converted lead so the client knows
                var isLeadConverted = false;
                if (type != null) {
                    if (type.toLowerCase() == "lead") {
                        if (res) {
                            if (res.IsConverted) {
                                if (res.IsConverted.toLowerCase() == "true") {
                                    isLeadConverted = true;
                                }
                            }
                        }
                    }
                }

                if (group != friendlyType) {
                    var groupCount = 0;

                    for (var d1 = 0; d1 < db.d.Values.length; d1++) {
                        var res1 = JSON.parse(db.d.Values[d1]);

                        var friendlyType1 = res1.attributes.type.replace("_", " ").replace("__c", "");

                        if (friendlyType == friendlyType1) {
                            groupCount++;
                        }
                    }

                    var grpItem = document.createElement('h2');
                    grpItem.innerText = CharacterSupport(friendlyType + ' (' + groupCount + ')');

                    listOl.appendChild(grpItem);

                    group = friendlyType;

                }

                if (objNameLength > 30) {
                    var shortName = objName.slice(0, 31);
                    displayText = shortName + '...';
                } else {
                    displayText = objName;
                }


                var actionLink = type;
                var recordTypeId = 'Master';
                try {


                    if (res.RecordTypeId != null) {
                        actionLink = type + '-' + res.RecordTypeId;
                        //actionLink = type;
                        recordTypeId = res.RecordTypeId;
                    }
                } catch (error) {
                }


                var liItem = document.createElement('li');
                liItem.setAttribute("role", "listitem");             

                var link = document.createElement('a');
                link.className = 'ebsta-search-result-item';

                if (isLeadConverted) {
                    link.href = 'Main.html?id=' + res.Id + '&action=' + actionLink + '&RecordTypeId=' + recordTypeId + '&IsConverted=' + isLeadConverted;
                } else {
                link.href = 'Main.html?id=' + res.Id + '&action=' + actionLink + '&RecordTypeId=' + recordTypeId;
                }

                link.setAttribute("sfid", res.Id);
                link.setAttribute("entity", actionLink);
                link.setAttribute("recordtypeid", recordTypeId);
                link.setAttribute("recordname", objName);

                var extrainformation = "";

                var spn1 = document.createElement('span');
                if (type == 'Contact') {
                    spn1.className = "candidate";

                    if (res.Account != null) {
                        extrainformation = ' (' + res.Account.Name + ')';
                    }
                } else if (type == 'Lead') {
                    spn1.className = "lead";
                    if (res.Company != null) {
                        extrainformation = ' (' + res.Company + ')';
                    }
                } else if (type == 'Account') {
                    spn1.className = "company";

                } else if (type == 'Opportunity') {
                    spn1.className = "opportunity";
                } else {
                    spn1.className = "customObject";
                }
                var spn2 = document.createElement('span');
                spn2.className = "detailsArrow";
                spn2.innerText = " more>";
                link.appendChild(spn1);
                var resultText = document.createTextNode(CharacterSupport(displayText + extrainformation));
                link.appendChild(resultText);
                link.appendChild(spn2);
                liItem.appendChild(link);
                liItem.appendChild(CreateIconForHoverOver(res.Id, actionLink, objName));
                listOl.appendChild(liItem);
            }

            if (resultCount == 0) {

                var liFailure = document.createElement('li');
                liFailure.setAttribute("id", "failureMessage");
                liFailure.setAttribute("class", "showMe");
                liFailure.innerText = "There are no results. Please search again.";

                listOl.appendChild(liFailure);

                var lkMsg = getParameterByName("msgLk");

            }

            var searchResplaceHolder = document.getElementById('searchResultClient');
            if (searchResplaceHolder != null) {
                searchResplaceHolder.innerHTML = '';
                searchResplaceHolder.appendChild(listOl);
            }

        }

        if (entityType.toLowerCase() == "allopentasks" || entityType.toLowerCase() == "overduetasks" || entityType.toLowerCase() == "duetodaytasks" || entityType.toLowerCase() == "todayandoverduetasks" || entityType.toLowerCase() == "duetomorrowtasks" || entityType.toLowerCase() == "next7tasks" || entityType.toLowerCase() == "next7andoverduetasks" || entityType.toLowerCase() == "thismonthtasks") {
            var taskListHtml = '';
            var limit = db.d.Values.length;
            var now = new Date();
            var activityDateCompare;
            var formattedActivityDate = "";

            var searchResplaceHolder = document.getElementById('homepageTaskInnerDiv');
            if (searchResplaceHolder != null) {
                searchResplaceHolder.innerHTML = '';
            }

            if (limit == 0) {
                var divReplace = document.createElement('div');
                divReplace.setAttribute("class", "homepagetaskdiv taskListDiv");
                divReplace.innerText = " - You have no open tasks scheduled for this period. - ";
                searchResplaceHolder.appendChild(divReplace);
            }
            else {
                for (var ots = 0; ots < limit; ots++) {

                    var jstring = db.d.Values[ots].toString();
                    var j = JSON.parse(jstring);

                    var taskId = j["Id"];

                    var taskSubject = j["Subject"];
                    var activityDate = j["ActivityDate"];
                    var tskDateSplit;

                    // if Task has no date, set it to blank.
                    if (activityDate == null || activityDate == "null") {
                        activityDate = "";
                    }
                    else { // else format it and create a Date to compare with now
                        activityDateCompare = new Date(activityDate);
                    }
                    // if the task somehow has no subject, set it to "no Text" so that there is still a click through
                    if (taskSubject.length == 0) {
                        taskSubject = " - No Subject - ";
                    }

                    var whoName = "";
                    var whatName = "";
                    var whoLink = "";
                    var whatLink = "";
                    var tryWhatName = false;
                    var shortStatus = "";

                    var whatLink1 = document.createElement('a');
                    var whoLink1 = document.createElement('a');


                    //try and get the contact the task is attached to.
                    try {
                        whoName = j["Who"]["Name"];

                        if (j["Who"]["Type"].indexOf("ts2__") != -1) {
                            whoLink1.setAttribute('class', 'setLastKnown extlink');
                            whoLink1.setAttribute('href', 'https://na15.salesforce.com/' + j["Who"]["Id"]);
                        } else {
                            whoLink1.setAttribute('class', 'referenceLink');
                            whoLink1.setAttribute('href', 'Main.html?action=LinkJumper&ObjectName=' + j["Who"]["Type"] + '&id=' + j["Who"]["Id"]);
                        }
                    } catch (error) { // if task is not assigned against a contact, set flag to try to get account the Task if for
                        tryWhatName = true;
                    }

                    if (tryWhatName == true) {
                        try {
                            whatName = j["What"]["Name"];

                            if (j["What"]["Type"].indexOf("ts2__") != -1) {
                                whatLink1.setAttribute('class', 'setLastKnown extlink');
                                whatLink1.setAttribute('href', 'https://na15.salesforce.com/' + j["What"]["Id"]);
                            } else if (j["What"]["Type"] != "Campaign") {
                                whatLink1.setAttribute('class', 'referenceLink');
                                whatLink1.setAttribute('href', 'Main.html?action=LinkJumper&ObjectName=' + j["What"]["Type"] + '&id=' + j["What"]["Id"]);
                            }
                        } catch (error) {
                            //do nothing
                        }
                    }

                    // if contact/account name is to long, substring it to display properly
                    if (whoName.length > 27) {
                        whoName = whoName.substring(0, 27) + "...";
                    }

                    if (whatName.length > 27) {
                        whatName = whatName.substring(0, 27) + "...";
                    }
                    // do the same with task status
                    if (j["Status"].toString().length > 15) {
                        shortStatus = j["Status"].toString().substring(0, 15) + "...";
                    } else {
                        shortStatus = j["Status"].toString();
                    }

                    //start building div
                    var divReplace = document.createElement('div');
                    divReplace.setAttribute("class", "homepagetaskdiv taskListDiv");

                    var span1 = document.createElement('span');
                    span1.setAttribute('class', 'leftSpanBlock');

                    var div1 = document.createElement('div');
                    div1.setAttribute('class', 'restrainDiv');

                    var a1 = document.createElement('a');
                    a1.href = 'Main.html?action=LinkJumper&ObjectName=Task&id=' + taskId;
                    a1.className = 'setLastKnown';

                    var t1 = document.createTextNode(CharacterSupport(TrimTaskSubject(taskSubject)));
                    a1.appendChild(t1);

                    div1.appendChild(a1);

                    // if high priority, add big red !
                    if (j["Priority"].toString() == "High") {
                        var span2 = document.createElement('span');
                        span2.setAttribute('class', 'hiPriTask');
                        var b1 = document.createElement('b');
                        var t2 = document.createTextNode(' !');
                        b1.appendChild(t2);
                        span2.appendChild(b1);
                        div1.appendChild(span2);
                    }

                    var br1 = document.createElement('br');
                    div1.appendChild(br1);

                    // if we have a contact name, display that, else display what we have to account
                    if (whoName.length > 0) {
                        var t3 = document.createTextNode(CharacterSupport(whoName));
                        whoLink1.appendChild(t3);
                        div1.appendChild(whoLink1);
                    } else {
                        var t4 = document.createTextNode(CharacterSupport(whatName));
                        whatLink1.appendChild(t4);
                        div1.appendChild(whatLink1);
                    }

                    // add status to html
                    var span2 = document.createElement('span');
                    span2.setAttribute('class', 'homepagemidspan');
                    var restrainDiv2 = document.createElement('div');
                    restrainDiv2.setAttribute('class', 'restrainDiv');

                    var t5 = document.createTextNode(CharacterSupport(shortStatus));
                    restrainDiv2.appendChild(t5);
                    var br3 = document.createElement('br');
                    restrainDiv2.appendChild(br3);

                    var div3 = document.createElement('div');

                    now.setHours(0);
                    now.setMinutes(0);
                    now.setSeconds(0);
                    now.setMilliseconds(0);

                    // if activity is overdue, add css to display the date as red
                    if (activityDateCompare < now) {
                        div3.setAttribute('class', 'overdueTask');
                    } else {

                    }

                    //add the date and [x] to close the task
                    var t3 = document.createTextNode(FormatDateLocal(activityDate));
                    div3.appendChild(t3);

                    restrainDiv2.appendChild(div3);
                    span1.appendChild(div1);
                    divReplace.appendChild(span1);
                    span2.appendChild(restrainDiv2);
                    divReplace.appendChild(span2);

                    var span3 = document.createElement('span');
                    span3.setAttribute('class', 'homepagerightspan');

                    var a3 = document.createElement('a');
                    a3.href = 'Main.html?action=Task-Edit&id=' + taskId + '&RecordTypeId=Master&SetClosed=1';

                    var divA = document.createElement('div');
                    divA.id = taskId;
                    divA.className = 'homepageclosetaskdiv';
                    divA.title = 'Mark ' + taskSubject + ' Complete';

                    a3.appendChild(divA);

                    span3.appendChild(a3);

                    divReplace.appendChild(span3);

                    searchResplaceHolder.appendChild(divReplace);

                }
            }
        }        

        if (entityType.toLowerCase() == "calendarsforsync") {

            var calendarList = document.createElement('div');
            calendarList.id = 'CalendarListInner';

            var calendarContainer = document.createElement('div');
            calendarContainer.id = 'CalendarListContainer';

            var displayTimeOffSetWarning = false;

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];
                var noteList = JSON.parse(fld);

                var calendarTitle = noteList.summary;
                var calendarId = noteList.id;
                var accessRole = noteList.accessRole;
                var isPrimary = noteList.primary;
                var timeZonesMatch = noteList.timeZonesMatch;

                var isSyncingToSalesforce = noteList.isSyncingToSalesforce;
                var isSyncingToGoogle = noteList.isSyncingToGoogle;

                var primaryText = '';
                var toolTip = calendarTitle;

                if (isPrimary) {
                    primaryText = ' (Primary)';
                    calendarTitle = CheckStringLength(calendarTitle, 23);
                } else if (accessRole != "owner" && accessRole != "writer") {
                    primaryText = ' (Read Only)';
                    calendarTitle = CheckStringLength(calendarTitle, 21);
                } else {
                    calendarTitle = CheckStringLength(calendarTitle, 38);
                }

                var timeZoneWarningImage = document.createElement('span');

                if (timeZonesMatch) {
                    timeZoneWarningImage.className = 'timeZoneNoWarning';
                } else {
                    timeZoneWarningImage.className = 'timeZoneWarningImage';

                    if (accessRole == "owner" || accessRole == "writer") {
                        displayTimeOffSetWarning = true;
                    }
                    
                }

                var calendarListItem = document.createElement('div');
                calendarListItem.id = calendarId;
                calendarListItem.className = 'calendarListItem';
                calendarListItem.appendChild(timeZoneWarningImage);
                calendarListItem.appendChild(document.createTextNode(CharacterSupport(calendarTitle)));
                calendarListItem.appendChild(document.createTextNode(CharacterSupport(primaryText)));
                calendarListItem.setAttribute('title', toolTip);

                var calendarCheckBoxHolder = document.createElement('div');
                calendarCheckBoxHolder.className = 'calendarCheckBox';

                var calendarSFCheckBox = document.createElement('input');
                calendarSFCheckBox.type = 'checkbox';
                calendarSFCheckBox.className = 'chkToSFValue-' + calendarId + ' calendarToSalesforceCheckValue';
                calendarSFCheckBox.setAttribute('CalendarId', calendarId);
                calendarSFCheckBox.setAttribute('IsPrimary', isPrimary);
                calendarSFCheckBox.setAttribute('AccessRole', accessRole);
                calendarSFCheckBox.setAttribute('CalendarTitle', calendarTitle);                

                var calendarGoogleCheckBox = document.createElement('input');
                calendarGoogleCheckBox.type = 'checkbox';
                calendarGoogleCheckBox.className = 'calendarToGoogleCheckValue chkToGoogleValue-' + calendarId;
                calendarGoogleCheckBox.setAttribute('CalendarId', calendarId);
                calendarGoogleCheckBox.setAttribute('IsPrimary', isPrimary);
                calendarGoogleCheckBox.setAttribute('AccessRole', accessRole);
                calendarGoogleCheckBox.setAttribute('CalendarTitle', calendarTitle);

                if (isSyncingToSalesforce) {
                    calendarSFCheckBox.checked = true;
                } else {
                    calendarSFCheckBox.checked = false;
                }

                if (isSyncingToGoogle) {
                    calendarGoogleCheckBox.checked = true;
                } else {
                    calendarGoogleCheckBox.checked = false;
                }

                var isReadOnly = false;

                if (accessRole != "owner" && accessRole != "writer") {
                    calendarGoogleCheckBox.setAttribute('disabled', 'disabled');
                    calendarGoogleCheckBox.setAttribute('title', 'Read Only');
                    isReadOnly = true;
                }

                calendarCheckBoxHolder.appendChild(calendarGoogleCheckBox);
                calendarCheckBoxHolder.appendChild(calendarSFCheckBox);
                calendarListItem.appendChild(calendarCheckBoxHolder);

                //don't give users the option to sync read only calendars.
                if (!isReadOnly) { 
                    calendarContainer.appendChild(calendarListItem);
                }
            }

            calendarList.appendChild(calendarContainer);

            var learnMoreLink = document.createElement('a');
            learnMoreLink.href = 'https://ebsta.zendesk.com/entries/51738855-How-do-I-update-my-timezone-settings-in-Salesforce-and-or-Google-Calendar-';
            learnMoreLink.target = '_blank';
            learnMoreLink.appendChild(document.createTextNode("Learn more"));            

            if (displayTimeOffSetWarning) {
                var timeZoneWarningImage2 = document.createElement('span');
                timeZoneWarningImage2.className = 'timeZoneWarningImage';

                var offSetMessage = document.createElement('div');
                offSetMessage.appendChild(timeZoneWarningImage2);
                offSetMessage.appendChild(document.createTextNode("Your calendar time zones are different. "));
                offSetMessage.appendChild(learnMoreLink);
                offSetMessage.appendChild(document.createTextNode("."));
                offSetMessage.className = 'marginTop10';

                calendarList.appendChild(offSetMessage);
            }

            var saveButton = document.createElement('button');
            saveButton.className = 'save saveCalendars';
            saveButton.appendChild(document.createTextNode('Save'));

            var saveLoaderSpan = document.createElement('span');
            saveLoaderSpan.className = 'calendarSaveLoader';

            calendarList.appendChild(saveButton);
            calendarList.appendChild(saveLoaderSpan);
            calendarList.appendChild(document.createElement('br'));

            $(".calendarListHeaders").show();
            $("#CalendarList").text('');
            $("#CalendarList").append(calendarList);

            if (!displayTimeOffSetWarning) {
                $(".timeZoneNoWarning").hide();
            }

            $("body").delegate(".saveCalendars", "click", function () {

                var calendars = $("body").find(".calendarToSalesforceCheckValue");
                var calendarsGoogle = $("body").find(".calendarToGoogleCheckValue");

                var fieldList = '[';
                fieldList = fieldList + background.GenerateEntityField("Id", localStorage.WebUserId, '', true, '');

                var calendarItemList = '[';

                var calendarCount = 0;

                calendars.each(function () {

                    var checkedValue = $(this).prop('checked');
                    var calendarId = $(this).attr("CalendarId");
                    var accessRole = $(this).attr("AccessRole");
                    var isPrimary = $(this).attr("IsPrimary");
                    var calendarTitle = $(this).attr("CalendarTitle");                    

                    var checkedValueToGoogle = '';

                    calendarsGoogle.each(function () {
                        if ($(this).attr("CalendarId") == calendarId) {
                            checkedValueToGoogle = $(this).prop('checked');
                            return false;
                        }
                    });

                    if (isPrimary == "undefined")
                    {
                        isPrimary = 'false';
                    }

                    var newItem = '{';
                    newItem = newItem + '"id": "' + calendarId + '",';
                    newItem = newItem + '"isPrimary": "' + isPrimary + '",';
                    newItem = newItem + '"isSyncingToSalesforce": "' + checkedValue + '",';
                    newItem = newItem + '"isSyncingToGoogle": "' + checkedValueToGoogle + '",';
                    newItem = newItem + '"accessRole": "' + accessRole + '",';
                    newItem = newItem + '"calendarTitle": "' + calendarTitle + '",';
                    newItem = newItem + '}';

                    if (calendarCount == 0) {
                        calendarItemList = calendarItemList + newItem;
                    } else {
                        calendarItemList = calendarItemList + ',' + newItem;
                    }

                    calendarCount++;
                });

                calendarItemList = calendarItemList + ']';

                fieldList = fieldList + ',' + background.GenerateEntityField('CalendarItems', calendarItemList, '', 'false');
                fieldList = fieldList + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
                fieldList = fieldList + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
                fieldList = fieldList + ',' + background.GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');

                fieldList = fieldList + ']';

                var strFields = JSON.stringify(fieldList);
                var tabId = localTabId.innerText;

                $(".calendarSaveLoader").html('<img src="../images/ajax-loader.gif" alt"Saving Calendars..." />');

                background.AddEntity('saveactivecalendars', strFields, tabId);
            });
        }

        if (entityType.toLowerCase() == "allopenevents" || entityType.toLowerCase() == "overdueevents" || entityType.toLowerCase() == "duetodayevents" || entityType.toLowerCase() == "todayandoverdueevents" || entityType.toLowerCase() == "duetomorrowevents" || entityType.toLowerCase() == "next7events" || entityType.toLowerCase() == "next7andoverdueevents" || entityType.toLowerCase() == "thismonthevents") {

            var eventListHtml = '';
            var limit = db.d.Values.length;

            var searchResplaceHolder = document.getElementById('homepageEventInnerDiv');
            searchResplaceHolder.innerHTML = '';


            if (limit == 0) {
                var divReplace = document.createElement('div');
                divReplace.className = 'homepageeventdiv eventListDiv';
                var t1 = document.createTextNode(' - No Events Due Today - ');
                divReplace.appendChild(t1);
                searchResplaceHolder.appendChild(divReplace);

            }
            else {
                for (var ots = 0; ots < limit; ots++) {

                    var jstring = db.d.Values[ots].toString();
                    var j = JSON.parse(jstring);


                    var eventSubject = j["Subject"];
                    // if the event somehow has no subject, set it to "no Text" so that there is still a click through
                    if (eventSubject.length == 0) {
                        eventSubject = " - No Subject - ";
                    }
                    eventSubject = CharacterSupport(eventSubject);

                    var startDateTime = j["StartDateTime"];
                    var startTime = "";
                    if (startDateTime == null || startDateTime == "null") {
                        startDateTime = "";
                    }

                    if (startDateTime.length > 0) {
                        startTime = startDateTime.split("T")[1].substring(0, 5);
                    }


                    var endDateTime = j["EndDateTime"];
                    var endTime = "";
                    if (endDateTime == null || endDateTime == "null") {
                        endDateTime = "";
                    }

                    if (endDateTime.length > 0) {
                        endTime = endDateTime.split("T")[1].substring(0, 5);
                    }

                    var whoName = "";
                    var whatName = "";
                    var whoLink = "";
                    var whatLink = "";
                    var tryWhatId = false;
                    var shortWhoName = "";
                    var shortWhatName = "";
                    var whatType = "";

                    var whatLink1 = document.createElement('a');
                    var whoLink1 = document.createElement('a');

                    try {
                        whoName = j["Who"]["Name"];

                        if (j["Who"]["Type"].indexOf("ts2__") != -1) {
                            whatLink1.href = 'https://na15.salesforce.com/' + j["Who"]["Id"];
                            whatLink1.className = 'setLastKnown extlink';
                        } else {
                            whoLink1.href = 'Main.html?action=LinkJumper&ObjectName=' + j["Who"]["Type"] + '&id=' + j["Who"]["Id"];
                            whoLink1.className = 'referenceLink';
                        }
                    }
                    catch (error) {
                        tryWhatId = true;
                    }

                    if (tryWhatId == true) {
                        try {
                            whatName = j["What"]["Name"];
                            whatType = j["What"]["Type"];

                            if (j["What"]["Type"].indexOf("ts2__") != -1) {
                                whatLink1.href = 'https://na15.salesforce.com/' + j["What"]["Id"];
                                whatLink1.className = 'setLastKnown extlink';

                            } else if (whatType != "Campaign") {
                                whatLink1.href = 'Main.html?action=LinkJumper&ObjectName=' + j["What"]["Type"] + '&id=' + j["What"]["Id"];
                                whatLink1.className = 'referenceLink';
                            }
                        }
                        catch (error) {
                            //do nothing
                        }
                    }

                    if (whoName.length > 23) {
                        shortWhoName = whoName.substring(0, 23) + "...";
                    }

                    if (whatName.length > 23) {
                        shortWhatName = whatName.substring(0, 23) + "...";
                    }

                    var allDayEvent = "";

                    try {
                        allDayEvent = j["IsAllDayEvent"];
                    } catch (error) {
                        allDayEvent = false;
                    }

                    var divReplace = document.createElement('div');
                    divReplace.className = 'homepageeventdiv eventListDiv';

                    var spanLeft = document.createElement('span');
                    spanLeft.className = 'leftSpanBlock';

                    var divRestrain1 = document.createElement('div');
                    divRestrain1.className = 'restrainDiv';

                    var anchor1 = document.createElement('a');
                    anchor1.href = 'Main.html?action=LinkJumper&ObjectName=Event&id=' + j["Id"];
                    anchor1.className = 'setLastKnown';

                    var txtAnchor1 = document.createTextNode(CharacterSupport(eventSubject));
                    anchor1.appendChild(txtAnchor1);

                    divRestrain1.appendChild(anchor1);

                    var br1 = document.createElement('br');
                    divRestrain1.appendChild(br1);

                    if (shortWhoName.length > 0) {
                        var txtAnchor = document.createTextNode(CharacterSupport(shortWhoName));
                        whoLink1.appendChild(txtAnchor);
                        divRestrain1.appendChild(whoLink1);
                    } else {
                        if (shortWhatName.length > 0) {
                            var txtAnchor = document.createTextNode(CharacterSupport(shortWhatName));
                            whatLink1.appendChild(txtAnchor);
                            divRestrain1.appendChild(whatLink1);
                        }
                        else {
                            if (whoName.length > 0) {
                                var txtAnchor = document.createTextNode(CharacterSupport(whoName));
                                whoLink1.appendChild(txtAnchor);
                                divRestrain1.appendChild(whoLink1);
                            }
                            else {
                                if (whatName.length > 0) {
                                    if (whatType == "Cadence") {
                                        var txtAnchor = document.createTextNode(CharacterSupport(whatName));
                                        divRestrain1.appendChild(txtAnchor);
                                    }
                                    else {
                                        var txtAnchor = document.createTextNode(CharacterSupport(whatName));
                                        whatLink1.appendChild(txtAnchor);
                                        divRestrain1.appendChild(whatLink1);
                                    }
                                }
                            }
                        }
                    }
                    spanLeft.appendChild(divRestrain1);
                    divReplace.appendChild(spanLeft);

                    var spanRight = document.createElement('span');
                    spanRight.className = 'rightSpanBlock';

                    var divRestrain2 = document.createElement('div');
                    divRestrain2.className = 'restrainDiv eventDate';
                    var txtDivRestrain2 = document.createTextNode(startTime + " - " + endTime);
                    divRestrain2.appendChild(txtDivRestrain2);

                    spanRight.appendChild(divRestrain2);
                    divReplace.appendChild(spanRight);

                    searchResplaceHolder.appendChild(divReplace);

                }
            }
        }


        var title = '';
        var firstname = '';
        var surname = '';
        var entityUri = '';
        var OppFound = false;

        //var loadEditDetails = localStorage.ReloadEditData;

        for (var d = 0; d < lgm.d.CrmEntities.length; d++) { // For each entity in the layout manager...


            if (lgm.d.CrmEntities[d].Name.toLowerCase() == "opportunity") {
                OppFound = true;
            }

            if (lgm.d.CrmEntities[d].Name.toLowerCase() == entityType.toLowerCase()) { // If entity being passed is current layout manager entity
                if (moveFromLinkJumper) {
                    var recordTypeId = lgm.d.CrmEntities[d].RecordTypeId;

                    var isLeadConverted = false;

                    if (entityType.toLowerCase() != "event") {
                        for (var dt = 0; dt < db.d.Values.length; dt++) {

                            if (db.d.Fields[dt].Name == "RecordTypeId") {
                                recordTypeId = db.d.Values[dt];
                            }

                            if (db.d.Fields[dt].Name == "IsConverted") {
                                isLeadConverted = db.d.Values[dt];
                            }
                        }
                    }

                    var objectId = getParameterByName("id");
                    var objectType = entityType;

                    if (recordTypeId != null && recordTypeId != '' && typeof recordTypeId != "undefined" && recordTypeId != "Master") {
                        objectType = objectType + '-' + recordTypeId;
                    }

                    // Client needs to know if this is a lead if the lead has been converted already so
                    // we'll include an extra parameter in the url for leads so we can pick this up later
                    if (entityType.toLowerCase() == "lead")
                    {
                        MoveMe('Main.html?action=' + objectType + '&id=' + objectId + '&RecordTypeId=' + recordTypeId + '&IsConverted='+isLeadConverted);
                    }
                    else
                    {
                        MoveMe('Main.html?action=' + objectType + '&id=' + objectId + '&RecordTypeId=' + recordTypeId + '');
                    }

                    moveFromLinkJumper = false;
                }
                else
                {
                    //Hide the Edit Button should the user have no access to update/edit this entity
                    if (!lgm.d.CrmEntities[d].Edit)
                    {
                        if (getParameterByName("RecordTypeId") == lgm.d.CrmEntities[d].RecordTypeId)
                        {
                            $('a.edit').hide();
                        }
                    }
                }

                let recordTypeIdParam = getParameterByName("RecordTypeId");
                if (recordTypeIdParam === "") {
                    recordTypeIdParam = "Master";
                }

                /**
                 * Before we go into setting the field values we need to make sure these Record Types match, otherwise if there are muliple
                 * record types for one object this will loop around for each record type enabled.
                 */  
                if (recordTypeIdParam !== lgm.d.CrmEntities[d].RecordTypeId) continue;

                for (var f = 0; f < lgm.d.CrmEntities[d].Fields.length; f++) { // For each field in the layout manager entity...

                    var fldLayout = lgm.d.CrmEntities[d].Fields[f]; // Get fields from layout manager entity   
                    lgm.d.CrmEntities[d].Fields[f].FieldFound = false;

                    for (var i = 0; i < db.d.Fields.length; i++) { //for each field being passed down...

                        // Crm Entities
                        var fld = db.d.Fields[i];

                        if (fld.Name == "Name") {
                            var localId = getParameterByName("id");
                            var title = "" + CharacterSupport(db.d.Values[i]);
                        }

                        if (fld.Name == 'Link') {
                            entityUri = db.d.Values[i];
                        }


                        if (fld.Name + '' == '' + fldLayout.ValueField) { // if field passed down is the same as the layout entity field we are on
                            lgm.d.CrmEntities[d].Fields[f].FieldFound = true;
                            if (fldLayout.TypeOfField == "reference") {

                                if (localAction.innerText.indexOf('-Edit') == -1) {
                                    var name = '.ref-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);
                                    var value = '' + CharacterSupport(db.d.Values[i]);
                                    var textField = fldLayout.FieldText;
                                    var pos = 0;

                                    for (var t = 0; t < db.d.Fields.length; t++) {

                                        var fld1 = db.d.Fields[t];

                                        if (fld1.Name == textField) {
                                            pos = t;
                                            break;
                                        }
                                    }

                                    //use the jumper page for links - we need to grab record type ids if possible...
                                    //var lnk = 'Main.html?action=' + fldLayout.DataSource + '&id=' + value;
                                    var lnk = '';
                                    var target = '';

                                    if (fldLayout.DataSource == "Group^User" || fldLayout.ValueField == "OwnerId") {
                                        lnk = 'https://login.salesforce.com/' + value;
                                        target = 'target="_blank"';
                                    } else {
                                        lnk = 'Main.html?action=LinkJumper&ObjectName=' + fldLayout.DataSource + '&id=' + value;
                                    }

                                    var name1 = db.d.Values[pos];
                                    // This should be reversed on release of custom objects
                                    if (fldLayout.DataSource == "Account" ^ fldLayout.DataSource == "Contact") {
                                        var a = document.createElement('a');
                                        a.href = lnk;
                                        a.className = 'referenceLink';
                                        var t = document.createTextNode(CharacterSupport(name1));
                                        a.appendChild(t);
                                        $(name).empty();
                                        $(name).append(a);
                                    } else {
                                        if (fldLayout.ValueField == "WhatId" || fldLayout.ValueField == "WhoId") {

                                            var whowhat = "";
                                            if (name1.length > 0 && fldLayout.ValueField == "WhoId") {
                                                for (var linkLooper = 0; linkLooper < db.d.Fields.length; linkLooper++) { // for each field being passed down
                                                    if (db.d.Fields[linkLooper].Name == "Who") {  // finds "who" attribute
                                                        if (db.d.Values[linkLooper].length > 0) { // if it has length, save the who/what Object type
                                                            whowhat = db.d.Values[linkLooper];
                                                        }
                                                    }
                                                }
                                            }
                                            if (name1.length > 0 && fldLayout.ValueField == "WhatId") {
                                                for (var linkLooper = 0; linkLooper < db.d.Fields.length; linkLooper++) { // for each field being passed down
                                                    if (db.d.Fields[linkLooper].Name == "What") { // finds "what" attribute
                                                        if (db.d.Values[linkLooper].length > 0) { // if it has length, save the who/what Object type
                                                            whowhat = db.d.Values[linkLooper];
                                                        }
                                                    }
                                                }
                                            }

                                            //var clickThrough = "";
                                            if (whowhat.length > 0) {
                                                var t = document.createTextNode(name1);
                                                if (whowhat.indexOf("Account") > -1 || whowhat.indexOf("Contact") > -1 || whowhat.indexOf("Lead") > -1 || whowhat.indexOf("Opportunity") > -1) {
                                                    //clickThrough = '<a href="Main.html?action=LinkJumper&ObjectName=' + whowhat + '&id=' + value + '" class="referenceLink">' + name1 + '</a>';
                                                    var a = document.createElement('a');
                                                    a.href = 'Main.html?action=LinkJumper&ObjectName=' + whowhat + '&id=' + value;
                                                    a.className = 'referenceLink';
                                                    a.appendChild(t);
                                                    $(name).empty();
                                                    $(name).append(a);
                                                }
                                                else {
                                                    //clickThrough = name1;
                                                    $(name).empty();
                                                    $(name).append(t);
                                                }
                                            } else {
                                                $(name).empty();
                                            }
                                        } else {
                                            var t = document.createTextNode(name1);
                                            if (fldLayout.DataSource != 'User' && fldLayout.ValueField != "CampaignId") {

                                                var a = document.createElement('a');
                                                a.href = lnk;
                                                a.target = '_blank';
                                                a.appendChild(t);
                                                $(name).empty();
                                                $(name).append(a);
                                            } else {
                                                if (fldLayout.ValueField == "OwnerId" && lnk.length > 0 && target.length > 0 && name1.length > 0) {
                                                    var a = document.createElement('a');
                                                    a.href = lnk;
                                                    a.target = '_blank';
                                                    a.appendChild(t);
                                                    $(name).empty();
                                                    $(name).append(a);
                                                }
                                                else {
                                                    $(name).empty();
                                                    $(name).append(t);
                                                }
                                            }
                                        }
                                    }
                                } else {

                                    // Do something else for Edit. 
                                    var nameEdit = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);
                                    var textField = fldLayout.FieldText;
                                    var nameFieldName = '.lb-' + entityType + '-' + CleanOutBadNames(textField);

                                    var pos = 0;

                                    for (var t = 0; t < db.d.Fields.length; t++) {
                                        var fld1 = db.d.Fields[t];

                                        if (db.d.Fields[t].Name == "What") {
                                            if (db.d.Values[t] != null && db.d.Values[t] != "") {
                                                $("#dd-task-WhatId").val(db.d.Values[t]);
                                            }
                                        }

                                        if (db.d.Fields[t].Name == "Who") {
                                            if (db.d.Values[t] != null && db.d.Values[t] != "") {
                                                $("#dd-task-WhoId").val(db.d.Values[t]);
                                            }
                                        }

                                        if (fld1.Name == textField) {
                                            pos = t;
                                        }
                                    }

                                    var valueEdit = '' + db.d.Values[i];
                                    var valueName = '' + db.d.Values[pos];

                                    $(nameEdit).val(valueEdit);
                                    $(nameFieldName).val(valueName);

                                    SetReadOnlyOnReference(fldLayout.ValueField);
                                }

                                if (fldLayout.ValueField == "WhatId") {
                                    var whatType = $("#dd-task-WhatId").val();
                                    $("#CoLookup-WhatId").attr("datasource", whatType);
                                    $("#TxtLookup-WhatId").attr("placeholder", whatType);
                                    $("#TxtLookup-WhatId, #CoLookup-WhatId").attr("searchlabeltext", whatType);

                                    $("body").delegate("#dd-task-WhatId", "change", function () {
                                        $("#CoLookup-WhatId").attr("datasource", $(this).val());
                                        $("#TxtLookup-WhatId").attr("placeholder", $(this).val());
                                        $("#TxtLookup-WhatId, #CoLookup-WhatId").attr("searchlabeltext", $(this).val());
                                    });
                                }

                                if (fldLayout.ValueField == "WhoId") {
                                    var whoType = $("#dd-task-WhoId").val();
                                    $("#CoLookup-WhoId").attr("datasource", whoType);
                                    $("#TxtLookup-WhoId").attr("placeholder", whoType);
                                    $("#TxtLookup-WhoId, #CoLookup-WhoId").attr("searchlabeltext", whoType);

                                    $("body").delegate("#dd-task-WhoId", "change", function () {
                                        $("#CoLookup-WhoId").attr("datasource", $(this).val());
                                        $("#TxtLookup-WhoId").attr("placeholder", $(this).val());
                                        $("#TxtLookup-WhoId, #CoLookup-WhoId").attr("searchlabeltext", $(this).val());

                                        //deactivate whatid field...
                                        if ($(this).val() == "Lead") {
                                            $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-task-WhatId").attr("disabled", true);
                                            $("#WhatId").removeClass("data");
                                        } else {
                                            $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-task-WhatId").attr("disabled", false);
                                            $("#WhatId").addClass("data");
                                        }
                                    });
                                }
                            }

                            if (fldLayout.TypeOfField == "string" || fldLayout.TypeOfField == "combobox") {

                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);

                                var value = '' + CharacterSupport(db.d.Values[i]);

                                if (emailCheck(value) == true) {
                                    var a = document.createElement('a');
                                    a.className = 'email';
                                    a.href = 'mailto:' + value;
                                    var t = document.createTextNode(value);
                                    $(name).empty();
                                    a.appendChild(t);
                                    $(name).append(a);

                                } else {
                                    $(name).text(value + ' ');
                                }


                                $(name).val(value);
                                if (fldLayout.ValueField + "" == "firstName" || fldLayout.ValueField + "" == "FirstName") {
                                    firstname = value;
                                    $('.titleFirstname').text(value);
                                }

                                if (fldLayout.ValueField + "" == "lastName" || fldLayout.ValueField + "" == "LastName") {
                                    surname = value;
                                    $('.titleSurname').text(value);
                                }


                                if (fldLayout.ValueField + "" == "name" || fldLayout.ValueField + "" == "Name") {

                                    firstname = value;
                                    surname = '';
                                }

                                // If the firstname field is blank lets look for the title field just in case there is no name field on the object
                                // If there is a name field after this then it will overwrite this value for that name value
                                if (fldLayout.ValueField + "" == "title" || fldLayout.ValueField + "" == "Title") {
                                    if (firstname.length == 0)
                                    {
                                        firstname = value;
                                    }
                                }  
                            }

                            if (fldLayout.TypeOfField == "phone") {
                                var value = '' + CharacterSupport(db.d.Values[i]);
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);

                                $(name).text(value);
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField == "boolean") {
                                var value = '' + db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);

                                $(name).text(value);
                                $(name).val(value);

                                //checkboxes do not check in edit across the board...fixed...
                                if (value == "True") {
                                    $(name).prop('checked', true);

                                    if (fldLayout.ValueField == "IsReminderSet") {
                                        $("#txt-Task-ReminderDateTime").attr("disabled", false);
                                        $("#txt-Event-ReminderDateTime").attr("disabled", false);
                                        $("#RelatedToTimePicker").attr("disabled", false);
                                    }
                                }
                            }


                            if (fldLayout.TypeOfField == "email") {
                                var value = '' + CharacterSupport(db.d.Values[i]);
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);

                                if (emailCheck(value) == true) {
                                    var a = document.createElement('a');
                                    a.className = 'email';
                                    a.href = 'mailto:' + value;
                                    var t = document.createTextNode(value);
                                    a.appendChild(t);
                                    $(name).empty();
                                    $(name).append(a);

                                } else {
                                    $(name).text(value + ' ');
                                }

                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField == "textarea") {
                                var value = '' + CharacterSupport(db.d.Values[i]);

                                // value = db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);

                                var displayValue = document.createElement('pre');

                                // aovid html elements in the editor area
                                var val = document.createTextNode(value);
                                displayValue.appendChild(val);

                                $(name).text('');
                                $(name).append(displayValue);
                                //$(name).val(value);

                                if (localAction.innerText.indexOf('-Edit') != -1) {
                                    document.getElementById('txt-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField)).value = displayValue.innerText;
                                }

                                //$(name).text(value);
                                //$(name).val(value);
                            }

                            if (fldLayout.TypeOfField == "datetime" || fldLayout.TypeOfField == "date") {
                                var value = '' + db.d.Values[i];
                                if (fldLayout.TypeOfField == "date")
                                {
                                    // Default date format comes back as dd/mm/yyyy hh:mm:ss from SelectEntity but when using javascript Date() constructor it takes values as mm/dd/yyyy or yyyy/mm/dd
                                    // So below we'll just reverse the date around so when it gets passed into FormatDateLocal it'll be in the correct format
                                    if (value.length > 10)
                                    {
                                        // We only want the dd/mm/yyyy part so we'll just take the first part and cut off the hh:mm:ss
                                        // We'll then split it up by '/' then reverse the the contents then re-join them so 11/12/2015 turns into 2015/12/11
                                        var value = value.substr(0, 10).split("/").reverse().join("/");
                                    }
                                    value = FormatDateLocal(value);
                                }
                                
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);

                                if (value.length) {
                                    var pattern = new RegExp("(\\d{2})/(\\d{2})/(\\d{4}) (\\d{2}):(\\d{2}):(\\d{2})");

                                    var parts = value.match(pattern);
                                    if (parts != null) {
                                        //var dtm = new Date(parseInt(parts[3]), parseInt(parts[2]), parseInt(parts[1]));

                                        //value = dtm.getFullYear() + "-" + dtm.getMonth() + "-" + dtm.getDate();

                                        var dtm = new Date(parseInt(parts[3]), parseInt(parts[2]) - 1, parseInt(parts[1]));

                                        value = dtm.getFullYear() + "-" + ('0' + (dtm.getMonth() + 1)).slice(-2) + "-" + dtm.getDate();

                                        value = FormatDateLocal(value);

                                        if (fldLayout.ValueField == "ReminderDateTime") {

                                            var timeValue = parts[4] + ':' + parts[5];

                                            //apply to time dropdown if in edit mode...
                                            if (localAction.innerText.indexOf('-Edit') == -1) {
                                                //only apply time if it has not already been applied
                                                if (value.indexOf("T") == -1) {
                                                    value = value + ' ' + timeValue;
                                                }
                                            } else {

                                                $("#RelatedToTimePicker").val(timeValue);

                                                if ($("#chk-Task-IsReminderSet").is(':checked')) {
                                                    $("#txt-Task-ReminderDateTime").attr("disabled", false);
                                                } else {
                                                    $("#txt-Task-ReminderDateTime").attr("disabled", true);
                                                }

                                                if ($("#chk-Event-IsReminderSet").is(':checked')) {
                                                    $("#txt-Event-ReminderDateTime").attr("disabled", false);
                                                } else {
                                                    $("#txt-Event-ReminderDateTime").attr("disabled", true);
                                                }
                                            }
                                        }

                                        if (fldLayout.ValueField == "StartDateTime") {

                                            var dtm = new Date(parseInt(parts[3]), parseInt(parts[2]) - 1, parseInt(parts[1]));

                                            value = dtm.getFullYear() + "-" + ('0' + (dtm.getMonth() + 1)).slice(-2) + "-" + dtm.getDate();

                                            value = FormatDateLocal(value);

                                            var timeValue = parts[4] + ':' + parts[5];

                                            //only add the time if it is not already there
                                            if (value.indexOf("T") == -1) {
                                                value = value + ' ' + timeValue;
                                            }
                                            //apply to time dropdown if in edit mode...
                                            if (localAction.innerText.indexOf('-Edit') != -1) {
                                                value = value.split(" ")[0];
                                                $(".TimePickerStart").val(timeValue);
                                            }
                                        }

                                        if (fldLayout.ValueField == "EndDateTime") {

                                            //var dtm = new Date(parseInt(parts[3]), parseInt(parts[2]), parseInt(parts[1]));
                                            //value = dtm.getFullYear() + "-" + dtm.getMonth() + "-" + dtm.getDate();

                                            var dtm = new Date(parseInt(parts[3]), parseInt(parts[2]) - 1, parseInt(parts[1]));

                                            value = dtm.getFullYear() + "-" + ('0' + (dtm.getMonth() + 1)).slice(-2) + "-" + dtm.getDate();

                                            value = FormatDateLocal(value);
                                            var timeValue = parts[4] + ':' + parts[5];

                                            //only add the time if it is not already there
                                            if (value.indexOf("T") == -1) {
                                                value = value + ' ' + timeValue;
                                            }
                                            //apply to time dropdown if in edit mode...
                                            if (localAction.innerText.indexOf('-Edit') != -1) {
                                                value = value.split(" ")[0];
                                                $(".TimePickerEnd").val(timeValue);
                                            }
                                        }
                                    }
                                }

                                $(name).text(value);
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField.indexOf("url") != -1) {
                                var value = '' + CharacterSupport(db.d.Values[i]);
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);

                                if (emailCheck(value) == true) {
                                    var a = document.createElement('a');
                                    a.href = value;
                                    a.className = 'email';
                                    var t = doc.createTextNode(value);
                                    a.appendChild(t);
                                    $(name).empty();
                                    $(name).append(a);

                                } else {
                                    var a = document.createElement('a');
                                    if (localAction.innerText.indexOf("-Edit") == -1) {
                                        a.className = 'extlink';
                                        var t = document.createTextNode(value);
                                        a.appendChild(t);
                                        if (value.toLowerCase().indexOf("http") == -1) {
                                            value = "http://" + value;
                                        } 
                                       a.href = value;
                                    }
                                    $(name).empty();
                                    $(name).append(a);
                                }
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField.indexOf("currency") != -1) {
                                var value = '' + db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                $(name).text(value);
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField.indexOf("percent") != -1) {
                                var value = '' + db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                $(name).text(value);
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField.indexOf("double") != -1) {
                                var value = '' + db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                $(name).text(value);
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField.indexOf("boolean") != -1) {
                                var value = '' + db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                $(name).text(value);
                                $(name).val(value);
                            }

                            if (fldLayout.TypeOfField.indexOf("int") != -1) {
                                var value = '' + db.d.Values[i];
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                $(name).text(value);
                                $(name).val(value);
                            }


                            if (fldLayout.TypeOfField == "click") {
                                var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);

                                var value = db.d.Values[i];
                                var vals = value.split("|");
                                var clickEntity = entityType;
                                if (entityType == 'Contact') {
                                    clickEntity = 'Company';
                                }

                                var a = document.createElement('a');
                                a.href = 'Main.html?id=' + vals[0] + '&action=' + clickEntity;
                                var spA = document.createElement('span');
                                spA.className = 'detailsArrow';
                                var tA = document.createText(vals[1]);
                                var tS = document.createText('more&gt;');
                                a.appendChild(tA);
                                spA.appendChild(tS);
                                $(name).empty();
                                $(name).append(a);

                                $(name).val(vals[1]);
                            }


                            if (fldLayout.TypeOfField == "picklist") {

                                if (localAction.innerText.indexOf('-Edit') != -1) {

                                    var name = '.lb-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                    var value = CharacterSupport(db.d.Values[i]);

                                    var selected = '';

                                    $(name + " option").each(function () {
                                        if ($(this).val().toLowerCase() + '' == '' + value.toLowerCase()) {

                                            selected = $(this).val();
                                        }
                                    });

                                    if (selected != '') {
                                        $(name).val(selected);
                                        $(name).change();
                                    }

                                } else {
                                    var name = '.dd-' + entityType + '-' + CleanOutBadNames(fld.Name);

                                    var value = CharacterSupport(db.d.Values[i]);
                                    var valueSelected = GetLookupValue(fldLayout.DataSource, value);

                                    $(name).text(valueSelected);
                                }
                            }

                            if (fldLayout.TypeOfField == "multipicklist") {

                                if (localAction.innerText.indexOf('-Edit') == -1) {
                                    var name = '.lm-' + entityType + '-' + CleanOutBadNames(fld.Name);
                                    var value = CharacterSupport(db.d.Values[i]);
                                    var valueStr = GetLookupMultiDetails(lgm, fldLayout.DataSource, value);

                                    $(name).text(value);

                                } else {

                                    var value = db.d.Values[i];

                                    var valueStr = GetLookupMultiDetailsForEdit(lgm, fldLayout.DataSource, value);

                                    var fid = '#' + fldLayout.ValueField;

                                    $(fid).empty();
                                    $(fid).append(valueStr);

                                    $("body").delegate(".closeTag", "click", function () {

                                        var name = $(this).attr("name");

                                        var strObject = '.tag-' + name;
                                        $(strObject).remove();
                                    });
                                }
                            }
                        } 
                    }
                    //end of layout field loop.
                }
            }
        }

        function CleanUpInvalidFields(layoutManagerFields) {

            //We are going through each field in the current layout manager. Looking for fields that we have not found in the result returned from
            //select entity. If the result is in layout manager but not in the returned result set, we have tried to look for a field that we no longer have access to
            //and thus it will be stripped from XML and not returned. We need to remove this field from display, as it will display as Loading..

            //Set that we are not in edit mode
            var isLocalActionEdit = true;

            if (localAction.innerText) {
                //Then check if we are, if so flag it. changes some of the classes we will use.
                if (localAction.innerText.indexOf('-Edit') == -1) {
                    isLocalActionEdit = false;
                }
            }

            //If we actually have layout manager fields
            if (layoutManagerFields != null && typeof layoutManagerFields != 'undefined') {
                
                for (i = 0; i < layoutManagerFields.length; i++) {

                    //We will have set a FieldFound flag when we find a match between layout manger field and returned set field - if this flag is true. 
                    //we can exit and look at the next field
                    if (layoutManagerFields[i].FieldFound) {
                        continue;
                    }

                    //If we go past this point - it means there is a field in layout manager that was not returned in the result set.

                    var currTypeOfField = "",
                        currClassPrefix = "",
                        currentFieldName = "";
                    
                    //Get the name of the current field
                    if(layoutManagerFields[i].ValueField != null && typeof layoutManagerFields[i].ValueField != 'undefined') {
                        currentFieldName = layoutManagerFields[i].ValueField;
                    }
                    
                    //Get the type of field - string, int, picklist etc (decides which class we need to use)
                    if (layoutManagerFields[i].TypeOfField != null && typeof layoutManagerFields[i].TypeOfField != 'undefined') {

                        currTypeOfField = '' + layoutManagerFields[i].TypeOfField;
   
                        //check for url, int, currency by typeofField.indexOf()
                        if (CheckForTypeFieldsByIndex(currTypeOfField)) {
                            currTypeOfField = 'wideIndexOfCheck';
                        }

                    }

                    //Sets the class that we need to use to find the field in the display layout 
                    //based on the type of field - and in cases the current edit mode setting
                    switch (currTypeOfField) {
                        
                        case "reference":
                            //If we are in edit mode
                            if (isLocalActionEdit) {
                                currClassPrefix = '.lb-'
                                break;
                            }

                            //If not
                            currClassPrefix = '.ref-';
                            break;

                        case "multipicklist":

                            //If we are in edit mode - leave picklists alone handle on click
                            if (isLocalActionEdit) {
                                currClassPrefix = '';
                                break;
                            }

                            //If we are not
                            currClassPrefix = '.lm-';
                            break;

                        case "picklist":
                            //If we are in edit mode - leave picklists alone handle on click
                            if (isLocalActionEdit) {
                                currClassPrefix = '.lb-';
                                break;
                            }

                            //If we are not
                            currClassPrefix = '.dd-';
                            break;


                        case "string":
                        case "combobox":
                        case "phone":
                        case "boolean":
                        case "email":
                        case "textarea":
                        case "datetime":
                        case "date":
                        case "click":
                        case "wideIndexOfCheck":
                            currClassPrefix = '.lb-';
                            break;
                            
                        default:
                            currClassPrefix = '';
                            break;
                    }

                    //Find the invalid field element - and find the dt (label) for it
                    var invalidFildElm = $(currClassPrefix + entityType + '-' + CleanOutBadNames(currentFieldName)),
                        invalidFildElmSibling = $(invalidFildElm).prev('dt');

                    //Hide the field and hide the related label
                    $(invalidFildElm).hide();
                    $(invalidFildElmSibling).hide();

                }

            }

        }

        //Catch all non standard objects (not Opp, Account, Lead, Contact) and put the clickable title in when viewing a record in the bubble
        if (firstname.length > 0 || surname.length > 0) {
            title = firstname + ' ' + surname;
            $(".titleCompany").text(CharacterSupport(title));
        }

        if (entityType == 'Opportunity') {

            title = firstname + ' ' + surname;

            $(".titleCompany").text(CharacterSupport(title));

            var localId = getParameterByName("id");

            if (localAction.innerText.indexOf('-Edit') == -1) {
                background.AddToRecentList('', localId, entityType, title, 1);
            }

            $("body").delegate("#LogACall", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Opportunity&Type=LogACall');
            });

            $("body").delegate("#Task", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Opportunity&Type=General');
            });

            $("body").delegate("#Event", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&title=' + title + '&entity=Opportunity&Type=General');
            });


            $("body").delegate(".addTask", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Opportunity&Type=General');
            });

            $("body").delegate(".addEvent", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&title=' + title + '&entity=Opportunity&Type=General');
            });

            $("body").delegate(".logCallTask", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Opportunity&Type=LogACall');
            });

            $("body").delegate("#ContactRoles", "click", function () {
                var id = getParameterByName("id");
                openURLNewTab('https://Login.salesforce.com/p/opp/ContactRoleEditUi/e?oppid=' + id);
            });
        }

        if (entityType == 'Contact') {

            title = firstname + ' ' + surname;

            title = CharacterSupport(title);
            
            var localId = getParameterByName("id");

            if (localAction.innerText.indexOf('-Edit') == -1) {
                ////console.log('Adding');
                //background.AddToRecentList('<a href="Main.html?action=LinkJumper&ObjectName=' + entityType + '&id=' + localId + '">' + title + '</a>', localId);
                background.AddToRecentList('', localId, entityType, title, 1);
            }

            $("body").delegate("#LogACall", "click", function () {
                var id = getParameterByName("id");

                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=LogACall');
            });

            $("body").delegate("#CallList", "click", function () {
                var id = getParameterByName("id");

                var callListUrl = "https://tr1." + lgm.d.DataUrl.substring(lgm.d.DataUrl.indexOf("//") + 2, lgm.d.DataUrl.indexOf("salesforce.com")) + "visual.force.com/apex/CallListManager?ConId=" + id + "&retURL=/" + id;

                openURLNewTab(callListUrl);

            });

            if (OppFound) {
                $("body").delegate("#Opp", "click", function () {
                    var id = getParameterByName("id");
                    var accountId = "Empty";
                    var accountName = "Empty";
                    for (var t = 0; t < db.d.Fields.length; t++) {

                        if (db.d.Fields[t].Name == "AccountId") {
                            accountId = db.d.Values[t];

                            if (accountId.length == 0) {
                                accountId = "Empty";
                            }
                        }

                        if (db.d.Fields[t].Name == "Account.Name") {
                            accountName = CharacterSupport(db.d.Values[t]);
                            accountName = encodeURIComponent(accountName);
                            if (accountName.length == 0) {
                                accountName = "Empty";
                            }
                        }


                    }
                    MoveMe('Main.html?action=Opportunity-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=Opportunity&Parse=No&AccountId=' + accountId + '&AccountName=' + accountName);
                });
            } else {
                $("#Opp").hide();
            }

            $("body").delegate("#Note", "click", function () {
                var id = getParameterByName("id");

                MoveMe('Main.html?action=Note-Add&id=' + id + '&title=' + title + '&entity=Contact');
            });

            $("body").delegate(".addNote", "click", function () {
                var id = getParameterByName("id");

                MoveMe('Main.html?action=Note-Add&id=' + id + '&title=' + title + '&entity=Contact');
            });

            $("body").delegate("#Task", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=General');
            });

            $("body").delegate("#Event", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=General');
            });

            $("body").delegate(".addTask", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=General');
            });

            $("body").delegate(".addEvent", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=General');
            });

            $("body").delegate(".logCallTask", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Contact&Type=LogACall');
            });


            $("body").delegate("#Campaign, .campaignadd", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Campaign-Add&id=' + id + '&entity=Contact&title=' + title + '&company=false');
            });


            $("body").delegate("#Campaign", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Campaign-Add&id=' + id + '&entity=Contact&title=' + title + '&company=false');
            });

            $("body").delegate("#Attach", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=File-Add&id=' + id + '&entity=Contact&title=' + title);
            });

            $("body").delegate("#btEdit", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Contact-Edit&id=' + id);
            });

            //$("body").delegate(".edit", "click", function () {

            //    var id = getParameterByName("id");
            //    MoveMe('Main.html?action=Contact-Edit&id=' + id);
            //});       
        }


        if (entityType == 'Lead') {

            title = firstname + ' ' + surname;

            //title = CharacterSupport(title);
            
            var localId = getParameterByName("id");

            if (localAction.innerText.indexOf('-Edit') == -1) {
                //background.AddToRecentList('<a href="Main.html?action=LinkJumper&ObjectName=' + entityType + '&id=' + localId + '">' + title + '</a>', localId);
               background.AddToRecentList('', localId, entityType, title, 1);
            }

            $("body").delegate("#LogACall", "click", function () {
                var id = getParameterByName("id");

                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Lead&Type=LogACall');
            });


            $("body").delegate(".logCallTask", "click", function () {
                var id = getParameterByName("id");

                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Lead&Type=LogACall');
            });


            $("body").delegate("#Task", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Lead&Type=General');
            });

            $("body").delegate("#Event", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&title=' + title + '&entity=Lead&Type=General');
            });

            $("body").delegate(".addTask", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Lead&Type=General');
            });

            $("body").delegate(".addEvent", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&title=' + title + '&entity=Lead&Type=General');
            });

            $("body").delegate("#Campaign", "click", function () {

                var id = getParameterByName("id");
                MoveMe('Main.html?action=Campaign-Add&id=' + id + '&entity=Lead&title=' + title + '&company=false');
            });


            $("body").delegate("#Campaign", "click", function () {

                var id = getParameterByName("id");
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-Campaign-Add', '1']);
                MoveMe('Main.html?action=Campaign-Add&id=' + id + '&entity=Lead&title=' + title + '&company=false');
            });


            $("body").delegate("#btEdit", "click", function () {

                var id = getParameterByName("id");
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-Edit', '1']);
                MoveMe('Main.html?action=Lead-Edit&id=' + id);
            });

            //$("body").delegate(".edit", "click", function () {

            //    var id = getParameterByName("id");
            //    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Link-AFContact-Edit', '1']);
            //    MoveMe('Main.html?action=Lead-Edit&id=' + id);
            //});

            $("body").undelegate(".entityclick", "click");
            $("body").delegate(".entityclick", "click", function () {
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-OpenExternal', '1']);

                openURL(entityUri);
            });
        }

        if (entityType == 'Account') {

            title = firstname + ' ' + surname;

            //title = CharacterSupport(title);
            
            var localId = getParameterByName("id");

            if (localAction.innerText.indexOf('-Edit') == -1) {
                //background.AddToRecentList('<a href="Main.html?action=LinkJumper&ObjectName=' + entityType + '&id=' + localId + '">' + title + '</a>', localId);
               background.AddToRecentList('', localId, entityType, title, 1);
            }

            if (OppFound) {
                $("body").delegate("#Opp", "click", function () {
                    var id = getParameterByName("id");

                    MoveMe('Main.html?action=Opportunity-Add&AccountId=' + id + '&title=' + title + '&entity=Account&Type=Opportunity&Parse=No');
                });
            } else {
                $("#Opp").hide();
            }

            $("body").delegate("#ContactAdd, .contactadd", "click", function () {
                var id = getParameterByName("id");

                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-Load-Add', '1']);
                MoveMe('Main.html?action=Contact-Add&id=' + id + '&title=' + title + '&company=true');
            });

            $("body").delegate("#ConntactAdd, .contactadd", "click", function () {
                var id = getParameterByName("id");

                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-Load-Add', '1']);
                MoveMe('Main.html?action=Contact-Add&id=' + id + '&title=' + title + '&company=true');
            });

            $("body").delegate(".addContact", "click", function () {
                var id = getParameterByName("id");

                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-Load-Add', '1']);
                MoveMe('Main.html?action=Contact-Add&id=' + id + '&title=' + title + '&company=true');
            });

            $("body").delegate("#LogACall", "click", function () {
                var id = getParameterByName("id");

                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-Task-Add', '1']);
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Account&Type=LogACall');
            });

            $("body").delegate("#Task", "click", function () {

                var id = getParameterByName("id");
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-Task-Add', '1']);
                MoveMe('Main.html?action=Task-Add&id=' + id + '&entity=Account&title=' + title + '&company=false');
            });

            $("body").delegate("#Event", "click", function () {

                var id = getParameterByName("id");
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-Event-Add', '1']);
                MoveMe('Main.html?action=Event-Add&id=' + id + '&entity=Account&title=' + title + '&company=false');
            });

            $("body").delegate(".addTask", "click", function () {

                var id = getParameterByName("id");
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-Task-Add', '1']);
                MoveMe('Main.html?action=Task-Add&id=' + id + '&entity=Account&title=' + title + '&company=false');
            });

            $("body").delegate(".addEvent", "click", function () {
                var id = getParameterByName("id");
                MoveMe('Main.html?action=Event-Add&id=' + id + '&entity=Account&title=' + title + '&company=false');
            });

            $("body").delegate(".logCallTask", "click", function () {
                var id = getParameterByName("id");

                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-SFContact-Task-Add', '1']);
                MoveMe('Main.html?action=Task-Add&id=' + id + '&title=' + title + '&entity=Account&Type=LogACall');
            });

            if (OppFound) {
                $("body").delegate(".addOpportunity", "click", function () {
                    var id = getParameterByName("id");
                    MoveMe('Main.html?action=Opportunity-Add&AccountId=' + id + '&title=' + title + '&entity=Account&Type=Opportunity');
                });
            } else {
                $(".addOpportunity").hide();
            }


            //        $("body").delegate("#Attach", "click", function () {
            //            
            //            var id = getParameterByName("id");
            //            //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Contact-File-Add', '1']);
            //            MoveMe('Main.html?action=File-Add&id=' + id + '&entity=Acc&title=' + title);
            //        });

            $("body").delegate("#btEdit", "click", function () {

                var id = getParameterByName("id");
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Account-Edit', '1']);
                MoveMe('Main.html?action=Account-Edit&id=' + id);
            });

            //$("body").delegate(".edit", "click", function () {

            //    var id = getParameterByName("id");
            //    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Link-Account-Edit', '1']);
            //    MoveMe('Main.html?action=Account-Edit&id=' + id);
            //});

            $("body").undelegate(".entityclick", "click");
            $("body").delegate(".entityclick", "click", function () {
                openURL(entityUri);
            });
        }

        if (entityType == 'taskaccountopen') {
            var buildView = DisplayWidgetTasks(db, lgm);


            var taskAccountOpen = document.getElementById('taskaccountopen');
            if (taskAccountOpen != null) {
                taskAccountOpen.innerHTML = '';
                taskAccountOpen.appendChild(buildView);
            }
        }

        if (entityType == 'taskopportunityopen') {
            var buildView = DisplayWidgetTasks(db, lgm);

            var taskOpportunityOpen = document.getElementById('taskopportunityopen');
            taskOpportunityOpen.innerHTML = '';
            taskOpportunityOpen.appendChild(buildView);
        }

        if (entityType == 'opportunityaccount') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Opportunities (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('opportunityCount');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                //var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                //var buildLink = 'Main.html?action=LinkJumper&ObjectName=Opportunity&id=' + noteList.Id;

                var closeDate = noteList.CloseDate;

                if (typeof closeDate == "undefined") {
                    closeDate = 'N/A';
                }

                var amount = noteList.Amount;

                if (typeof amount == "undefined") {
                    amount = 'N/A';
                }

                var link = 'Main.html?action=LinkJumper&ObjectName=Opportunity&id=' + noteList.Id;
                //link = '<a href="' + link + '">' + noteList.Name + '</a>';
                if (!OppFound) {
                    link = '' + noteList.Name;
                }

                var linkObject = document.createElement('a');
                linkObject.href = link;
                linkObject.appendChild(document.createTextNode(CharacterSupport(noteList.Name)));

                var noteListDiv = document.createElement('div');
                noteListDiv.className = 'noteListDiv';

                var opportunityIconSpan = document.createElement('span');
                opportunityIconSpan.className = 'opportunity listIconFormat';

                var leftSpanBlockOpp = document.createElement('span');
                leftSpanBlockOpp.className = 'leftSpanBlockOpp';

                var rightSpanBlockOpp = document.createElement('span');
                rightSpanBlockOpp.className = 'rightSpanBlockOpp';

                var restrainLeft = document.createElement('div');
                restrainLeft.className = 'restrainDiv';

                var restrainRight = document.createElement('div');
                restrainRight.className = 'restrainDiv';

                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');

                restrainLeft.appendChild(linkObject);
                restrainLeft.appendChild(lineBreak);
                restrainLeft.appendChild(document.createTextNode('Close Date: ' + closeDate));
                leftSpanBlockOpp.appendChild(restrainLeft);

                restrainRight.appendChild(document.createTextNode('Stage: ' + CharacterSupport(noteList.StageName)));
                restrainRight.appendChild(lineBreak2);
                restrainRight.appendChild(document.createTextNode('Amount: ' + amount));
                rightSpanBlockOpp.appendChild(restrainRight);

                noteListDiv.appendChild(opportunityIconSpan);
                noteListDiv.appendChild(leftSpanBlockOpp);
                noteListDiv.appendChild(rightSpanBlockOpp);

                buildView.appendChild(noteListDiv);

                //buildView = buildView + '<dt>' + noteList.StageName + '<sub>' + noteList.CreatedDate + '</sub></dt><dd href="' + buildLink + '" class="itemLink objectLink">' + noteList.Name + '</dd>';
                //buildView = buildView + '<div class="noteListDiv"><span class="opportunity listIconFormat"> </span><span class="leftSpanBlockOpp"><div class="restrainDiv">' + link + '<br/>Close Date: ' + closeDate + '</div></span><span class="rightSpanBlockOpp"><div class="restrainDiv">Stage: ' + noteList.StageName + '<br />Amount: ' + amount + '</div></span></div>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('opportunityaccount');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'contactopportunity') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Contact Roles (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('contactCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                //var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                var buildLink = 'Main.html?action=LinkJumper&ObjectName=Contact&id=' + noteList.Contact.Id;

                var contactRoleRecord = document.createElement('div');
                contactRoleRecord.className = 'contactRoleRecord';

                var candidateIcon = document.createElement('span');
                candidateIcon.className = 'candidateIcon';

                var linkSpan = document.createElement('span');
                linkSpan.className = 'itemLink objectLink';

                var roleRightSpan = document.createElement('span');
                roleRightSpan.className = 'right roleRight';

                linkSpan.setAttribute('href', buildLink);
                linkSpan.appendChild(document.createTextNode(CharacterSupport(noteList.Contact.Name)));

                roleRightSpan.appendChild(document.createTextNode('Role: ' + CharacterSupport(noteList.Role)));

                contactRoleRecord.appendChild(candidateIcon);
                contactRoleRecord.appendChild(linkSpan);
                contactRoleRecord.appendChild(roleRightSpan);

                buildView.appendChild(contactRoleRecord);

                //buildView = buildView + '<div class="contactRoleRecord"><span class="candidateIcon"> </span><span href="' + buildLink + '" class="itemLink objectLink">' + noteList.Contact.Name + '</span><span class="right roleRight">Role: &nbsp;&nbsp;&nbsp;' + noteList.Role + '</span></div>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('contactopportunity');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }


        if (entityType == 'opportunitycontact') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Opportunities (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('opportunityCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                //var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                var buildLink = 'Main.html?action=LinkJumper&ObjectName=Opportunity&id=' + noteList.Opportunity.Id;

                var closeDate = noteList.Opportunity.CloseDate;

                if (typeof closeDate == "undefined") {
                    closeDate = 'N/A';
                }

                var amount = noteList.Opportunity.Amount;

                if (typeof amount == "undefined") {
                    amount = 'N/A';
                }


                var noteListDiv = document.createElement('div');
                noteListDiv.className = 'noteListDiv';

                var opportunityIcon = document.createElement('span');
                opportunityIcon.className = 'opportunity listIconFormat';

                var leftSpanBlockOpp = document.createElement('span');
                leftSpanBlockOpp.className = 'leftSpanBlockOpp';

                var rightSpanBlockOpp = document.createElement('span');
                rightSpanBlockOpp.className = 'rightSpanBlockOpp';

                var restrainLeft = document.createElement('div');
                restrainLeft.className = 'restrainDiv';

                var restrainRight = document.createElement('div');
                restrainRight.className = 'restrainDiv';

                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');

                var oppLink = document.createElement('a');
                oppLink.href = 'Main.html?action=LinkJumper&ObjectName=Opportunity&id=' + noteList.Opportunity.Id;
                oppLink.appendChild(document.createTextNode(CharacterSupport(noteList.Opportunity.Name)));

                var roleRightSpan = document.createElement('span');
                roleRightSpan.className = 'right roleRight';

                //left span...

                restrainLeft.appendChild(oppLink);
                restrainLeft.appendChild(lineBreak);
                restrainLeft.appendChild(document.createTextNode('Close Date: ' + closeDate));
                leftSpanBlockOpp.appendChild(restrainLeft);

                //right span...
                restrainRight.appendChild(document.createTextNode('Stage: ' + CharacterSupport(noteList.Opportunity.StageName)));
                restrainRight.appendChild(document.createTextNode(lineBreak2));
                restrainRight.appendChild(document.createTextNode('Amount: ' + amount));

                noteListDiv.appendChild(opportunityIcon);
                noteListDiv.appendChild(leftSpanBlockOpp);
                noteListDiv.appendChild(rightSpanBlockOpp);

                buildView.appendChild(noteListDiv);

                //buildView = buildView + '<dt>' + noteList.StageName + '<sub>' + noteList.CreatedDate + '</sub></dt><dd href="' + buildLink + '" class="itemLink objectLink">' + noteList.Name + '</dd>';
                //buildView = buildView + '<div class="noteListDiv"><span class="opportunity listIconFormat"> </span><span class="leftSpanBlockOpp"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Opportunity&id=' + noteList.Opportunity.Id + '">' + noteList.Opportunity.Name + '</a><br/>Close Date: ' + closeDate + '</div></span><span class="rightSpanBlockOpp"><div class="restrainDiv">Stage: ' + noteList.Opportunity.StageName + '<br />Amount: ' + amount + '</div></span></div>';

                //buildView = buildView + '<div class="contactRoleRecord"><span class="candidateIcon"> </span><span href="' + buildLink + '" class="itemLink objectLink">' + noteList.Opportunity.Name + '</span><span class="right roleRight">Role: &nbsp;&nbsp;&nbsp;' + noteList.Role + '</span></div>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('opportunitycontact');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'taskaccountclosed') {

            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Activities History (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('activitySFHistoryCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            buildView = document.createElement('dl');

            var popupDiv = '';

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                //var buildLink = 'Main.html?action=Task&id=' + noteList.Id;

                var subject = '';
                var status = '';
                var activityDate = '';
                var popupTriggerClass = '';
                var contact = 'N/A';

                if (noteList.Subject == null || noteList.Subject == '') {
                    subject = 'N/A';
                } else {
                    subject = noteList.Subject;
                }

                if (noteList.ActivityDate == null || noteList.ActivityDate == '') {
                    activityDate = '';
                } else {
                    activityDate = noteList.ActivityDate;
                }

                if (noteList.Status == null || noteList.Status == '') {
                    status = 'N/A';
                } else {
                    status = noteList.Status;
                }

                //if (noteList.Subject == null || noteList.Subject == '') {
                //    popupTriggerClass = '';
                //} else {
                //    popupTriggerClass = 'popupTrigger';
                //}

                //var popupFooterLinks = '<div style="margin-top: 10px;"><a href="https://login.salesforce.com/" target="_blank" class="pointer popupFooterLink">View in Salesforce >>></a></div>';
                //var popupFooterLinks = '<div style="margin-top: 10px;"></div>';

                var subject = noteList.Subject;

                if (subject == '') {
                    subject = 'View Activity';
                }

                //are we an event or a task...
                if (noteList.attributes.type == "Event") {
                    var startTime = new Date(noteList.StartDateTime);
                    var endTime = new Date(noteList.EndDateTime);

                    var startSplit = startTime.toTimeString().split(':');
                    var endSplit = endTime.toTimeString().split(':');

                    var taskListDiv = document.createElement('div');
                    taskListDiv.className = 'homepagetaskdiv taskListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown';
                    objectLink.appendChild(document.createTextNode(TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak2);
                    restrainLeft.appendChild(document.createTextNode(CharacterSupport(noteList.Owner.Name)));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(activityDate)));
                    restrainRight.appendChild(lineBreak);
                    restrainRight.appendChild(document.createTextNode(startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1]));
                    rightSpanBlock.appendChild(restrainRight);

                    taskListDiv.appendChild(leftSpanBlock);
                    taskListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(taskListDiv);

                    //buildView = buildView + '<div class="homepagetaskdiv taskListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + FormatDateLocal(activityDate) + '<br />' + startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1] + '</div></span></div>';
                } else {

                    var noteListDiv = document.createElement('div');
                    noteListDiv.className = 'noteListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown';
                    objectLink.appendChild(document.createTextNode(TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak);
                    restrainLeft.appendChild(document.createTextNode(CharacterSupport(noteList.Owner.Name)));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(CharacterSupport(noteList.Status)));
                    restrainRight.appendChild(lineBreak2);
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(activityDate)));
                    rightSpanBlock.appendChild(restrainRight);

                    noteListDiv.appendChild(leftSpanBlock);
                    noteListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(noteListDiv);

                    //buildView = buildView + '<div class="noteListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + noteList.Status + '<br />' + FormatDateLocal(activityDate) + '</div></span></div>';
                }
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('taskaccountclosed');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'taskopportunityclosed') {

            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Activities History (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('closedtaskCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            buildView = document.createElement('dl');

            var popupDiv = '';

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                //var buildLink = 'Main.html?action=Task&id=' + noteList.Id;

                var subject = '';
                var status = '';
                var activityDate = '';
                var popupTriggerClass = '';
                var contact = 'N/A';

                if (noteList.Subject == null || noteList.Subject == '') {
                    subject = 'N/A';
                } else {
                    subject = noteList.Subject;
                }

                if (noteList.ActivityDate == null || noteList.ActivityDate == '') {
                    activityDate = '';
                } else {
                    activityDate = noteList.ActivityDate;
                }

                if (noteList.Status == null || noteList.Status == '') {
                    status = 'N/A';
                } else {
                    status = noteList.Status;
                }

                //if (noteList.Subject == null || noteList.Subject == '') {
                //    popupTriggerClass = '';
                //} else {
                //    popupTriggerClass = 'popupTrigger';
                //}

                var subject = noteList.Subject;

                if (subject == '') {
                    subject = 'View Activity';
                }

                var popupFooterLinks = '<div style="margin-top: 10px;"></div>';

                //popupDiv = '<div id="' + noteList.Id + '" class="hidden popupElement"><div class="popupbody"><h5>Task Information <a class="closePopupLink pointer" popupName="' + noteList.Id + '">&nbsp;</a><div class="clearer"></div></h5><p class="minititle">Subject</p><p>' + subject + '</p><p class="minititle">Due Date Only</p><p>' + activityDate + '</p><p class="minititle">Status</p><p>' + status + '</p>' + popupFooterLinks + '</div></div>';

                //are we an event or task...
                if (noteList.attributes.type == "Event") {
                    var startTime = new Date(noteList.StartDateTime);
                    var endTime = new Date(noteList.EndDateTime);

                    var startSplit = startTime.toTimeString().split(':');
                    var endSplit = endTime.toTimeString().split(':');

                    var taskListDiv = document.createElement('div');
                    taskListDiv.className = 'homepagetaskdiv taskListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown';
                    objectLink.appendChild(document.createTextNode(TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak2);
                    restrainLeft.appendChild(document.createTextNode(CharacterSupport(noteList.Owner.Name)));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(activityDate)));
                    restrainRight.appendChild(lineBreak);
                    restrainRight.appendChild(document.createTextNode(startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1]));
                    rightSpanBlock.appendChild(restrainRight);

                    taskListDiv.appendChild(leftSpanBlock);
                    taskListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(taskListDiv);

                    //buildView = buildView + '<div class="homepagetaskdiv taskListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + FormatDateLocal(activityDate) + '<br />' + startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1] + '</div></span></div>';
                } else {
                    var noteListDiv = document.createElement('div');
                    noteListDiv.className = 'noteListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown';
                    objectLink.appendChild(document.createTextNode(TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak);
                    restrainLeft.appendChild(document.createTextNode(CharacterSupport(noteList.Owner.Name)));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(CharacterSupport(noteList.Status)));
                    restrainRight.appendChild(lineBreak2);
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(activityDate)));
                    rightSpanBlock.appendChild(restrainRight);

                    noteListDiv.appendChild(leftSpanBlock);
                    noteListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(noteListDiv);

                    //buildView = buildView + '<div class="noteListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + noteList.Status + '<br />' + FormatDateLocal(activityDate) + '</div></span></div>';
                }
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('taskopportunityclosed');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'taskcontactopen') {
            var buildView = DisplayWidgetTasks(db, lgm);

            var taskContactOpen = document.getElementById('taskcontactopen');
            taskContactOpen.innerHTML = '';
            taskContactOpen.appendChild(buildView);
        }

        if (entityType == 'taskcontactclosed') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Activities History (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('closedtaskCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                //var buildLink = 'Main.html?action=Task&id=' + noteList.Id;

                var subject = noteList.Subject;

                if (subject == '') {
                    subject = 'View Activity';
                }

                var listItemDate = noteList.ActivityDate;
                var activityDate = noteList.ActivityDate;
                if (listItemDate == null) {
                    listItemDate = '';
                }
                //are we an event or a task...
                if (noteList.attributes.type == "Event") {

                    var taskListDiv = document.createElement('div');
                    taskListDiv.className = 'homepagetaskdiv taskListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';


                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown';
                    objectLink.appendChild(document.createTextNode("" + TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak2);
                    restrainLeft.appendChild(document.createTextNode(noteList.Owner.Name));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(listItemDate)));
                    restrainRight.appendChild(lineBreak);

                    //Create the time values using the data given as the hard work has been done in the backend
                    var timeString = GetTimeFromDateTimeValue(noteList.StartDateTime) + "-" + GetTimeFromDateTimeValue(noteList.EndDateTime);
                    restrainRight.appendChild(document.createTextNode(timeString));

                    rightSpanBlock.appendChild(restrainRight);

                    taskListDiv.appendChild(leftSpanBlock);
                    taskListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(taskListDiv);

                    //buildView = buildView + '<div class="homepagetaskdiv taskListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + FormatDateLocal(listItemDate) + '<br />' + startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1] + '</div></span></div>';
                } else {

                    var noteListDiv = document.createElement('div');
                    noteListDiv.className = 'noteListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown';
                    objectLink.appendChild(document.createTextNode("" + TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak);
                    restrainLeft.appendChild(document.createTextNode(noteList.Owner.Name));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode("" + noteList.Status));
                    restrainRight.appendChild(lineBreak2);
                    restrainRight.appendChild(document.createTextNode("" + FormatDateLocal(listItemDate)));
                    rightSpanBlock.appendChild(restrainRight);
                    noteListDiv.appendChild(leftSpanBlock);
                    noteListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(noteListDiv);

                    //buildView = buildView + '<div class="noteListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + noteList.Status + '<br />' + FormatDateLocal(listItemDate) + '</div></span></div>';
                }
            }

            //buildView = buildView + '</dl>';
            var renderArea = document.getElementById('taskcontactclosed');
            if (renderArea != null) {
                renderArea.innerHTML = '';
                renderArea.appendChild(buildView);
            }
        }

        if (entityType == 'taskleadopen') {
            var buildView = DisplayWidgetTasks(db, lgm);

            var taskLeadOpen = document.getElementById('taskleadopen');
            taskLeadOpen.innerHTML = '';
            taskLeadOpen.appendChild(buildView);
        }

        if (entityType == 'taskleadclosed') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Activities History (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('closedtaskCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var buildLink = lgm.d.DataUrl + "/" + noteList.Id;
                //var buildLink = 'Main.html?action=Task&id=' + noteList.Id;

                var subject = noteList.Subject;

                if (subject == '') {
                    subject = 'View Activity';
                }

                var listItemDate = noteList.ActivityDate;

                if (listItemDate == null) {
                    listItemDate = '';
                }

                //are we an event or a task...
                if (noteList.attributes.type == "Event") {
                    var startTime = new Date(noteList.StartDateTime);
                    var endTime = new Date(noteList.EndDateTime);

                    var startSplit = startTime.toTimeString().split(':');
                    var endSplit = endTime.toTimeString().split(':');

                    var taskListDiv = document.createElement('div');
                    taskListDiv.className = 'homepagetaskdiv taskListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown ebsta-homepage-select-task';
                    objectLink.appendChild(document.createTextNode(TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak2);
                    restrainLeft.appendChild(document.createTextNode(noteList.Owner.Name));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(listItemDate)));
                    restrainRight.appendChild(lineBreak);
                    restrainRight.appendChild(document.createTextNode(startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1]));
                    rightSpanBlock.appendChild(restrainRight);

                    taskListDiv.appendChild(leftSpanBlock);
                    taskListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(taskListDiv);

                    //buildView = buildView + '<div class="homepagetaskdiv taskListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + FormatDateLocal(listItemDate) + '<br />' + startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1] + '</div></span></div>';
                } else {
                    var noteListDiv = document.createElement('div');
                    noteListDiv.className = 'noteListDiv';

                    var leftSpanBlock = document.createElement('span');
                    leftSpanBlock.className = 'leftSpanBlock';

                    var rightSpanBlock = document.createElement('span');
                    rightSpanBlock.className = 'rightSpanBlock';

                    var restrainLeft = document.createElement('dev');
                    restrainLeft.className = 'restrainDiv';

                    var restrainRight = document.createElement('dev');
                    restrainRight.className = 'restrainDiv';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id;
                    objectLink.className = 'setLastKnown ebsta-homepage-select-task';
                    objectLink.appendChild(document.createTextNode(TrimTaskSubject(subject)));

                    var lineBreak = document.createElement('br');
                    var lineBreak2 = document.createElement('br');

                    //left span...
                    restrainLeft.appendChild(objectLink);
                    restrainLeft.appendChild(lineBreak);
                    restrainLeft.appendChild(document.createTextNode(CharacterSupport(noteList.Owner.Name)));
                    leftSpanBlock.appendChild(restrainLeft);

                    //right span...
                    restrainRight.appendChild(document.createTextNode(CharacterSupport(noteList.Status)));
                    restrainRight.appendChild(lineBreak2);
                    restrainRight.appendChild(document.createTextNode(FormatDateLocal(listItemDate)));
                    rightSpanBlock.appendChild(restrainRight);

                    noteListDiv.appendChild(leftSpanBlock);
                    noteListDiv.appendChild(rightSpanBlock);

                    buildView.appendChild(noteListDiv);

                    //buildView = buildView + '<div class="noteListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Task&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a><br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock"><div class="restrainDiv">' + noteList.Status + '<br />' + FormatDateLocal(listItemDate) + '</div></span></div>';
                }
            }

            //buildView = buildView + '</dl>';


            var renderArea = document.getElementById('taskleadclosed');
            if (renderArea != null) {
                renderArea.innerHTML = '';
                renderArea.appendChild(buildView);
            }
        }

        if (entityType == 'accountcontacts') {

            var accordionText = document.createTextNode('Contacts (' + db.d.Values.length + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('contactContacts');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            var htmlStr = document.createElement('ol');
            htmlStr.id = 'allLogins';
            htmlStr.className = 'itemList3';

            //var htmlStr = '<ol id="allLogins" class="itemList3">';

            for (var dt = 0; dt < db.d.Values.length; dt++) {

                var res = JSON.parse(db.d.Values[dt]);

                if (res.Id + '' != 'null') {

                    var strTitle = '';

                    if (res.Title != null) {
                        strTitle = '(' + res.Title + ')';
                    }

                    var listItem = document.createElement('li');
                    listItem.setAttribute('role', 'listitem');
                    listItem.className = 'contact';

                    var candidateIcon = document.createElement('span');
                    candidateIcon.className = 'candidateIcon';

                    var objectLink = document.createElement('a');
                    objectLink.href = 'Main.html?id=' + res.Id + '&action=LinkJumper&ObjectName=Contact';
                    objectLink.appendChild(document.createTextNode(CharacterSupport(res.FirstName + ' ' + res.LastName + ' ' + strTitle)));

                    listItem.appendChild(candidateIcon);
                    listItem.appendChild(objectLink);
                    htmlStr.appendChild(listItem);

                    //htmlStr = htmlStr + '<li role="listitem" class="contact"><span class="candidateIcon"> </span><a href="Main.html?id=' + res.Id + '&action=LinkJumper&ObjectName=Contact">' + res.FirstName + ' ' + res.LastName + ' ' + strTitle + '</a></li>';
                }

            }

            //htmlStr += '</ol>';

            var renderArea = document.getElementById('accountcontacts');
            renderArea.innerHTML = '';
            renderArea.appendChild(htmlStr);

            return;
        }

        if (entityType == 'topicsuggestionsafterpost') {
            if (db.d.Values.length > 0) {

                var topicLinkList = document.getElementById('SuggestionsAfterPost');
                topicLinkList.innerText = '';

                for (var dt = 0; dt < db.d.Values.length; dt++) {

                    var res = JSON.parse(db.d.Values[dt]);
                    var existingTopic = res.existingTopic;

                    if (dt > 0) {
                        topicLinkList.appendChild(document.createTextNode(', '));
                    }

                    var newTopicLink2 = document.createElement('a');

                    if (existingTopic != null) {                        
                        //newTopicLink2.href = lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=' + existingTopic.id;
                        newTopicLink2.className = 'postTopicLink' + dt;
                        newTopicLink2.setAttribute('topicId', existingTopic.id);
                        newTopicLink2.setAttribute('topicName', CharacterSupport(existingTopic.name));
                        newTopicLink2.appendChild(document.createTextNode(RenderSpecialCharacters(existingTopic.name)));

                        topicLinkList.appendChild(newTopicLink2);
                    } else {
                        //newTopicLink2.href = lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=newtopic';
                        newTopicLink2.className = 'postTopicLink' + dt;
                        newTopicLink2.setAttribute('topicId', 'newtopic');
                        newTopicLink2.setAttribute('topicName', CharacterSupport(res.name));
                        newTopicLink2.appendChild(document.createTextNode(RenderSpecialCharacters(res.name)));
                        topicLinkList.appendChild(newTopicLink2);
                    }                    
                   
                    var postSectionId = $("#TopicEditorId").val();
                    var msgText = document.getElementById("postTextId-" + postSectionId);

                    $("body").undelegate(".postTopicLink" + dt, "click");
                    $("body").delegate(".postTopicLink" + dt, "click", function () {
                        $(".postSuggestionContainer").hide();

                        DisplayTopicManager(postSectionId, msgText);

                        var chosenSuggestedTopic = document.createElement('li');
                        chosenSuggestedTopic.className = 'topic';
                        chosenSuggestedTopic.setAttribute('topicId', $(this).attr("topicId"));
                        chosenSuggestedTopic.setAttribute('topicName', $(this).attr("topicName"));

                        var nameDiv = document.createElement('div');
                        nameDiv.className = 'name';

                        var closeSpan = document.createElement('span');
                        closeSpan.className = 'closeTopic';

                        nameDiv.appendChild(document.createTextNode($(this).attr("topicName")));
                        nameDiv.appendChild(closeSpan);

                        chosenSuggestedTopic.appendChild(nameDiv);

                        //topicList = topicList + '<li class="topic" topicId="' + $(this).attr("topicId") + '" topicName="' + $(this).attr("topicName") + '"><div class="name">' + $(this).attr("topicName") + '<span class="closeTopic"> </span></div></li>';

                        $(".topicList").append(chosenSuggestedTopic);

                        var placeHolderElement = document.getElementById('TBInput-' + postSectionId);
                        placeHolderElement.setAttribute('placeholder', '');

                        $("body").undelegate(".closeTopic", "click");
                        $("body").delegate(".closeTopic", "click", function () {
                            $(this).parent().parent().remove();

                            if ($(this).parent().parent().attr('topicid') != "newtopic") {
                                var value = $("#RemoveTopicList").val();

                                if (value.length > 0) {
                                    value = value + ', ';
                                }

                                value = value + $(this).parent().parent().attr('topicid');

                                $("#RemoveTopicList").val(value);
                            }

                            CheckForPresentTopics(postSectionId);
                        });
                    });
                }
            }
        }

        if (entityType == 'chatternewtopic') {
            if (db.d.Values.length > 0) {

                var postSectionId = $("#TopicEditorId").val();
                var listContainer = document.getElementById('TopicLinkList-' + postSectionId);
                $(".topicLinkList-" + postSectionId).text('');

                for (var dt = 0; dt < db.d.Values.length; dt++) {

                    var res = JSON.parse(db.d.Values[dt]);                    

                    var resultTopicItem = res.result;
                    var resultStatus = res.statusCode;

                    if (resultStatus == '201') {
                        if (dt > 0) {
                            listContainer.appendChild(document.createTextNode(','));
                        }

                        var newTopic = document.createElement('a');
                        newTopic.href = lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=' + resultTopicItem.id;
                        newTopic.className = 'topicLink';
                        newTopic.setAttribute('topicId', resultTopicItem.id);
                        newTopic.setAttribute('topicName', resultTopicItem.name);
                        newTopic.appendChild(document.createTextNode(CharacterSupport(resultTopicItem.name)));

                        listContainer.appendChild(newTopic);
                    }
                    //var newTopic = newTopicList + '<a href="' + lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=" class="topicLink" topicId="new" topicName="' + newTopic + '">' + newTopic + '</a>';
                }

                //$(".topicLinkList-" + postSectionId).html(newTopicList);
            }
        }

        if (entityType == 'topicsuggestions') {

            //var htmlStr = '';
            //var htmlStr = document.createElement('');    

            var printedTopics = 0;

            if (db.d.Values.length > 0) {
                $(".autoCompleteGroup").text('');
                for (var dt = 0; dt < db.d.Values.length; dt++) {

                    var res = JSON.parse(db.d.Values[dt]);

                    var existingTopic = res.existingTopic;

                    var existingId = '';
                    var existingName = '';
                    var existingTalkingAbout = '';

                    if (existingTopic != null) {

                        existingId = existingTopic.id;
                        existingName = CharacterSupport(existingTopic.name);
                        existingTalkingAbout = existingTopic.talkingAbout;
                    } else {
                        existingId = 'newtopic';
                    }

                    if (res.name + '' != 'null') {
                        var printTopicSuggestion = CheckExistingTopics(res.name);

                        if (printTopicSuggestion) {
                            printedTopics++;

                            var htmlStr = document.createElement('li');
                            htmlStr.className = 'autoCompleteRow';
                            htmlStr.setAttribute('role', 'presentation');
                            htmlStr.id = 'inputsuggested-' + existingId;

                            var rowLink = document.createElement('a');
                            rowLink.className = 'autoCompleteRowLink';
                            rowLink.setAttribute('topicId', existingId);
                            rowLink.setAttribute('topicName', CharacterSupport(res.name));
                            rowLink.setAttribute('role', 'option');
                            rowLink.setAttribute('tabindex', '-1');
                            rowLink.id = '';

                            var linkSpan = document.createElement('span');
                            linkSpan.className = 'actitle';
                            linkSpan.appendChild(document.createTextNode(CharacterSupport(res.name)));

                            var linkSpan2 = document.createElement('span');
                            linkSpan2.className = 'aclabel';
                            linkSpan2.appendChild(document.createTextNode(existingTalkingAbout));

                            rowLink.appendChild(linkSpan);
                            rowLink.appendChild(linkSpan2);
                            htmlStr.appendChild(rowLink);

                            //$(".autoCompleteGroup").text('');
                            $(".autoCompleteGroup").append(htmlStr);

                            //htmlStr = htmlStr + '<li role="presentation" class="autoCompleteRow" id="inputsuggested-' + existingId + '"><a class="autoCompleteRowLink" topicId="' + existingId + '" topicName="' + res.name + '" role="option" tabindex="-1" id=""><span class="actitle">' + res.name + '</span><span class="aclabel">' + existingTalkingAbout + '</span></a></li>';

                            $("body").delegate("#inputsuggested-" + existingId, "click", function () {

                                var inputSegment = document.createTextNode($(this).parent().parent().parent().parent().children(".topicInput").children(".topicList").html());

                                //var newTopic = '<li class="topic" topicId="' + $(this).children(".autoCompleteRowLink").attr("topicId") + '" topicName="' + $(this).children(".autoCompleteRowLink").attr("topicName") + '"><div class="name">' + $(this).children(".autoCompleteRowLink").attr("topicName") + '<span class="closeTopic"> </span></div></li>';

                                var newTopic = document.createElement('li');
                                newTopic.className = 'topic';
                                newTopic.setAttribute('topicId', '' + $(this).children(".autoCompleteRowLink").attr("topicId"));
                                newTopic.setAttribute('topicName', '' + $(this).children(".autoCompleteRowLink").attr("topicName"));

                                var nameDiv = document.createElement('div');
                                nameDiv.className = 'name';

                                var closeSpan = document.createElement('span');
                                closeSpan.className = 'closeTopic';

                                nameDiv.appendChild(document.createTextNode($(this).children(".autoCompleteRowLink").attr("topicName")));
                                nameDiv.appendChild(closeSpan);
                                newTopic.appendChild(nameDiv);

                                $(this).parent().parent().parent().parent().children(".topicInput").children(".topicList").append(newTopic);

                                $(this).remove();

                                $("#autoCompleteBoxId-" + $("#TopicEditorId").val()).find("#suggestionListKeyPress").hide();
                                var editorId = $("#TopicEditorId").val();
                                $("#TBInput-" + editorId).attr("placeholder", "");

                                $("body").undelegate(".closeTopic", "click");
                                $("body").delegate(".closeTopic", "click", function () {
                                    $(this).parent().parent().remove();

                                    if ($(this).parent().parent().attr('topicid') != "newtopic") {
                                        var value = $("#RemoveTopicList").val();

                                        if (value.length > 0) {
                                            value = value + ', ';
                                        }

                                        value = value + $(this).parent().parent().attr('topicid');

                                        $("#RemoveTopicList").val(value);
                                    }

                                    CheckForPresentTopics(editorId);
                                });

                                CheckExistingTopicSuggestions();
                            });
                        }
                    }
                }

                CheckExistingTopicSuggestions();
            } else {
                //htmlStr = '<li><div class="nosuggestions">No more suggestions</div></li>';

                var noSuggestionsLI = document.createElement('li');

                var innerDiv = document.createElement('div');
                innerDiv.className = 'nosuggestions';
                innerDiv.appendChild(document.createTextNode('No more suggestions'));

                noSuggestionsLI.appendChild(innerDiv);

                $(".autoCompleteGroup").text('');
                $(".autoCompleteGroup").append(noSuggestionsLI);
            }

            if (printedTopics == 0) {
                var noSuggestionsLI = document.createElement('li');

                var innerDiv = document.createElement('div');
                innerDiv.className = 'nosuggestions';
                innerDiv.appendChild(document.createTextNode('No more suggestions'));

                noSuggestionsLI.appendChild(innerDiv);

                $(".autoCompleteGroup").text('');
                $(".autoCompleteGroup").append(noSuggestionsLI);
            }


            return;
        }


        if (entityType == 'chatterfollow') {
            var str = db.d.Values[0];

            var followers = JSON.parse(str);

            var followId;
            if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null) {
                followId = localStorage.UserId;
            } else {
                var lgmObj = JSON.parse(localStorage.LayoutManager);
                followId = lgmObj.d.SaleforceUserId;
            }

            var beingfollowed = false;
            var subscriptionId = '';

            for (var i = 0; i < followers["followers"].length; i++) {
                var follow = followers["followers"][i];

                if (follow["subscriber"]["id"] == followId) {
                    beingfollowed = true;
                    subscriptionId = "" + follow["id"];
                }
            }

            var buildView = '';


            var followspan = document.createElement('span');
            followspan.className = 'followRecord';

            var followimg = document.createElement('img');
            followimg.setAttribute("src", "/images/follow_on.jpg");
            followimg.setAttribute("class", "follow");

            var followa = document.createElement('a');
            followa.setAttribute("class", "follow pointer");

            if (beingfollowed) {
                followimg.setAttribute("src", "/images/follow_on.jpg");
                followa.innerText = "Un Follow";
                //                    buildView = '<span class="followRecord"><img src="/images/follow_on.jpg" class="follow"><a class="follow pointer">Un Follow</a></span>';
            } else {
                //      buildView = '<span class="followRecord"><img src="/images/follow.jpg" class="follow"><a class="follow pointer">Follow</a></span>';
                followimg.setAttribute("src", "/images/follow.jpg");
                followa.innerText = "Follow";
            }
            followspan.appendChild(followimg);
            followspan.appendChild(followa);

            var searchResplaceHolder4 = document.getElementById('chatterfollow');
            searchResplaceHolder4.innerHTML = '';
            searchResplaceHolder4.appendChild(followspan);

            var isLike = '1';
            var commentId = '' + getParameterByName("id");

            if (beingfollowed) {
                isLike = 0;
                commentId = subscriptionId;

            }

            $("body").undelegate(".followRecord", "click");

            $("body").delegate(".followRecord", "click", function () {

                var fields = '[';

                fields = fields + background.GenerateEntityField("Id", commentId, '', true, '');
                fields = fields + ',' + background.GenerateEntityField("Type", isLike, '', false, '');
                fields = fields + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
                fields = fields + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
                fields = fields + ',' + background.GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');


                fields = fields + "]";

                var strFields = JSON.stringify(fields);
                $("#chatterfollow").empty();

                background.AddEntity("chatterfollow", strFields, localTabId.innerText);
            });
        }


        if (entityType == 'accountjobs') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Jobs (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('jobCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                var rightSpanBlockJob = document.createElement('span');
                rightSpanBlockJob.className = 'rightSpanBlockJob';

                var restrainDivLeft = document.createElement('div');
                restrainDivLeft.className = 'restrainDiv';

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                var jobTitleLink = document.createElement('a');
                jobTitleLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink.className = 'setLastKnown extlink';
                jobTitleLink.appendChild(document.createTextNode(CharacterSupport(noteList.JobTitle)));

                var jobNumberLink = document.createElement('a');
                jobNumberLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobNumberLink.className = 'setLastKnown extlink';
                jobNumberLink.appendChild(document.createTextNode(noteList.JobNumber));

                var recruiterLink = document.createElement('a');
                recruiterLink.href = 'https://na15.salesforce.com/' + noteList.RecruiterId;
                recruiterLink.className = 'setLastKnown extlink';
                recruiterLink.appendChild(document.createTextNode(CharacterSupport(noteList.RecruiterName)));

                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');

                //left span...
                restrainDivLeft.appendChild(jobTitleLink);
                restrainDivLeft.appendChild(lineBreak);
                restrainDivLeft.appendChild(jobNumberLink);
                leftSpanBlock.appendChild(restrainDivLeft);

                //right span...
                restrainDivRight.appendChild(recruiterLink);
                restrainDivRight.appendChild(lineBreak2);
                restrainDivRight.appendChild(document.createTextNode('Status: ' + noteList.Status));
                rightSpanBlockJob.appendChild(restrainDivRight);

                jobListDiv.appendChild(leftSpanBlock);
                jobListDiv.appendChild(rightSpanBlockJob);

                buildView.appendChild(jobListDiv);

                //buildView = buildView + '<div class="jobListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobTitle + '</a><br/><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobNumber + '</a></div></span><span class="rightSpanBlockJob"><div class="restrainDiv">Primary Recruiter: <a href="https://na15.salesforce.com/' + noteList.RecruiterId + '" class="setLastKnown extlink">' + noteList.RecruiterName + '</a><br />Status: ' + noteList.Status + '</div></span></div>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('accountJobs');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'accountjobstalentrover') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Jobs (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('jobCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var closeDate = noteList.CloseDate;

                if (closeDate == null) {
                    closeDate = '';
                }

                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var iconSpan = document.createElement('span');
                iconSpan.className = 'trJobIcon listIconFormat';

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                var rightSpanBlockJobTR = document.createElement('span');
                rightSpanBlockJobTR.className = 'rightSpanBlockJob rightSpanBlockJobTR';

                var restrainDivLeft = document.createElement('div');
                restrainDivLeft.className = 'restrainDiv';

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                var jobTitleLink = document.createElement('a');
                jobTitleLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink.className = 'setLastKnown extlink';
                jobTitleLink.appendChild(document.createTextNode(CharacterSupport(noteList.JobTitle)));

                var jobNumberLink = document.createElement('a');
                jobNumberLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobNumberLink.className = 'setLastKnown extlink';
                jobNumberLink.appendChild(document.createTextNode(CharacterSupport(noteList.JobNumber)));

                var holdLeftDiv = document.createElement('div');
                holdLeftDiv.className = 'holdLeft';

                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');

                //left span...
                restrainDivLeft.appendChild(jobTitleLink);
                restrainDivLeft.appendChild(lineBreak);
                restrainDivLeft.appendChild(jobNumberLink);
                leftSpanBlock.appendChild(restrainDivLeft);

                //right span...
                holdLeftDiv.appendChild(document.createTextNode(CharacterSupport(noteList.Status)));
                holdLeftDiv.appendChild(lineBreak2);
                holdLeftDiv.appendChild(document.createTextNode('Closed Date: ' + closeDate));
                restrainDivRight.appendChild(holdLeftDiv);
                rightSpanBlockJobTR.appendChild(restrainDivRight);

                jobListDiv.appendChild(iconSpan);
                jobListDiv.appendChild(leftSpanBlock);
                jobListDiv.appendChild(rightSpanBlockJobTR);

                buildView.appendChild(jobListDiv);

                //buildView = buildView + '<div class="jobListDiv"><span class="trJobIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobTitle + '</a><br/><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobNumber + '</a></div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">' + noteList.Status + '<br />Closed Date: ' + closeDate + '</div></div></span></div>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('accountJobsTalentRover');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'accountcontactstalentrover') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Contacts (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('contactContacts');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');
            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var iconSpan = document.createElement('span');
                iconSpan.className = 'trContactIcon listIconFormat';

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                var rightSpanBlockJobTR = document.createElement('span');
                rightSpanBlockJobTR.className = 'rightSpanBlockJob rightSpanBlockJobTR';

                var restrainDivLeft = document.createElement('div');
                restrainDivLeft.className = 'restrainDiv';

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                var contactLink = document.createElement('a');
                contactLink.href = 'Main.html?id=' + noteList.Id + '&action=LinkJumper&ObjectName=Contact';
                contactLink.className = 'setLastKnown';
                contactLink.appendChild(document.createTextNode(CharacterSupport(noteList.FirstName + ' ' + noteList.LastName)));

                var jobNumberLink = document.createElement('a');
                jobNumberLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobNumberLink.className = 'setLastKnown extlink';
                jobNumberLink.appendChild(document.createTextNode('' + noteList.JobNumber));
                var holdLeftDiv = document.createElement('div');
                holdLeftDiv.className = 'holdLeft';

                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');
                //left span...
                restrainDivLeft.appendChild(contactLink);
                restrainDivLeft.appendChild(lineBreak);
                restrainDivLeft.appendChild(document.createTextNode(CharacterSupport('' + noteList.Title)));

                leftSpanBlock.appendChild(restrainDivLeft);
                //right span...
                holdLeftDiv.appendChild(document.createTextNode('Client Status: ' + noteList.ClientStatus));
                holdLeftDiv.appendChild(lineBreak2);
                holdLeftDiv.appendChild(document.createTextNode('CandidateStatus: ' + noteList.CandidateStatus));
                restrainDivRight.appendChild(holdLeftDiv);
                rightSpanBlockJobTR.appendChild(restrainDivRight);
                jobListDiv.appendChild(iconSpan);
                jobListDiv.appendChild(leftSpanBlock);
                jobListDiv.appendChild(rightSpanBlockJobTR);
                buildView.appendChild(jobListDiv);

                //buildView = buildView + '<div class="jobListDiv"><span class="trContactIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?id=' + noteList.Id + '&action=LinkJumper&ObjectName=Contact">' + noteList.FirstName + ' ' + noteList.LastName + '</a><br/>' + noteList.Title + '</div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">Client Status: ' + noteList.ClientStatus + '</a><br />CandidateStatus: ' + noteList.CandidateStatus + '</div></div></span></div>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('accountContactsTalentRover');
            if (renderArea != null) {
                renderArea.innerHTML = '';
                renderArea.appendChild(buildView);
            }
        }

        if (entityType == 'contactjobs') {
            contactJobApplicationCounter = contactJobApplicationCounter + db.d.Values.length;
            if (contactJobApplicationCounter > 10) {
                contactJobApplicationCounter = '10+';
            }

            var accordionText = document.createTextNode('Jobs (' + contactJobApplicationCounter + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('jobCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            var buildView = '<dl style="margin-top:0px;">';

            var dl = document.createElement('dl');
            dl.setAttribute("style", "margin-top:0px;");



            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);


                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                jobListDiv.appendChild(leftSpanBlock);

                var restrainDiv = document.createElement('div');
                restrainDiv.className = 'restrainDiv';

                leftSpanBlock.appendChild(restrainDiv);

                var jobTitleLink = document.createElement('a');
                jobTitleLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink.className = 'setLastKnown extlink';
                jobTitleLink.appendChild(document.createTextNode(CharacterSupport(noteList.JobTitle)));

                restrainDiv.appendChild(jobTitleLink);

                var br = document.createElement('br');

                restrainDiv.appendChild(br);

                var jobNumber = document.createElement('a');
                jobNumber.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobNumber.className = 'setLastKnown extlink';
                jobNumber.appendChild(document.createTextNode(noteList.JobNumber));

                restrainDiv.appendChild(jobNumber);

                //buildView = buildView + '<div class="jobListDiv">
                //<span class="leftSpanBlock">
                //<div class="restrainDiv">
                //<a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobTitle + '</a>
                //<br/>
                //<a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobNumber + '</a></div>
                //</span>


                var rightSpanBlockJob = document.createElement('span');
                rightSpanBlockJob.className = 'rightSpanBlockJob';

                jobListDiv.appendChild(rightSpanBlockJob);

                var restrainDiv1 = document.createElement('div');
                restrainDiv1.className = 'restrainDiv';
                restrainDiv1.appendChild(document.createTextNode("Primary Recruiter:"));

                rightSpanBlockJob.appendChild(restrainDiv1);

                var ahref1 = document.createElement('a');
                ahref1.setArribute("href", "https://na15.salesforce.com/' + noteList.RecruiterId");
                ahref1.setAttribute("class", "setLastKnown extlink");
                ahref1.appendChild(document.createTextNode(CharacterSupport("" + noteList.RecruiterName)));

                restrainDiv1.appendChild(ahref1);

                var br1 = document.createElement('br');

                restrainDiv1.appendChild(br1);

                var txt1 = document.createTextNode("Status: " + noteList.Status);
                //<span class="rightSpanBlockJob"><div class="restrainDiv">
                //Primary Recruiter: <a href="https://na15.salesforce.com/' + noteList.RecruiterId + '" 
                //class="setLastKnown extlink">' + noteList.RecruiterName + '</a><br />Status: ' + noteList.Status + '</div></span>
                //</div>';
                restrainDiv1.appendChild(txt1);

                dl.appendChild(jobListDiv);
            }

            //buildView = buildView + '</dl>';

            var searchResplaceHolder = document.getElementById('contactJobs');
            searchResplaceHolder.innerHTML = '';
            searchResplaceHolder.appendChild(dl);
        }

        if (entityType == 'chattergroupsforuser') {
            //var buildView = 'To <select id="GroupDropdown">';

            var buildView = document.createElement('select');
            buildView.id = 'GroupDropdown';

            var ddFirstOption = document.createElement('option');
            ddFirstOption.value = '-1';
            ddFirstOption.appendChild(document.createTextNode('My Followers'));

            buildView.appendChild(ddFirstOption);

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var ddOption = document.createElement('option');
                ddOption.value = noteList.id;
                ddOption.appendChild(document.createTextNode(CharacterSupport(noteList.name)));

                buildView.appendChild(ddOption);

                //buildView = buildView + '<option value="' + noteList.id + '">' + noteList.name + '</option>';
            }

            //buildView = buildView + '</select>';

            var renderArea = document.getElementById('chatterGroups');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'contactjobstalentrover') {
            contactJobApplicationCounter = contactJobApplicationCounter + db.d.Values.length;
            if (contactJobApplicationCounter > 10) {
                contactJobApplicationCounter = '10+';
            }

            var accordionText = document.createTextNode('Hiring Manager for Jobs (' + contactJobApplicationCounter + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('jobCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);


            //var buildView = '<dl style="margin-top:0px;">';
            var buildView = document.createElement('dl');
            buildView.setAttribute("style", "margin-top:0px;");// style.marginTop('0px');


            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var closeDate = noteList.CloseDate;

                if (closeDate == null) {
                    closeDate = '';
                }

                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var iconSpan = document.createElement('span');
                iconSpan.className = 'trJobIcon listIconFormat';

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                var rightSpanBlockJobTR = document.createElement('span');
                rightSpanBlockJobTR.className = 'rightSpanBlockJob rightSpanBlockJobTR';

                var restrainDivLeft = document.createElement('div');
                restrainDivLeft.className = 'restrainDiv';

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                var holdLeft = document.createElement('div');
                holdLeft.className = 'holdLeft';

                var link1 = document.createElement('a');
                link1.href = 'https://na15.salesforce.com/' + noteList.Id;
                link1.className = 'setLastKnown extlink';
                link1.appendChild(document.createTextNode(CharacterSupport("" + noteList.JobTitle)));

                var link2 = document.createElement('a');
                link2.href = 'Main.html?id=' + noteList.AccountId + '&action=LinkJumper&ObjectName=Account';
                link2.className = 'setLastKnown';
                link2.appendChild(document.createTextNode(CharacterSupport("" + noteList.AccountName)));

                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');

                //left span...
                restrainDivLeft.appendChild(link1);
                restrainDivLeft.appendChild(lineBreak);
                restrainDivLeft.appendChild(link2);
                leftSpanBlock.appendChild(restrainDivLeft);
                //right span...
                holdLeft.appendChild(document.createTextNode(CharacterSupport('Status: ' + noteList.Status)));
                holdLeft.appendChild(lineBreak2);
                holdLeft.appendChild(document.createTextNode('Closed Date: ' + closeDate));
                restrainDivRight.appendChild(holdLeft);
                rightSpanBlockJobTR.appendChild(restrainDivRight);

                jobListDiv.appendChild(iconSpan);
                jobListDiv.appendChild(leftSpanBlock);
                jobListDiv.appendChild(rightSpanBlockJobTR);
                buildView.appendChild(jobListDiv);

                //buildView = buildView + '<div class="jobListDiv"><span class="trJobIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.JobTitle + '</a><br/><a href="Main.html?id=' + noteList.AccountId + '&action=LinkJumper&ObjectName=Account">' + noteList.AccountName + '</a></div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">Status: ' + noteList.Status + '<br />Closed Date: ' + closeDate + '</div></div></span></div>';
            }

            //buildView = buildView + '</dl>';

            var displayDiv = document.getElementById('contactJobsTalentRover');
            if (displayDiv != null) {
                displayDiv.innerHTML = '';
                displayDiv.appendChild(buildView);
            }
        }

        if (entityType == 'contacthiringmanager') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Hiring Manager for Jobs (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('hiringManagerCount');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl style="margin-top:0px;">';


            var dl = document.createElement('dl');
            dl.setAttribute('style', 'margin-top:0px;');

            for (var i = 0; i < db.d.Values.length; i++) {
                var fld = db.d.Values[i];
                var noteList = JSON.parse(fld);

                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var listIconFormat = document.createElement('span');
                listIconFormat.className = 'trJobIcon listIconFormat';

                jobListDiv.appendChild(listIconFormat);

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                jobListDiv.appendChild(leftSpanBlock);

                var restrainDiv1 = document.createElement('div');
                restrainDiv1.className = 'restrainDiv';

                leftSpanBlock.appendChild(restrainDiv1);

                //buildView = buildView + '<div class="jobListDiv">
                //<span class="trJobIcon listIconFormat"> </span>
                //<span class="leftSpanBlock">
                //<div class="restrainDiv">
                //<a href="https://salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Id + '</a>
                //<br/><a href="https://salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Id + '</a>
                //</div>
                //</span><span class="rightSpanBlockJob"><div class="restrainDiv">

                var jobTitleLink = document.createElement('a');
                jobTitleLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink.className = 'setLastKnown extlink';
                jobTitleLink.appendChild(document.createTextNode(noteList.Id));

                restrainDiv1.appendChild(jobTitleLink);

                var br1 = document.createElement('br');
                restrainDiv1.appendChild(br1);

                var jobTitleLink1 = document.createElement('a');
                jobTitleLink1.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink1.className = 'setLastKnown extlink';
                jobTitleLink1.appendChild(document.createTextNode(noteList.Id));

                restrainDiv1.appendChild(jobTitleLink1);

                var rightSpanBlockJob = document.createElement('span');
                rightSpanBlockJob.className = 'rightSpanBlockJob';

                jobListDiv.appendChild(rightSpanBlockJob);

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                rightSpanBlockJob.appendChild(restrainDivRight);

                var txt1 = document.createTextNode('Primary Recruiter:');

                restrainDivRight.appendChild(txt1);

                var jobTitleLink = document.createElement('a');
                jobTitleLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink.className = 'setLastKnown extlink';
                jobTitleLink.appendChild(document.createTextNode(noteList.Id));

                restrainDivRight.appendChild(jobTitleLink);

                //Primary Recruiter: 
                //<a href="https://salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Id + '</a>
                //<br />Status: ' + noteList.Id + '</div></span></div>';

                var br3 = document.createElement('br');

                restrainDivRight.appendChild(br3);

                var txt2 = document.createTextNode('Status: ' + noteList.Id);

                restrainDivRight.appendChild(txt2);

                dl.appendChild(jobListDiv);
            }

            //buildView = buildView + '</dl>';

            var searchResplaceHolder4 = document.getElementById('contactHiringManagers');
            searchResplaceHolder4.innerHTML = '';
            searchResplaceHolder4.appendChild(dl);
        }

        if (entityType == 'contactcandidatejobstatus') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Candidate Job Status (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('jobStatusCount');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            var buildView = '<dl style="margin-top:0px;">';

            var dl = document.createElement('dl');
            dl.setAttribute("style", "margin-top:0px;");

            for (var i = 0; i < db.d.Values.length; i++) {
                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var threadType = noteList.attributes.type.toString().toLowerCase();


                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var span1 = document.createElement('span');
                span1.className = 'applicationIcon listIconFormat';

                var applicationText = document.createTextNode(CharacterSupport('Application: ' + noteList.Status));


                if (threadType == "tr1__application__c") {
                    span1.className = 'applicationIcon listIconFormat';

                }

                //print submittals...
                if (threadType == "tr1__submittal__c") {
                    //   buildView = buildView + '<div class="jobListDiv"><span class="submittalIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a><br/><a href="Main.html?id=' + noteList.AccountId + '&action=Account">' + noteList.AccountName + '</a></div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">Submittal: ' + noteList.Status + '<br /><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a></div></div></span></div>';
                    span1.className = 'submittalIcon listIconFormat';
                    applicationText.innerText = 'Submittal: ' + CharacterSupport(noteList.Status);
                }

                //print sendouts...
                if (threadType == "tr1__send_out__c") {
                    //                        buildView = buildView + '<div class="jobListDiv"><span class="sendoutIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a><br/><a href="Main.html?id=' + noteList.AccountId + '&action=Account">' + noteList.AccountName + '</a></div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">Sendout: ' + noteList.Status + '<br /><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a></div></div></span></div>';
                    span1.className = 'sendoutIcon listIconFormat';
                    applicationText.innerText = 'Sendout: ' + CharacterSupport(noteList.Status);

                }

                //print sendout schedules...
                if (threadType == "tr1__send_out_schedule__c") {

                    //                        buildView = buildView + '<div class="jobListDiv"><span class="sendoutScheduleIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a><br/><a href="Main.html?id=' + noteList.AccountId + '&action=Account">' + noteList.AccountName + '</a></div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">Sendout Schedule: ' + noteList.Status + '<br /><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a></div></div></span></div>';
                    applicationText.innerText = 'Sendout Schedule: ' + CharacterSupport(noteList.Status);
                    span1.className = 'sendoutScheduleIcon listIconFormat';

                }

                //print offers...
                if (threadType == "tr1__offer__c") {
                    //buildView = buildView + '<div class="jobListDiv"><span class="offerIcon listIconFormat"> </span><span class="leftSpanBlock"><div class="restrainDiv"><a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a><br/><a href="Main.html?id=' + noteList.AccountId + '&action=Account">' + noteList.AccountName + '</a></div></span><span class="rightSpanBlockJob rightSpanBlockJobTR"><div class="restrainDiv"><div class="holdLeft">Offer: ' + noteList.Status + '<br /><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a></div></div></span></div>';
                    applicationText.innnerText = 'Offer: ' + CharacterSupport(noteList.Status);
                    span1.className = 'offerIcon listIconFormat';

                }

                jobListDiv.appendChild(span1);

                //buildView = buildView + '<div class="jobListDiv"><span class="applicationIcon listIconFormat"> </span>
                //<span class="leftSpanBlock"><div class="restrainDiv">
                //<a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a>
                //<br/>
                //<a href="Main.html?id=' + noteList.AccountId + '&action=Account">' + noteList.AccountName + '</a>
                //</div>
                //</span><span class="rightSpanBlockJob rightSpanBlockJobTR">
                //<div class="restrainDiv"><div class="holdLeft">Application: ' + noteList.Status + '<br /><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a></div></div></span></div>';

                var span2 = document.createElement('span');
                span2.className = 'leftSpanBlock';

                jobListDiv.appendChild(span2);

                var restrainDiv = document.createElement('div');
                restrainDiv.className = 'restrainDiv';

                span2.appendChild(restrainDiv);

                var jobTitleLink = document.createElement('a');
                jobTitleLink.href = 'https://na15.salesforce.com/' + noteList.Id;
                jobTitleLink.className = 'setLastKnown extlink';
                jobTitleLink.appendChild(document.createTextNode(CharacterSupport(noteList.JobName)));

                restrainDiv.appendChild(jobTitleLink);

                var br = document.createElement('br');
                restrainDiv.appendChild(jobTitleLink);

                var jobTitleLink1 = document.createElement('a');
                jobTitleLink1.href = 'Main.html?id=' + noteList.AccountId + '&action=Account';
                jobTitleLink1.className = 'setLastKnown extlink';
                jobTitleLink1.appendChild(document.createTextNode(CharacterSupport(noteList.AccountName)));

                restrainDiv.appendChild(jobTitleLink1);
                //<span class="rightSpanBlockJob rightSpanBlockJobTR">
                //<div class="restrainDiv">
                //<div class="holdLeft">Application: ' + noteList.Status + '<br />
                //<a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + 
                //noteList.Name + '</a></div></div></span></div>';

                var rightSpanBlockJob = document.createElement('span');
                rightSpanBlockJob.className = 'rightSpanBlockJob rightSpanBlockJobTR';

                jobListDiv.appendChild(rightSpanBlockJob);

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                rightSpanBlockJob.appendChild(restrainDivRight);

                var holdleft1 = document.createElement('div');
                holdleft1.className = 'holdLeft';

                restrainDivRight.appendChild(holdleft1);

                // APPLICATION TEXT HERE.
                holdleft1.appendChild(applicationText);

                var lineBreak = document.createElement('br');

                holdleft1.appendChild(lineBreak);

                var noteListName = document.createElement('a');
                noteListName.href = 'https://na15.salesforce.com/' + noteList.Id;
                noteListName.className = 'setLastKnown extlink';
                noteListName.appendChild(document.createTextNode(noteList.Name));

                holdleft1.appendChild(noteListName);
                dl.appendChild(jobListDiv);
                //print applications...
            }

            //                buildView = buildView + '</dl>';
            var searchResplaceHolder1 = document.getElementById('contactCandidateJobStatus');
            searchResplaceHolder1.innerHTML = '';
            searchResplaceHolder1.appendChild(dl);
        }

        if (entityType == 'contactopportunitiesdiscussed') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Opportunities Discussed (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('opportunitiesDiscussedCount');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl style="margin-top:0px;">';

            var dl = document.createElement('div');
            dl.setAttribute("style", "margin-top:0px;");

            for (var i = 0; i < db.d.Values.length; i++) {
                var fld = db.d.Values[i];
                var noteList = JSON.parse(fld);
                //buildView = buildView + '<div class="jobListDiv">
                //<span class="opportunitiesdDiscussedIcon listIconFormat"> </span>
                //<span class="leftSpanBlock">
                //<div class="restrainDiv">
                //<a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a>
                //</div></span>

                var jobListDiv = document.createElement('div');
                jobListDiv.className = 'jobListDiv';

                var opportunitiesdDiscussedIcon = document.createElement('span');
                opportunitiesdDiscussedIcon.className = 'opportunitiesdDiscussedIcon listIconFormat';

                jobListDiv.appendChild(opportunitiesdDiscussedIcon);

                var leftSpanBlock = document.createElement('span');
                leftSpanBlock.className = 'leftSpanBlock';

                jobListDiv.appendChild(leftSpanBlock);

                var restrainDivLeft = document.createElement('div');
                restrainDivLeft.className = 'restrainDiv';

                leftSpanBlock.appendChild(restrainDivLeft);

                var noteListName = document.createElement('a');
                noteListName.href = 'https://na15.salesforce.com/' + noteList.Id;
                noteListName.className = 'setLastKnown extlink';
                noteListName.appendChild(document.createTextNode(CharacterSupport(noteList.Name)));

                restrainDivLeft.appendChild(noteListName);

                //<span class="rightSpanBlockJob rightSpanBlockJobTR">
                //<div class="restrainDiv">

                var rightSpanBlockJob = document.createElement('span');
                rightSpanBlockJob.className = 'rightSpanBlockJob rightSpanBlockJobTR';

                jobListDiv.appendChild(rightSpanBlockJob);

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                rightSpanBlockJob.appendChild(restrainDivRight);

                var holdLeft = document.createElement('div');
                holdLeft.className = 'holdLeft';

                restrainDivRight.appendChild(holdLeft);

                var txt1 = document.createTextNode("Job:");

                //<div class="holdLeft">Job: 
                //<a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a>
                //<br />Interested: ' + noteList.Interested + '</div></div></span></div>';

                holdLeft.appendChild(txt1);

                var JobName = document.createElement('a');
                JobName.href = 'https://na15.salesforce.com/' + noteList.JobId;
                JobName.className = 'setLastKnown extlink';
                JobName.appendChild(document.createTextNode(CharacterSupport(noteList.JobName)));

                holdLeft.appendChild(JobName);

                var br2 = document.createElement('br');

                holdLeft.appendChild(br2);

                var txt1 = document.createTextNode("Interested: ");

                holdLeft.appendChild(txt1);

                var txt4 = document.createTextNode(CharacterSupport("" + noteList.Interested));

                holdLeft.appendChild(txt4);

                dl.appendChild(jobListDiv);

            }

            //buildView = buildView + '</dl>';

            var searchResplaceHolderbv1 = document.getElementById('contactOpportunitiesDiscussed');
            searchResplaceHolderbv1.innerHTML = '';
            searchResplaceHolderbv1.appendChild(dl);

        }

        if (entityType == 'contactapplications') {
            //var count = db.d.Values.length;
            //if (count > 10) { count = '10+'; }

            contactJobApplicationCounter = contactJobApplicationCounter + db.d.Values.length;
            if (contactJobApplicationCounter > 10) {
                contactJobApplicationCounter = '10+';
            }

            var accordionText = document.createTextNode('Jobs (' + contactJobApplicationCounter + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('jobCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);


            //var buildView = '<dl style="margin-top:0px;">';
            var dl = document.createElement('dl');
            dl.setAttribute("style", "margin-top:0px;");

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var divApplicationList = document.createElement('div');
                divApplicationList.setAttribute("class", "applicationListDiv");


                var spanLeftSpanBlock = document.createElement('span');
                spanLeftSpanBlock.setAttribute("class", "leftSpanBlock");
                divApplicationList.appendChild(spanLeftSpanBlock);

                var div2 = document.createElement('div');
                div2.setAttribute("class", "restrainDiv");
                spanLeftSpanBlock.appendChild(div2);

                //buildView = buildView + '<div class="applicationListDiv"><span class="leftSpanBlock"><div class="restrainDiv">

                var anoteJob = document.createElement('a');
                anoteJob.setAttribute("class", "setLastKnown extlink");
                anoteJob.href = 'https://na15.salesforce.com/' + noteList.JobId;
                anoteJob.innerText = noteList.JobName;

                spanLeftSpanBlock.appendChild(anoteJob);

                //<a href="https://na15.salesforce.com/' + noteList.JobId + '" class="setLastKnown extlink">' + noteList.JobName + '</a>

                var br1 = document.createElement('br');
                spanLeftSpanBlock.appendChild(br1);

                var anoteJob1 = document.createElement('a');
                anoteJob1.setAttribute("class", "setLastKnown extlink");
                anoteJob1.href = 'https://na15.salesforce.com/' + noteList.Id;
                anoteJob1.innerText = CharacterSupport(noteList.Name);

                spanLeftSpanBlock.appendChild(anoteJob1);

                //<br/><a href="https://na15.salesforce.com/' + noteList.Id + '" class="setLastKnown extlink">' + noteList.Name + '</a>

                //</div></span>
                // Back Down to Div divApplicationList
                var spanjobRightSpan = document.createElement('span');
                spanjobRightSpan.setAttribute("class", "jobRightSpan");

                divApplicationList.appendChild(spanjobRightSpan);

                //<span class="jobRightSpan">
                var restrainDiv = document.createElement('div');
                restrainDiv.setAttribute("class", "restrainDiv");
                restrainDiv.innerText = 'Stage: ' +CharacterSupport(noteList.Stage);

                var br1 = document.createElement('br');
                restrainDiv.appendChild(br1);


                var textNode = document.createTextNode('Status: ' + CharacterSupport(noteList.Status));
                restrainDiv.appendChild(textNode);

                spanjobRightSpan.appendChild(restrainDiv);
                //<div class="restrainDiv">Stage: ' + noteList.Stage + '<br />Status: ' + noteList.Status + '</div></span>';
                // Back down to Div

                //                    divApplicationList.appendChild(spanLeftSpanBlock);

                var bottomSpan = document.createElement('span');
                bottomSpan.setAttribute("class", "bottomSpan");

                divApplicationList.appendChild(bottomSpan);

                var restrainDiv1 = document.createElement('div');
                restrainDiv1.setAttribute("class", "restrainDiv");

                bottomSpan.appendChild(restrainDiv1);

                var iconblock2 = document.createElement('span');
                iconblock2.className = "iconBlock";

                restrainDiv1.appendChild(iconblock2);

                var h31 = document.createElement('h2');
                h31.innerText = "Control";

                iconblock2.appendChild(h31);

                var spanbuttonPanel = document.createElement('span');
                spanbuttonPanel.className = "buttonPanel";


                //buildView = buildView + '<span class="bottomSpan"><div class="restrainDiv">';
                //buildView = buildView + '<span class="iconBlock"><h3>Control</h3><span class="buttonPanel">


                iconblock2.appendChild(spanbuttonPanel);


                var spanbuttonPanelMove1 = document.createElement('span');
                spanbuttonPanelMove1.className = "move pointer";
                spanbuttonPanelMove1.setAttribute("title", "Move");
                spanbuttonPanelMove1.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSMoveCandidates?Id=' + noteList.Id);

                spanbuttonPanel.appendChild(spanbuttonPanelMove1);

                var spanbuttonSnooze = document.createElement('span');
                spanbuttonSnooze.className = "snooze pointer";
                spanbuttonSnooze.setAttribute("title", "Snooze");
                spanbuttonSnooze.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSSnoozeCandidates?Id=' + noteList.Id);

                spanbuttonPanel.appendChild(spanbuttonSnooze);

                var spanbuttonReject = document.createElement('span');
                spanbuttonReject.className = "reject pointer";
                spanbuttonReject.setAttribute("title", "Reject");
                spanbuttonReject.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSRejectCandidates?Id=' + noteList.Id);

                spanbuttonPanel.appendChild(spanbuttonReject);

                //<span class="move pointer" title="Move" jslink="https://ts2extams.na12.visual.force.com/apex/AMSMoveCandidates?Id=' + noteList.Id + '"></span>
                //<span class="snooze pointer" title="Snooze" jslink="https://ts2extams.na12.visual.force.com/apex/AMSSnoozeCandidates?Id=' + noteList.Id + '"></span>
                //<span class="reject pointer" title="Reject" jslink="https://ts2extams.na12.visual.force.com/apex/AMSRejectCandidates?Id=' + noteList.Id + '"></span></span></span>';


                var iconblock4 = document.createElement('span');
                iconblock4.className = "iconBlock";
                iconblock4.setAttribute("style", "padding-left: 38px;");

                restrainDiv1.appendChild(iconblock4);

                var h3comm = document.createElement('h2');
                h3comm.innerText = "Communication";
                iconblock4.appendChild(h3comm);

                var spanbuttonPanel2 = document.createElement('span');
                spanbuttonPanel2.className = "buttonPanel";

                iconblock4.appendChild(spanbuttonPanel2);


                var spanbuttonPanelEmail = document.createElement('span');
                spanbuttonPanelEmail.className = "emailJsCandidate pointer";
                spanbuttonPanelEmail.setAttribute("title", "Email");
                spanbuttonPanelEmail.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSEmailCandidate?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonPanelEmail);

                var spanbuttonschedule = document.createElement('span');
                spanbuttonschedule.className = "schedule pointer";
                spanbuttonschedule.setAttribute("title", "Snooze");
                spanbuttonschedule.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSScheduleCandidate?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonschedule);

                var spanbuttonforward = document.createElement('span');
                spanbuttonforward.className = "forward pointer";
                spanbuttonforward.setAttribute("title", "Reject");
                spanbuttonforward.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSForwardCandidate?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonforward);

                //buildView = buildView + '<span class="iconBlock" style="padding-left: 38px;"><h3>Communication</h3>
                //<span class="buttonPanel">
                //<span class="emailJsCandidate pointer" title="Email" jslink="https://ts2extams.na12.visual.force.com/apex/AMSEmailCandidate?id=' + noteList.Id + '"></span>
                //<span class="schedule pointer" title="Schedule" jslink="https://ts2extams.na12.visual.force.com/apex/AMSScheduleCandidate?id=' + noteList.Id + '"></span>
                //<span class="forward pointer" title="Forward" jslink="https://ts2extams.na12.visual.force.com/apex/AMSForwardCandidate?id=' + noteList.Id + '"></span></span></span>';


                var iconblock41 = document.createElement('span');
                iconblock41.className = "iconBlock";
                iconblock41.setAttribute("style", "padding-left: 28px;");

                restrainDiv1.appendChild(iconblock41);

                var h3action = document.createElement('h2');
                h3action.innerText = "Action";

                iconblock41.appendChild(h3action);

                var spanbuttonPanel2 = document.createElement('span');
                spanbuttonPanel2.className = "buttonPanel";

                iconblock41.appendChild(spanbuttonPanel2);

                //buildView = buildView + '<span class="iconBlock" style="padding-left: 28px;">
                //<h3>Action</h3><span class="buttonPanel">

                var spanbuttonPanelEdit = document.createElement('span');
                spanbuttonPanelEdit.className = "emailJsCandidate pointer";
                spanbuttonPanelEdit.setAttribute("title", "Edit");
                spanbuttonPanelEdit.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSEditCandidate?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonPanelEdit);

                var spanbuttonDetails = document.createElement('span');
                spanbuttonDetails.className = "details pointer";
                spanbuttonDetails.setAttribute("title", "Details");
                spanbuttonDetails.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSDetailsCandidate?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonDetails);

                var spanbuttonresume = document.createElement('span');
                spanbuttonresume.className = "forward pointer";
                spanbuttonresume.setAttribute("title", "Resume");
                spanbuttonresume.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSResume?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonresume);

                var spanbuttonmatch = document.createElement('span');
                spanbuttonmatch.className = "forward pointer";
                spanbuttonmatch.setAttribute("title", "Reject");
                spanbuttonmatch.setAttribute("jslink", 'https://ts2extams.na12.visual.force.com/apex/AMSMatch?id=' + noteList.Id);

                spanbuttonPanel2.appendChild(spanbuttonmatch);

                //<span class="editJsCandidate pointer" title="Edit" jslink="https://ts2extams.na12.visual.force.com/apex/AMSEditCandidate?id=' + noteList.Id + '"></span>
                //<span class="details pointer" title="Details" jslink="https://ts2extams.na12.visual.force.com/apex/AMSDetailsCandidate?id=' + noteList.Id + '"></span>
                //<span class="resume pointer" title="Resume" jslink="https://ts2extams.na12.visual.force.com/apex/AMSResume?id=' + noteList.Id + '"></span>
                //<span class="match pointer" title="Match" jslink="https://ts2extams.na12.visual.force.com/apex/AMSMatch?id=' + noteList.Id + '"></span></span></span>';
                //buildView = buildView + '</div></span></div>';
                dl.appendChild(divApplicationList);
            }


            //buildView = buildView + '</dl>';
            var searchResplaceHolder = document.getElementById('contactApplications');
            searchResplaceHolder.innerHTML = '';
            searchResplaceHolder.appendChild(dl);
        }

        if (entityType == 'alltasksaccount' || entityType == 'alltaskscontact') {

            var buildView = DisplayWidgetTasks(db, lgm);

            var allTasks = document.getElementById('allTasks');

            if (allTasks != null) {
                allTasks.innerHTML = '';
                allTasks.appendChild(buildView);
            }
        }

        if (entityType == 'chatterfeedallcompany' || entityType == 'chatterfeedbookmarked' || entityType == 'chatterfeedfollows' || entityType == 'chatterfeedtome') {

            var divChatter = document.createElement('div');
            divChatter.className = 'chatterLoader';
            var imgLoader = document.createElement('img');
            imgLoader.src = '../images/ajax-loader.gif';
            imgLoader.alt = 'Loading Chatter';
            divChatter.appendChild(imgLoader);

            var dlChatter = document.createElement('dl');

            var sfUserId;
            if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null) {
                sfUserId = localStorage.UserId;
            } else {
                var lgmObj = JSON.parse(localStorage.LayoutManager);
                sfUserId = lgmObj.d.SaleforceUserId;
            }

            for (var i = 0; i < db.d.Values.length; i++) {
                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var msgText = ChatterFormatOutMessage(noteList);
                msgText.id = 'postTextId-' + noteList.id;

                var messageKey = noteList.id.toString().trim();

                var dataPrinter = noteList.likes.likes;

                var likeButton = '';
                var aLike = document.createElement('a');


                if (dataPrinter.length > 0) {

                    for (var x = 0; x < dataPrinter.length; x++) {

                        if (dataPrinter[x].user.id == sfUserId) {
                            //render 'unlike' button...
                            //likeButton = '<a class="feeditemactionlink btUnlike pointer fireChatterAction" itemId="' + messageKey + '" likeId="' + dataPrinter[x].id + '">Unlike</a>';
                            aLike.className = 'feeditemactionlink btUnlike pointer fireChatterAction';
                            aLike.setAttribute('itemId', messageKey);
                            aLike.setAttribute('likeId', dataPrinter[x].id);
                            var txtALike = document.createTextNode('Unlike');
                            aLike.appendChild(txtALike);

                        } else {
                            //render 'like' button...
                            //likeButton = '<a class="feeditemactionlink btLike pointer fireChatterAction" itemId="' + messageKey + '" >Like</a>';
                            aLike.className = 'feeditemactionlink btLike pointer fireChatterAction';
                            aLike.setAttribute('itemId', messageKey);
                            var txtALike = document.createTextNode('Like');
                            aLike.appendChild(txtALike);
                        }
                    }
                } else {
                    //likeButton = '<a class="feeditemactionlink btLike pointer fireChatterAction" itemId="' + messageKey + '" >Like</a>';
                    aLike.className = 'feeditemactionlink btLike pointer fireChatterAction';
                    aLike.setAttribute('itemId', messageKey);
                    var txtALike = document.createTextNode('Like');
                    aLike.appendChild(txtALike);
                }

                //var commentButton = '<a class="feeditemactionlink btComment pointer" itemId="' + messageKey + '" >Comment</a>';
                var aComment = document.createElement('a');
                aComment.className = 'feeditemactionlink btComment pointer';
                aComment.setAttribute('itemId', messageKey);
                var txtComment = document.createTextNode('Comment');

                aComment.appendChild(txtComment);

                //Get comments for each post...

                var commentArray = noteList.comments.comments;

                var commentString = '';
                var divComment = document.createElement('div');
                var divCommentStrings = document.createElement('section');
                //divCommentStrings.id = '' + noteList.id;

                if (commentArray.length > 0) {

                    if (entityType == 'chatterusersmall') {
                        //commentString = '<div class="commentsection commentsectionhome">';
                        divComment.className = 'commentsection commentsectionhome';
                    } else {
                        //commentString = '<div class="commentsection">';
                        divComment.className = 'commentsection';
                    }



                    for (var x = 0; x < commentArray.length; x++) {
                        var commentTextFormatted = ChatterFormatOutMessage(commentArray[x]);
                        var divCommentString = document.createElement('div');

                        //commentString = commentString + '<div>';

                        //commentString = commentString + '<h4><a href="https://login.salesforce.com/' + commentArray[x].user.id + '" target="_blank">' + commentArray[x].user.name + '</a></h4>';

                        var h4Comment1 = document.createElement('h4');
                        var aComment1 = document.createElement('a');
                        aComment1.href = 'https://login.salesforce.com/' + commentArray[x].user.id;
                        aComment1.target = '_blank';
                        var txtAComment = document.createTextNode(CharacterSupport(commentArray[x].user.name));
                        aComment1.appendChild(txtAComment);
                        h4Comment1.appendChild(aComment1);
                        divCommentString.appendChild(h4Comment1);
                        //commentString = commentString + '<p class="commentBody">' + commentTextFormatted + '</p>';

                        pComment = document.createElement('p');
                        pComment.className = 'commentBody';
                        pComment.appendChild(commentTextFormatted);
                        divCommentString.appendChild(pComment);
                        var aCommentLike = document.createElement('a');
                        if (commentArray[x].myLike) {
                            //commentString = commentString + '<a class="unlikeComment pointer fireChatterAction" commentId="' + commentArray[x].id + '" likeId="' + commentArray[x].myLike.id + '">Unlike</a>';

                            aCommentLike.className = 'unlikeComment pointer fireChatterAction';
                            aCommentLike.setAttribute('commentId', commentArray[x].id);
                            aCommentLike.setAttribute('likeId', commentArray[x].myLike.id);
                            var txtACommentLike = document.createTextNode('Unlike');
                            aCommentLike.appendChild(txtACommentLike);

                            divCommentString.appendChild(aCommentLike);
                        } else {
                            //commentString = commentString + '<a class="likeComment pointer fireChatterAction" commentId="' + commentArray[x].id + '">Like</a>';

                            aCommentLike.className = 'likeComment pointer fireChatterAction';
                            aCommentLike.setAttribute('commentId', commentArray[x].id);
                            var txtACommentLike = document.createTextNode('Like');
                            aCommentLike.appendChild(txtACommentLike);

                            divCommentString.appendChild(aCommentLike);
                        }
                        // var dateString = FormatDateSF(commentArray[x].createdDate, lgm.d.TimeZone);
                        var dateString = commentArray[x].relativeCreatedDate;

                        var timeComment = document.createElement('time');
                        var txtTimeComment = document.createTextNode(' ' + dateString);

                        timeComment.appendChild(txtTimeComment);

                        divCommentString.appendChild(document.createTextNode(' - '));
                        divCommentString.appendChild(timeComment);

                        divCommentStrings.appendChild(divCommentString);
                    }

                    //commentString = commentString + ' - <time>' + dateString + '</time></div>';

                    
                }//end for

                //commentString = commentString + '</div>';

                var parentName = '';

                var parentType = noteList.parent.type;
                var aParent = document.createElement('a');
                var imgParent = document.createElement('img');
                imgParent.src = 'https://c.eu2.content.force.com' + noteList.parent.motif.smallIconUrl;
                imgParent.className = 'iconPaddingRight';

                var txtParent = document.createTextNode(noteList.parent.name);
                var gotParent = 0;
                if (noteList.parent.type == "CollaborationGroup") {
                    //parentName = '<a href="https://eu2.salesforce.com/' + noteList.parent.id + '" class="extlink"><img class="iconPaddingRight" src="https://c.eu2.content.force.com' + noteList.parent.motif.smallIconUrl + '" />' + noteList.parent.name + '</a> - ';

                    aParent.href = 'https://eu2.salesforce.com/' + noteList.parent.id;
                    aParent.className = 'extlink';
                    aParent.appendChild(imgParent);
                    aParent.appendChild(txtParent);
                    gotParent = 1;

                } else if (noteList.parent.name != "" && noteList.parent.name != null && noteList.parent.name != noteList.actor.name) {
                    if (parentType == "User") {
                        //parentName = '<a href="https://login.salesforce.com/' + noteList.parent.id + '" target="_blank"><img class="iconPaddingRight" src="https://c.eu2.content.force.com' + noteList.parent.motif.smallIconUrl + '" />' + noteList.parent.name + '</a> - ';
                        aParent.href = 'https://login.salesforce.com/' + noteList.parent.id;
                        aParent.target = '_blank';
                        aParent.appendChild(imgParent);
                        aParent.appendChild(txtParent);
                        gotParent = 1;
                    } else {
                        //parentName = '<a href="Main.html?action=LinkJumper&ObjectName=' + noteList.parent.type + '&id=' + noteList.parent.id + '"><img class="iconPaddingRight" src="https://c.eu2.content.force.com' + noteList.parent.motif.smallIconUrl + '" />' + noteList.parent.name + '</a> - ';
                        aParent.href = 'Main.html?action=LinkJumper&ObjectName=' + noteList.parent.type + '&id=' + noteList.parent.id;
                        aParent.appendChild(imgParent);
                        aParent.appendChild(txtParent);
                        gotParent = 1;
                    }
                }

                var removeBold = '';

                //if (parentName.length != 0) {
                //    removeBold = 'style="font-weight: normal;"';
                //}
                var dateString = noteList.relativeCreatedDate; //FormatDateSF(noteList.createdDate, lgm.d.TimeZone);

                var dateString = noteList.relativeCreatedDate; //FormatDateSF(noteList.createdDate, lgm.d.TimeZone);

                var aPoster = document.createElement('a');
                aPoster.href = 'https://login.salesforce.com/' + noteList.actor.id;
                aPoster.target = '_blank';
                var txtAPoster = document.createTextNode(CharacterSupport(noteList.actor.name));

                aPoster.appendChild(txtAPoster);

                //var poster = '<a href="https://login.salesforce.com/' + noteList.actor.id + '" target="_blank" ' + removeBold + '>' + noteList.actor.name + '</a>';
                var dtPhoto = document.createElement('dt');
                var imgPhoto = document.createElement('img');
                imgPhoto.src = noteList.photoUrl;
                imgPhoto.width = '20';
                imgPhoto.className = 'imgNotFound';
                dtPhoto.appendChild(imgPhoto);
                dlChatter.appendChild(dtPhoto);

                var ddName = document.createElement('dd');
                var h4Name = document.createElement('h4');
                h4Name.appendChild(aParent);

                if (gotParent == 1) {
                    h4Name.appendChild(document.createTextNode(' - '));
                    aPoster.setAttribute('style', 'font-weight: normal;');
                }

                //get and render post topics...
                var topicList = noteList.topics.topics;

                //var topicPrinter = '';
                var topicPrinter = document.createElement('div');
                topicPrinter.id = 'TopicSection';
                topicPrinter.className = 'padder greyText linkSpacing topicSectionClass' + noteList.id;

                var mainTopicslink = document.createElement('a');
                mainTopicslink.href = '#';
                mainTopicslink.id = noteList.id;
                mainTopicslink.className = 'topicPicker';
                mainTopicslink.appendChild(document.createTextNode('Topics'));

                var topicLinkList = document.createElement('span');
                topicLinkList.className = 'topicLinkList-' + noteList.id;
                topicLinkList.id = 'TopicLinkList-' + noteList.id;

                topicPrinter.appendChild(mainTopicslink);
                topicPrinter.appendChild(document.createTextNode(': '));

                var topicMenuLabel = 'Add Topics';

                if (topicList.length > 0) {
                    //topicPrinter = '<div id="TopicSection" class="padder greyText linkSpacing topicSectionClass' + noteList.id + '"><a href="#" id="' + noteList.id + '" class="topicPicker">Topics</a>: <span class="topicLinkList-' + noteList.id + '">';

                    for (var x = 0; x < topicList.length; x++) {
                        if (x > 0) {
                            //topicPrinter = topicPrinter + ', ';
                            topicLinkList.appendChild(document.createTextNode(', '));
                        }

                        //topicPrinter = topicPrinter + '<a href="' + lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=' + topicList[x].id + '" class="topicLink exLink" topicId="' + topicList[x].id + '" topicName="' + topicList[x].name + '">' + topicList[x].name + '</a>';

                        var newTopicLink = document.createElement('a');
                        newTopicLink.href = lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=' + topicList[x].id;
                        newTopicLink.className = 'topicLink exLink';
                        newTopicLink.setAttribute('topicId', topicList[x].id);
                        newTopicLink.setAttribute('topicName', topicList[x].name);
                        newTopicLink.appendChild(document.createTextNode(CharacterSupport(topicList[x].name)));

                        topicLinkList.appendChild(newTopicLink);
                    }

                    topicMenuLabel = 'Edit Topics';
                    topicPrinter.appendChild(topicLinkList);
                    //topicPrinter = topicPrinter + '</span></div>';
                } else {

                    topicPrinter.className = 'padder hiddenTopics greyText linkSpacing topicSectionClass' + noteList.id;

                    var topicPrinter2 = document.createElement('div');
                    topicPrinter2.id = 'TopicSection';
                    topicPrinter2.className = 'padder hiddenTopics greyText linkSpacing topicSectionClass' + noteList.id;

                    var mainTopicslink2 = document.createElement('a');
                    mainTopicslink2.href = '#';
                    mainTopicslink2.id = noteList.id;
                    mainTopicslink2.className = 'topicPicker';
                    mainTopicslink2.appendChild(document.createTextNode('Topics'));

                    var topicLinkList2 = document.createElement('span');
                    topicLinkList2.className = 'topicLinkList-' + noteList.id;
                    topicLinkList2.id = 'TopicLinkList-' + noteList.id;

                    topicPrinter2.appendChild(mainTopicslink2);
                    topicPrinter2.appendChild(document.createTextNode(': '));
                    topicPrinter2.appendChild(topicLinkList2);

                    topicPrinter.appendChild(topicLinkList);
                    //topicPrinter = '<div id="TopicSection" class="padder hiddenTopics greyText linkSpacing topicSectionClass' + noteList.id + '"><a href="#" id="' + noteList.id + '" class="topicPicker">Topics</a>: <span class="topicLinkList-' + noteList.id + '"> </span></div>';
                }

                var teDiv = document.createElement('div');
                teDiv.id = 'TE-' + noteList.id;
                teDiv.className = 'padder topicsEditor linkSpacing';
                teDiv.appendChild(RenderTopicEditor(noteList.id));
                teDiv.appendChild(RenderTopicDoneButton(noteList.id));
                teDiv.appendChild(RenderTopicClearDiv(noteList.id));
                teDiv.appendChild(RenderTopicsAc(noteList.id));                

                //editorBlock[0].push(topicEditor);
                //editorBlock[1].push(button);
                //editorBlock[2].push(clearDiv);
                //editorBlock[3].push(topicsAc);


                var successDiv = document.createElement('div');
                successDiv.id = 'Success-' + noteList.id;
                successDiv.className = 'padder topicSuccessDiv linkSpacing';

                var successBold = document.createElement('span');
                successBold.className = 'boldSpan';
                successBold.appendChild(document.createTextNode('Success!'));

                successDiv.appendChild(successBold);
                successDiv.appendChild(document.createTextNode(' People are also talking about this.'));

                //topicPrinter.appendChild(teDiv);
                //topicPrinter.appendChild(successDiv);

                //topicPrinter = topicPrinter + '<div id="TE-' + noteList.id + '" class="padder topicsEditor linkSpacing"> ' + RenderTopicEditor(noteList.id) + ' </div>';
                //topicPrinter = topicPrinter + '<div id="Success-' + noteList.id + '" class="padder topicSuccessDiv linkSpacing"><span class="boldSpan">Success!</span> People are also talking about this.</div>';

                var postMenu = document.createElement('span');
                postMenu.className = 'feeditemActionMenu menuTrigger-' + noteList.id;
                postMenu.setAttribute('postsource', noteList.id);
                postMenu.setAttribute('title', 'More Actions');

                var boldTag = document.createElement('b');
                boldTag.className = '';

                postMenu.appendChild(boldTag);

                var postMenuDiv = document.createElement('div');
                postMenuDiv.className = 'postMenu postMenu-' + noteList.id;

                var postMenuList = document.createElement('span');
                postMenuList.className = 'postMenuItem menuItemTrigger-' + noteList.id;
                postMenuList.appendChild(document.createTextNode(CharacterSupport(topicMenuLabel)));                

                //var postMenu = '<span class="feeditemActionMenu menuTrigger-' + noteList.id + '" postsource="' + noteList.id + '" title="More Actions"><b class=""></b></span><div class="postMenu postMenu-' + noteList.id + '"><span class="postMenuItem menuItemTrigger-' + noteList.id + '">Edit Topics</span></div>';

                postMenuDiv.appendChild(postMenuList);

                //h4Name.appendChild(aPoster);
                //h4Name.appendChild(postMenu);
                //h4Name.appendChild(postMenuDiv);
                //ddName.appendChild(h4Name);

                var pPadder = document.createElement('p');
                pPadder.className = 'padder mainChatterPostText';
                pPadder.appendChild(msgText);
                
                //render differently for "TrackedChange" posts...
                if (noteList.type == 'TrackedChange') {

                    var noTitleNode = document.createElement('span');
                    noTitleNode.appendChild(ChatterFormatOutMessage(noteList));
                    noTitleNode.className = 'fixChatterPostHeader';

                    h4Name.appendChild(noTitleNode);
                    h4Name.appendChild(postMenu);
                    h4Name.appendChild(postMenuDiv);
                    h4Name.className = 'bottomPadder';
                    ddName.appendChild(h4Name);

                } else {
                    h4Name.appendChild(aPoster);
                    h4Name.appendChild(postMenu);
                    h4Name.appendChild(postMenuDiv);
                    h4Name.className = '';
                    ddName.appendChild(h4Name);
                    ddName.appendChild(pPadder);
                }

                var divPadder = document.createElement('div');
                divPadder.className = 'padder linkSpacing';
                divPadder.appendChild(aComment);
                var txtPadder1 = document.createTextNode(' - ');
                divPadder.appendChild(txtPadder1);
                divPadder.appendChild(aLike);

                var timePadder = document.createElement('time');
                var txtTimePadder = document.createTextNode(" " + dateString);
                timePadder.appendChild(txtTimePadder);
                divPadder.appendChild(document.createTextNode(' - '));
                divPadder.appendChild(timePadder);

                if (i == 0 && localStorage.NewPostSuggestions == 1) {

                    localStorage.NewPostSuggestions = 0;

                    var postPostSuggestionContainer = document.createElement('div');
                    postPostSuggestionContainer.id = 'PostSuggestionContainer-' + noteList.id;
                    postPostSuggestionContainer.className = 'postSuggestionContainer';

                    var postPostSuggestions = document.createElement('div');
                    postPostSuggestions.className = 'topics init';
                    postPostSuggestions.id = 'topicContainer' + noteList.id;
                    postPostSuggestions.setAttribute('data-entityid', noteList.id);

                    var highlightDiv = document.createElement('div');
                    highlightDiv.className = 'view highlight postpostsuggestionformat';

                    var topicEditLink = document.createElement('a');
                    topicEditLink.className = 'editLink';
                    topicEditLink.id = 'displayTopicEditorPostPrompt-' + noteList.id;
                    topicEditLink.appendChild(document.createTextNode('Click to add topics: '));

                    var suggestionList = document.createElement('span');
                    suggestionList.className = 'suggestions';
                    suggestionList.id = 'SuggestionsAfterPost';
                    suggestionList.appendChild(document.createTextNode('No suggestions. Add your own topics.'));

                    highlightDiv.appendChild(topicEditLink);
                    highlightDiv.appendChild(suggestionList);

                    postPostSuggestions.appendChild(highlightDiv);
                    postPostSuggestionContainer.appendChild(postPostSuggestions);

                    ddName.appendChild(postPostSuggestionContainer);

                    topicPrinter.style = 'display:none;';
                    ddName.appendChild(topicPrinter);

                    var fields = '[';
                    fields = fields + background.GenerateEntityField("TopicTextBody", msgText.innerText, '', 'false', '');
                    fields = fields + ']';

                    var fieldsStr = JSON.stringify(fields);

                    $("#TopicEditorId").val(noteList.id);

                    background.SelectEntity("topicsuggestionsafterpost", fieldsStr, background.GenerateBHKeyField(noteList.id), localTabId.innerText);
                } else {
                    ddName.appendChild(topicPrinter);
                }

                ddName.appendChild(teDiv);
                ddName.appendChild(successDiv);
                ddName.appendChild(divPadder);

                dlChatter.appendChild(ddName);

                //buildView = buildView + '<dt><img src="' + noteList.photoUrl + '" width="20px" class="imgNotFound" /></dt><dd><h4>' + parentName + poster + '</h4><p class="padder">' + msgText + '</p><div class="padder">' + commentButton + ' - ' + likeButton + ' <time>' + dateString + '</time></div></dd>';
                //buildView = buildView + commentString;

                divComment.appendChild(divCommentStrings);

                //dlChatter.appendChild(divChatter);

                dlChatter.appendChild(divComment);
                
                SetupTopicManager(noteList.id, msgText);

                //end for

                //buildView = buildView + '</dl>';
            }
            if (entityType == 'chatterfeedtome') {
                $(".chatsToMeSection").empty();
                $(".chatsToMeSection").append(divChatter);
                $(".chatsToMeSection").append(dlChatter);
            } else if (entityType == 'chatterfeedfollows') {
                $(".chatsFollowsSection").empty();
                $(".chatsFollowsSection").append(divChatter);
                $(".chatsFollowsSection").append(dlChatter);
            } else if (entityType == 'chatterfeedbookmarked') {
                $(".chatsBookmarksSection").empty();
                $(".chatsBookmarksSection").append(divChatter);
                $(".chatsBookmarksSection").append(dlChatter);
            } else if (entityType == 'chatterfeedallcompany') {
                $(".chatsAllCompany").empty();
                $(".chatsAllCompany").append(divChatter);
                $(".chatsAllCompany").append(dlChatter);
            }

            AssingChatter();
            SetupChatterComments();
            //SetupTopicManager();           
        
        }

        if (entityType == 'chatterfeed') {

            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }
                
            var spanCount = document.createElement('span');
            spanCount.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';
            var txtCount = document.createTextNode('Chatter (' + count + ')');
            $("#chatterCounter").empty();
            $("#chatterCounter").append(spanCount);
            $("#chatterCounter").append(txtCount);

            var feedId = getParameterByName("id");

            //var chatterPostBox = '<div class="chatter" style="margin:0px"><div class="linkbox"><button id="btChatter" class="chatterButton">Share</button><span id="addlink"><img src="/imgs/s.gif" class="publishericon" alt="add link" />Add Link</span>';

            var divChatter = document.createElement('div');
            divChatter.className = 'chatter';
            divChatter.setAttribute('style', 'margin:0px');

            var divLinkBox = document.createElement('div');
            divLinkBox.className = 'linkbox';

            var btChatter = document.createElement('button');
            btChatter.id = 'btChatter';
            btChatter.className = 'chatterButton';
            var txtBtChatter = document.createTextNode('Share');
            btChatter.appendChild(txtBtChatter);

            var spanAddLink = document.createElement('span');
            spanAddLink.id = 'addlink';

            var imgIcon = document.createElement('img');
            imgIcon.src = '/imgs/s.gif';
            imgIcon.className = 'publishericon';
            imgIcon.alt = 'add link';
            var txtImgIcon = document.createTextNode('Add Link');
            //                imgIcon.appendChild(txtImgIcon);

            spanAddLink.appendChild(imgIcon);
            spanAddLink.appendChild(txtImgIcon);
            divLinkBox.appendChild(btChatter);
            divLinkBox.appendChild(spanAddLink);

            //chatterPostBox = chatterPostBox + '<div class="linkShow"><table><tbody><tr><th scope="row">Link Name</td><td><input type="text" value="" class="linkName"></td></tr><tr><th scope="row">Link Url</td>';

            var divLinkShow = document.createElement('div');
            divLinkShow.className = 'linkShow';

            var table1 = document.createElement('table');
            var tbody1 = document.createElement('tbody');
            var tr1 = document.createElement('tr');
            var td1 = document.createElement('th');
            td1.scope = 'row';
            txtTd1 = document.createTextNode('Link Name');
            td1.appendChild(txtTd1);
            tr1.appendChild(td1);

            var td2 = document.createElement('td');
            var inputLink = document.createElement('input');
            inputLink.type = 'text';
            inputLink.className = 'linkName';
            td2.appendChild(inputLink);
            tr1.appendChild(td2);

            var tr2 = document.createElement('tr');
            var td3 = document.createElement('th');
            td3.scope = 'row';
            txtTd2 = document.createTextNode('Link Url');
            td3.appendChild(txtTd2);
            tr2.appendChild(td3);

            //chatterPostBox = chatterPostBox + '<td><input type="text" value="" class="linkUrl" spellcheck="false"></td></tr></tbody></table></div></div><div class="textarea">';
            var td4 = document.createElement('td');
            var inputLink2 = document.createElement('input');
            inputLink2.type = 'text';
            inputLink2.className = 'linkUrl';
            inputLink2.spellcheck = false;
            td4.appendChild(inputLink2);
            tr2.appendChild(td4);

            tbody1.appendChild(tr1);
            tbody1.appendChild(tr2);
            table1.appendChild(tbody1);
            divLinkShow.appendChild(table1);
            divLinkBox.appendChild(divLinkShow);
            divChatter.appendChild(divLinkBox);

            var divTextArea = document.createElement('div');
            divTextArea.className = 'textarea';
                
            //chatterPostBox = chatterPostBox + '<textarea class="publishercontainer chatterWidget" id="chatterWidget1" chatterId="main" type="text" wrap="soft" placeholder="Write a post"></textarea></div>';

            var textArea1 = document.createElement('textarea');
            textArea1.className = 'publishercontainer chatterWidget';

            textArea1.id = 'chatterWidget1';
            textArea1.setAttribute('chatterId', 'main');
            textArea1.type = 'text';
            textArea1.wrap = 'soft';
            textArea1.placeholder = 'Write a post';
            divTextArea.appendChild(textArea1);
            divChatter.appendChild(divTextArea);

            //chatterPostBox = chatterPostBox + '<ul class="userList" id="chatterListSelect-main"></ul><div class="userbox"><input type="hidden" class="chatterUsers" id="chatterUsers-main" value="" /></div></div>';
            var ulUserList = document.createElement('ul');
            ulUserList.className = 'userList';
            ulUserList.id = 'chatterListSelect-main';
            divChatter.appendChild(ulUserList);

            var divUserBox = document.createElement('div');
            divUserBox.className = 'userbox';
            var inputUsers = document.createElement('input');
            inputUsers.type = 'hidden';
            inputUsers.className = 'chatterUsers';
            inputUsers.id = 'chatterUsers-main';
            divUserBox.appendChild(inputUsers);
            divChatter.appendChild(divUserBox);

            var linkBoxes = '';
            //var buildView = linkBoxes + chatterPostBox + '<div class="chatterLoader"><img src="../images/ajax-loader.gif" alt="Loading Chatter"></div><dl>';

            var divChatterLoader = document.createElement('div');
            divChatterLoader.className = 'chatterLoader';
            var imgLoader = document.createElement('img');
            imgLoader.src = '../images/ajax-loader.gif';
            imgLoader.alt = 'Loading Chatter';
            divChatterLoader.appendChild(imgLoader);

            var dlChatter = document.createElement('dl');

            var sfUserId;
            if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null) {
                sfUserId = localStorage.UserId;
            } else {
                var lgmObj = JSON.parse(localStorage.LayoutManager);
                sfUserId = lgmObj.d.SaleforceUserId;
            }

            for (var i = 0; i < db.d.Values.length; i++) {
                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var msgText = ChatterFormatOutMessage(noteList);
                msgText.id = 'postTextId-' + noteList.id;

                var dataPrinter = noteList.likes.likes;

                var likeButton = '';

                var messageKey = noteList.id.toString().trim();
                var aLike = document.createElement('a');
                if (dataPrinter.length > 0) {

                    for (var x = 0; x < dataPrinter.length; x++) {
                            
                        if (dataPrinter[x].user.id == sfUserId) {

                            //likeButton = '<a class="feeditemactionlink btUnlike pointer fireChatterAction" itemId="' + messageKey + '" likeId="' + dataPrinter[x].id + '">Unlike</a>';
                            aLike.className = 'feeditemactionlink btUnlike pointer fireChatterAction';
                            aLike.setAttribute('itemId', messageKey);
                            aLike.setAttribute('likeId', dataPrinter[x].id);
                            var txtALike = document.createTextNode('Unlike');
                            aLike.appendChild(txtALike);
                        } else {
                            //likeButton = '<a class="feeditemactionlink btLike pointer fireChatterAction" itemId="' + messageKey + '" >Like</a>';
                            aLike.className = 'feeditemactionlink btLike pointer fireChatterAction';
                            aLike.setAttribute('itemId', messageKey);
                            var txtALike = document.createTextNode('Like');
                            aLike.appendChild(txtALike);
                        }
                    }
                } else {

                    //likeButton = '<a class="feeditemactionlink btLike pointer fireChatterAction" itemId="' + messageKey + '" >Like</a>';
                    aLike.className = 'feeditemactionlink btLike pointer fireChatterAction';
                    aLike.setAttribute('itemId', messageKey);
                    var txtALike = document.createTextNode('Like');
                    aLike.appendChild(txtALike);
                }
                //var commentButton = '<a class="feeditemactionlink btComment pointer" itemId="' + messageKey + '" >Comment</a>';
                var aComment = document.createElement('a');
                aComment.className = 'feeditemactionlink btComment pointer';
                aComment.setAttribute('itemId', messageKey);
                var txtComment = document.createTextNode('Comment');
                aComment.appendChild(txtComment);


                var commentArray = noteList.comments.comments;

                var commentString = '';
                var divCommentSection = document.createElement('div');
                if (commentArray.length > 0) {
                    commentString = '<div class="commentsection">';
                        
                    divCommentSection.className = 'commentsection';

                    for (var x = 0; x < commentArray.length; x++) {

                        var commentTextFormatted = ChatterFormatOutMessage(commentArray[x]);

                        //commentString = commentString + '<div>';
                        var divComment = document.createElement('div');
                        //commentString = commentString + '<h4><a href="https://login.salesforce.com/' + commentArray[x].user.id + '" target="_blank">' + commentArray[x].user.name + '</a></h4>';
                        var h4Comment1 = document.createElement('h4');
                        var aComment1 = document.createElement('a');
                        aComment1.href = 'https://login.salesforce.com/' + commentArray[x].user.id;
                        aComment1.target = '_blank';
                        var txtAComment = document.createTextNode(CharacterSupport(commentArray[x].user.name));
                        aComment1.appendChild(txtAComment);
                        h4Comment1.appendChild(aComment1);
                        divComment.appendChild(h4Comment1);
                        //commentString = commentString + '<p>' + commentTextFormatted + '</p>';
                        var pComment = document.createElement('p');
                        pComment.appendChild(commentTextFormatted);
                        divComment.appendChild(pComment);

                        var aCommentLike = document.createElement('a');
                        if (commentArray[x].myLike) {
                            //commentString = commentString + '<a class="unlikeComment pointer fireChatterAction" commentId="' + commentArray[x].id + '" likeId="' + commentArray[x].myLike.id + '">Unlike</a>';
                            aCommentLike.className = 'unlikeComment pointer fireChatterAction';
                            aCommentLike.setAttribute('commentId', commentArray[x].id);
                            aCommentLike.setAttribute('likeId', commentArray[x].myLike.id);
                            var txtACommentLike = document.createTextNode('Unlike');
                            aCommentLike.appendChild(txtACommentLike);
                            divComment.appendChild(aCommentLike);
                        } else {
                            //commentString = commentString + '<a class="likeComment pointer fireChatterAction" commentId="' + commentArray[x].id + '">Like</a>';
                            aCommentLike.className = 'likeComment pointer fireChatterAction';
                            aCommentLike.setAttribute('commentId', commentArray[x].id);
                            var txtACommentLike = document.createTextNode('Like');
                            aCommentLike.appendChild(txtACommentLike);
                            divComment.appendChild(aCommentLike);
                        }
                        var dateString = commentArray[x].relativeCreatedDate;

                        var timeComment = document.createElement('time');
                        var txtTimeComment = document.createTextNode(' ' + dateString);
                        timeComment.appendChild(txtTimeComment);
                        divComment.appendChild(document.createTextNode(' - '));
                        divComment.appendChild(timeComment);

                        divCommentSection.appendChild(divComment);
                    }

                    //commentString = commentString + '</div>';
                }

                var baseDate = '' + noteList.createdDate;

                var dateString = noteList.relativeCreatedDate; 
                    
                var poster = '<a href="https://login.salesforce.com/' + noteList.actor.id + '" target="_blank">' + noteList.actor.name + '</a>';
                var aPoster = document.createElement('a');
                aPoster.href = 'https://login.salesforce.com/' + noteList.actor.id;
                aPoster.target = '_blank';
                var txtAPoster = document.createTextNode(noteList.actor.name);
                aPoster.appendChild(txtAPoster);

                //buildView = buildView + '<dt><img src=\"' + noteList.photoUrl + '\" width="20px" /><sub>' + noteList.body.text + '</sub><sub>' + noteList.createdDate + '</sub></dt><dd>' + noteList.actor.name + '</dd>';
                //get and render post topics...
                var topicList = noteList.topics.topics;

                //var topicPrinter = '';
                var topicPrinter = document.createElement('div');
                topicPrinter.id = 'TopicSection';
                topicPrinter.className = 'padder greyText linkSpacing topicSectionClass' + noteList.id;

                var mainTopicslink = document.createElement('a');
                mainTopicslink.href = '#';
                mainTopicslink.id = noteList.id;
                mainTopicslink.className = 'topicPicker';
                mainTopicslink.appendChild(document.createTextNode('Topics'));

                var topicLinkList = document.createElement('span');
                topicLinkList.className = 'topicLinkList-' + noteList.id;
                topicLinkList.id = 'TopicLinkList-' + noteList.id;

                topicPrinter.appendChild(mainTopicslink);
                topicPrinter.appendChild(document.createTextNode(': '));

                var topicMenuLabel = 'Add Topics';

                if (topicList.length > 0) {
                    //topicPrinter = '<div id="TopicSection" class="padder greyText linkSpacing topicSectionClass' + noteList.id + '"><a href="#" id="' + noteList.id + '" class="topicPicker">Topics</a>: <span class="topicLinkList-' + noteList.id + '">';

                    for (var x = 0; x < topicList.length; x++) {
                        if (x > 0) {
                            //topicPrinter = topicPrinter + ', ';
                            topicLinkList.appendChild(document.createTextNode(', '));
                        }

                        //topicPrinter = topicPrinter + '<a href="' + lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=' + topicList[x].id + '" class="topicLink exLink" topicId="' + topicList[x].id + '" topicName="' + topicList[x].name + '">' + topicList[x].name + '</a>';

                        var newTopicLink = document.createElement('a');
                        newTopicLink.href = lgm.d.DataUrl + '/_ui/core/chatter/topics/TopicPage?id=' + topicList[x].id;
                        newTopicLink.className = 'topicLink exLink';
                        newTopicLink.setAttribute('topicId', topicList[x].id);
                        newTopicLink.setAttribute('topicName', topicList[x].name);
                        newTopicLink.appendChild(document.createTextNode(CharacterSupport(topicList[x].name)));

                        topicLinkList.appendChild(newTopicLink);
                    }

                    topicMenuLabel = 'Edit Topics';
                    topicPrinter.appendChild(topicLinkList);
                    //topicPrinter = topicPrinter + '</span></div>';
                } else {

                    topicPrinter.className = 'padder hiddenTopics greyText linkSpacing topicSectionClass' + noteList.id;

                    var topicPrinter2 = document.createElement('div');
                    topicPrinter2.id = 'TopicSection';
                    topicPrinter2.className = 'padder hiddenTopics greyText linkSpacing topicSectionClass' + noteList.id;

                    var mainTopicslink2 = document.createElement('a');
                    mainTopicslink2.href = '#';
                    mainTopicslink2.id = noteList.id;
                    mainTopicslink2.className = 'topicPicker';
                    mainTopicslink2.appendChild(document.createTextNode('Topics'));

                    var topicLinkList2 = document.createElement('span');
                    topicLinkList2.className = 'topicLinkList-' + noteList.id;
                    topicLinkList2.id = 'TopicLinkList-' + noteList.id;

                    topicPrinter2.appendChild(mainTopicslink2);
                    topicPrinter2.appendChild(document.createTextNode(': '));
                    topicPrinter2.appendChild(topicLinkList2);

                    topicPrinter.appendChild(topicLinkList);
                }

                var teDiv = document.createElement('div');
                teDiv.id = 'TE-' + noteList.id;
                teDiv.className = 'padder topicsEditor linkSpacing';
                teDiv.appendChild(RenderTopicEditor(noteList.id));
                teDiv.appendChild(RenderTopicDoneButton(noteList.id));
                teDiv.appendChild(RenderTopicClearDiv(noteList.id));
                teDiv.appendChild(RenderTopicsAc(noteList.id));

                var successDiv = document.createElement('div');
                successDiv.id = 'Success-' + noteList.id;
                successDiv.className = 'padder topicSuccessDiv linkSpacing';

                var successBold = document.createElement('span');
                successBold.className = 'boldSpan';
                successBold.appendChild(document.createTextNode('Success!'));

                successDiv.appendChild(successBold);
                successDiv.appendChild(document.createTextNode(' People are also talking about this.'));

                var postMenu = document.createElement('span');
                postMenu.className = 'feeditemActionMenu menuTrigger-' + noteList.id;
                postMenu.setAttribute('postsource', noteList.id);
                postMenu.setAttribute('title', 'More Actions');

                var boldTag = document.createElement('b');
                boldTag.className = '';

                postMenu.appendChild(boldTag);

                var postMenuDiv = document.createElement('div');
                postMenuDiv.className = 'postMenu postMenu-' + noteList.id;

                var postMenuList = document.createElement('span');
                postMenuList.className = 'postMenuItem menuItemTrigger-' + noteList.id;
                postMenuList.appendChild(document.createTextNode(topicMenuLabel));
            
                var dtPhoto = document.createElement('dt');
                var imgPhoto = document.createElement('img');
                imgPhoto.src = noteList.photoUrl;
                imgPhoto.width = '20';
                imgPhoto.className = 'imgNotFound';
                dtPhoto.appendChild(imgPhoto);
                dlChatter.appendChild(dtPhoto);
                var ddName = document.createElement('dd');
                var h4Name = document.createElement('h4');

                postMenuDiv.appendChild(postMenuList);

                var pPadder = document.createElement('p');
                pPadder.className = 'padder';
                pPadder.appendChild(msgText);

                //render differently for "TrackedChange" posts...
                if (noteList.type == 'TrackedChange') {

                    var noTitleNode = document.createElement('span');
                    noTitleNode.appendChild(ChatterFormatOutMessage(noteList));
                    noTitleNode.className = 'fixChatterPostHeader';

                    h4Name.appendChild(noTitleNode);
                    h4Name.appendChild(postMenu);
                    h4Name.appendChild(postMenuDiv);
                    h4Name.className = 'bottomPadder';
                    ddName.appendChild(h4Name);

                } else {
                    h4Name.appendChild(aPoster);
                    h4Name.appendChild(postMenu);
                    h4Name.appendChild(postMenuDiv);
                    h4Name.className = '';
                    ddName.appendChild(h4Name);
                    ddName.appendChild(pPadder);
                }

                var divPadder = document.createElement('div');
                divPadder.appendChild(aComment);
                divPadder.className = 'padder linkSpacing';
                var txtPadder1 = document.createTextNode(' - ');
                divPadder.appendChild(txtPadder1);
                divPadder.appendChild(aLike);

                var timePadder = document.createElement('time');
                var txtTimePadder = document.createTextNode(" " + dateString);
                timePadder.appendChild(txtTimePadder);
                divPadder.appendChild(document.createTextNode(' - '));
                divPadder.appendChild(timePadder);

                if (i == 0 && localStorage.NewPostSuggestions == 1) {

                    localStorage.NewPostSuggestions = 0;

                    var postPostSuggestionContainer = document.createElement('div');
                    postPostSuggestionContainer.id = 'PostSuggestionContainer-' + noteList.id;
                    postPostSuggestionContainer.className = 'postSuggestionContainer';

                    var postPostSuggestions = document.createElement('div');
                    postPostSuggestions.className = 'topics init';
                    postPostSuggestions.id = 'topicContainer' + noteList.id;
                    postPostSuggestions.setAttribute('data-entityid', noteList.id);

                    var highlightDiv = document.createElement('div');
                    highlightDiv.className = 'view highlight postpostsuggestionformat';

                    var topicEditLink = document.createElement('a');
                    topicEditLink.className = 'editLink';
                    topicEditLink.id = 'displayTopicEditorPostPrompt-' + noteList.id;
                    topicEditLink.appendChild(document.createTextNode('Click to add topics: '));

                    var suggestionList = document.createElement('span');
                    suggestionList.className = 'suggestions';
                    suggestionList.id = 'SuggestionsAfterPost';
                    suggestionList.appendChild(document.createTextNode('No suggestions. Add your own topics.'));

                    highlightDiv.appendChild(topicEditLink);
                    highlightDiv.appendChild(suggestionList);

                    postPostSuggestions.appendChild(highlightDiv);
                    postPostSuggestionContainer.appendChild(postPostSuggestions);

                    ddName.appendChild(postPostSuggestionContainer);
                    topicPrinter.style = 'display:none;';
                    ddName.appendChild(topicPrinter);

                    var fields = '[';
                    fields = fields + background.GenerateEntityField("TopicTextBody", msgText.innerText, '', 'false', '');
                    fields = fields + ']';

                    var fieldsStr = JSON.stringify(fields);

                    $("#TopicEditorId").val(noteList.id);

                    background.SelectEntity("topicsuggestionsafterpost", fieldsStr, background.GenerateBHKeyField(noteList.id), localTabId.innerText);
                } else {
                    ddName.appendChild(topicPrinter);
                }

                ddName.appendChild(teDiv);
                ddName.appendChild(successDiv);
                ddName.appendChild(divPadder);

                dlChatter.appendChild(ddName);
                dlChatter.appendChild(divCommentSection);

                SetupTopicManager(noteList.id, msgText);
            }

            $("#chatterfeed").empty();
            $("#chatterfeed").append(divChatter);
            $("#chatterfeed").append(divChatterLoader);
            $("#chatterfeed").append(dlChatter);
            AssingChatter();
            SetupChatterComments();
        }

        if (entityType == 'campaignfeedcontact') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Campaign (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('campaignCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var campaignRow = document.createElement('dt');

                var sub1 = document.createElement('sub');
                var sub2 = document.createElement('sub');

                var dd = document.createElement('dd');

                sub1.appendChild(document.createTextNode(noteList.Status));
                sub2.appendChild(document.createTextNode('+'));
                dd.appendChild(document.createTextNode('+'));

                campaignRow.appendChild(document.createTextNode(CharacterSupport(noteList.Campaign.Name)));
                campaignRow.appendChild(sub1);
                campaignRow.appendChild(sub2);

                buildView.appendChild(campaignRow);
                buildView.appendChild(dd);

                //buildView = buildView + '<dt>' + noteList.Campaign.Name + '<sub>' + noteList.Status + '</sub><sub>' + '</sub></dt><dd>' + '</dd>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('campaignfeedcontact');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);
        }

        if (entityType == 'campaignfeedlead') {
            var count = db.d.Values.length;
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Campaign (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = 'ui-accordion-header-icon ui-icon ui-icon-triangle-1-s';

            var accordionObject = document.getElementById('campaignCounter');
            accordionObject.innerHTML = '';
            accordionObject.appendChild(accordionSpan);
            accordionObject.appendChild(accordionText);

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                var campaignRow = document.createElement('dt');

                var sub1 = document.createElement('sub');
                var sub2 = document.createElement('sub');

                var dd = document.createElement('dd');

                sub1.appendChild(document.createTextNode(CharacterSupport(noteList.Status)));
                sub2.appendChild(document.createTextNode('+'));
                dd.appendChild(document.createTextNode('+'));

                campaignRow.appendChild(document.createTextNode("" + CharacterSupport(noteList.Campaign.Name)));
                campaignRow.appendChild(sub1);
                campaignRow.appendChild(sub2);

                buildView.appendChild(campaignRow);
                buildView.appendChild(dd);

                //buildView = buildView + '<dt>' + noteList.Campaign.Name + '<sub>' + noteList.Status + '</sub><sub>' + '</sub></dt><dd>' + '</dd>';
            }

            //buildView = buildView + '</dl>';

            var renderArea = document.getElementById('campaignfeedlead');
            renderArea.innerHTML = '';
            renderArea.appendChild(buildView);

        }

        $("body").delegate(".setLastKnown", "click", function() {
            localStorage.lastKnown = window.location;
        });


        if (action.toLowerCase() == "task-edit") {
            var setClosed = getParameterByName("SetClosed");
            if (setClosed == 1) {
                $(".lb-Task-Status").val("Completed");
            }
        }

        //if the AllDayEvent box is check in edit event, disable the time pickers
        if (action.toLowerCase() == "event-edit") {
            if ($("#chk-Event-IsAllDayEvent").is(':checked'))
            {
                $("#dd-Event-StartDateTime").attr("disabled", true);
                $("#dd-Event-EndDateTime").attr("disabled", true);
            }
                           
        }

        //localStorage.ReloadEditData = 1;

        //console.timeEnd("PassData");
    }

    function GetLookupValue(Name, valueToCheck) {
        var returnVal = "";

        var lgm = JSON.parse(localStorage.LayoutManager);

        for (var lk = 0; lk < lgm.d.DropDowns.length; lk++) {
            var drop = lgm.d.DropDowns[lk];


            if (drop.Name.toLowerCase() == Name.toLowerCase()) {

                for (var l = 0; l < drop.Values.length; l++) {

                    if (valueToCheck == drop.Values[l].Name || valueToCheck == drop.Values[l].Value) {
                        returnVal = drop.Values[l].Name;
                    }
                }
            }
        }


        return returnVal;
    }

    function TrimTaskSubject(subject) {
        var trimSubject = '';

        if (subject.length > 28) {
            trimSubject = subject.substring(0, 28);
            trimSubject = trimSubject + '...';
        } else {
            trimSubject = subject;
        }

        return CharacterSupport(trimSubject);
    }

    function RenderSpecialCharacters(input) {
        input = input.replace(/&#39;/g, "'");
        input = input.replace(/&quot;/g, "\"");
        input = input.replace(/&amp;/g, "&");

        return input;
    }

    function ChatterFormatOutMessageForComment(fld) {

        var newMessageText = '';

        var msgText = '';

        for (var i = 0; i < fld.comments.comments.length; i++) {
            var seg = fld.comments.comments[i];

            if (seg.type == 'Text') {
                msgText = msgText + seg.text;
            } else if (seg.type == 'Link') {
                msgText = msgText + '<a href="' + seg.url + '" class="exLink">' + seg.text + '</a>';
            } else if (seg.type == 'Mention') {

                var segUserId = '';
                var segName = '';

                try {
                    segUserId = seg.user.id;
                } catch(error) {
                    segUserId = seg.record.id;
                }

                msgText = msgText + '<a href="' + localStorage.InstanceUrl + '/' + segUserId + '" class="exLink">' + seg.text + "</a>";
            } else if (seg.type == 'Hashtag') {
                msgText = msgText + '<a href="' + localStorage.InstanceUrl + '/_ui/search/ui/UnifiedSearchResults?str=' + encodeURIComponent(seg.text) + '" class="exLink">' + seg.text + "</a>";
            } else {
                msgText = msgText + '' + seg.text;
            }
        }

        if (fld.attachment != null) {
            if (fld.attachment.type == 'Link') {
                msgText = msgText + '<br /><img src="/imgs/s.gif" class="publishericon" style="background-position: -3 -684px;" alt="add link"><a href="' + fld.attachment.url + '" class="exLink">' + fld.attachment.title + '</a>';
            }
        }

        return msgText;
    }

    function ChatterFormatOutMessage(fld) {

        var newMessageText = '';

        //var msgText = '';

        var divMessage = document.createElement('section');            

        for (var i = 0; i < fld.body.messageSegments.length; i++) {
            var seg = fld.body.messageSegments[i];

            if (seg.type == 'Text') {
                //msgText = msgText + seg.text;
                var txt = seg.text;
                //txt = txt.replace(/&lt;/g, "<");
                //txt = txt.replace(/&gt;/g, ">");
                txt = txt.replace(/&quot;/g, "\"");
                txt = txt.replace(/&#39;/g, "'");
                txt = txt.replace(/&amp;/g, "&");
                var txtMsg = document.createTextNode(txt);
                divMessage.appendChild(txtMsg);

            } else if (seg.type == 'Link') {
                //msgText = msgText + '<a href="' + seg.url + '" class="exLink">' + seg.text + '</a>';

                var aMsg = document.createElement('a');
                aMsg.className = 'exLink';
                aMsg.href = seg.url;
                var txtMsg = document.createTextNode(seg.text);
                aMsg.appendChild(txtMsg);
                divMessage.appendChild(aMsg);

            } else if (seg.type == 'Mention') {

                var segUserId = '';
                var segName = '';

                try {
                    segUserId = seg.user.id;
                } catch(error) {
                    segUserId = seg.record.id;
                }

                //msgText = msgText + '<a href="' + lgm.d.DataUrl + '/' + segUserId + '" class="exLink">' + seg.text + "</a>";

                var aMsg = document.createElement('a');
                aMsg.className = 'exLink';
                aMsg.href = localStorage.InstanceUrl + '/' + segUserId;
                var txtMsg = document.createTextNode(seg.text);
                aMsg.appendChild(txtMsg);
                divMessage.appendChild(aMsg);


            } else if (seg.type == 'Hashtag') {
                //msgText = msgText + '<a href="' + lgm.d.DataUrl + '/_ui/search/ui/UnifiedSearchResults?str=' + encodeURIComponent(seg.text) + '" class="exLink">' + seg.text + "</a>";

                var aMsg = document.createElement('a');
                aMsg.className = 'exLink';
                aMsg.href = localStorage.InstanceUrl + '/_ui/search/ui/UnifiedSearchResults?str=' + encodeURIComponent(seg.text);
                var txtMsg = document.createTextNode(seg.text);
                aMsg.appendChild(txtMsg);
                divMessage.appendChild(aMsg);

            } else {
                //msgText = msgText + '' + seg.text;

                var txtMsg = document.createTextNode(seg.text);
                divMessage.appendChild(txtMsg);
            }
        }

        if (fld.attachment != null) {
            if (fld.attachment.type == 'Link') {
                //msgText = msgText + '<br /><img src="/imgs/s.gif" class="publishericon" style="background-position: -3 -684px;" alt="add link"><a href="' + fld.attachment.url + '" class="exLink">' + fld.attachment.title + '</a>';

                var brMsg = document.createElement('br');
                divMessage.appendChild(brMsg);
                var imgMsg = document.createElement('img');
                imgMsg.src = '/imgs/s.gif';
                imgMsg.className = 'publishericon';
                imgMsg.setAttribute('style', 'background-position: -3 -684px;');
                imgMsg.alt = 'add link';

                var aMsg = document.createElement('a');
                aMsg.className = 'exLink';
                aMsg.href = fld.attachment.url;
                var txtMsg = document.createTextNode(CharacterSupport(fld.attachment.title));
                aMsg.appendChild(txtMsg);

                divMessage.appendChild(imgMsg);
                divMessage.appendChild(aMsg);
            }
        }

        if ((fld.type == 'CollaborationGroupCreated' && fld.body.text == null) || (fld.type == 'LinkPost' && fld.body.text == null)) {

            var txtMsg = document.createTextNode(fld.preamble.text);
            divMessage.appendChild(txtMsg);

            //msgText = fld.preamble.text;
        }

        if (fld.type == 'TrackedChange') {
            for (var i = 0; i < fld.preamble.messageSegments.length; i++) {
                var seg = fld.preamble.messageSegments[i];
                seg.text = CharacterSupport(seg.text);
                if (seg.type == "Text") {
                    //msgText = msgText + seg.text;

                    divMessage.appendChild(document.createTextNode(seg.text));
                } else if (seg.type == "EntityLink") {
                    //msgText = msgText + '<a href="' + lgm.d.DataUrl + '/' + seg.reference.id + '" class="exLink">' + seg.text + "</a>";

                    var msgText = document.createElement('a');
                    msgText.className = 'exLink';
                    msgText.href = localStorage.InstanceUrl + '/' + seg.reference.id;
                    msgText.appendChild(document.createTextNode(seg.text));

                    divMessage.appendChild(msgText);
                } else if (seg.type == "FieldChange") {
                    //msgText = msgText + '<span class="editChatterHover">' + seg.text + '</span>';

                    var msgText = document.createElement('span');
                    msgText.className = 'editChatterHover';
                    msgText.appendChild(document.createTextNode(seg.text));

                    divMessage.appendChild(msgText);
                }
            }
        }

        return divMessage;
    }

    function CleanOutBadNames(name) {
        name = name.split(" ").join("-");
        name = name.split(")").join("-");

        name = name.split("(").join("-");
        name = name.split(".").join("-");
        name = name.split(",").join("-");
        name = name.split("#").join("-");
        name = name.split("/").join("-");
        name = name.split("\\").join("-");
        name = name.split("&").join("-");
        name = name.split("%").join("-");
        name = name.split("\"").join("-");
        name = name.split("!").join("-");
        name = name.split("^").join("-");
        name = name.split("[").join("-");
        name = name.split("]").join("-");
        name = name.split(";").join("-");
        name = name.split(":").join("-");
        return name;
    }

    function GetLookup(Name, select) {

        var lgm = JSON.parse(localStorage.LayoutManager);

        var retStr = '';

        if (select == 1) {
            retStr = retStr + '<option value="-1">Please select</option>';
        }

        for (var lk = 0; lk < lgm.d.DropDowns.length; lk++) {
            var drop = lgm.d.DropDowns[lk];

            if (drop.Name.toLowerCase() == Name.toLowerCase()) {

                for (var l = 0; l < drop.Values.length; l++) {

                    retStr = retStr + '<option value="' + drop.Values[l].Value + '">' + CharacterSupport(drop.Values[l].Name) + '</option>';
                }
            }
        }

        return retStr;
    }


    function FreeTrialMessage() {
         

        $('#helpClose').hide();
        $('#helpwrapper').show();


    }

    function GetLookupMultiDetailsForEdit(lgm, Name, values) {

        var rtrStr = '';

        if (values == null) {
            values = '';
        }
        var val = values.split(";");
        var first = 0;

        var divReturn = document.createElement('div');

        for (var lk = 0; lk < lgm.d.DropDowns.length; lk++) {

            var drop = lgm.d.DropDowns[lk];

            if (drop.Name == Name) {

                for (var v = 0; v < val.length; v++) {

                    for (var l = 0; l < drop.Values.length; l++) {
                            
                        if (drop.Values[l].Value.trim() + '' == val[v].trim() + '') {

                            var divMs = document.createElement('div');
                            divMs.className = 'tag tag-' + CleanOutBadNames(drop.Values[l].Value);
                            divMs.setAttribute('tv', drop.Values[l].Value);
                            divMs.setAttribute('name', CleanOutBadNames(drop.Values[l].Value));

                            var txtMs = document.createTextNode(' ' + drop.Values[l].Value);
                            var spanMs = document.createElement('span');
                            spanMs.className = 'closeTag';
                            spanMs.setAttribute('tv', drop.Values[l].Value);
                            spanMs.setAttribute('name', CleanOutBadNames(drop.Values[l].Value));
                            spanMs.innerText = 'X';
                            divMs.appendChild(spanMs);
                            divMs.appendChild(txtMs);

                            divReturn.appendChild(divMs);
                        }

                    }

                }

            }
        }
        return  divReturn;
    }

    function GetLookupMultiDetails(lgm, Name, values) {

        var rtrStr = '';
        var val = values.split(",");
        var first = 0;

        for (var lk = 0; lk < lgm.d.DropDowns.length; lk++) {
            var drop = lgm.d.DropDowns[lk];
            
            if (drop.Name == Name) {

                for (var v = 0; v < val.length; v++) {

                    for (var l = 0; l < drop.Values.length; l++) {

                        if (drop.Values[l].Value.trim() + '' == val[v].trim() + '') {
                            if (first == 0) {
                                rtrStr = rtrStr + drop.Values[l].Name + '';
                                first = 1;
                            } else {
                                rtrStr = rtrStr + ', ' + drop.Values[l].Name;
                            }
                        }
                    }
                }
            }
        }

        return rtrStr;
    }

    function GetParse() {
        return localParseNeed.innerText;
    }
        
    function SetParse(val) {
        localParseNeed.innerText = "" + val;
    }

    function SetLocalTabId(val) {
        if (localTabId.innerText == "-1") {
            localTabId.innerText = '' + val;
        }
    }

    function utf8_to_b64(str) {
        return window.btoa(unescape(encodeURIComponent(str)));
    }

        
    chrome.extension.onMessage.addListener(
        function (request, sender, sendResponse) {
            //localTabId.innerText = '' + sender.tab.id;
            if (sender.tab == null) return true;

            SetLocalTabId(sender.tab.id);

            if (request.action == "GetRules") {

                sendResponse({ Rules: "" + localStorage.Rules, DebugMode: "", LayoutManager: background.GetLayoutManagerFromLocalStorage() });
            }

            if (request.action == "content") {

                localParseNeed.innerText = "1";

                localStorage.LastPage = request.content.length;
                localStorage.LastPageEncoded = utf8_to_b64(request.content);
                localStorage.ParseInformation = JSON.stringify(request.ParseInformation);
                localStorage.ParseUrl = sender.tab.url;
                //    // 
                var url = '' + sender.tab.url;
                url = '' + url.toLowerCase();


                 //Monster. Dirty Hack.
                if (url.indexOf('/jcm/resumesearch/searchresults.aspx') != -1 | url.indexOf('/jcm/candidates/') > -1) {
                    if (url.indexOf('#s=detail') != -1 ^ url.indexOf("#s=pageDetail") > -1) {
                        // 
                        // 
                        localParseNeed.innerText = "0";
                        ParseInfoToPage(url, false);
                    }
                }

                if (url.indexOf('oilandgasjobsearch.com/candidate/cvsearch?') != -1 ||
                    url.indexOf('recruiter.cwjobs.co.uk/recruitment/candidatesearch/') > -1 ||
                    url.indexOf('recruiter.totaljobs.com/recruitment/candidatesearch/candidatesearchresults.aspx') > -1 ||
                    url.indexOf('recruiter.retailchoice.com/recruitment/candidatesearch/candidatesearchresults.aspx') > -1 ||
                    url.indexOf('members.ocpinfo.com/search/search.aspx') > -1 ||
                    url.indexOf("/jcm/resumesearch/") > -1 ||
                    url.indexOf('recruiter.caterer.com/recruitment/candidatesearch/') > -1) {


                    localParseNeed.innerText = "0";
                    ParseInfoToPage(url, false);

                }


                if (localParseNeed.innerText == "1") {
                    localParseNeed.innerText = "0";
                    
                    ParseInfoToPage(url, false);
                }
            }
        });
    
//Looks through all rules and picks out just the custom gmail ones we have so we can 
//pass these to bar.js to check if we need to take these values
function Get_Custom_Gmail_Rules() {
    var parsedRules = (JSON.parse(localStorage.Rules).d);
    var rulesToReturn = new Array();
    for (var i = 0; i < parsedRules.length; i++) {
        var currentRule = parsedRules[i];
        if (currentRule != null) {
            if (currentRule.URL != null && currentRule.Xpath != null) {
                if (currentRule.URL.toLowerCase().indexOf("customgmail") >= 0) {
                    rulesToReturn.push(currentRule.Xpath);
                }
            }
        }
    }
    return rulesToReturn;
}

    // Inject our current page to get all the details needed.
    chrome.tabs.getSelected(null, function (tab) {
        localTabUrl.innerText = tab.url;
        if (tab.url.indexOf('chrome://') != -1 ^ tab.url.indexOf('https://chrome.google.com/') != -1 ^ tab.url.indexOf('chrome-extension:') != -1 ^ tab.url.indexOf("file://") != -1) {
            localTabId.innerText = '' + tab.url;
            localStorage.StopDoubleTap = tab.url;
        } else {

            SetLocalTabId(tab.id);
            localStorage.LastPageUrl = tab.url;

            var action12 = "" + getParameterByName("action");
            if (action12.indexOf("-Edit") !== -1 || action12.indexOf("-Add") !== -1) {
                localStorage.ParseUrl = tab.url;

                //If the user is in Gmail we do some custom parsing to get some of the values
                if (tab.url.indexOf("mail.google.com") !== -1) {

                    //Send message to bar.js to get the information for the bubble
                    chrome.tabs.sendMessage(parseInt(tab.id), {
                        MessageType: "SendDetailForParsingBack",
                        CustomGmailRules: Get_Custom_Gmail_Rules()
                    }, function(responseData) {
                        if (responseData) {
                            var runGmailParsingAgain = true;
                            var pageObj = background.GetPageCache(tab.id);
                            if (pageObj != null) {
                                if (pageObj.tabUrl != null && responseData.Url != null) {
                                    if (pageObj.tabUrl === responseData.Url) {
                                        if (pageObj.formsData !== "") {
                                            runGmailParsingAgain = false;
                                        }
                                    }
                                }
                            }

                            //If we didn't find anything cached to say the user had already inputted information into the 
                            //bubble run a reparse on the information from GMail
                            if (runGmailParsingAgain) {
                                if (responseData.CustomGmailOptFound) {
                                    // If we found that the email has some custom rules around this email then use our normal 
                                    // process of running the ContentGet.js script to obtain the values
                                    background.Fire_Content_Get_Script(tab);
                                } else {
                                    //Store the information we found in bar.js 
                                    localStorage.ParseInformation = JSON.stringify(responseData.ParseInformation);
                                    localStorage.ParseUrl = responseData.Url;
                                    ParseInfoToPage("mail.google.com", false);
                                }
                            } else {
                                ParseInfoToPage("mail.google.com", false);
                            }
                        }
                    });
                } else {
                    background.Fire_Content_Get_Script(tab);
                }
            }
        }

        RenderPage();

        var freeMessUrl = tab.url;
        var displayFreeMessaging = false;
        var onLinkedIn = false;
        var onGmail = false;
        var onGCalendar = false;
        var onEbstaConsole = false;
        var actionCheck = "" + getParameterByName("action");

        // Not on Gmail
        if (freeMessUrl.toLowerCase().indexOf("https://mail.google.co") == 0 || freeMessUrl.toLowerCase().indexOf("http://mail.google.co") == 0) {
            onGmail = true;
        }

        // Not on LinkedIn
        if (freeMessUrl.toLowerCase().indexOf("http://www.linkedin.co") == 0 || freeMessUrl.toLowerCase().indexOf("https://www.linkedin.co") == 0) {
            onLinkedIn = true;
        }

        // Not on Ebsta console
        if (freeMessUrl.toLowerCase().indexOf("ebsta.com") != -1) {
            onEbstaConsole = true;
        }

        // Not on Goole Calendar
        if (freeMessUrl.toLowerCase().indexOf("https://www.google.") == 0 || freeMessUrl.toLowerCase().indexOf("http://www.google.co") == 0 ) {
            if(freeMessUrl.toLowerCase().indexOf("/calendar") > -1){
                onGCalendar = true;
            }
        }

        if (localStorage.LicenceFound == "Free") {
           
            //if (!onLinkedIn && !onEbstaConsole && actionCheck != "Settings") {
            //if (!CanIAddEdit()) {
            //    //displayFreeMessaging = true;
            //}

            //}
        }
        //
        if (displayFreeMessaging) {
            DisplayFreeProductMessage();
            //$("#freeMessDiv").show();
            //$("#messageSuccess").hide();
            //$("body").delegate("#btProLicence", "click", function () {
            //    if (localStorage.TrialUsed == -1) {

            //        AssignLoaderWithText("#btProLicence", "Loading Free Trial...");

            //        background.CheckTrial();
            //    } else {
            //        background.CheckTrial();
            //        background.LogEventShort('Clicked-Upgrade-After-Trial');
            //    }

            //});
            if (actionCheck.indexOf("-Add") == -1 && actionCheck.indexOf("-Edit") == -1) {
                $(".closeFreeMes").hide();
            }
        }

    });

    function CheckStringLength(inputString, trimIndex) {
        if (inputString != null) {
            if (inputString.length > trimIndex) {
                inputString = inputString.substring(0, trimIndex) + '...';

                return inputString;
            } else {
                return inputString;
            }
        }

        return inputString;
    }

    function CleanUpSFObjectAndAddLookup(name) {
        name = name.replace("__c", "");
        name = name.replace("_", " ");

        var iconSpan = document.createElement('span');
        var className = '';

        if (name.indexOf('Contact') != -1) {
            //name = '<span class="candidate"></span>' + name;
            className = 'candidate';
        } else if (name.indexOf('Lead') != -1) {
            //name = '<span class="lead"></span>' + name;
            className = 'lead';
        } else if (name.indexOf('Account') != -1) {
            //name = '<span class="company"></span>' + name;
            className = 'company';
        } else if (name.indexOf('Opportunity') != -1) {
            //name = '<span class="opportunity"></span>' + name;
            className = 'opportunity';
        } else {
            if ((name.indexOf('People') != -1 || name.indexOf('Person') != -1) && localStorage.CrmDBType == 23) {
                //name = '<span class="candidate"></span>' + name;
                className = 'candidate';
            } else if ((name.indexOf('Client') != -1 || name.indexOf('Company') != -1) && localStorage.CrmDBType == 23) {
                //name = '<span class="company"></span>' + name;
                className = 'company';
            } else {
                //name = '<span class="customObject"></span>' + name;
                className = 'customObject';
            }
        }

        iconSpan.className = '' + className;

        return iconSpan;
    }

    function CleanUpSFObject(name) {
        name = name.replace("__c", "");
        name = name.replace("_", " ");
        return name;
    }

    //Takes a list of CRMEntities from LayoutManager and orders them by name for rendering within the Add menu
    function CustomSortEntitiesArrayByName(firstEntity, secondEntity)
    {
        if (firstEntity.Name > secondEntity.Name)
        {
            return 1;
        }
        if (firstEntity.Name < secondEntity.Name)
        {
            return -1;
        }
        return 0;
    }

    var renderOption = 0;
    // So we need a function to get all of the values off the field to Post / Store as object.
    var blockedobj = "";
    // We need a function to apply Stored objects and then Render the page using also Layout Manager. 
    // We need to understand what position the page is in. 
// Render function is got to take in ..
    

    //Renders the add entity list within the bubble
    function RenderAddEntityList(lgm)
    {
        $('#entityAdd').empty();
        blockedobj = "";

        if (lgm) {
            if (lgm.d) {
                if (lgm.d.CrmEntities) {
                    //Sort the array by name
                    lgm.d.CrmEntities.sort(CustomSortEntitiesArrayByName);
                    for (var d = 0; d < lgm.d.CrmEntities.length; d++) {
                        if (lgm.d.CrmEntities[d].Add == true) {

                            if (lgm.d.CrmEntities[d].Disabled == false) {
                                var addType = true;

                                var nameLabel = CleanUpSFObject(lgm.d.CrmEntities[d].Name);

                                var name = CleanUpSFObjectAndAddLookup(lgm.d.CrmEntities[d].Name);
                                var link = 'action=' + lgm.d.CrmEntities[d].Name + '-Add';

                                if (lgm.d.CrmEntities[d].FriendlyName.length != 0) {
                                    name = CleanUpSFObjectAndAddLookup(lgm.d.CrmEntities[d].FriendlyName);
                                    nameLabel = CleanUpSFObject(lgm.d.CrmEntities[d].FriendlyName);
                                }

                                if (lgm.d.CrmEntities[d].Fields.length == 0) {
                                    addType = false;
                                }

                                if (lgm.d.CrmEntities[d].RecordTypeId != 'Master') {

                                    name = CleanUpSFObjectAndAddLookup(lgm.d.CrmEntities[d].FriendlyName);
                                    nameLabel = CleanUpSFObject(lgm.d.CrmEntities[d].FriendlyName);

                                    link = link + '-' + lgm.d.CrmEntities[d].RecordTypeId;
                                    link = link + '&recordTypeId=' + lgm.d.CrmEntities[d].RecordTypeId;

                                    //Lets remove any master entities from the add list as there's a Record Type for this object
                                    $('#entityAdd').find("li[value=" + lgm.d.CrmEntities[d].Name + "][recordtype='Master']").remove();
                                }
                                else {
                                    //If we've already added an entity for this type then don't add to the add list
                                    if ($('#entityAdd').find("li[value=" + lgm.d.CrmEntities[d].Name + "]").length > 0) {
                                        addType = false
                                    }
                                }

                                if (addType) {

                                    var newAddItem = document.createElement('li');
                                    newAddItem.setAttribute('value', '' + lgm.d.CrmEntities[d].Name);
                                    newAddItem.setAttribute('recordType', '' + lgm.d.CrmEntities[d].RecordTypeId);

                                    var newAddItemLink = document.createElement('a');
                                    newAddItemLink.href = 'Main.html?' + link;
                                    newAddItemLink.appendChild(name);
                                    newAddItemLink.appendChild(document.createTextNode(nameLabel));

                                    newAddItem.appendChild(newAddItemLink);

                                    newAddItem.className = 'ebsta-add-record-link';

                                    $('#entityAdd').append(newAddItem);
                                }
                            }
                        }

                        if (lgm.d.CrmEntities[d].Disabled == true) {
                            if (blockedobj.length == 0) {
                                blockedobj = lgm.d.CrmEntities[d].Name;
                            } else {
                                blockedobj = "," + lgm.d.CrmEntities[d].Name;
                            }
                        }

                        localStorage.BlockObject = blockedobj;
                    }
                }
            }
        }
    }

    function RenderPage() {

        var postUpgrade = localStorage.LicenceUpgraded;

        if (postUpgrade == "true") {
            ShowTrialUpgradeMessage();
        }
           
        localStorage.NewPostSuggestions = 0;

        background.CheckLayoutManager();
       
        //only render licence type for enterprise users.
        if (localStorage.LicenceFound == "Enterprise") {
            $("#clientVersion").text(localStorage.LicenceFound);
        } else {
            $("#clientVersion").text("");
        }

        if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
            $("#txt_search").attr("placeholder", "Search Salesforce...");

            if (localStorage.CrmDBType == 20) {
                $("#txt_search").attr("placeholder", "Search Jobscience...");
            }

            if (localStorage.CrmDBType == 21) {
                $("#txt_search").attr("placeholder", "Search TalentRover...");
            }

            if (localStorage.CrmDBType == 22) {
                $("#txt_search").attr("placeholder", "Search TargetRecruit...");
            }

            if (localStorage.CrmDBType == 23) {
                $("#txt_search").attr("placeholder", "Search ClickToCloud...");
            }
        }

        if (localStorage.CrmDBType == 20) {
            try {
                contactJobApplicationCounter = 0;
            } catch (error) {
            }
        }

        //Check if we have a valid JSON in LayoutManager if not throw user our to let them try again
        if (IsValidJSON(localStorage.LayoutManager)) {
            var lgm = JSON.parse(localStorage.LayoutManager);
        } else {
            PopUpPageRedirector().LoginPage();
            return true;
        }

        if (renderOption == 0)
        {
            RenderAddEntityList(lgm);
            renderOption = 1;
        }

        $("#databaseTypeBottomBar-" + localStorage.CrmDBType).show();
        // Does tabid exist in the list.
        var tabId = localTabId.innerText;

        var chk = '' + getParameterByName("chk");

        if (localStorage.SearchTermTemp != null) {
            if (localStorage.SearchTermTemp != '') {
                $("#txt_search").val(localStorage.SearchTermTemp);
                localStorage.SearchTermTemp = '';
            }

        }

        if (chk.length != 0) {

            background.LogEventShort('Bubble-Dropped');             

            var randomnumber = Math.floor(Math.random() * (1000 - 10 + 1)) + 10;

            localStorage.SessionKey = randomnumber;

            var pageObj = background.GetPageCache(tabId);

            if (pageObj == null) {
                // Setup the Standard.
                if (localStorage.FirstCheck == null) {
                    localStorage.FirstCheck = '1';

                    if (localStorage.ChatterOnly != "1") {
                        localAction.innerText = "Welcome";
                    } else {
                        localAction.innerText = "WelcomeChatter";
                    }

                } else {
                    if (localStorage.ChatterOnly != "1") {
                        localAction.innerText = "Welcome";
                    } else {
                        localAction.innerText = "WelcomeChatter";
                    }
                }
                lastKnown.innerHTML = window.location;
            } else {
                window.location = pageObj.actionName;

                //check if the cached url and current url are exactly the same
                //if not, check if key profile id parts of the urls are the same, e.g on linkedin we can look for profile id in
                ///in/{profileId}/ to /in/{profileId}/detail/contact-info/ to tell us we are on the same profile and so can use
                //cached forms data
                if (localTabUrl.innerHTML == pageObj.tabUrl || sharedLinkedInHelper.DoUrlsContainTheSameId(localTabUrl.innerHTML, pageObj.tabUrl)) {

                    localStorage.DataForReload = pageObj.formsData;
                }

                localStorage.SearchTermTemp = pageObj.searchName;

                // Stop processing anything going forward.
                return false;
            }

        }

        if (localStorage.Message != null) {
            var message = '' + localStorage.Message;

            if (message != '') {

                $('#messageName').text(message);

                $('#messageSuccess').css('display', 'inline');

                $('#messageSuccess').fadeOut(4000);


                //if (localTabUrl.innerHTML.indexOf("mail.google.com") != -1)
                //{
                //    background.DisplayGoogleInboxMessage(message, localTabId.innerText);
                //}

                localStorage.Message = '';
            }

        }

        var newTask = getParameterByName("action");

        var titleByType = getParameterByName("Type");

        if (newTask != null) {
            localAction.innerText = newTask;
        }
        if (localAction.innerText == '') {
            if (localStorage.FirstCheck == null) {
                localStorage.FirstCheck = '1';
                if (localStorage.ChatterOnly != "1") {
                    localAction.innerText = "Welcome";
                } else {
                    localAction.innerText = "WelcomeChatter";
                }
            } else {
                if (localStorage.ChatterOnly != "1") {
                    localAction.innerText = "Welcome";
                } else {
                    localAction.innerText = "WelcomeChatter";
                }
            }
        }
        // Lets get the layout Manager. We need Render a Layout Manager. 
        var action = localAction.innerText;

        if (action.indexOf("Chatter") == -1) {
            localStorage.UnpostedChatter = "";
        }

        if (action.indexOf("Settings") != -1) {
            $(".settingsLoader").empty();
        }
            
        var layoutPosition = 0;
        localStorage.Action = action;

        var layoutFound = false;

        for (var i = 0; i < lgm.d.Layouts.length; i++) {
            if (lgm.d.Layouts[i].ActionName == action) {

                layoutPosition = i;

                layoutFound = true;
            }
        }

        var layoutForDisplay = lgm.d.Layouts[layoutPosition];

        if (!layoutFound) {
            //if we have no layout we will be falling over here anyway...so lets attempt to bail to a master layout...

            var mainAction = action.split('-');
            var objectId = getParameterByName("id");

            if (mainAction.length > 0 && objectId != null && typeof objectId != "undefined") {
                var objectType = mainAction[0];

                if (localStorage.renderCrashRetry != 0) {
                    MoveMe('Main.html?action=' + objectType + '&RecordTypeId=Master&id=' + objectId);

                    //if we fail we don't want to end up in a loop...
                    localStorage.renderCrashRetry = 0;

                    return false;
                } else {
                    localStorage.renderCrashRetry = 1;
                }
            }
        } else {
            //we have a layout so we want to attempt to handle subsequent crashes...
            localStorage.renderCrashRetry = 1;
            background.HistoryAdd(window.location, tabId);
        }
            
        //if (localAction.innerText != "LinkJumper" && localAction.innerText.indexOf("-Add") == -1 && localAction.innerText.indexOf("-Edit") == -1)            
        if (localAction.innerText.indexOf("-Add") == -1 && localAction.innerText.indexOf("-Edit") == -1) {
            //create the eventname
            var eventName = localAction.innerText;
            if (eventName != "Welcome" && eventName != "Search" && eventName != "LinkJumper") {
                eventName = eventName + "-View";
                eventName = eventName + "-" + localStorage.CrmDBType;
            }

        }

         
        chrome.tabs.getSelected(null, function (tab) {
            var fields = new Array();
            fields.push(2);
            fields.push(tab.id);
            fields.push("");
            fields.push(tab.url);
            fields.push(0);
            fields.push("PageTitle:" + tab.title);
            fields.push("Action:" + localAction.innerText);
            fields.push("Url:" + window.location);

            background.LogViewerItem(fields);
            // background.LogEventShort("Record-Opened-CRM");
            // chrome.tabs.update(tab.id, { url: uri });
        });
        
        //if (localStorage.StopDoubleTap != localStorage.LastPageUrl) {

        // }

        //background.HistoryAdd(window.location, tabId);


        // $("#mainContent").hide();
        mainContent.innerHTML = ProcessTags(layoutForDisplay.FormLayout);

        //If this is the Error page lets set some speicific error messages for certain errors
        if (action == "Error") {
            var didWeHitErrorCase = false;
            var errorType = getParameterByName("errorType");

            if (errorType != null) {
                if (errorType.indexOf("NotFound") != -1)
                {
                    var objectType = getParameterByName("objectType");
                    if (objectType.split('-').length > 1) {
                        objectType = objectType.split('-')[0];
                    }
                    
                    //If we didn't find anything for object type within the parameters we'll show a default error message
                    if (objectType.length > 0) {
                        SetErrorMessage(objectType + " doesn’t exist or is not accessible for your User Profile.", "Please contact your Salesforce Administrator for more information.");
                        didWeHitErrorCase = true;
                    }
                }
            }

            //If we didn't hit a error case we know about lets display a default message
            if (!didWeHitErrorCase) {
                SetErrorMessage("An error has occured.", "Please contact Ebsta Support for more information.");
            }
        }
           
        freeMessDiv.innerHTML = ShowFreeMessage2();

        if (localStorage.OpenFromTaskBar == 1) {
            $("#taskFilterDropdown").attr('selectedIndex', 3);
        }
        //$("#mainContent").effect('slide', 'slow');
        $("#mainContent").show();

        // Should search For this really. 


        $(function () {
            $("#tabs").tabs();
        });

        // Setup Match Events. 

        var textHidden = $("body").find(".dupe");

        textHidden.each(function() {
            $(this).focusout(function() {
                CheckMatch();
            });
        });

        $("#dedupe").empty();

        var accordianApply = 0;

        if (layoutForDisplay.FormLayout.indexOf("accordian") != -1) {
            accordianApply = 1;
        }

        SetupEvents(accordianApply);

        //Only load dependent picklists on add/edit screens - no point elsewhere.
        if (localAction.innerText.indexOf("-Add") != -1 || localAction.innerText.indexOf("-Edit") != -1) {
            SetupPicklistDependancies();
        }

        HelperMessages();

        if (titleByType == "LogACall") {
            $('#pageTitle').text('Log A Call');
        }

        if (localStorage.ChatterOnly == "1") {
            //$("#topMenuPopUp").empty();
            $("#topMenuPopUp").remove();
            $("#btSearch").attr('disabled', 'disabled');
        }

        if (action == "GmailSettings") {

            //request calendar sync status...
            background.LoadCalendarStatus(2, tabId);
        }
        if (action == "GoogleAccounts") {

            $('.gmailAccountsSave').find('img').hide();
            //request calendar sync status...
            background.GetGmailAccounts(tabId, true);
        }

        //Updates the client to show the only actions a user can do for a Converted Lead
        if (getParameterByName("IsConverted").toLowerCase() == "true") {
            //background.console.time("UpdatePageForConvertedLead");
            UpdatePageForConvertedLead();
            //background.console.timeEnd("UpdatePageForConvertedLead");
        }

        //If there are no labels in view then we need to feedback a error message to the user saying you've no rights to do this on this object
        if ($('label').length == 0)
        {
            $('#entityfields button.left.clear, #entityfields button.right.save').hide();
            var actionSplit = action.split("-");
            if (actionSplit.length > 1) {
                SetErrorMessage("You currently cannot " + actionSplit[1].toLowerCase() + " " + actionSplit[0] + " objects. Please contact your Salesforce Administrator.", "");
                $('#failureMessage').show().css('visibility', 'visible');
            }
        }

        return true;
    }

    //Updates the client to show the only actions a user can do for a Converted Lead
    function UpdatePageForConvertedLead() {
        //Hide profile edit buttons
        $("a.edit").hide();

        //hide actions buttons at the top
        $("#LogaCall,#Task, #Event, #ConvertLead, #Campaign").hide();

        //Hide open Activities add buttons
        $("a.addEvent, a.addTask").hide();

        //Hide Log a Call buttons
        $("a.logCallTask").hide();

    }

    function RenderAvailablePicklistValues(fieldName, fieldId, dropDowns, controllerType) {

        //ensure we have both of these, we may pass down some fields that are not real dropdown fields
        //like on events we have the time picker dropdown that is not a real field in itsself
        if (fieldName != null && fieldId != null) {

            for (var i = 0; i < dropDowns.length; i++) {

                (function (i) {

                    var dropDown = dropDowns[i];

                    if (fieldName == dropDown.ControllerName) { //the current field is a controller to this drop down list.

                        //check default load values. 
                        if (controllerType != "checkbox") {
                            if ($(".par-" + dropDown.ApiName).val() == -1) {
                                $(".par-" + dropDown.ApiName).attr("disabled", true); //in dependant picklists we must have a value to render child elements.
                            }
                        }

                        //set the onchange event for the controlling dropdown.
                        $("body").on("change", "#" + fieldId, function () {

                            var listenForCheckBoxes = false;

                            if (controllerType == "checkbox") {
                                listenForCheckBoxes = $(this).prop('checked');
                            }

                            var childRowsAdded = 0;

                            var selectedIndex = $("#" + fieldId + " option:selected").index();

                            if (controllerType == "checkbox") {
                                if (listenForCheckBoxes) {
                                    selectedIndex = 1
                                } else {
                                    selectedIndex = 0;
                                }
                            }

                            var childControlName = dropDown.ApiName;

                            // We're naming the some field different in GetLayoutManager so we need an additional selector to find the element we need
                            // i.e. all email fields have name .par-Email not the api name i.e. par-Test_Email__c so we try and find it secondly by the name attribute
                            var childControlElement = $(".par-" + childControlName + ", select[name='" + childControlName + "'], input[name='" + childControlName + "']")

                            if ($(this).val() != -1 || listenForCheckBoxes) {

                                var childDropDownValues = dropDown.Values;

                                var priorSelection = ''

                                if (localAction.innerText.indexOf('-Edit') != -1) { //let's keep the preloaded value when editing existing records.
                                    priorSelection = $(childControlElement).val();
                                }

                                $(childControlElement).html('');

                                if (controllerType != "checkbox") { //if there is a 'please select' option we need to adjust the index.
                                    selectedIndex = selectedIndex - 1;
                                }

                                for (var x = 0; x < childDropDownValues.length; x++) {

                                    var validFor = childDropDownValues[x].validFor;

                                    if (selectedIndex > -1 && validFor) {
                                        var isDependant = isDependentValue(selectedIndex, validFor)

                                        if (isDependant) { //if this option is valid - render it in the child element.
                                            RenderChildElement(childDropDownValues[x].Name, childDropDownValues[x].Value, childControlName);
                                            childRowsAdded++;
                                        }
                                    }
                                }
                                if (childRowsAdded == 0) { //if the child element is empty we should load default 'please select' and disable.
                                    var defaultValue = document.createElement("option");
                                    defaultValue.setAttribute("name", "");
                                    defaultValue.setAttribute("value", "-1");
                                    defaultValue.appendChild(document.createTextNode("Please select"));

                                    $(childControlElement).append(defaultValue);

                                    $(childControlElement).attr("disabled", true);

                                    //If this a Multi_picklist then remove the values from that box (if any have been chosen)
                                    if ($(childControlElement).attr('class')) {
                                        if ($(childControlElement).attr('class').indexOf("lm-") != -1) {
                                            $('.lm').each(function () {
                                                if ($(this).attr('id') == childControlName) {
                                                    $(this).find('.tag').remove();
                                                    return false;
                                                }
                                            });

                                            //Remove any values from the input box
                                            $("input[name='" + childControlName + "']").val('').removeClass('ui-state-error');
                                        }
                                    }
                                } else {
                                    $(childControlElement).attr("disabled", false);

                                    //attempt to hold the previously selected value.
                                    $(childControlElement).val(priorSelection);
                                }
                            } else {
                                if (controllerType != "checkbox") {

                                    //Skip setting the value on the Mutli Picklist fields
                                    var setValue = true;
                                    if ($(childControlElement).attr('class')) {
                                        if ($(childControlElement).attr('class').indexOf("lm-") != -1) {
                                            setValue = false;
                                        }
                                    }

                                    if (setValue) {
                                        $(childControlElement).attr("value", "-1"); //This needs to be set to -1 so dependancies of this dependancy can be updated
                                    }

                                    $(childControlElement).attr("disabled", true); //in dependant picklists we must have a value to render child elements.
                                }
                            }

                            $("#" + childControlName).find('.tag').remove(); //Remove values if this is a dependant picklist 

                            // Helps update a dependancy of a dependancy i.e if dep2 was a dependancy of dep1 which was in turn a dependancy of dep0,
                            // only dep 1 would update on changes of dep0 so the trigger below will help update dep2 and any waterfall type chain
                            $(childControlElement).trigger("change");

                        });

                        // Helps set initial values for settings, especially fields that have default values which activate/deactivate the dependancy
                        $("#" + fieldId).trigger("change");
                    }
                }(i));
            }
        }
    }

    function RenderChildElement(valueName, valueValue, controlName) {

        if ($(".par-" + controlName + " option, select[name='" + controlName + "'] option").length == 0) { //there are no values in the dropdowns currently.
            var defaultValue = document.createElement("option");
            defaultValue.setAttribute("name", "");
            defaultValue.setAttribute("value", "-1");
            defaultValue.appendChild(document.createTextNode("Please select"));

            $(".par-" + controlName + ", select[name='" + controlName + "']").append(defaultValue);
        }

        var newValue = document.createElement("option");
        newValue.setAttribute("name", valueName);
        newValue.setAttribute("value", valueValue);
        newValue.appendChild(document.createTextNode(valueName));

        $(".par-" + controlName + ", select[name='" + controlName + "']").append(newValue);
    }

    function SetupPicklistDependancies() {

        var lgmObj = JSON.parse(localStorage.LayoutManager);
        var dropDowns = lgmObj.d.DropDowns;

        //parent dropdowns.
        $('[id^="dd"]').each(function (index) {
            var fieldName = $(this).attr("name");
            var fieldId = $(this).attr("id");

            RenderAvailablePicklistValues(fieldName, fieldId, dropDowns, 'dropdown');            
        });

        //parent checkboxes.
        $('[id^="chk"]').each(function (index) {
            var fieldName = $(this).attr("name");
            var fieldId = $(this).attr("id");

            RenderAvailablePicklistValues(fieldName, fieldId, dropDowns, 'checkbox');
        });
    }

    function isDependentValue(index, validFor) {
        var base64 = new sforce.Base64Binary("");
        var decoded = base64.decode(validFor);
        var bits = decoded.charCodeAt(index >> 3);

        return ((bits & (0x80 >> (index % 8))) != 0);
    }

    function SetupDependentPicklistValues() {

        var lgmObj = JSON.parse(localStorage.LayoutManager);
        
        if (lgmObj.d.DependentLookupGroups != null) {
            for (var i = 0; i < lgmObj.d.DependentLookupGroups.length; i++) {
                var dependencyGroup = lgmObj.d.DependentLookupGroups[i];

                var controllerName = dependencyGroup.ControllerName;
                var childControlName = dependencyGroup.ChildControlName;
                var groupTag = dependencyGroup.DependencyGroupTag;
                var label = dependencyGroup.LookupItemLabel;
                var value = dependencyGroup.LookupItemName;

                var allowedSelectionsList = dependencyGroup.AllowedSelections;

                var parentController = $('.par-' + controllerName);

                $('.par-' + controllerName).attr("childelementcontrol", childControlName);

                if (parentController.length > 0) { //we've found the parent controller - process the rest.

                    var parentControlType = $('.par-' + controllerName).prop('type');

                    //set up parent dropdown controls.
                    if (parentControlType == "select-one") {
                        parentController.children('option').each(function () {

                            var dropdownControlValue = $(this).attr("value");
                            var dropdownControlTags = $(this).attr("DependencyGroups");

                            if (dropdownControlValue != "-1") {

                                var optionAllowedInGroup = false;

                                if (allowedSelectionsList != null && typeof allowedSelectionsList != "undefined") {
                                    for (var j = 0; j < allowedSelectionsList.length; j++) {
                                        var groupOptionValue = allowedSelectionsList[j].Value;

                                        if (groupOptionValue == dropdownControlValue) { //option is in the allowed list - add the group tag to it.
                                            optionAllowedInGroup = true;
                                            break;
                                        }
                                    }
                                }

                                if (!optionAllowedInGroup) { //this option should not load in this group - add to the exclude tags.
                                    var newTagList = '';

                                    if (dropdownControlTags == null) {
                                        newTagList = '' + groupTag;
                                    } else {
                                        //check we haven't added the tag already - no need to add again as we are already not loading this group.
                                        var splitter = dropdownControlTags.split(",");
                                        var tagAlreadyExcluded = false;
                                        for (var x = 0; x < splitter.length; x++) {
                                            if (splitter[x] == groupTag) {
                                                tagAlreadyExcluded = true;
                                            }
                                        }

                                        if (!tagAlreadyExcluded) {
                                            newTagList = '' + dropdownControlTags + ',' + groupTag;
                                        } else {
                                            newTagList = '' + dropdownControlTags;
                                        }
                                    }

                                    $(this).attr("DependencyGroups", newTagList);
                                } else {

                                }
                            }
                        });
                    }

                    //set up checkbox parent controls.
                    if (parentControlType == "checkbox") {
                        var checkedGroupSet = $('.par-' + controllerName).attr("checkedgroup");
                        var uncheckedGroupSet = $('.par-' + controllerName).attr("uncheckedgroup");

                        var newCheckedGroup = '';

                        for (var j = 0; j < allowedSelectionsList.length; j++) {
                            newCheckedGroup = allowedSelectionsList[j].Value;
                            break;
                        }

                        if (newCheckedGroup == "checked") {
                            $('.par-' + controllerName).attr("checkedgroup", groupTag);
                        } else {
                            $('.par-' + controllerName).attr("uncheckedgroup", groupTag);
                        }
                    }

                    //render the hidden field.
                    var hiddenDropDownChild = document.createElement('input');
                    hiddenDropDownChild.type = 'hidden';
                    hiddenDropDownChild.className = 'depenencyDropdownChild' + childControlName + ' ' + groupTag;
                    hiddenDropDownChild.setAttribute("label", label);
                    hiddenDropDownChild.setAttribute("name", value);
                    hiddenDropDownChild.setAttribute("grouptag", groupTag);
                    hiddenDropDownChild.setAttribute("controller", controllerName);
                    hiddenDropDownChild.setAttribute("childcontrolname", childControlName);
                    parentController.after(hiddenDropDownChild);

                    //set the delegate check/change event for the dropdown.
                    $("body").undelegate(".par-" + controllerName, "change");
                    $("body").delegate(".par-" + controllerName, "change", function () {

                        var selectedOption = $(this).find(":selected");

                        var parentControlType = $(this).prop("type");
                        var checkboxControlValue = '';
                        var checkboxGroupTrigger = '';

                        if (parentControlType == "checkbox") {
                            checkboxControlValue = $(this).prop("checked");

                            if (checkboxControlValue + "" == "true") {
                                checkboxGroupTrigger = $(this).attr("uncheckedgroup");
                            } else {
                                checkboxGroupTrigger = $(this).attr("checkedgroup");
                            }
                        }

                        var forbiddenOptionList = selectedOption.attr("DependencyGroups");

                        $(".par-" + $(this).attr("childelementcontrol")).empty(); //empty the child list - we are re-rendering it.

                        //disable the child picklist if no value is selected - it is dependent!
                        if (selectedOption.attr("value") == "-1") {
                            $(".par-" + $(this).attr("childelementcontrol")).attr("disabled", "disabled");
                        } else {
                            $(".par-" + $(this).attr("childelementcontrol")).attr("disabled", false);
                        }

                        var childOptionsProcessed = 0;

                        $(".depenencyDropdownChild" + $(this).attr("childelementcontrol")).each(function () { //get all child control values for re-rendering.
                            var taggedInExcludeList = false;
                            var dependencyTagGroup = $(this).attr("grouptag");

                            //check against the comma seperated lists of excluded groups.
                            if (parentControlType == "checkbox") {
                                if (dependencyTagGroup == checkboxGroupTrigger) {
                                    taggedInExcludeList = true;
                                }
                            } else {
                                if (forbiddenOptionList != null) {
                                    var splitter = forbiddenOptionList.split(",");
                                    for (var k = 0; k < splitter.length; k++) {
                                        if (splitter[k] == dependencyTagGroup) { //we are in the exclude list - don't render in the child dropdown.
                                            taggedInExcludeList = true;
                                        }
                                    }
                                }
                            }

                            if (!taggedInExcludeList) { //if we are not in the exclusion list for this group - render it in the child dropdown.
                                var childControlName = $(this).attr("childcontrolname");
                                var nameValue = $(this).attr("name");
                                var labelValue = $(this).attr("label");

                                if (childOptionsProcessed == 0) {
                                    var defaultDropdownItem = document.createElement('option');
                                    defaultDropdownItem.value = '-1';
                                    defaultDropdownItem.innerText = 'Please select';

                                    $(".par-" + childControlName).append(defaultDropdownItem); //add the default unselected option.
                                }

                                var newDropdownItem = document.createElement('option');
                                newDropdownItem.name = nameValue;
                                newDropdownItem.value = labelValue;
                                newDropdownItem.innerText = labelValue;

                                $(".par-" + childControlName).children().first().after(newDropdownItem); //add the new option to the child dropdown list.

                                childOptionsProcessed++;
                            }
                        });

                        if (childOptionsProcessed == 0) { //if the child control is empty or no valid values - disable it by default as per salesforce UI.
                            var defaultDropdownItem = document.createElement('option');
                            defaultDropdownItem.value = '-1';
                            defaultDropdownItem.innerText = 'Please select';
                            $(".par-" + $(this).attr("childelementcontrol")).append(defaultDropdownItem); //add the default unselected option.

                            $(".par-" + $(this).attr("childelementcontrol")).attr("disabled", "disabled"); //disable it.
                        }
                    });

                    var currentSelectedValue = '' + $('.par-' + controllerName).val();

                    //whilst we're at the parent controller - we should deactivate the child control if nothing is selected.
                    if (currentSelectedValue == "-1") {
                        $(".par-" + $('.par-' + controllerName).attr("childelementcontrol")).attr("disabled", "disabled");
                    } else {
                        $(".par-" + $('.par-' + controllerName).attr("childelementcontrol")).attr("disabled", false);
                    }

                    //we need to set up the checkbox parent controls on page load.
                    $('.par-' + controllerName).change();
                }
            }
        }
    }

    function ShowCalendarSettingsStatus(jsonInput)
    {
        var json = JSON.parse(jsonInput);
        var result = json.d;

        var errorMessage = result.ErrorMessage;

        var isActive = result.IsActive;

        if (errorMessage == "NOSYNCFOUND") {
            $("#btGmailOn").removeClass('hidden');
            $("#gmailOnText").removeClass('hidden');
            $("#btGmailOff").addClass('hidden');
            $("#gmailOffText").addClass('hidden');
            $("#GoogleSettingsSection").addClass('hidden');

            $("#gmailSettingsLoader").addClass('hidden');

            $("#CalendarList").html('<span>Sync process has not been set up yet.</span>');
            $("#SyncDatesLoader").hide();
            $("#SyncDates").show();
            $("#StatusLoader").hide();
        } else {

            $("#GoogleSettingsSection").removeClass('hidden');

            var systemStatus = result.SystemStatus;
            var isSuspended = result.IsSuspended;

            $("#StatusLoader").hide();

            if ('' + systemStatus == 'false') {
                $("#btGmailOn").removeClass('hidden');
                $("#gmailOnText").removeClass('hidden');
                $("#btGmailOff").addClass('hidden');
                $("#gmailOffText").addClass('hidden');

                //$("#lockedOutText").removeClass('hidden');
                $("#gmailSettingsLoader").addClass('hidden');

                $(".calendarStatusLabel").text("Disabled");
            } else {
                if ('' + isActive == "false") {
                    $("#btGmailOn").removeClass('hidden');
                    $("#gmailOnText").removeClass('hidden');
                    $("#btGmailOff").addClass('hidden');
                    $("#gmailOffText").addClass('hidden');

                    $("#gmailSettingsLoader").addClass('hidden');
                    $("#gmailSuspendedText").addClass("hidden");

                    $(".calendarStatusLabel").text("Off");
                } else {
                    if ('' + isSuspended == "1") {
                        $(".calendarStatusLabel").text("Paused");
                        $("#gmailSuspendedText").removeClass("hidden");

                        $("#btGmailOff").addClass('hidden');
                        $("#gmailOffText").addClass('hidden');
                        $("#btGmailOn").addClass('hidden');
                        $("#gmailOnText").addClass('hidden');
                    } else {
                        $("#btGmailOff").removeClass('hidden');
                        $("#gmailOffText").removeClass('hidden');
                        $("#btGmailOn").addClass('hidden');
                        $("#gmailOnText").addClass('hidden');
                        $("#gmailSuspendedText").addClass("hidden");

                        $(".calendarStatusLabel").text("On");
                    }                    

                    $("#gmailSettingsLoader").addClass('hidden');
                }
            }

            var dateCreated = new Date(parseInt(result.DateCreated.substr(6)));
            var lastSyncDate = new Date(parseInt(result.LastSync.substr(6)));
            

            var fullDateCreated = '' + dateCreated.toLocaleTimeString() + ' on ' + dateCreated.toLocaleDateString();
            var fullLastSyncDate = '' + lastSyncDate.toLocaleTimeString() + ' on ' + lastSyncDate.toLocaleDateString();

            //account for early syncs that don't have a start date and are chucking down rubbish.
            if (dateCreated.toLocaleDateString() + '' == "1/2/1") {
                fullDateCreated = 'N/A';
            }

            if (lastSyncDate.toLocaleDateString() + '' == "1/2/1") {
                fullLastSyncDate = 'N/A';
            }

            $(".dateCreatedSpan").text(fullDateCreated);
            $(".lastSyncSpan").text(fullLastSyncDate);
            $("#SyncDatesLoader").hide();
            $("#SyncDates").show();

            var webUserId = result.WebUserId;

            //grab calendars.
            background.SelectEntity("calendarsforsync", "", background.GenerateBHKeyField(webUserId), localTabId.innerText);
        }
    }
    
    //Render the Page for GmailAccounts
    function ShowGmailAccounts(json) 
    {
        var json = JSON.parse(json);
        var parsedJson = json.d;
        var gmailAccountListDiv = $('.gmailAccountstext');

        $('.gmailAccountstext').find('img').hide();

        if (parsedJson != null && parsedJson.length > 0)
        {
            //Create table
            var tableDiv = document.createElement('table');
            tableDiv.setAttribute("class", "googleAccountTable");

            for (var i = 0; i < parsedJson.length; i++)
            {
                var rowDiv = GoogleAccount.CreateGmailAccountRow(parsedJson[i]);
                if (rowDiv !== null) {
                    tableDiv.appendChild(rowDiv);
                }
            }
            gmailAccountListDiv.append(tableDiv);

            SaveGoogleAccountsBtnListener($('.savebtn'));
        }
        else
        {
            $('.gmailAccountsContainer').find('.settingsHeader').remove();
            var noEmailDiv = document.createElement('div');
            noEmailDiv.setAttribute("class", "googleAccountEmail");
            noEmailDiv.innerHTML = "You have no Gmail accounts synced with this account, please visit Gmail";
            gmailAccountListDiv.append(noEmailDiv);
            $('.savebtn').hide();
        }
    }

    //Listener for the save button in Google Accounts Screen to save new info
    function SaveGoogleAccountsBtnListener()
    {
        $('.savebtn').click(function ()
        {
            $('.gmailAccountUpdatedMessage').remove();

            localStorage.GmailAccountActive = 'reload';
            
            var fieldList = '[';
            fieldList = fieldList + background.GenerateEntityField("Id", localStorage.WebUserId, '', true, '');

            $('.gmailAccountsSave').find('img').show(); 

            var emailList = '[';
            var countOfEmails = 0;
            $('.gmailAccountsContainer').find('input').each(function ()
            {
                var saveItem = GoogleAccount.GenerateSaveObjectForGmailAccountCheckBox(this);
                if (saveItem && saveItem.googleAccountEmail) {

                    if (countOfEmails === 0) {
                        emailList = emailList + JSON.stringify(saveItem);
                    } else {
                        emailList = emailList + ',' + JSON.stringify(saveItem);
                    }

                    GoogleAccount.UpdateLocalStorage(saveItem.googleAccountEmail, saveItem.isActive, saveItem.dropBarWithNoAuth);

                    countOfEmails++;
                }
            });

            emailList = emailList + ']';

            fieldList = fieldList + ',' + background.GenerateEntityField('GoogleAccountEmailList', emailList, '', 'false');
            fieldList = fieldList + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
            fieldList = fieldList + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
            fieldList = fieldList + ',' + background.GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
            fieldList = fieldList + ']';

            var strFields = JSON.stringify(fieldList);
            var tabId = localTabId.innerText;

            background.AddEntity('updategoogleaccounts', strFields, tabId);
        });
    }

    function HelperMessages() {

    }

    $("body").delegate("#helpClose", "click", function() {
        $('#helpwrapper').hide();
        // Update local storage.. To remove the message. 
        UpdateHelperClosed();
    });

    function UpdateHelperClosed() {
        var action = localAction.innerText;

        var arrys = JSON.parse(localStorage.HelperCheck);
        var pos = -1;

        for (var d = 0; d < arrys.length; d++) {
            var help = arrys[d];

            if (help.actionId == action) {
                pos = d;
            }
        }

        if (pos != -1) {
            var newCheck = arrys[pos];
            newCheck.closed = 1;

            arrys.splice(pos, 1, newCheck);
            localStorage.HelperCheck = JSON.stringify(arrys);
        }

    }

    function HelperCheck(actionId, views, closed) {
        this.actionId = actionId;
        this.views = views;
        this.closed = closed;
    }

    function CheckCompanyLookup() {
        var companyCoId = document.getElementById("CoId").value;
        if (companyCoId != '-1') {

            $("#CompanyId").attr('readonly', true);
            $("#CompanyId").addClass('readonlyTextBox');

            $("#btLookupCompany").text("Change");
        }
    }


    function CheckHelperStorage(action, views) {

        var returnVal = true;

        if (localStorage.HelperCheck == null) {
            var arry = [];

            arry.push(new HelperCheck(action, 1, 0));

            localStorage.HelperCheck = JSON.stringify(arry);
        } else {
            var arrys = JSON.parse(localStorage.HelperCheck);

            var pos = 0;
            var found = 0;

            for (var d = 0; d < arrys.length; d++) {
                var help = arrys[d];

                if (help.actionId == action) {
                    found = 1;
                    pos = d;
                    if (help.closed == 1) {
                        returnVal = false;
                        break;
                    }

                    if (help.views >= views) {
                        returnVal = false;
                        break;
                    }


                }

            }
            if (returnVal) {
                if (found == 1) {
                    // Need to update the array. 
                    var newCheck = arrys[pos];
                    newCheck.views = newCheck.views + 1;

                    arrys.splice(pos, 1, newCheck);


                } else {
                    var newCheck = new HelperCheck(action, 1, 0);
                    arrys.push(newCheck);

                }

                localStorage.HelperCheck = JSON.stringify(arrys);
            }
        }

        return returnVal;
    }


    function SetupEvents(accordianApply) {

        var action = localAction.innerText;
        var index = $("#taskFilterDropdown").val();

        var lgmObj = JSON.parse(localStorage.LayoutManager);

        var id;
        if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null) {
            id = localStorage.UserId;
        } else {
            id = lgmObj.d.SaleforceUserId;
        }

        if (action == "Welcome") {
            if (action == "Welcome" && localStorage.OpenFromTaskBar == 1) {
                $("#taskFilterDropdown").val('3');
            }
            $("body").delegate(".myTasksTab", "click", function() {
                    
                //var id = getParameterByName("id");
                $('#taskFilterDropdown').show();
                $('#btAddTaskHP').show();
                $('#homepagedateandeventbutton').hide();

                if (localStorage.ChatterOnly != "1") {
                    RenderHomePageTasks(index);
                } else {
                    $("#homepageTaskInnerDiv").empty();
                    $(".btHomePageAdd").attr('disabled', 'disabled');
                }

                $(this).addClass('pointer');
            });

            $("body").delegate(".myEventsTab", "click", function () {
                AssignLoaderWithText("#homepageEventInnerDiv", "Loading Events... ");

                //var id = getParameterByName("id");
                $('#taskFilterDropdown').hide();
                $('#btAddTaskHP').hide();
                $('#homepagedateandeventbutton').show();

                if (localStorage.ChatterOnly != "1") {
                    background.SelectEntity("allopenevents", "", background.GenerateBHKeyField(id), localTabId.innerText);
                } else {
                    $("#homepageEventInnerDiv").empty();
                    $(".btHomePageAdd").attr('disabled', 'disabled');
                }
                $(this).addClass('pointer');
            });

            $("body").delegate(".chatterToMe", "click", function() {
                AssignLoaderWithText(".chatsToMeSection", "Loading Chatter... ");

                var id = getParameterByName("id");
                background.SelectEntity("chatterfeedtome", "", background.GenerateBHKeyField(id), localTabId.innerText);
                $(this).addClass('pointer');
            });


            $("#taskFilterDropdown").change(function () {
                if (localStorage.ChatterOnly != "1") {
                    RenderHomePageTasks(-2);
                }
            });
        }

        if (action == "WelcomeChatter") {

            if (localStorage.LicenceFound == "Free" || localStorage.LicenceFound == 'Chatter') {

                $('.recentactivity').addClass('sizeDown');
            }

            var prevMessage = localStorage.UnpostedChatter;

            if (prevMessage != null && typeof prevMessage != "undefined") {
                if (prevMessage.length > 0) {
                    $("#chatterWidget1").val(prevMessage);
                }
            }

            $("body").delegate("#btValidate", "click", function() {
                background.ValidateSessionLicence(0, 0, 0);


            });

            $("body").delegate(".chatterToMe", "click", function () {
                $('.homeChatter').text('');

                AssignLoaderWithText(".chatsToMeSection", "Loading Chatter... ");

                var id = getParameterByName("id");
                background.SelectEntity("chatterfeedtome", "", background.GenerateBHKeyField(id), localTabId.innerText);
                $(this).addClass('pointer');
            });

            $("body").delegate(".chatterWhatIFollow", "click", function () {
                $('.homeChatter').text('');

                AssignLoaderWithText(".chatsFollowsSection", "Loading Chatter... ");

                var id = getParameterByName("id");
                background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
                $(this).addClass('pointer');
            });

            $("body").delegate(".chatterBookmarked", "click", function () {
                $('.homeChatter').text('');

                AssignLoaderWithText(".chatsBookmarksSection", "Loading Chatter... ");

                var id = getParameterByName("id");
                background.SelectEntity("chatterfeedbookmarked", "", background.GenerateBHKeyField(id), localTabId.innerText);
                $(this).addClass('pointer');
            });

            $("body").delegate(".chatterAllCompany", "click", function () {
                $('.homeChatter').text('');

                AssignLoaderWithText(".chatsAllCompany", "Loading Chatter... ");

                var id = getParameterByName("id");
                background.SelectEntity("chatterfeedallcompany", "", background.GenerateBHKeyField(id), localTabId.innerText);
                $(this).addClass('pointer');
            });
        }
                
        if (action == "Settings") {

            //console.log('RENDER SETTINGS PAGE');

            if ("" + localStorage.Username !== "") {
                $(".ebsta-usernamemessage").text("" + localStorage.Username);
                $(".ebsta-settings-currentusercontainer").show();
            }

            if (typeof localStorage.GmailGo != "undefined" && localStorage.GmailGo != null) {
                if (localStorage.GmailGo.toLowerCase() == "true") {
                    if (typeof localStorage.LicenceFound != "undefined" && localStorage.LicenceFound != null) {
                        if (localStorage.LicenceFound.toLowerCase() == "pro" || localStorage.LicenceFound.toLowerCase() == "enterprise" || localStorage.GmailGoLicence.toLowerCase() == "true") {
                            $('#hidebutton').removeClass('hidden');
                        }
                    }
                }
            }

            var reloadSettingsOnLoad = getParameterByName("reload");

            if (reloadSettingsOnLoad == 1 && reloadAgain) {
                reloadAgain = false;
                AssignLoaderWithText(".settingsLoader", "Loading Settings... ");

                ReloadLayoutSetup();
            }

            $("body").delegate("#btEbstaPro", "click", function() {
                background.CheckTrial();

            });

            // Attach Events..
            $("body").delegate("#btLogout", "click", function() {
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Settings-Logout', '2']);
                ClearKey();
            });

            SettingsPageClickEvents().EnableClickEvents();

            $("body").undelegate("#btControlPanel", "click");
            $("body").delegate("#btControlPanel", "click", function() {
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Settings-Settings', '2']);
                openURLNewTab('https://console.ebsta.com/LoginSalesforce.aspx?k=' + localStorage.WebUserId);
            });

            $("body").undelegate("#btCustomiseField", "click");
            $("body").delegate("#btCustomiseField", "click", function () {
                openURLNewTab('https://console.ebsta.com/LoginSalesforce.aspx?k=' + localStorage.WebUserId +'&j=crmintegration&objectLinker=Account');
            });
          
            $("body").undelegate("#btGmailSettings", "click");
            $("body").delegate("#btGmailSettings", "click", function ()
            {
                // Sends user to Gmail and we'll set the 'shouldWeShowCalendarSync' variable in background.js 
                // so when they actually get through to the gmail page the Onboarding process shold open straight up in Calendar Sync
                openURLNewTab('https://mail.google.com');
                background.shouldWeShowCalendarSync = true;
                background.LogEventShort("Google Calendar Sync Bubble Click");
                window.close();
            });

            $("body").undelegate("#btContactSync", "click");
            $("body").delegate("#btContactSync", "click", function () {
                // Sends user to Gmail and we'll set the 'shouldWeShowContactSync' variable in background.js 
                // so when they actually get through to the gmail page the Onboarding process should open straight up in Contac Sync step
                openURLNewTab('https://mail.google.com');
                background.shouldWeShowContactSync = true;
                background.LogEventShort("Google Contact Sync Bubble Click");
                window.close();
            });

            $("body").undelegate("#btGmailOptions", "click");
            $("body").delegate("#btGmailOptions", "click", function () {
                MoveMe('Main.html?action=GmailOptions');
            });

            //Google Accounts Button
            $("body").undelegate("#btGoogleAccounts", "click");
            $("body").delegate("#btGoogleAccounts", "click", function () {
                MoveMe('Main.html?action=GoogleAccounts');
            });

            $("body").undelegate("#btEmailTracking", "click");
            // 
            $("body").delegate("#btEmailTracking", "click", function () {
                ShowEmailTrackingSummaryFromMain();
            });

            $("#lbLayoutManager").text("Version: " + background.GetVersion() + ", Layout Version : " + localStorage.LayoutManagerVersion);

            HideElementsForAbtesting();
        }

        if (action == "GmailSettings")
        {
            //TURN SYNC ON
            AssignLoaderWithText("#LoaderGif", "");


            $("body").undelegate("#btGmailOn", "click");
            $("body").delegate("#btGmailOn", "click", function () {
                openURLNewTab('https://console.ebsta.com/Google/CalendarAuth.aspx?wb=' + localStorage.WebUserId);
            });


            $("body").undelegate("#btGmailOff, #btGmailOffSuspended", "click");
            $("body").delegate("#btGmailOff, #btGmailOffSuspended", "click", function ()
            {
                background.GoogleCalendarSyncOnOff("CalendarSyncOff", localTabId.innerText);
                $("#gmailOnText").show();
                $("#gmailOffText").hide();
                $(".calendarStatusLabel").text("Off");
                $("#gmailSuspendedText").addClass("hidden");
            });
            

        }

        if (action == "GmailOptions") {
            
        }

        if (action == "GmailCalendarAuth") {
            $("body").undelegate("#btGmailCalendarAuth", "click");
            $("body").delegate("#btGmailCalendarAuth", "click", function () {                                                
                openURLNewTab('https://console.ebsta.com/Google/CalendarAuth.aspx?wb=' + localStorage.WebUserId);
            });
        }



        if (action.indexOf('-Add') != -1) {
            var textHidden = $("body").find(".lm");

            textHidden.each(function() {
                var strid = $(this).attr("id");
                var strLookup = $(this).attr("name");
                var entity = $(this).attr("ent");
                SetupMultiSelector(strid, strLookup, entity, lgmObj);
            });
        }

        if (action.indexOf('-Edit') != -1) {
            var textHidden = $("body").find(".lm");

            textHidden.each(function() {
                var strid = $(this).attr("id");
                var strLookup = $(this).attr("name");
                var entity = $(this).attr("ent");
                SetupMultiSelector(strid, strLookup, entity, lgmObj);
            });
        }

        if (accordianApply == 1) {

            $("#accordian").accordion({ heightStyle: "fill", collapsible: "true" });

            $("#accordian").on("accordionactivate",
                function(event, ui) {
                    var index = jQuery(this).find("h3").index(ui.newHeader[0]);
                    //    var index2 = jQuery(this).find("h3").index(ui.oldHeader[0]);
                    if (localStorage.CrmDBType == 1) {
                        if (index == 4 && action !== "Company") {
                            jQuery(this).accordion("option", "active", 0);
                        } else if (index == 6 && action == "Company") {
                            jQuery(this).accordion("option", "active", 0);
                        } else if (index == 5 && action == "Company") {
                            jQuery(this).accordion("option", "active", 0);
                        }
                    }
                    if (localStorage.CrmDBType == 2) {
                        if (index == 10 || index == 8 || index == 0) {
                            jQuery(this).accordion("option", "active", 0);
                        }
                    }

                    //set accordion events for jobscience...
                    if (localStorage.CrmDBType == 20) {
                        if (index == 10 || index == 8 || index == 0) {
                            jQuery(this).accordion("option", "active", 0);
                        }
                    }

                    //set accordion events for talentrover...
                    if (localStorage.CrmDBType == 21) {
                        if (index == 12 || index == 10 || index == 8 || index == 0) {
                            jQuery(this).accordion("option", "active", 0);
                        }
                    }

                    if (localStorage.CrmDBType == 22) {
                        if (index == 10 || index == 8 || index == 0) {
                            jQuery(this).accordion("option", "active", 0);
                        }
                    }

                    if (localStorage.CrmDBType == 23) {
                        if (index == 10 || index == 8 || index == 0) {
                            jQuery(this).accordion("option", "active", 0);
                        }
                    }
                });

            $("#accordian").on("accordionbeforeactivate",
                function(event, ui) {
                    var index = jQuery(this).find("h3").index(ui.newHeader[0]);
                    var index2 = jQuery(this).find("h3").index(ui.oldHeader[0]);
                    if (localStorage.CrmDBType == 1) {
                        if (index2 == 0 && index == 4) {
                            return false;
                        } else if (index2 == 0 && index == 6) {
                            return false;
                        } else if (index2 == 0 && index == 5) {
                            return false;
                        }
                    }
                    if (localStorage.CrmDBType == 2) {
                        if (index2 == 0 && index == 8) {
                            return false;
                        }
                    }

                    //set accordion events for jobscience...
                    if (localStorage.CrmDBType == 20) {
                        if (index2 == 0 && index == 10) {
                            return false;
                        }
                    }

                    //set accordion events for talentrover...
                    if (localStorage.CrmDBType == 21) {
                        if (index2 == 0 && index == 12) {
                            return false;
                        }
                    }
                });

            if (localStorage.Mode == "false") {
                $(".ui-state-default").unbind("click");
            }
        }

        if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {

            //this stops us double tapping parse info on pages where we dont 
            //reloade the page to display a new person
            if (localStorage.LastPageUrl) {
                if (localStorage.LastPageUrl.indexOf(".monster.") === -1
                    && localStorage.LastPageUrl.indexOf("mail.google.com") === -1
                    && localStorage.LastPageUrl.indexOf("go.zoominfo.com/#/apps/") === -1 ) {
                    ParseInfoToPage(localStorage.LastPageUrl, false);
                }
            }
        
            if (action == "Contact") {
                $('#activityWidgetChatter').delegate("#btShareChatter", "click", function() {
                    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'ButtonBottom-Settings', '1']);                   
                });
            }
                
            if (action.indexOf("Event") != -1) {
                var typ = '' + getParameterByName("Type");
                $('#txt-event-Subject').val(typ);
                $("#TxtLookup-WhoId").addClass("autofire");
                $("#TxtLookup-WhatId").addClass("autofire");

                SetupEventEvents();
                    

                var entity = "" + getParameterByName("entity");
                var id = "" + getParameterByName("id");
                var title = "" + getParameterByName("title");
                    

                if (entity == "Lead" || entity == "Contact") {
                    if (entity == "Lead") {
                        $("#dd-event-WhoId").val("Lead");
                        $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-event-WhatId").attr("disabled", true);
                        $("#WhatId").removeClass("data");
                        
                    }

                    $("#TxtLookup-WhoId").val(title);
                    $("#TxtLookup-WhoId").addClass("readonlyTextBox");
                    $("#WhoId").val(id);
                    $("#TxtLookup-WhoId").attr("disabled", true);
                    $("#CoLookup-WhoId").text("Change");

                    $("#dd-task-WhoId").val(entity);
                } else if (id.length > 0) {
                        
                    if (action.indexOf("-Edit") == -1) {
                        $("#TxtLookup-WhatId").addClass("readonlyTextBox");
                        $("#TxtLookup-WhatId").val(title);
                        $("#WhatId").val(id);
                        $("#TxtLookup-WhatId").attr("disabled", true);
                        $("#CoLookup-WhatId").text("Change");
                    }
                    //$("#dd-task-WhatId").val(entity);
                }

                if (typ == "LogACall") {
                    $('#txt-Task-Subject').val("Call");
                    $("#dd-task-Status").val("Completed");
                    $("#txt-Task-ActivityDate").datepicker('setDate', new Date());
                }
                //  SetReadOnlyOnReference('OwnerId');
            }

            if (action == "Task-Add") {
                var typ = '' + getParameterByName("Type");
                $('#txt-Task-Subject').val(typ);
                $("#TxtLookup-WhoId").addClass("autofire");
                $("#TxtLookup-WhatId").addClass("autofire");

                var entity = "" + getParameterByName("entity");
                var id = "" + getParameterByName("id");
                var title = "" + getParameterByName("title");
                //
                if (entity == "Lead" || entity == "Contact") {
                    //Disable fields if add task is selected for a lead
                    if (entity == "Lead") {
                        $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-task-WhatId").attr("disabled", true);
                        $("#WhatId").removeClass("data");
                    }

                    $("#TxtLookup-WhoId").val(title);
                    $("#TxtLookup-WhoId").addClass("readonlyTextBox");
                    $("#WhoId").val(id);
                    $("#TxtLookup-WhoId").attr("disabled", true);
                    $("#CoLookup-WhoId").text("Change");

                    $("#dd-task-WhoId").val(entity);
                } else if(id.length > 0){
                    $("#TxtLookup-WhatId").addClass("readonlyTextBox");
                    $("#TxtLookup-WhatId").val(title);
                    $("#WhatId").val(id);
                    $("#TxtLookup-WhatId").attr("disabled", true);
                    $("#CoLookup-WhatId").text("Change");

                    $("#dd-task-WhatId").val(entity);
                }

                if (typ == "LogACall") {
                    $('#txt-Task-Subject').val("Call");
                    $("#dd-task-Status").val("Completed");
          
                    var today = GetDateToday();

                    if (today != null) {

                        // using the FormatDateLocal function to format the date according to user's SF locale
                        dateToday = FormatDateLocal(today);

                        $("#txt-Task-ActivityDate").val(dateToday);
                    }

                }
                //  SetReadOnlyOnReference('OwnerId');
            }

            if (action == "Opportunity-Add") {

                var entityPassing1 = "" + getParameterByName("entity");
                if (entityPassing1 == "Account") {
                    var name = getParameterByName("AccountId");
                    var nameTitle = getParameterByName("title");
                    var keyId = getParameterByName("id");

                    if (name.length > 0) {
                        $("#TxtLookup-AccountId").val(nameTitle);
                        $("#TxtLookup-AccountId").prop('disabled', true);
                        $("#AccountId").val(name);
                        $("#btLookupCompany").addClass("hidden");
                    } else {
                        $("#TxtLookup-AccountId").prop('disabled', false);
                        //SC-688 / SC-670
                        // background.GetExtraInformation("ContactAccount", keyId, "AccountId");

                    }
                }

                if (entityPassing1 == "Contact") {
                    var nameTitle = "" + getParameterByName("title");
                    var keyId = "" + getParameterByName("id");

                    if (nameTitle.length > 0) {
                        $("#TxtLookup-ContactId").val(nameTitle);
                        $("#TxtLookup-ContactId").prop('disabled', true);
                        $("#ContactId").val(keyId);
                        $("#btLookupCompany").addClass("hidden");
                    } else {
                        $("#TxtLookup-ContactId").prop('disabled', false);
                        //SC-688 / SC-670
                        // background.GetExtraInformation("ContactAccount", keyId, "AccountId");

                    }

                    var keyIdAccount = "" + getParameterByName("AccountId");
                    var nameAccountTitle = "" +getParameterByName("AccountName");
                        
                    if (nameAccountTitle != "Empty") {
                        if (nameAccountTitle.length > 0) {
                            $("#TxtLookup-AccountId").val(nameAccountTitle);
                            $("#TxtLookup-AccountId").prop('disabled', true);
                            $("#AccountId").val(keyIdAccount);
                            $("#btLookupCompany").addClass("hidden");
                        } else {
                            $("#TxtLookup-AccountId").prop('disabled', false);
                              
                        }
                    }

                }


            }

            if (action == "Contact-Add") {
                var urlcheck = localTabUrl.innerText;
                    
                if (localStorage.ParseUrl != null) {
                    urlcheck = localStorage.ParseUrl;
                }
                //if we are on linkedin, and we have not already shown the messaage, when trying to add - show this message explaining re linkedin terms, and set the 
                //localstorage flag to 1 so it is not shown again during this session
                if (urlcheck.indexOf(".linkedin.com") != -1 && localStorage.linkedInMessageShown != 1) {
                    var message = '<h3><b style="font-weight: bold;">Ebsta automatically pre-populates the Salesforce fields below on <a href="https://ebsta.zendesk.com/entries/40875758-What-websites-is-Ebsta-optimized-for-" target="_blank">50+ websites</a>, but not on LinkedIn due to their terms and conditions. <a href="https://ebsta.zendesk.com/entries/33846963-Using-Ebsta-on-LinkedIn" target="_blank">More information</a>.</p>';
               
                    $('#dedupe').html(message);
                    $('#dedupe').addClass("linkedinMessage");
                    localStorage.linkedInMessageShown = 1;
                }

                var name = getParameterByName("title");

                if (name.length > 0) {
                    $("#TxtLookup-AccountId").val(name);
                    $("#TxtLookup-AccountId").prop('disabled', true);
                    $("#AccountId").val(getParameterByName("id"));
                    $("#btLookupCompany").addClass("hidden");
                } else {
                    $("#TxtLookup-AccountId").prop('disabled', false);
                }

                SetReadOnlyOnReference("AccountId");
                    
            }

            if (action == "Lead-Add") {
                var urlcheck = localTabUrl.innerText;

                if (localStorage.ParseUrl != null) {
                    urlcheck = localStorage.ParseUrl;
                }
                //if we are on linkedin, and we have not already shown the messaage, when trying to add - show this message explaining re linkedin terms, and set the 
                //localstorage flag to 1 so it is not shown again during this session
                if (urlcheck.indexOf(".linkedin.com") != -1 && localStorage.linkedInMessageShown != 1) {
                    var message = '<h3><b style="font-weight: bold;">Ebsta does not automatically pre-populate Salesforce fields on LinkedIn due to their terms and conditions. <a href="https://ebsta.zendesk.com/entries/33846963-Using-Ebsta-on-LinkedIn" target="_blank">More information</a>.</p>';
                    $('#dedupe').html(message);
                    $('#dedupe').addClass("linkedinMessage");
                    localStorage.linkedInMessageShown = 1;
                }                      
            }

            if (action.indexOf("Account-Add") != -1) {
                var urlcheck = localTabUrl.innerText;

                if (localStorage.ParseUrl != null) {
                    urlcheck = localStorage.ParseUrl;
                }
                //if we are on linkedin, and we have not already shown the messaage, when trying to add - show this message explaining re linkedin terms, and set the 
                //localstorage flag to 1 so it is not shown again during this session
                if (urlcheck.indexOf(".linkedin.com") != -1 && localStorage.linkedInMessageShown != 1) {
                    var message = '<h3><b style="font-weight: bold;">Ebsta does not automatically pre-populate Salesforce fields on LinkedIn due to their terms and conditions. <a href="https://ebsta.zendesk.com/entries/33846963-Using-Ebsta-on-LinkedIn" target="_blank">More information</a>.</p>';
                    $('#dedupe').html(message);
                    $('#dedupe').addClass("linkedinMessage");
                    localStorage.linkedInMessageShown = 1;
                }

            }

            if (action == "Campaign-Add") {
                SetupCampaignView();
            }
        }

        if (action.toLowerCase().indexOf("task") != -1) {
            SetupTaskEvents();
        }

        SetupDefaults();

        if (action.indexOf("-Add") != -1 || action.indexOf("-Edit") != -1) {
        
            SetupCustomObjectDropDowns();

            //Set the default format for the date picker
            $(".valid-datetime, .valid-date").datepicker({ dateFormat: "dd-mm-yy", firstDay: 1 });

            //Look to see if we have this users locale then try and find the format for that locale so we change the display
            if (localStorage.Locale != null) {
                var dateFormatToUse = GetDateFormatFromLocale(localStorage.Locale);

                //If we've detected a locale format then re-assigned the datepicker format
                if (dateFormatToUse.length > 0) {
                    $('.valid-datetime, .valid-date').datepicker("destroy");
                    $(".valid-datetime, .valid-date").datepicker({ dateFormat: dateFormatToUse, firstDay: 1 });
                }
            }            
                
            var chk = '' + getParameterByName("chk");
            if (chk.length == 0) {
                if (localStorage.DataForReload != null) {
                    ReloadData(localStorage.DataForReload);
                }
            }

            $(':input:enabled:visible:first').focus();

            $("#entitySearchLookup").dialog({
                height: 400,
                width: 350,
                modal: true,
                autoOpen: false,
                closeText : ''
            });

            $(".autofire").focusout(function() {

                var btName = $(this).attr("id");
                var fieldId = btName.replace("CoLookup-", "");

                var entityText = '' + $('#' + fieldId).val();
                // No Value set
                if (entityText == '') {
                    var bt = $(this).attr("autofire");
                    $("#" + bt).click();
                }
            });

            $("body").delegate(".btLookup", "click", function () {

                $('#entitySearchLookup').dialog('open');
                $('#entitySearchLookup').find("p,fieldset,img").show();

                var entityName = $(this).attr("datasource");
                var entityLabel = $(this).attr("searchLabelText");
                var btName = $(this).attr("id");
                var fieldId = btName.replace("CoLookup-", "");
                var searchTerm = "" + $("#TxtLookup-" + fieldId).val();
                $("#lbEntityNameLookup").val(searchTerm);
                $("#btEntitySearchName").val(fieldId);
                var source = '' + entityName;

                source = source.replace(/\^/gi, ' or ');

                $(".entitySearchLabel").text(entityLabel);
                $("#btEntitySearch").attr("datasource", entityName);
                $("#entitySearchLookup").attr("title", "Lookup " + entityName);
                //$("#entityResults").hide();

                $(".entitySearchLabelResults").text(entityLabel + ' Results');

                $(".txtSearchBox").keypress(function(e) {
                    if (e.which == 13) {
                        var entityName = $("#btEntitySearch").attr("datasource");

                        var search = $("#lbEntityNameLookup").val();

                        AssignLoader("#entityResults");

                        background.Search("lookup-" + entityName, search, localTabId.innerText, null, null, null, null, 0, PassData, function(responseObject) {
                            if(responseObject && responseObject.errormessage) {
                                ShowSearchError(responseObject.errormessage);
                            }
                        });
                    }
                });

                if (searchTerm.length != 0) {
                    var entityName = $("#btEntitySearch").attr("datasource");

                    var search = $("#lbEntityNameLookup").val();

                    AssignLoader("#allLogins");
                    AssignLoader("#entityResults");

                        
                    background.Search("lookup-" + entityName, search, localTabId.innerText, null, null, null, null, 0, PassData, function(responseObject) {
                        if(responseObject && responseObject.errormessage) {
                            ShowSearchError(responseObject.errormessage);
                        }
                    });
                } else {
                    $("#entityResults").empty();
                }
            });

            //Setup dialog box for entries to select into the text box
            $("body").delegate(".btComboBoxLookup", "click", function ()
            {
                //Clear results list ready for new inputs
                $("#entityResults").empty();

                //Open the dialog box
                $('#entitySearchLookup').dialog('open');

                var lookupList = $(this).attr("datasource");

                //Hide elements we don't need
                $('#entitySearchLookup').find("p,fieldset,img").hide();

                //Get field name to pass to the dialog
                var fieldName = $(this).prev('input').prev("label").attr('for');

                var textNode = document.createTextNode("Select a " + fieldName + " below");

                //Change header text
                $('.entitySearchLabelResults').append(textNode);
                
                //Create div elements for combox box options
                var resultsDiv = CreateElementsForComboBoxOptions(lookupList, lgmObj);

                //Get the id of the textbox we want the results to append to
                var textBoxId = $(this).prev("input").attr('id');

                AttachClickListenerToComboBoxOptions(textBoxId,resultsDiv);

                //Display results
                $('#entityResults').append(resultsDiv);
            });

            $("body").delegate("#btEntitySearch", "click", function() {

                var entityName = $("#btEntitySearch").attr("datasource");

                var search = $("#lbEntityNameLookup").val();

                if (search.length != 0) {
                    AssignLoader("#allLogins");
                    AssignLoader("#entityResults");
                }

                background.Search("lookup-" + entityName, search, localTabId.innerText, null, null, null, null, 0, PassData, function (responseObject) {
                    if (responseObject && responseObject.errormessage) {
                        ShowSearchError(responseObject.errormessage);
                    }
                });
            });

            $('.autofire').each(function(i, obj) {
                //test
                var entityname = $(this).attr('id').replace('TxtLookup-', '');
                SetReadOnlyOnReference(entityname);
            });
        }
    }

/**
 * Changes the CampaignMember View so that when its selected from a Contact or Lead it will display the relevant fiels only
 * @returns {} 
 */
function SetupCampaignView() {
    var entity = getParameterByName("entity");
    var recordName = getParameterByName("title");
    var recordId = getParameterByName("id");

    //Set values passed in with the url paramaters
    $("#TxtLookup-" + entity + "Id").val(recordName);
    $("#" + entity + "Id").val(recordId);

    var entityToRemove = entity === "Contact" ? "Lead" : "Contact";

    //Remove either the Contact or Leads fields so that the campaign only tries to relate the selected entity not both of them
    var inputToRemove = document.getElementById("TxtLookup-" + entityToRemove+ "Id");
    if (inputToRemove) {
        var inputLabel = inputToRemove.previousElementSibling;
        if (inputLabel && inputLabel.tagName === "LABEL") {
            inputLabel.remove();
        }

        var lookupButton = inputToRemove.nextSibling;
        if (lookupButton && lookupButton.id === "CoLookup-" + entityToRemove + "Id") {
            lookupButton.remove();
        }

        var hiddenValueField = inputToRemove.nextSibling;
        if (hiddenValueField && hiddenValueField.id === entityToRemove + "Id") {
            hiddenValueField.remove();
        }

        inputToRemove.remove();
    }
}

    //Takes a lookup value, looks for the values in the dropdown list and append them to the list
    function CreateElementsForComboBoxOptions(lookupValue, lgmObj) {

        var listOl = document.createElement('ol');
        listOl.id = "allLogins1";
        listOl.setAttribute("class", "itemlist");

        var lookupArray = GetLookupMultiDetailsForDropDown(lookupValue, lgmObj);
        
        //Loop through found options and create elements for these
        for (var i = 0; i < lookupArray.length; i++)
        {
            var listItem = document.createElement('li');
            listItem.setAttribute('role', 'listitem');
            listItem.className = 'subject pointer';
            listItem.setAttribute("name", lookupArray[i].value);
            listItem.textContent = lookupArray[i].value;
            listOl.appendChild(listItem);
        }

        return listOl;
    }
    
    //Attachs a click listener to each result to append back into the text box
    function AttachClickListenerToComboBoxOptions(textBoxId, resultDiv){
        $(resultDiv).find('li[role="listitem"]').each(function () {
            $(this).on("click", function () {
                SelectEntityLookupForComboBox(textBoxId, $(this).attr('name'));
            });
        });
    }
    
    // When user selects a result from the lookup box it'll look for any address 
    // fields to use to pre-populate any other address fields that may exists
    function PrePopulateAddressFields(selectedItem) {

        var street = $(selectedItem).attr("street");
        var city = $(selectedItem).attr("city");
        var state = $(selectedItem).attr("state");
        var postcode = $(selectedItem).attr("postcode");
        var country = $(selectedItem).attr("country");

        CheckLengthAndApply('.par-Street', street);
        CheckLengthAndApply('.par-MailingStreet', street);
        CheckLengthAndApply('.par-OtherStreet', street);
        CheckLengthAndApply('.par-Address', street);
        CheckLengthAndApply('.par-ShippingStreet', street);
        CheckLengthAndApply('.par-ShippingAddress', street);
        CheckLengthAndApply('.par-City', city);
        CheckLengthAndApply('.par-MailingCity', city);
        CheckLengthAndApply('.par-OtherCity', city);
        CheckLengthAndApply('.par-ShippingCity', city);
        CheckLengthAndApply('.par-State', state);
        CheckLengthAndApply('.par-MailingState', state);
        CheckLengthAndApply('.par-OtherState', state);
        CheckLengthAndApply('.par-ShippingState', state);
        CheckLengthAndApply('.par-Postcode', postcode);
        CheckLengthAndApply('.par-MailingPostalCode', postcode);
        CheckLengthAndApply('.par-OtherPostalCode', postcode);
        CheckLengthAndApply('.par-ShippingPostalCode', postcode);
        CheckLengthAndApply('.par-Country', country);
        CheckLengthAndApply('.par-MailingCountry', country);
        CheckLengthAndApply('.par-OtherCountry', country);
        CheckLengthAndApply('.par-ShippingCountry', country);
    }

        // Sets up the change events on reference fields for Custom Objects so a user can search the relevant record of an object
        // This is only for reference fields that have an option to link a different objects not just one type of object
        //i.e. the ParentId field can be linked to Account or Opportunity or Asset
        function SetupCustomObjectDropDowns()
        {
            $('select[multireferencefield="true"]').each(function ()
            {
                var fieldName = $(this).attr('name');
                if (fieldName)
                {
                    //This is currently being done already elsewhere below (SetupTaskEvents()) so skip these fields
                    if (fieldName.toLowerCase().indexOf("whatid") == -1 && fieldName.toLowerCase().indexOf("whoid") == -1)
                    {
                        var currentValue = $(this).val();

                        //Set the intial values on page load
                        $("#CoLookup-" + fieldName).attr("datasource", currentValue);
                        $("#TxtLookup-" + fieldName).attr("placeholder", currentValue);
                        $("#TxtLookup-" + fieldName + ", #CoLookup-" + fieldName).attr("searchlabeltext", currentValue);

                        //Set the change event on the dropdown box
                        $(this).on("change", function () {
                            var fieldName = $(this).attr('name');

                            //Reset Text Field on DropDown change
                            $("#TxtLookup-" + fieldName).val(null).removeClass('readonlyTextBox').removeAttr('readonly');

                            //Set new field values
                            $("#CoLookup-" + fieldName).attr("datasource", $(this).val());
                            $("#TxtLookup-" + fieldName).attr("placeholder", $(this).val());
                            $("#TxtLookup-" + fieldName + ", #CoLookup-" + fieldName).attr("searchlabeltext", $(this).val());
                        });
                    }
                }
            });
        }

        function SetupTaskEvents() {
            var whatType = $("#dd-task-WhatId").val();
            $("#CoLookup-WhatId").attr("datasource", whatType);
            $("#TxtLookup-WhatId").attr("placeholder", whatType);
            $("#TxtLookup-WhatId, #CoLookup-WhatId").attr("searchlabeltext", whatType);

            $("body").delegate("#dd-task-WhatId", "change", function() {
                $("#CoLookup-WhatId").attr("datasource", $(this).val());
                $("#TxtLookup-WhatId").attr("placeholder", $(this).val());
                $("#TxtLookup-WhatId, #CoLookup-WhatId").attr("searchlabeltext", $(this).val());
            });

            var whoType = $("#dd-task-WhoId").val();
            $("#CoLookup-WhoId").attr("datasource", whoType);
            $("#TxtLookup-WhoId").attr("placeholder", whoType);
            $("#TxtLookup-WhoId, #CoLookup-WhoId").attr("searchlabeltext", whoType);
        

            $("body").delegate("#dd-task-WhoId", "change", function() {
                $("#CoLookup-WhoId").attr("datasource", $(this).val());
                $("#TxtLookup-WhoId").attr("placeholder", $(this).val());
                $("#TxtLookup-WhoId, #CoLookup-WhoId").attr("searchlabeltext", $(this).val());

                //Clear values for Name field when there's a change
                $("#TxtLookup-WhoId, #WhoId").val(null);

                //deactivate whatid field and clear values if lead is selected
                if ($(this).val() == "Lead") {
                    $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-task-WhatId").attr("disabled", true);
                    $("#WhatId").removeClass("data");
                    $("#TxtLookup-WhatId, #WhatId").val(null);
                } else {
                    $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-task-WhatId").attr("disabled", false);
                    $("#WhatId").addClass("data");
                }
            });

            $("body").delegate("#chk-Task-IsReminderSet", "change", function () {

                var isDisabled = $("#txt-Task-ReminderDateTime").attr("disabled");

                if (isDisabled == "disabled") {
                    $("#txt-Task-ReminderDateTime").attr("disabled", false);
                    $("#RelatedToTimePicker").attr("disabled", false);
                    $("#txt-Task-ReminderDateTime").addClass("data");
                } else {
                    $("#txt-Task-ReminderDateTime").attr("disabled", true);
                    $("#RelatedToTimePicker").attr("disabled", true);
                    $("#txt-Task-ReminderDateTime").removeClass("data");
                }
            });
        }


        function SetupEventEvents() {

            //if we click 'all day event' then disable times            
            $("body").delegate("#chk-Event-IsAllDayEvent", "change", function () {
                var isDisabled = $("#dd-Event-StartDateTime").attr("disabled");
                if (isDisabled == "disabled") {
                    $("#dd-Event-StartDateTime").attr("disabled", false);
                    $("#dd-Event-EndDateTime").attr("disabled", false);
                } else {
                    $("#dd-Event-StartDateTime").attr("disabled", true);
                    $("#dd-Event-EndDateTime").attr("disabled", true);
                }
            });          
                
            var todayAndTimes = GetDateTimeStartEnd();
            var dateToday = todayAndTimes.split("?")[0];
            var startTime = todayAndTimes.split("?")[1];
            var endTime = todayAndTimes.split("?")[2];

            $("#dd-Event-StartDateTime").val(startTime);
            $("#dd-Event-EndDateTime").val(endTime);

            dateToday = FormatDateLocal(dateToday);
            $("#txt-Event-StartDateTime").val(dateToday);
            $("#txt-Event-EndDateTime").val(dateToday);
                        

            var whatType = $("#dd-event-WhatId").val();
            $("#CoLookup-WhatId").attr("datasource", whatType);
            $("#TxtLookup-WhatId").attr("placeholder", whatType);
            $("#TxtLookup-WhatId, #CoLookup-WhatId").attr("searchlabeltext", whatType);

            $("body").delegate("#dd-event-WhatId", "change", function() {
                $("#CoLookup-WhatId").attr("datasource", $(this).val());
                $("#TxtLookup-WhatId").attr("placeholder", $(this).val());
                $("#TxtLookup-WhatId, #CoLookup-WhatId").attr("searchlabeltext", $(this).val());
            });

            var whoType = $("#dd-event-WhoId").val();
            $("#CoLookup-WhoId").attr("datasource", whoType);
            $("#TxtLookup-WhoId").attr("placeholder", whoType);
            $("#TxtLookup-WhoId, #CoLookup-WhoId").attr("searchlabeltext", whoType);

            $("body").delegate("#dd-event-WhoId", "change", function() {
                $("#CoLookup-WhoId").attr("datasource", $(this).val());
                $("#TxtLookup-WhoId").attr("placeholder", $(this).val());
                $("#TxtLookup-WhoId, #CoLookup-WhoId").attr("searchlabeltext", $(this).val());

                //Reset values to null when user changes
                $("#WhoId, #TxtLookup-WhoId").val(null);

                //deactivate whatid field...
                if ($(this).val() == "Lead") {
                    $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-event-WhatId").attr("disabled", true);
                    $("#WhatId").removeClass("data");
                    $("#TxtLookup-WhatId, #WhatId").val(null);
                } else {
                    $("#TxtLookup-WhatId, #CoLookup-WhatId, #dd-event-WhatId").attr("disabled", false);
                    $("#WhatId").addClass("data");
                }
            });

            $("body").delegate("#chk-Event-IsReminderSet", "change", function () {

                var isDisabled = $("#txt-Event-ReminderDateTime").attr("disabled");

                if (isDisabled == "disabled") {
                    $("#txt-Event-ReminderDateTime").attr("disabled", false);
                    $("#RelatedToTimePicker").attr("disabled", false);
                    $("#txt-Event-ReminderDateTime").addClass("data");
                } else {
                    $("#txt-Event-ReminderDateTime").attr("disabled", true);
                    $("#RelatedToTimePicker").attr("disabled", true);
                    $("#txt-Event-ReminderDateTime").removeClass("data");
                }
            });

            //for events, set the reminder to be the start datetime -30 mins
            $("#chk-Event-IsReminderSet").attr("checked", true);
            $("#txt-Event-ReminderDateTime").attr("disabled", false);
            $("#RelatedToTimePicker").attr("disabled", false);
            var reminderDate = $("#txt-Event-StartDateTime").val();
            var startTime = $("#dd-Event-StartDateTime").val();
            var reminderTime = "";

            var startHour = '';
            var startMinute = '';

            if (typeof startTime != "undefined") {

                var startTimeArray = startTime.split(":");

                if (startTimeArray.length > 1) {
                    startHour = startTime.split(":")[0];
                    startMinute = startTime.split(":")[1];
                }
            }

            switch (startMinute) {
                case "30":
                    startMinute = "00";
                    break;
                case "00":
                    startMinute = "30";
                    startHour--;
                    break;
            }
            reminderTime = startHour + ":" + startMinute;
            $("#txt-Event-ReminderDateTime").val(reminderDate);
            $("#RelatedToTimePicker").val(reminderTime);

            //now also change the reminder date and time when the start datetime changes
            $("body").delegate("#txt-Event-StartDateTime", "change", function () {
                var newReminderDate = $("#txt-Event-StartDateTime").val();
                $("#txt-Event-ReminderDateTime").val(newReminderDate);
                $("#txt-Event-EndDateTime").val(newReminderDate);
            });

            $("body").delegate("#dd-Event-StartDateTime", "change", function () {
                var startTime = $("#dd-Event-StartDateTime").val();
                var newReminderTime = "";
                var newEndTime = "";
                var startHour = startTime.split(":")[0];
                var endHour = startTime.split(":")[0];
                var startMinute = startTime.split(":")[1];
                var endMinute = "00";

                switch (startMinute) {
                    case "30":
                        startMinute = "00";
                        endMinute = "30";
                        break;
                    case "00":
                        startMinute = "30";
                        endMinute = "00";
                        startHour--;                        
                        if (startHour < 10)
                        {
                            startHour = "0" + startHour;
                        }
                        break;
                }

                endHour++;

                if (endHour < 10) {
                    endHour = "0" + endHour;
                }else if (endHour >= 24) {
                    endHour = "00";
                }

                newReminderTime = startHour + ":" + startMinute;
                newEndTime = endHour + ":" + endMinute;

                $("#RelatedToTimePicker").val(newReminderTime);
                $("#dd-Event-EndDateTime").val(newEndTime);
            });           
        }

        function SelectEntityLookup(id, name, control) {

            $("#" + control).val(id);
            $("#TxtLookup-" + control).val(name);
            SetReadOnlyOnReference(control);
            $("#entitySearchLookup").dialog('close');

        }
    
        //Populates the textbox for the chosen selection of the combobox
        function SelectEntityLookupForComboBox(textBoxId, value) {
            $('#' + textBoxId).val(value);
            $("#entitySearchLookup").dialog('close');
        }

        //Takes a selector and value and applys the value to all selectors found
        // shouldWeOverrideValue - is an extra parameter which helps control if we need to override the element that already may be there
        function CheckLengthAndApply(selector, value, shouldWeOverrideValue) {

            //Loop through all elements with the selector as each selector may be a different type of field
            $(selector).each(function () {

                if (selector == ".par-Name") {
                    value = value.trim();
                }

                if (value != null) {
                    if (typeof value != "undefined") {
                        if (value.length != 0) {
                            if (value != '-1') {

                                var dataTimePicker = false;

                                // 
                                var css = $(this).attr('class');

                                if (css != null) {
                                    if (css.indexOf('valid-date') != -1) {

                                        var id = $(this).attr('id');

                                        var parts = value.split("-");

                                        var dt = new Date(parseInt(parts[0]), parseInt(parts[1]) - 1, parseInt(parts[2]));

                                        if (dt != "Invalid Date") {
                                            $('#' + id).datepicker('setDate', dt);
                                        }

                                        dataTimePicker = true;
                                    }
                                }

                                if (!dataTimePicker) {
                                    var maxLenStr = $(this).attr('maxlength');
                                    var hasVal = '' + $(this).val();
                                    
                                    if (hasVal.length == 0 || hasVal == "-1" || shouldWeOverrideValue) {
                                        if (maxLenStr != null) {

                                            try {
                                                var maxLen = parseInt(maxLenStr);
                                                if (value.length > maxLen) {
                                                    CheckForDropDownOrApply($(this), value.substring(value, maxLen));

                                                } else {
                                                    CheckForDropDownOrApply($(this), value);

                                                }
                                            } catch (error) {
                                                CheckForDropDownOrApply($(this), value);

                                            }
                                        } else {
                                            // No Max Length field.
                                            CheckForDropDownOrApply($(this), value);

                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            });
        }

        function CheckForDropDownOrApply(selector, value) {
            var idItem = '' + $(selector).attr('id');

            if (idItem.indexOf('dd-') != -1) {
                var valueApplied = value;
                var multiSelector = false;
                var splitter = '';

                if (value == 'LinkedIn') {
                    splitter = 'LinkedIn,Linked In,Linked-in';
                    multiSelector = true;
                }

                if (multiSelector) {
                    var partsOfStr = splitter.split(',');
                    var foundValue = false;
                    for (var d = 0; d < partsOfStr.length; d++) {
                        value = partsOfStr[d];

                        $('#' + idItem + ' option').each(function(index, option) {

                            var val = '' + $(this).val();
                            var htmlVal = '' + $(this).text();
                            var valueTotest = '' + value;

                            val = val.toLowerCase();
                            htmlVal = htmlVal.toLowerCase();
                            valueTotest = valueTotest.toLowerCase();

                            if (valueTotest == htmlVal || valueTotest == val) {
                                valueApplied = $(this).val();
                                foundValue = true;
                            }
                        });
                        if (foundValue) {
                            break;
                        }
                    }
                    if (foundValue) {
                        $(selector).val(valueApplied);
                        $(selector).change();
                    }
                } else {
                    var foundVal = false;
                    $('#' + idItem + ' option').each(function(index, option) {
                        // option will contain your item
                        if ($(this).val().toLowerCase() == value.toLowerCase() || $(this).text().toLowerCase() == value.toLowerCase()) {
                            valueApplied = $(this).val();
                            foundVal = true;
                        }
                    });
               
                    if (foundVal) {
                        $(selector).val(valueApplied);
                        $(selector).change();
                    }
                }
            } else if (idItem.indexOf('-LM') != -1) {
                
                var entityPos = idItem.indexOf('-LM');

                var idForLookup = '#' + idItem.substring(0, entityPos);

                var lookupId = $(idForLookup).attr('name');

                if (value == 'LinkedIn') {
                    value = 'LinkedIn,Linked In,Linked-in';

                }

                var lgm = JSON.parse(localStorage.LayoutManager);

                var valueStr = GetLookupMultiDetailsForEdit(lgm, lookupId, value);
                
                var fid = '' + idForLookup;

                if (valueStr != '') {
                    $(fid).append(valueStr);

                    $("body").delegate(".closeTag", "click", function() {

                        var name = $(this).attr("name");

                        var strObject = '.tag-' + name;
                        $(strObject).remove();
                    });
                }

            } else {
                $(selector).val(value);
                $(selector).change();
            }
        }
        
        function ParseInfoToPage(url, shouldWeOverrideValue) {
            //only parse info for pro/enterprise licences...
            if (localStorage.LicenceFound == 'Pro' || localStorage.LicenceFound == 'Enterprise' || url.indexOf('mail.google.com') != -1) {
                var parsing = '' + getParameterByName("Parse");

                if (parsing != 'No') {
                    // Don't parse anything linkedin related even if there is a rules failure.
                    if (url.indexOf('.linkedin.') == -1) {
                        var action = localAction.innerText;

                        var parseVal = null;

                        if (action.indexOf("-Add") != -1) {
                            if (localStorage.ParseInformation != null) {
                                parseVal = JSON.parse(localStorage.ParseInformation);
                                if (parseVal != null) {
                                    if (parseVal.Url == localTabUrl.innerText) {
                                        if (parseVal.Firstname != null) {
                                            CheckLengthAndApply('.lb-Contact-First-name', parseVal.Firstname, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Last-name', parseVal.Surname, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Email', parseVal.Email, shouldWeOverrideValue);
                                            CheckLengthAndApply('.dd-Contact-Source', parseVal.Source, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Title', parseVal.Title, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Mobile', parseVal.Mobile, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Account-FirstName', parseVal.Firstname, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Account-LastName', parseVal.Surname, shouldWeOverrideValue);
                                            StandardParsing(parseVal, shouldWeOverrideValue);

                                            var companyName = '' + parseVal.Company;
                                            if (companyName.indexOf(' at ') != -1) {
                                                var index = companyName.indexOf(' at ') + 4;
                                                var company = companyName.substring(index);
                                                CheckLengthAndApply('#CompanyId', company, shouldWeOverrideValue);
                                            } else {
                                                CheckLengthAndApply('#CompanyId', parseVal.Company, shouldWeOverrideValue);
                                            }

                                            CheckLengthAndApply('.lb-Contact-Cell-Phone', parseVal.Mobile, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Mobile-Phone', parseVal.Mobile, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Postal-Code', parseVal.Postcode, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-Zip', parseVal.Postcode, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Contact-City', parseVal.City, shouldWeOverrideValue);

                                            CheckMatch();
                                        }

                                        if (parseVal.ProjectDirector != null) {
                                            CheckLengthAndApply('.par-Director__c', parseVal.ProjectDirector, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectProductionCompany != null) {
                                            CheckLengthAndApply('.par-Production_Company__c', parseVal.ProjectProductionCompany, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectWriters != null) {
                                            CheckLengthAndApply('.par-Writers__c', parseVal.ProjectWriters, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectCast != null) {
                                            CheckLengthAndApply('.par-Cast__c', parseVal.ProjectCast, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectDistributor != null) {
                                            CheckLengthAndApply('.par-Distributor__c', parseVal.ProjectDistributor, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectProducers != null) {
                                            CheckLengthAndApply('.par-Producers__c', parseVal.ProjectProducers, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectEditors != null) {
                                            CheckLengthAndApply('.par-Editor__c', parseVal.ProjectEditors, shouldWeOverrideValue);
                                        }

                                        if (parseVal.ProjectProductionManagers != null) {
                                            CheckLengthAndApply('.par-Production_Manager__c', parseVal.ProjectProductionManagers, shouldWeOverrideValue);
                                        }

                                        if (parseVal.DunsNumber != null) {
                                            CheckLengthAndApply('.par-DunsNumber', parseVal.DunsNumber, shouldWeOverrideValue);
                                        }

                                    }
                                    else {
                                        localParseNeed.innerText = "1";
                                    }


                                }
                            }
                        }

                        if (action == "Lead-Add") {

                            if (localStorage.ParseInformation != null) {

                                var parseVal = JSON.parse(localStorage.ParseInformation);
                                if (parseVal != null) {

                                    if (parseVal.Url == localTabUrl.innerText) {
                                        if (parseVal.Firstname != null) {
                                            CheckLengthAndApply('.lb-Lead-First-name', parseVal.Firstname, shouldWeOverrideValue);

                                            CheckLengthAndApply('.lb-Lead-Last-name', parseVal.Surname, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Email', parseVal.Email, shouldWeOverrideValue);
                                            CheckLengthAndApply('.dd-Lead-Source', parseVal.Source, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Title', parseVal.Title, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Mobile', parseVal.Mobile, shouldWeOverrideValue);


                                            StandardParsing(parseVal, shouldWeOverrideValue);

                                            var companyName = '' + parseVal.Company;
                                            if (companyName.indexOf(' at ') != -1) {
                                                var index = companyName.indexOf(' at ') + 4;
                                                var company = companyName.substring(index);
                                                CheckLengthAndApply('.par-Company', company, shouldWeOverrideValue);
                                            } else {
                                                CheckLengthAndApply('.par-Company', parseVal.Company, shouldWeOverrideValue);
                                            }

                                            CheckLengthAndApply('.lb-Lead-Cell-Phone', parseVal.Mobile, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Mobile-Phone', parseVal.Mobile, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Postal-Code', parseVal.Postcode, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Street', parseVal.Street, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Zip', parseVal.Postcode, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-City', parseVal.City, shouldWeOverrideValue);
                                            CheckLengthAndApply('.par-countryid', parseVal.Country, shouldWeOverrideValue);
                                            CheckLengthAndApply('.par-Country', parseVal.Country, shouldWeOverrideValue);
                                            CheckLengthAndApply('.par-phone', parseVal.HomePhone, shouldWeOverrideValue);
                                        
                                            //Groupon optimisation
                                            CheckLengthAndApply('.lb-Lead-Deal_Discount__c', parseVal.DealDiscount, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Deal_Description__c', parseVal.DealDescription, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Deal_Quantity__c', parseVal.DealQuantity, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Deal_Price__c', parseVal.DealPrice, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Deal_Link__c', parseVal.DealLink, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-Deal_Saving__c', parseVal.DealSaving, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-RRP__c', parseVal.DealRRP, shouldWeOverrideValue);
                                            CheckLengthAndApply('.lb-Lead-competitors__c', parseVal.CompetitorName, shouldWeOverrideValue);
                                        }
                                    } else {
                                        localParseNeed.innerText = "1";
                                    }
                                }
                            }
                        }

                        //Custom Implementation of adding Cases from an email in Gmail
                        if (action.indexOf("Case-Add") != -1)
                        {
                            if (parseVal != null)
                            {
                                if (parseVal.Url == localTabUrl.innerText)
                                {
                                    //Subject details
                                    if (parseVal.gmailEmailSubject) {
                                        CheckLengthAndApply('.par-Subject', parseVal.gmailEmailSubject, shouldWeOverrideValue);
                                    }

                                    //Last email in the thread's content
                                    if (parseVal.gmailLastEmailInThreadContent) {
                                        CheckLengthAndApply('.par-Description', parseVal.gmailLastEmailInThreadContent, shouldWeOverrideValue);
                                    }

                                    //WhoId of email if applicable
                                    if (parseVal.gmailLastEmailInThreadWhoId && parseVal.gmailLastEmailInThreadWhoName && parseVal.gmailLastEmailInThreadWhoType) {
                                        //Lets find the lookup fields related with this Who type
                                        $('button[datasource="' + parseVal.gmailLastEmailInThreadWhoType + '"]').each(function () {
                                            //Find the div to put the value in which is the input field before
                                            var inputDiv = $(this).prev();
                                            CheckLengthAndApply(inputDiv, parseVal.gmailLastEmailInThreadWhoName, shouldWeOverrideValue);
                                            $(inputDiv).addClass('readonlyTextBox').attr('readonly', 'readonly');

                                            //Find the div to put the actual value we'll use to pass up to the server which is the input field after
                                            $(this).next().val(parseVal.gmailLastEmailInThreadWhoId);
                                        });
                                    }

                                    //Account information of WhoId if applicable
                                    if (parseVal.gmailLastEmailInThreadWhatId && parseVal.gmailLastEmailInThreadWhatName) {
                                        CheckLengthAndApply('.par-AccountId', parseVal.gmailLastEmailInThreadWhatName, shouldWeOverrideValue);
                                        $('.par-AccountId').addClass('readonlyTextBox').attr('readonly', 'readonly');
                                        $('.lb-Case-AccountId').val(parseVal.gmailLastEmailInThreadWhatId);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        function StandardParsing(parseVal, shouldWeOverrideValue) {

            CheckLengthAndApply('.par-Url', parseVal.Url, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-FirstName', parseVal.Firstname, shouldWeOverrideValue);
            CheckLengthAndApply('.par-LastName', parseVal.Surname, shouldWeOverrideValue);
            CheckLengthAndApply('.par-firstName', parseVal.Firstname, shouldWeOverrideValue);
            CheckLengthAndApply('.par-lastName', parseVal.Surname, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-Email', parseVal.Email, shouldWeOverrideValue);
            CheckLengthAndApply('.par-EmailAddress', parseVal.Email, shouldWeOverrideValue);
            CheckLengthAndApply('.par-OtherEmail', parseVal.OtherEmail, shouldWeOverrideValue);

            CheckLengthAndApply('.par-Mobile', parseVal.Mobile, shouldWeOverrideValue);

            CheckLengthAndApply('.par-MobilePhone', parseVal.Mobile, shouldWeOverrideValue);
            CheckLengthAndApply('.par-HomePhone', parseVal.HomePhone, shouldWeOverrideValue);
            CheckLengthAndApply('.par-WorkPhone', parseVal.WorkPhone, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Phone', parseVal.WorkPhone, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Fax', parseVal.Fax, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Title', parseVal.Title, shouldWeOverrideValue);

            CheckLengthAndApply('.par-Postcode', parseVal.Postcode, shouldWeOverrideValue);
            CheckLengthAndApply('.par-City', parseVal.City, shouldWeOverrideValue);
            CheckLengthAndApply('.par-State', parseVal.State, shouldWeOverrideValue);

            CheckLengthAndApply('.par-Country', parseVal.Country, shouldWeOverrideValue);

            CheckLengthAndApply('.par-Twitter', parseVal.Twitter, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-Address', parseVal.Address, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Street', parseVal.Address, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Street', parseVal.Street, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Company', parseVal.Company, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Company', parseVal.Name, shouldWeOverrideValue);

            CheckLengthAndApply('.par-WebAddress', parseVal.WebAddress, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-BillingCountry', parseVal.Country, shouldWeOverrideValue);
            CheckLengthAndApply('.par-BillingState', parseVal.State, shouldWeOverrideValue);
            CheckLengthAndApply('.par-AccountId', parseVal.Company, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Name', parseVal.Firstname + " " + parseVal.Surname, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Source', parseVal.Source, shouldWeOverrideValue);
            CheckLengthAndApply('.par-occupation', parseVal.Title, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-DealDescription', parseVal.DealDescription, shouldWeOverrideValue);
            CheckLengthAndApply('.par-DealPrice', parseVal.DealPrice, shouldWeOverrideValue);
            CheckLengthAndApply('.par-DealDiscount', parseVal.DealDiscount, shouldWeOverrideValue);
            CheckLengthAndApply('.par-DealSaving', parseVal.DealSaving, shouldWeOverrideValue);
            CheckLengthAndApply('.par-DealRRP', parseVal.DealRRP, shouldWeOverrideValue);
            CheckLengthAndApply('.par-DealQuantity', parseVal.DealQuantit, shouldWeOverrideValue);
            CheckLengthAndApply('.par-DealLink', parseVal.DealLink, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-Gender', parseVal.Gender, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmAka', parseVal.Aka, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmLastRelease', parseVal.LastRelease, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmNextRelease', parseVal.NextRelease, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectType', parseVal.ProjectType, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectName', parseVal.ProjectName, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectStatus', parseVal.ProjectStatus, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectGenre', parseVal.ProjectGenre, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectBudget', parseVal.ProjectBudget, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectDevNotes', parseVal.ProjectDevNotes, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectDiStartDate', parseVal.ProjectDiStartDate, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectLogLine', parseVal.ProjectLogLine, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectReleaseDate', parseVal.ProjectReleaseDate, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectStartDate', parseVal.ProjectStartDate, shouldWeOverrideValue);
            CheckLengthAndApply('.par-filmProjectWrapDate', parseVal.ProjectWrapDate, shouldWeOverrideValue);

            CheckLengthAndApply('.par-MailingStreet', parseVal.Street, shouldWeOverrideValue);
            CheckLengthAndApply('.par-BillingStreet', parseVal.Street, shouldWeOverrideValue);
            CheckLengthAndApply('.par-OtherStreet', parseVal.Street, shouldWeOverrideValue);
            CheckLengthAndApply('.par-ShippingStreet', parseVal.Street, shouldWeOverrideValue);
        
            CheckLengthAndApply('.par-LegalName', parseVal.LegalName, shouldWeOverrideValue);
            CheckLengthAndApply('.par-MailingAddress', parseVal.MailingAddress, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Description', parseVal.Description, shouldWeOverrideValue);
            CheckLengthAndApply('.par-LinkedInUrl', parseVal.LinkedInUrl, shouldWeOverrideValue);
            CheckLengthAndApply('.par-AccountSource', parseVal.AccountSource, shouldWeOverrideValue);
            CheckLengthAndApply('.par-AccountSourceDetails', parseVal.AccountSourceDetails, shouldWeOverrideValue);
            CheckLengthAndApply('.par-StateIncorporated', parseVal.StateIncorporated, shouldWeOverrideValue);
            CheckLengthAndApply('.par-StartYear', parseVal.StartYear, shouldWeOverrideValue);
            CheckLengthAndApply('.par-FiscalEndYear', parseVal.FiscalEndYear, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Ownership', parseVal.Ownership, shouldWeOverrideValue);
            CheckLengthAndApply('.par-ServiceOverview', parseVal.ServiceOverview, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Employees', parseVal.Employees, shouldWeOverrideValue);
            CheckLengthAndApply('.par-BillableEmployees', parseVal.BillableEmployees, shouldWeOverrideValue);
            CheckLengthAndApply('.par-AnnualRevenue', parseVal.AnnualRevenue, shouldWeOverrideValue);
            CheckLengthAndApply('.par-OtherServices', parseVal.OtherServices, shouldWeOverrideValue);
            CheckLengthAndApply('.par-RunRate', parseVal.RunRate, shouldWeOverrideValue);
            CheckLengthAndApply('.par-PartnersAndCertifications', parseVal.PartnersAndCertifications, shouldWeOverrideValue);
            CheckLengthAndApply('.par-OtherCustomerFocus', parseVal.OtherCustomerFocus, shouldWeOverrideValue);
            CheckLengthAndApply('.par-ActiveCustomers', parseVal.ActiveCustomers, shouldWeOverrideValue);
            CheckLengthAndApply('.par-CustomerBaseSize', parseVal.CustomerBaseSize, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Department', parseVal.Department, shouldWeOverrideValue);
            CheckLengthAndApply('.par-Type', parseVal.Type, shouldWeOverrideValue);

            CheckLengthAndApply('.par-FullBillingAddress', parseVal.FullBillingAddress, shouldWeOverrideValue);
            CheckLengthAndApply('.par-SST', parseVal.SST, shouldWeOverrideValue);
            CheckLengthAndApply('.par-AwardsRankings', parseVal.AwardsRankings, shouldWeOverrideValue);

            CheckLengthAndApply('.par-VerticalMarkets', parseVal.VerticalMarkets, shouldWeOverrideValue);
            CheckLengthAndApply('.par-VendorPartnerships', parseVal.VendorPartnerships, shouldWeOverrideValue);
            CheckLengthAndApply('.par-RevenueRange', parseVal.RevenueRange, shouldWeOverrideValue);
            CheckLengthAndApply('.par-CommunicationNotes', parseVal.CommunicationNotes, shouldWeOverrideValue);
            CheckLengthAndApply('.par-cnEmployees', parseVal.Employees, shouldWeOverrideValue);
            CheckLengthAndApply('.par-NumberOfEmployees', parseVal.Employees, shouldWeOverrideValue);
        }

        function showLookup() {
            document.getElementById("coLookup").value = document.getElementById("CompanyId").value;

            document.getElementById("companyCreate").style.display = 'none';
            document.getElementById("companyLookup").style.display = 'block';
            document.getElementById("pageTitle").innerHTML = "Find Company";

            if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
                document.getElementById("pageTitle").innerHTML = "Find Account";

            }

            $('.save').hide();

            $("body").undelegate(".back", "click");
            $("body").delegate(".back", "click", function() {
                document.getElementById("companyLookup").style.display = 'none';
                document.getElementById("entityfields").style.display = 'block';
                document.getElementById("companyCreate").style.display = 'none';
                $('.save').show();

                document.getElementById("pageTitle").innerHTML = "Add Contact";

                $("body").delegate(".back", "click", function() {
                    var tabId = localTabId.innerText;
                    var location = background.HistoryGoBack(tabId);
                    window.location = location;
                });

            });

            if (document.getElementById("coLookup").value.length > 2) {
                $(this).next('input').focus();
                if (document.getElementById("entityfields").style.display == 'block') {
                    if (localStorage.CrmDBType == 1) {
                        RunCoLookup();
                    }

                    if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
                        RunAccountLookup();
                    }
                }
            }
            document.getElementById("entityfields").style.display = 'none';
        }


        function CompanySaveComplete(id) {

            document.getElementById("entityfields").style.display = 'block';
            document.getElementById("companyLookup").style.display = 'none';
            document.getElementById("companyCreate").style.display = 'none';
            document.getElementById("pageTitle").innerHTML = "Add Contact";
            document.getElementById("CompanyId").value = document.getElementById("txt-Account-Name").value;

            document.getElementById("CompanyId").disabled = true;
            document.getElementById("CoId").value = id;

            $('.save').text('Save');


            $('#messageName').text('Saving');

            $('#messageSuccess').hide();


            $("body").delegate(".back", "click", function() {
                //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-CompanySaveComplete', '1']);
                var tabId = localTabId.innerText;
                var location = background.HistoryGoBack(tabId);
                window.location = location;
            });

        }

        function GmailCalendarSyncUpdateComplete(isActive)
        {        
            if (isActive == '1') {
                localStorage.GmailSync = 1;
                localStorage.GmailCalendarSync = "true";
                $("#btGmailOff").removeClass('hidden');
                $("#gmailOffText").removeClass('hidden');
                $("#btGmailOn").addClass('hidden');
                $("#gmailOnText").addClass('hidden');
            }

            if (isActive == '0') {
                localStorage.GmailSync = 0;
                localStorage.GmailCalendarSync = "false";
                $("#btGmailOn").removeClass('hidden');
                $("#gmailOnText").removeClass('hidden');
                $("#btGmailOff").addClass('hidden');
                $("#gmailOffText").addClass('hidden');
            }

            $("#LoaderGif").addClass('hidden');        
            //RenderPage();
            //$(".gmailsettingstext").text("");
        }


        function RunCoLookup() {

           

        }


        function RunAccountLookup() {


        }


        function SetupDefaults() {

            //Lets find what entity user is currently on so we search the right entity for defaults
            var entityType = getParameterByName("action").split("-")[0];
            var recordTypeId = getParameterByName("recordTypeId");
            var lgm = JSON.parse(localStorage.LayoutManager);

            for (var d = 0; d < lgm.d.CrmEntities.length; d++) {
                
                if (lgm.d.CrmEntities[d].Name.toLowerCase() == entityType.toLowerCase()) {

                    //Lets make sure that if we have a Record Type that we look for values associated with the record type rather than other record types
                    if (recordTypeId.length > 0){
                        if (lgm.d.CrmEntities[d].RecordTypeId.toLowerCase() != recordTypeId.toLowerCase()) {
                            continue;
                        }
                    }

                    for (var f = 0; f < lgm.d.CrmEntities[d].Fields.length; f++) {

                        var fldLayout = lgm.d.CrmEntities[d].Fields[f];
                        var value = fldLayout.DefaultValue;

                        //Skip applying defaults to Status field when user selects logacall
                        if (fldLayout.ValueField) {
                            if (fldLayout.ValueField.toLowerCase() === "status") {
                                if (getParameterByName("Type").toLowerCase() === "logacall") {
                                    continue;
                                }
                            }
                        }

                        if (value != null) {
                            if (value.length != 0) {
                                if (fldLayout.TypeOfField == "Text") {
                                    var name = '.lb-' + entityType + '-' + CleanOutBadNames(fldLayout.Name);

                                    $(name).val(value);
                                }

                                if (fldLayout.TypeOfField == "picklist" ^ fldLayout.TypeOfField == "reference") {

                                    var name = '.dd-' + entityType + '-' + CleanOutBadNames(fldLayout.ValueField);


                                    $(name + " option").each(function() {
                                        if ($(this).val().toLowerCase() == value.toLowerCase() || $(this).text().toLowerCase() == value.toLowerCase()) {
                                            $(this).attr('selected', 'selected');
                                        }

                                    });
                                }

                                if (fldLayout.TypeOfField == "multipicklist") {
                                    var valueStr = GetLookupMultiDetailsForEdit(lgm, fldLayout.DataSource, value);

                                    var fid = '#' + fldLayout.ValueField;
                                    $(fid).append(valueStr);

                                    $("body").delegate(".closeTag", "click", function() {

                                        var name = $(this).attr("name");

                                        var strObject = '.tag-' + name;
                                        $(strObject).remove();
                                    });
                                }
                            }
                        }
                    }
                }
            }
            
            $('.autofire').each(function (i, obj) {
                //test
            
                var entityname = $(this).attr('id').replace('TxtLookup-', '');
                SetReadOnlyOnReference(entityname);
            });

        }


        function ValueLabel(value, label) {
            this.value = value;
            this.label = label;
        }

        function GetLookupMultiDetailsForDropDown(Name, lgm) {

            var rtrStr = [];
            var first = 0;

            for (var lk = 0; lk < lgm.d.DropDowns.length; lk++) {
                var drop = lgm.d.DropDowns[lk];

                if (drop.Name == Name) {

                    for (var l = 0; l < drop.Values.length; l++) {

                        rtrStr.push(new ValueLabel(drop.Values[l].Value, drop.Values[l].Name));
                        //                        if (first == 0) {
                        //                            rtrStr = rtrStr + '{ label: "' + drop.Values[l].Name + '", value: "' + drop.Values[l].Value + '" }'
                        //                            first = 1;
                        //                        }
                        //                        else {
                        //                            rtrStr = rtrStr + ',{ label: "' + drop.Values[l].Name + '", value: "' + drop.Values[l].Value + '" }'
                        //                        }


                    }

                }
            }

            return rtrStr;
        }

        function SetupMultiSelector(lookup, source, entity, lgmObj) {
            var nameInput = '#' + lookup + '-LM-' + entity;
            var name = '#' + lookup;

            $(function() {
                var strTags = GetLookupMultiDetailsForDropDown(source, lgmObj);
                var availableTags = strTags;
                //        var availableTags = [
                //            { label: "ActionScript", value: "23" },
                //            { label: "AppleScript", value: "2343" }
                //        ];

                $(nameInput).autocomplete({
                    source: availableTags,
                    focus: function(event, ui) {
                        $(nameInput).val(ui.item.label);
                        return false;
                    },
                    select: function (event, ui) {
          
                        var div1 = CreateDiv("",'tag tag-' + CleanOutBadNames(ui.item.value));
                        div1.setAttribute("tv", ui.item.value);
                        div1.setAttribute("name", CleanOutBadNames(ui.item.value));

                        var span1 = CreateSpan(CleanOutBadNames(ui.item.value), "");
                        span1.setAttribute("tv", ui.item.value);
                        span1.setAttribute("name", CleanOutBadNames(ui.item.value));
                        span1.innerText = "X";
                        span1.className = "closeTag";
                        div1.appendChild(span1);
                    
                        var txt1 = document.createTextNode(' ' + ui.item.label);
                        div1.appendChild(txt1);
                    
                        $(nameInput).val(ui.item.label);
                        $(name).append(div1);

                        $("body").delegate(".closeTag", "click", function() {

                            var name = $(this).attr("name");

                            var strObject = '.tag-' + CleanOutBadNames(name);
                            $(strObject).remove();
                        });

                        $(this).val('');
                        return false;
                    },
                    response: function(event, ui) {
                        if (ui.content.length == 0) {
                            $(this).addClass("ui-state-error");
                        } else {
                            $(this).removeClass("ui-state-error");
                        }
                    }
                })
                    .data("autocomplete")._renderItem = function (ul, item) {

                        var itemLink = document.createElement('a');
                        itemLink.appendChild(document.createTextNode(item.label));

                        // If the asosciated input element has options appended that means there is a dependancy
                        // picklist on this field so only display the appropriate values
                        var optionCount = $(nameInput).find('option').length;
                        var optionFound = $(nameInput).find('option[name="' + item.value + '"]').length > 0;
                        if (!optionFound && optionCount > 0)
                        {
                            return $('<li class="pointer">')
                                .data("item.autocomplete", item)
                                .append(itemLink)
                                .appendTo(ul)
                                .hide();
                        }
                        else
                        {
                            return $('<li class="pointer">')
                                .data("item.autocomplete", item)
                                .append(itemLink)
                                .appendTo(ul);
                        }
                    };

            });
        }

        function CreateDiv(Name, className) {
            var spanHeader = document.createElement('Div');
            spanHeader.setAttribute("class", className);
            spanHeader.innerText = Name;
        
            return spanHeader;
        }

        function CreateSpan(name, className) {
            var spanHeader = document.createElement('span');
            spanHeader.setAttribute("class", className);
            spanHeader.innerText = "" + name;

            return spanHeader;
        }

        /**
         * Finds all the fields with a class attribute as 'dupe' and then we'll use
         * these fields to run a duplicate record search before allowing the user to save
         */
        function CheckMatch() {
            var textHidden = $("body").find(".dupe");

            if (localAction.innerText.indexOf('Contact') != -1) {

                textHidden = $("#entityfields").find(".dupe");
                var objMatch = document.getElementById("pageTitle");

                if (objMatch != null) {
                    if (document.getElementById("pageTitle").innerHTML == "Add Account") {
                        textHidden = $("#companyCreate").find(".dupe");
                    }
                }
            }

            var searchString = '';

            textHidden.each(function() {
                if ($(this).val().length != 0) {
                    if ($(this).val().trim().length != 0) {
                        searchString = searchString + ' ' + $(this).val();
                    }
                }
            });

            if (searchString.length != 0) {
                RunDupeSearch(searchString);
            }
        }

        /**
         * Runs a dupe search to check if there a records in Salesforce that match what the user is potentially about to add
         * @param {string} searchString - The search query
         */
        function RunDupeSearch(searchString) {

            if (searchString.trim().length > 1) {
                var action = localAction.innerText;

                if (action.indexOf('-Add') != -1) {
                    var entityPos = action.indexOf('-Add');
                    var entityAdd = action.substring(0, entityPos);

                    background.Search("dupesearch-" + entityAdd, searchString, localTabId.innerText, null, null, null, null, 0, PassData, function (responseObject) {
                        if (responseObject && responseObject.errormessage) {
                            ShowSearchError(responseObject.errormessage);
                        }
                    });

                    if (localAction.innerText.indexOf('Contact') != -1) {
                        if (document.getElementById("pageTitle").innerHTML == "Add Account") {
                            AssignLoaderWithText('#dedupeContact', 'Searching for Possible Matches');
                        } else {
                            AssignLoaderWithText('#dedupe', 'Searching for Possible Matches');
                        }
                    } else {
                        AssignLoaderWithText('#dedupe', 'Searching for Possible Matches');
                    }
                }
            }
}

/**
 * Checks to see if the input element is representing a Date/DateTime fields and then formats the value in the box to
 * be a value accepted by Salesforce.
 * i.e. 13/09/2019 is turned into 2019-09-13
 * @param {DOMElement} textBoxElement - The element representing the date field
 * @returns {string} - The date to send up to salesforce
 */
function FormatDateValueForSalesforce(textBoxElement) {
    if (textBoxElement && textBoxElement.classList) {
        if (textBoxElement.classList.contains("valid-date") || textBoxElement.classList.contains("valid-datetime")) {
            return unFormatDateLocal(textBoxElement.value);
        }
    }
    return textBoxElement.value;
}

        function SaveEntity(entityName) {


            var action = localAction.innerText;

            var textboxes = $("body").find(".data");
            var textHiddenBool = $("body").find(".valid-boolean");
            var textHiddenLm = $("body").find(".lm");

            if (entityName == 'Account' && action == 'Contact-Add') {
                textboxes = $("#companyCreate").find(".data");
                textHiddenBool = $("#companyCreate").find(".valid-boolean");
                textHiddenLm = $("#companyCreate").find(".lm");
            } else {
                textboxes = $("#entityfields").find(".data");
                textHiddenBool = $("#entityfields").find(".valid-boolean");
                textHiddenLm = $("#entityfields").find(".lm");
            }

            var fields = '[';

            var counter = 2;
            var fldLink = background.GenerateEntityField('URLAdd', localStorage.LastPageUrl, '', false, '#UrlAdd');

            var fldLinkedinStatus = background.GenerateEntityField('LinkedInStatus', true, '', false, '#LinkedInStatus');

            var linkedinStatusValue = false;

            if (typeof localStorage.LinkedInStatus != "undefined") {
                linkedinStatusValue = localStorage.LinkedInStatus;
            }

            // var fldLinkedinStatus = background.GenerateEntityField('LinkedInStatus', linkedinStatusValue, '', false, '#LinkedInStatus');

            fields = fields + fldLink;
            fields = fields + "," + fldLinkedinStatus;

            var foundWhatId = false;
            var foundWhoId = false;

            textboxes.each(function () {

                if (this.id.indexOf("-LM") == -1 && this.id.indexOf("chk-") == -1) {

                    let textBoxValueToAddToSalesforce = this.value;

                    textBoxValueToAddToSalesforce = FormatDateValueForSalesforce(this);

                    if (this.id == "WhatId") {
                        foundWhatId = true;
                    }

                    if (this.id == "WhoId") {
                        foundWhoId = true;
                    }

                    if (this.id == "txt-Task-ReminderDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            var timeSelected = $("#RelatedToTimePicker").val();
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (this.id == "txt-Event-ReminderDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            var timeSelected = $("#RelatedToTimePicker").val();
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (this.id == "txt-Event-StartDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            var timeSelected = $("#dd-Event-StartDateTime").val();
                            //if the add fails for any reason, like a missing field, we dont want to add the time twice or SF API will not accept it
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (this.id == "txt-Event-EndDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            var timeSelected = $("#dd-Event-EndDateTime").val();
                            //if the add fails for any reason, like a missing field, we dont want to add the time twice or SF API will not accept it
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce+ 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (background.isResumeField(this.name)) {
                        textBoxValueToAddToSalesforce = localStorage.LastPageEncoded;
                    }

                    if (textBoxValueToAddToSalesforce != "-1") {
                        
                        var fld = background.GenerateEntityField(this.name, textBoxValueToAddToSalesforce, '', false, '');

                        if (counter == 0) {
                            fields = fields + fld;
                        } else {
                            fields = fields + "," + fld;
                        }

                        counter++;
                    }
                }
            });

            var textHidden = $("body").find(".key");
            textHidden.each(function() {
                var fld = background.GenerateEntityField(this.name, this.value, '', true);

                if (counter == 0) {
                    fields = fields + fld;
                } else {
                    fields = fields + "," + fld;
                }

                counter++;
            });

            textHiddenBool.each(function() {
                var parse = false;
                if ($(this).is(':checked')) {
                    parse = true;
                }


                var fld = background.GenerateEntityField(this.name, parse, '', false);

                if (counter == 0) {
                    fields = fields + fld;
                } else {
                    fields = fields + "," + fld;
                }

                counter++;
            });

            textHiddenLm.each(function() {
                var strid = $(this).attr("id");
                var strLookup = $(this).attr("name");
                var ids = '';
                var first = 0;
                var idTags = $("#" + strid).find(".tag");

                idTags.each(function() {
                    if (first == 0) {
                        ids = '' + $(this).attr("tv");
                        first = 1;
                    } else {
                        ids = ids + ';' + $(this).attr("tv");
                    }
                });

                fields = fields + ',' + background.GenerateEntityField(strid, ids, '', false);
            });

            if (localStorage.CrmDBType == 2 || localStorage.CrmDBType >= 20) {
                var id = getParameterByName("id");
                var entity = getParameterByName("entity");
                if (entityName == 'Task') {

                    //Check if the user is using whoid/whatid...
                    if (!foundWhatId && !foundWhoId) {
                        if (entity == "Contact") {
                            fields = fields + ',' + background.GenerateEntityField('WhoId', '' + id, '', 'false');
                        }

                        if (entity == "Lead") {
                            fields = fields + ',' + background.GenerateEntityField('WhoId', '' + id, '', 'false');
                        }

                        if (entity == "Opportunity") {
                            fields = fields + ',' + background.GenerateEntityField('WhatId', '' + id, '', 'false');
                        }

                        if (entity == "Account") {
                            fields = fields + ',' + background.GenerateEntityField('WhatId', '' + id, '', 'false');
                        }
                    }
                }

                if (entityName == "CampaignMember") {

                    if (entity == "Contact") {
                        if (fields.indexOf('ContactId') == -1) {
                            fields = fields + ',' + background.GenerateEntityField('ContactId', '' + id, '', 'false');
                        }
                    }

                    if (entity == "Lead") {
                        if (fields.indexOf('LeadId') == -1) {
                            fields = fields + ',' + background.GenerateEntityField('LeadId', '' + id, '', 'false');
                        }
                    }

                }

            }

            fields = fields + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
            fields = fields + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
            fields = fields + ',' + background.GenerateEntityField('EBActionTaken', '' + localStorage.Action, '', 'false');
            fields = fields + "]";

            var strFields = JSON.stringify(fields);

            var tabId = localTabId.innerText;

            background.AddEntityNew(entityName, strFields, tabId, null, SaveEntityCallBack(entityName));
        }

/**
 * The callback to handle the response when Adding a new record
 * @param {string} entityTypeName - The type of object being added
 * @returns {function} - The function to handle the request returned when the record is saved
 */
function SaveEntityCallBack(entityTypeName) {
    return function(returnedRequestJson) {
        SaveComplete(entityTypeName, returnedRequestJson, "Added");
    };
}

        function EditEntity(entityName) {
            var textboxes = $("body").find(".data");

            var fields = '['
            var counter = 0;
            textboxes.each(function() {

                if (this.id.indexOf("-LM") == -1 && this.id.indexOf("chk-") == -1) {
                    
                    let textBoxValueToAddToSalesforce = this.value;

                    textBoxValueToAddToSalesforce = FormatDateValueForSalesforce(this);
                    
                    if (this.id == "txt-Task-ReminderDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            const timeSelected = $("#RelatedToTimePicker").val();
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (this.id == "txt-Event-ReminderDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            const timeSelected = $("#RelatedToTimePicker").val();
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (this.id == "txt-Event-StartDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            const timeSelected = $("#dd-Event-StartDateTime").val();
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    if (this.id == "txt-Event-EndDateTime") {
                        if (textBoxValueToAddToSalesforce.length > 1) {
                            const timeSelected = $("#dd-Event-EndDateTime").val();
                            if (textBoxValueToAddToSalesforce.indexOf("T") == -1) {
                                textBoxValueToAddToSalesforce = textBoxValueToAddToSalesforce + 'T' + timeSelected + ':00';
                            }
                        }
                    }

                    var fld = background.GenerateEntityField(this.name, textBoxValueToAddToSalesforce, '', false);

                    if (counter == 0) {
                        fields = fields + fld;
                    } else {
                        fields = fields + "," + fld;
                    }

                    counter++;
                }
            });


            var textHidden = $("body").find(".key");
            textHidden.each(function() {
                var fld = background.GenerateEntityField(this.name, this.value, '', true);

                if (counter == 0) {
                    fields = fields + fld;
                } else {
                    fields = fields + "," + fld;
                }

                counter++;
            });

            var textHidden = $("body").find(".valid-boolean");
            textHidden.each(function() {
                var parse = false;
                if ($(this).is(':checked')) {
                    parse = true;
                }

                var fld = background.GenerateEntityField(this.name, parse, '', false);

                if (counter == 0) {
                    fields = fields + fld;
                } else {
                    fields = fields + "," + fld;
                }

                counter++;
            });

            var textHidden = $("body").find(".lm");

            textHidden.each(function() {
                var strid = $(this).attr("id");
                var strLookup = $(this).attr("name");
                var ids = '';
                var first = 0;
                var idTags = $("#" + strid).find(".tag");
                idTags.each(function() {
                    if (first == 0) {
                        ids = '' + $(this).attr("tv");
                        first = 1;
                    } else {
                        ids = ids + ';' + $(this).attr("tv");
                    }
                });


                fields = fields + ',' + background.GenerateEntityField(strid, ids, '', false);
            });

            fields = fields + ',' + background.GenerateEntityField('SiteURL', '' + localStorage.LastPageUrl, '', 'false');
            fields = fields + ',' + background.GenerateEntityField('SessionKey', '' + localStorage.SessionKey, '', 'false');
            fields = fields + "]";
                  
            var strFields = JSON.stringify(fields);
            var tabId = localTabId.innerText;

            const callBack = (function (lEntityName) {
                return function (returnedJson) {
                    SaveComplete(lEntityName, returnedJson, 'Updated');
                };
            })(entityName);

            background.UpdateEntity(entityName, strFields, tabId, callBack);
        }

        function ProcessTags(html) {
            var patt1 = /<<[a-z0-9\-\s\=\b\_]*>>/gi;

            var matches = html.match(patt1);

            if (matches != null) {
                for (var i = 0; i < matches.length; i++) {
                    var str = GetTagInformation(matches[i]);
                    html = html.replace(matches[i], str);
                }
                //html = html + ShowFreeMessage2();
            }

            return html;
        }

/**
 * The callback to handle the response when firing a SelectEntity request
 * @param {string} entityTypeName - The type of object being added
 * @returns {function} - The function to handle the request returned when the record is saved
 */
function SelectEntityCallBack(entityTypeName) {
    return function(returnedRequestJson) {
        PassData(entityTypeName, returnedRequestJson, 0);
    };
}

        function GetTagInformation(tagName) {

            tagName = tagName.replace('<<', '');
            tagName = tagName.replace('>>', '');
            var rawTag = tagName;

            var lastType = '';

            tagName = tagName.toLowerCase();


            if (tagName == 'ent-event-read') {
                // At this point we want to read something.

                var id = getParameterByName("id");
                //var rtId = getParameterByName("RecordTypeId");
                var fields = '[';
                fields = fields + background.GenerateEntityField("TaskRelatedEntityType", '', '', 'false', '');
                fields = fields + ']';

                var fieldsStr = JSON.stringify(fields);

                background.SelectEntity("Event", fieldsStr, background.GenerateBHKeyField(id), localTabId.innerText);
                return '';

            }

            if (tagName == 'ent-event-edit') {
                // At this point we want to read something.

                var id = getParameterByName("id");
                //var rtId = getParameterByName("RecordTypeId");
                background.SelectEntity("Event", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '';

            }


            if (tagName == "check-licence") {

                if (localStorage.LicenceFound == 'Free' || localStorage.LicenceFound == 'Chatter') {
                    //ShowUpgradeMessage();
                    if (!CanIAddEdit()) {
                        DisplayFreeProductMessage();
                    }
                } else {
                    return '';
                }
            }

            if (tagName == 'entityadd-list') {

                var lgm = JSON.parse(localStorage.LayoutManager);
                
                var olLst = document.createElement('ol');

                olLst.setAttribute("id", "entityAdd");

                lgm.d.CrmEntities.sort(CustomSortEntitiesArrayByName);
                for (var d = 0; d < lgm.d.CrmEntities.length; d++) {
                    if (lgm.d.CrmEntities[d].Add == true) {

                        if (lgm.d.CrmEntities[d].Disabled == false) {

                            var addType = true;
                            
                            var nameLabel = CleanUpSFObject(lgm.d.CrmEntities[d].Name);

                            var name = '' + CleanUpSFObjectAndAddLookup(lgm.d.CrmEntities[d].Name);
                            var link = 'action=' + lgm.d.CrmEntities[d].Name + '-Add';

                            if (lgm.d.CrmEntities[d].FriendlyName.length != 0) {
                                name = CleanUpSFObjectAndAddLookup(lgm.d.CrmEntities[d].FriendlyName);
                                nameLabel = CleanUpSFObject(lgm.d.CrmEntities[d].FriendlyName);
                            }

                            if (lgm.d.CrmEntities[d].RecordTypeId != 'Master') {

                                name = CleanUpSFObjectAndAddLookup(lgm.d.CrmEntities[d].FriendlyName);
                                nameLabel = CleanUpSFObject(lgm.d.CrmEntities[d].FriendlyName);

                                link = link + '-' + lgm.d.CrmEntities[d].RecordTypeId;
                                link = link + '&recordTypeId=' + lgm.d.CrmEntities[d].RecordTypeId;

                                //Lets remove any master entities from the add list as there's a Record Type for this object
                                $(olLst).find("li[value=" + lgm.d.CrmEntities[d].Name + "][recordtype='Master']").remove();
                            } else {
                                if ($(olLst).find("li[value=" + lgm.d.CrmEntities[d].Name + "]").length > 0) {
                                    // Same type and is Master remove from Add . 
                                    addType = false;
                                }
                            }

                            lastType = lgm.d.CrmEntities[d].Name;
                            if (addType) {
                                var newAddItem = document.createElement('li');
                                newAddItem.setAttribute('value', '' + lgm.d.CrmEntities[d].Name);
                                newAddItem.setAttribute('recordType', '' + lgm.d.CrmEntities[d].RecordTypeId);

                                var newAddItemLink = document.createElement('a');
                                newAddItemLink.href = 'Main.html?' + link;
                                newAddItemLink.appendChild(name);
                                newAddItemLink.appendChild(document.createTextNode(nameLabel));

                                newAddItem.appendChild(newAddItemLink);

                                olLst.appendChild(newAddItem);
                            }
                        }
                    }
                }

                return olLst.outerHTML;
            }

            if (tagName == 'wu-firstname') {
                return localStorage.Firstname;
            }

            if (tagName == 'wu-surname') {
                return localStorage.Surname;
            }

            // We should loop around the entity
            if (tagName == 'ent-candidate-read') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                background.SelectEntity("Candidate", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '';

            }

            if (tagName == 'ent-candidate-edit') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                background.SelectEntity("Candidate", "", background.GenerateBHKeyField(id), localTabId.innerText);
                //return '<button id="btSave" class="save" >Save</button>';
                return '';
            }

            if (tagName == 'ent-task-edit') {
                var id = getParameterByName("id");

                var fields = '[';
                fields = fields + background.GenerateEntityField("TaskRelatedEntityType", '', '', 'false', '');
                fields = fields + ']';

                var fieldsStr = JSON.stringify(fields);

                background.SelectEntity("Task", fieldsStr, background.GenerateBHKeyField(id), localTabId.innerText);
                return '';
            }

            if (tagName == 'ent-contact-read') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                var rtId = getParameterByName("RecordTypeId");

                background.SelectEntity("Contact", "", background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText);
                return '';

            }

            if (tagName == 'ent-lead-read') {
                var id = getParameterByName("id");
                var rtId = getParameterByName("RecordTypeId");
                background.SelectEntity("Lead", "", background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText, null, SelectEntityCallBack("Lead"));
                return '';
            }


            if (tagName == 'ent-account-read') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                var rtId = getParameterByName("RecordTypeId");

                const callBack = (function(entityName) {
                    return function(returnedJson) {
                        PassData(entityName, returnedJson, 0);
                    };
                })("Account");

                background.SelectEntity("Account", "", background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText, null, callBack);
                return '';

            }

            if (tagName == 'ent-task-read') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                var rtId = getParameterByName("RecordTypeId");
                var fields = '[';
                fields = fields + background.GenerateEntityField("TaskRelatedEntityType", '', '', 'false', '');
                fields = fields + ']';

                var fieldsStr = JSON.stringify(fields);

                background.SelectEntity("Task", fieldsStr, background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText);
                return '';

            }


            if (tagName == 'ent-opportunity-read') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                var rtId = getParameterByName("RecordTypeId");

                background.SelectEntity("Opportunity", "", background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText);
                return '';

            }


            if (tagName.indexOf('ent-') != -1) {
                if (tagName.indexOf('-read') != -1) {
                    var entityName = rawTag.replace('ENT-', '');
                    entityName = entityName.replace('-READ', '');

                    var id = '' + getParameterByName("id");

                    var rtId = '' + getParameterByName("RecordTypeId");


                    background.SelectEntity(entityName, "", background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText);
                    return '';

                }
            }

            if (tagName == 'ent-contact-edit') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                var rtId = getParameterByName("RecordTypeId");

                background.SelectEntity("Contact", "", background.GenerateBHKeyFieldWithRecordTypeId(id, rtId), localTabId.innerText);
                return '';
                //return '<button id="btSave" class="save" >Save</button>';
            }

            if (tagName == 'ent-company-read') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                background.SelectEntity("Company", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '';

            }

            if (tagName == 'ent-company-edit') {

                // At this point we want to read something.

                var id = getParameterByName("id");
                background.SelectEntity("Company", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return ''; // return '<button id="btSave" class="save" >Save</button>';

            }

            if (tagName == "ent-company-contacts") {
                var id = getParameterByName("id");
                background.SelectEntity("companyContacts", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="companyContacts"><img src="../images/ajax-loader.gif" alt="loading contacts" /> </div';
            }


            if (tagName == 'ent-candidate-activity') {
                var id = getParameterByName("id");
                background.SelectEntity("candidateactivitywidget", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="entityactivitywidget"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'ent-contact-activity') {
                var id = getParameterByName("id");
                background.SelectEntity("contactactivitywidget", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="entityactivitywidget"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'ent-company-activity') {
                var id = getParameterByName("id");
                background.SelectEntity("companyactivitywidget", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="entityactivitywidget"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'check-link-record-type') {
                var id = getParameterByName("id");
                var object = getParameterByName("ObjectName");
                moveFromLinkJumper = true;

                var fields = '[';
                fields = fields + background.GenerateEntityField("LinkJumperRecordType", '', '', 'false', '');
                fields = fields + ']';

                var fieldsStr = JSON.stringify(fields);

                background.SelectEntity(object, fieldsStr, background.GenerateBHKeyField(id), localTabId.innerText, null, SelectEntityCallBack(object));
                return '<div id="checklinkrecordtype"> </div>';
            }

            if (tagName == 'task') {
                var id = getParameterByName("id");
                background.SelectEntity("task", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="task"><img src="../images/ajax-loader.gif" alt"loading task" /> Loading activity... </div>';
            }

            if (tagName == 'task-account-open') {
                var id = getParameterByName("id");
                background.SelectEntity("taskaccountopen", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskaccountopen"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'task-account-closed') {
                var id = getParameterByName("id");
                background.SelectEntity("taskaccountclosed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskaccountclosed"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'task-opportunity-open') {
                var id = getParameterByName("id");
                background.SelectEntity("taskopportunityopen", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskopportunityopen"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'task-opportunity-closed') {
                var id = getParameterByName("id");
                background.SelectEntity("taskopportunityclosed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskopportunityclosed"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'opportunity-account') {
                var id = getParameterByName("id");
                background.SelectEntity("opportunityaccount", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="opportunityaccount"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'note-opportunity') {
                var id = getParameterByName("id");
                background.SelectEntity("noteopportunity", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="noteopportunity"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'contact-opportunity') {
                var id = getParameterByName("id");
                background.SelectEntity("contactopportunity", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="contactopportunity"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'opportunity-contact') {
                var id = getParameterByName("id");
                background.SelectEntity("opportunitycontact", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="opportunitycontact"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'contact-account-on') {
                var id = getParameterByName("id");
                background.SelectEntity("accountcontacts", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="accountcontacts"><img src="../images/ajax-loader.gif" alt="loading contacts" /> Loading contacts... </div>';
            }

            if (tagName == 'contact-account-tr') {
                var id = getParameterByName("id");
                background.SelectEntity("accountcontactstalentrover", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="accountContactsTalentRover"><img src="../images/ajax-loader.gif" alt="loading contacts" /> Loading contacts... </div>';
            }

            if (tagName == 'chatter-feed') {
                var id = getParameterByName("id");

                //You can't query anything on chatter if a Lead as been converted so only send chatter requests if this lead isn't converted
                var isConverted = getParameterByName("IsConverted");
                if (isConverted.toLowerCase() == "false" || isConverted == '') {
                    background.SelectEntity("chatterfeed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    return '<div id="chatterfeed"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading Chatter... </div>';
                }
            }

            if (tagName == 'chatter-follow') {
                var id = getParameterByName("id");

                //You can't query anything on chatter if a Lead as been converted so only send chatter requests if this lead isn't converted
                var isConverted = getParameterByName("IsConverted");
                if (isConverted.toLowerCase() == "false" || isConverted == '') {
                    background.SelectEntity("chatterfollow", "", background.GenerateBHKeyField(id), localTabId.innerText);

                    //  return '<div id="chatterfollow"><img src="../images/ajax-loader.gif" alt="Loading Chatter follow" /> Loading Chatter follow... </div>';

                    return '<div id="chatterfollow"></div>';
                }
            }

            if (tagName == 'chatter-like') {
                var id = getParameterByName("id");
                background.SelectEntity("chatterlike", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="chatterfeed"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading Chatter... </div>';
            }

            if (tagName == 'chatter-user') {
                var id = getParameterByName("id");
                background.SelectEntity("chatteruser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssingChatter();
                return '<div id="chatteruser"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading Chatter... </div>';
            }

            if (tagName == 'chatter-usersmall') {
                var id = getParameterByName("id");
                background.SelectEntity("chatterusersmall", "", background.GenerateBHKeyField(id), localTabId.innerText);
                AssingChatter();
                return '<div id="chatterusersmall"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading Chatter... </div>';
            }

            if (tagName == 'chatter-what-i-follow-home') {
                var id = getParameterByName("id");
                background.SelectEntity("chatterfeedfollows", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading Chatter... ';
            }

            if (tagName == 'task-contact-open') {
                var id = getParameterByName("id");
                background.SelectEntity("taskcontactopen", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskcontactopen"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'task-contact-closed') {
                var id = getParameterByName("id");
                background.SelectEntity("taskcontactclosed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskcontactclosed"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'task-lead-open') {
                var id = getParameterByName("id");
                background.SelectEntity("taskleadopen", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskleadopen"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'task-lead-closed') {
                var id = getParameterByName("id");
                background.SelectEntity("taskleadclosed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="taskleadclosed"><img src="../images/ajax-loader.gif" alt="loading activity" /> Loading activity... </div>';
            }

            if (tagName == 'chatter-user') {
                var id = getParameterByName("id");
                background.SelectEntity("chatteruser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="chatteruser"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading Chatter... </div>';
            }

            if (tagName == 'campaign-feed-contact') {
                var id = getParameterByName("id");
                background.SelectEntity("campaignfeedcontact", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="campaignfeedcontact"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading campaigns... </div>';
            }

            if (tagName == 'campaign-feed-lead') {
                var id = getParameterByName("id");
                background.SelectEntity("campaignfeedlead", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="campaignfeedlead"><img src="../images/ajax-loader.gif" alt="Loading Chatter" /> Loading campaigns... </div>';
            }


            if (tagName == 'ent-candidate-note') {

                var id = getParameterByName("id");
                background.SelectEntity("candidatenotes", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="candidateNotes"><img src="../images/ajax-loader.gif" alt="loading notes" /> Loading notes...</div>';
            }
            if (tagName == 'ent-candidate-task') {

                var id = getParameterByName("id");
                background.SelectEntity("candidatetasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="candidateTasks"><img src="../images/ajax-loader.gif" alt="loading tasks" /> Loading Tasks...</div>';
            }


            if (tagName == 'ent-contact-note') {

                var id = getParameterByName("id");
                background.SelectEntity("contactnotes", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="candidateNotes"><img src="../images/ajax-loader.gif" alt="loading notes" /> Loading notes...</div>';
            }

            if (tagName == 'ent-contact-task') {

                var id = getParameterByName("id");
                background.SelectEntity("contacttasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="candidateTasks"><img src="../images/ajax-loader.gif" alt="loading tasks" /> Loading Tasks...</div>';
            }

            if (tagName == 'ent-company-note') {

                var id = getParameterByName("id");
                background.SelectEntity("companynotes", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="candidateNotes"><img src="../images/ajax-loader.gif" alt="loading notes" /> Loading notes...</div>';
            }

            if (tagName == 'ent-company-task') {

                var id = getParameterByName("id");
                background.SelectEntity("companytasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="candidateTasks"><img src="../images/ajax-loader.gif" alt="loading tasks" /> Loading Tasks...</div>';
            }

            if (tagName == 'job-contact') {

                var id = getParameterByName("id");
                background.SelectEntity("contactjobs", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="contactJobs"><img src="../images/ajax-loader.gif" alt="loading jobs" /> Loading Jobs...</div>';
            }

            if (tagName == 'job-account') {

                var id = getParameterByName("id");
                background.SelectEntity("accountjobs", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="accountJobs"><img src="../images/ajax-loader.gif" alt="loading jobs" /> Loading Jobs...</div>';
            }

            if (tagName == 'job-account-tr') {

                var id = getParameterByName("id");
                background.SelectEntity("accountjobstalentrover", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="accountJobsTalentRover"><img src="../images/ajax-loader.gif" alt="loading jobs" /> Loading Jobs...</div>';
            }

            if (tagName == 'application-contact') {

                var id = getParameterByName("id");
                background.SelectEntity("contactapplications", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="contactApplications"> </div>';
            }

            if (tagName == 'task-read-all') {
                var id = getParameterByName("id");
                background.SelectEntity("alltasksaccount", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="allTasks"><img src="../images/ajax-loader.gif" alt="loading activities" /> Loading Activities...</div>';
            }

            if (tagName == 'hiring-manager') {
                var id = getParameterByName("id");
                background.SelectEntity("contactjobstalentrover", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="contactJobsTalentRover"><img src="../images/ajax-loader.gif" alt="loading activities" /> Loading Managers...</div>';
            }

            if (tagName == 'task-read-all-contact') {
                var id = getParameterByName("id");
                background.SelectEntity("alltaskscontact", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="allTasks"><img src="../images/ajax-loader.gif" alt="loading activities" /> Loading Activities...</div>';
            }

            if (tagName == 'chatter-home-group-dropdown') {
                var id = getParameterByName("id");
                background.SelectEntity("chattergroupsforuser", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="chatterGroups">To <select><option value="myfollowers">My Followers</option></select></div>';
            }

            if (tagName == 'candidate-job-status') {

                var id = getParameterByName("id");
                background.SelectEntity("contactcandidatejobstatus", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="contactCandidateJobStatus"><img src="../images/ajax-loader.gif" alt="loading managers" /> Loading Job Status...</div>';
            }

            if (tagName == 'opportunities-discussed') {

                var id = getParameterByName("id");
                background.SelectEntity("contactopportunitiesdiscussed", "", background.GenerateBHKeyField(id), localTabId.innerText);
                return '<div id="contactOpportunitiesDiscussed"><img src="../images/ajax-loader.gif" alt="loading managers" /> Loading Opportunities...</div>';
            }

            if (tagName == 'search-people-results') {

                var search = getParameterByName("search");
                txt_search.value = search;

                var amountOnPage = getParameterByName("amountonpage");

                background.Search("people", search, localTabId.innerText, amountOnPage, null, null, null, 1, PassData, function (responseObject) {
                    if (responseObject && responseObject.errormessage) {
                        ShowSearchError(responseObject.errormessage);
                    }
                });

                return '<div id="searchResult"><h2>People</h2><img src="../images/ajax-loader.gif" alt="loading notes" /> </div>';
            }

            if (tagName == 'search-sfaccount-results') {

                var search = getParameterByName("search");
                txt_search.value = search;

                var amountOnPage = getParameterByName("amountonpage");

                background.Search("sfaccount", search, localTabId.innerText, amountOnPage, null, null, null, 1, PassData, function(responseObject) {
                    if (responseObject && responseObject.errormessage) {
                        ShowSearchError(responseObject.errormessage);
                    }
                });

                return '<div id="searchResultClient"><h2>Resu</h2><img src="../images/ajax-loader.gif" alt="loading Client Search" /> </div>';
            }

            if (tagName == 'search-coresearch-results') {

                let search = getParameterByName("search");
                txt_search.value = search;

                if (search.length < 2) {
                    ShowSearchError("Please enter at least 2 characters in the search box.");
                    return '<div id="searchResultClient"><ol id="allLogins1" class="itemlist"><li role="listitem" class="showMe" id="failureMessage">Please try a search with more characters</li></ol></div>';
                } else {
                    let amountOnPage = getParameterByName("amountonpage");

                    $('#txt_search').removeClass('magnify');
                    background.Search("coresearch", search, localTabId.innerText, amountOnPage, null, null, null, 1, PassData, function (responseObject) {
                        if (responseObject && responseObject.xhr) {
                            ShowSearchError("Error: " + responseObject.xhr.statusText);
                        }
                    });
                    return '<div id="searchResultClient"><h2>Results</h2><img src="../images/ajax-loader.gif" alt="loading Client Search" /> </div>';
                }                               
            }

            if (tagName == 'search-sfcontact-results') {

                var search = getParameterByName("search");
                txt_search.value = search;

                var amountOnPage = getParameterByName("amountonpage");

                background.Search("sfcontact", search, localTabId.innerText, amountOnPage, null, null, null, 1, PassData, function (responseObject) {
                    if (responseObject && responseObject.errormessage) {
                        ShowSearchError(responseObject.errormessage);
                    }
                });

                return '<div id="searchResult"><h2>Search Results</h2><img src="../images/ajax-loader.gif" alt="loading Searches" /> </div>';
            }


            if (tagName == 'search-client-results') {

                var search = getParameterByName("search");
                txt_search.value = search;

                var amountOnPage = getParameterByName("amountonpage");

                background.Search("client", search, localTabId.innerText, amountOnPage, null, null, null, 1, PassData, function (responseObject) {
                    if (responseObject && responseObject.errormessage) {
                        ShowSearchError(responseObject.errormessage);
                    }
                });

                return '<div id="searchResultClient"><h2>Clients</h2><img src="../images/ajax-loader.gif" alt="loading Client Search" /> </div>';
            }

            if (tagName.indexOf('dd-') != -1) {

                var val = tagName.split('-');
                var action = localAction.innerText;
                if (action.indexOf('-Add') == -1) {
                    return GetLookup(val[2], 1);
                } else {
                    // Yes I Know.. JBK
                    return GetLookup(val[2], 1);
                }
            }

            if (tagName == 'shortlistdistro') {


                var fields = '[';
                fields = fields + background.GenerateEntityField("searchString", '', '', 'true');
                fields = fields + ']';

                var fieldsStr = JSON.stringify(fields);

                background.SelectEntity("DistributionList", "", fieldsStr, localTabId.innerText);

                $("body").delegate("#btShortlist", "click", function() {

                    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-ShortlistDistro-Add', '1']);

                    var fields = '[';
                    fields = fields + background.GenerateEntityField("searchString", '' + txt_SearchShortList.value, '', 'true');
                    fields = fields + ']';

                    var fieldsStr = JSON.stringify(fields);

                    
                    AssignLoader("#DistributionList");

                    background.SelectEntity("DistributionList", "", fieldsStr, localTabId.innerText);


                });

                return '<div id="DistributionList"><img src="../images/ajax-loader.gif" alt="loading" /></div>';


            }


            if (tagName == 'shortlist') {

                var fields = '[';
                fields = fields + background.GenerateEntityField("searchString", '', '', 'true');
                fields = fields + ']';

                var fieldsStr = JSON.stringify(fields);

                background.SelectEntity("TearsheetList", "", fieldsStr, localTabId.innerText);

                $("body").delegate("#btShortlist", "click", function() {

                    //_gaq.push(['_trackEvent', '' + localStorage.WebUserId, 'Button-Shortlist-Add', '1']);


                    var fields = '[';
                    fields = fields + background.GenerateEntityField("searchString", '' + txt_SearchShortList.value, '', 'true');
                    fields = fields + ']';

                    var fieldsStr = JSON.stringify(fields);

                    AssignLoader("#TearsheetList");

                    background.SelectEntity("TearsheetList", "", fieldsStr, localTabId.innerText);


                });

                return '<div id="TearsheetList"><img src="../images/ajax-loader.gif" alt="loading" /></div>';

            }


            if (tagName == 'id') {
                var id = getParameterByName("id");
                return id;
            }

            if (tagName == 'appversion') {

                //console.log('display app version');

                var trialBracketMessage = '';

                if ("" + localStorage.EbstaGrowthTrial === 'true') {
                    trialBracketMessage = ' (Trial)';
                }

                var html = '<div id="lbVersion">' + localStorage.ProductName + trialBracketMessage + '</div>';

                //console.log(localStorage.EbstaGrowthTrial);

                if ("" + localStorage.EbstaGrowthTrial === 'true') {
                    html = html + '<br /><button class="licenceUpdate nosave" >Upgrade</button><br />';
                }else {
                    html = html + '<br />';
                }

                $("body").on("click", ".licenceUpdate", function() {
                    openURLNewTab("https://www.ebsta.com/pricing/");
                });

                return html;
            }

            if (tagName == 'title') {
                var title = getParameterByName("title");
                return title;
            }

            if (tagName == "notetypedropdown") {
                var noteType = '<select id="noteType" class="required" msg="Type is missing" >';

                noteType = noteType + GetLookup('NoteType', 1);

                noteType = noteType + '</select>';

                return noteType;
            }

            if (tagName == 'welcomechatter') {
                var greetings = "Welcome";//background.ebstaMessages.greetings[Math.floor(Math.random() * background.ebstaMessages.greetings.length)].message;

                return greetings;
            }

            if (tagName == 'licence') {


                var licence = '<div class="welcome"><h2>Validate Licence</h2><div id="nolicensefound"></div><div id="validatelicenseprompt">If you have purchased a licence, please click this button to:<button id="btValidate" >Validate Your Licence</button></div></div>';


                if (localStorage.Mode == 'true') {
                    licence = '';
                }
                return licence;
            }

            if (tagName == 'freetrial') {

                licence = '';

                //if (localStorage.LicenceFound == "Chatter") {
                //    licence = '<div class="welcome"><h2>Start a Free Trial</h2><div id="nolicensefound" class="hidden"></div><div id="validatelicenseprompt">If you have not started a free trial of :<button id="btEbstaPro" >Ebsta Pro click here.</button></div></div>';

                //}
                return licence;
            }


            if (tagName == 'getstarted') {
                var greetings = "Welcome";//background.ebstaMessages.getstarted[Math.floor(Math.random() * background.ebstaMessages.getstarted.length)].message;

                return greetings;
            }

            if (tagName == 'jokes') {
                var greetings = "";//background.ebstaMessages.jokes[Math.floor(Math.random() * background.ebstaMessages.jokes.length)].message;

                return greetings;
            }

            if (tagName == 'recentactivity') {

                var html = '';
                var found = 0;

                //let's make today's date
                var date = new Date();
                var month = date.getMonth() + 1;
                var day = date.getDate();

                var today = "" +
                    (day < 10 ? '0' : '') + day + '/' +
                    (month < 10 ? '0' : '') + month
                    + '/' + date.getFullYear();

                var eventLinkButton = '<a href="#">New Event</a>';
                var taskLinkButton = '<a href="#">New Task</a>';

                if (localStorage.ChatterOnly != "1") {
                    eventLinkButton = '<a href="Main.html?action=Event-Add">New Event</a>';
                    taskLinkButton = '<a href="Main.html?action=Task-Add">New Task</a>';
                }

                html = html + '<div class="homepagedisplaydiv"><p><h2>Recent Items</h2></p>';

                html = html + '<span id="recentListInput"></span></div>';

                html = html + '<div id="homepagetasksdiv" class="homepagedisplaydiv">';

                html = html + '<div id="tabs">';
                html = html + '<ul class="taskEventTabs ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all" role="tablist">';
                html = html + '<li><a href="#homepageTaskInnerDiv" class="myTasksTab pointer">My Tasks</a></li>';
                html = html + '<li><a href="#homepageEventInnerDiv" class="myEventsTab pointer">My Events</a></li>';
                html = html + '</ul>';
                html = html + '</h2><br>';
                html = html + '<div class="homepagedropdowndiv"><button id="btAddTaskHP" class="btHomePageAdd addTaskEvent">' + taskLinkButton + '</button>';
                html = html + '<select id="taskFilterDropdown">';
                html = html + '<option value="2">Overdue</option>';
                html = html + '<option value="3">Today</option>';
                html = html + '<option value="-1" selected>Today + Overdue</option>';
                html = html + '<option value="5">Tomorrow</option>';
                html = html + '<option value="6">Next 7 days</option>';
                html = html + '<option value="7">Next 7 days + Overdue</option>';
                html = html + '<option value="8">This Month</option>';
                html = html + '<option value="4">All Open</option>';
                html = html + '</select>';
                html = html + '<div id="homepagedateandeventbutton" class="hidden">';
                html = html + '<h3 class="leftEventHeader">Today\'s Meetings</h3>';
                html = html + '<button id="btAddEventHP" class="btHomePageAdd addTaskEvent">' + eventLinkButton + '</button>';
                html = html + '</div>';
                html = html + '</div>'; 
            
                var id;
                if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null) {
                    id = localStorage.UserId;
                } else {
                    var lgmObj = JSON.parse(localStorage.LayoutManager);
                    id = lgmObj.d.SaleforceUserId;
                }
               
                if (localStorage.ChatterOnly != "1") {
                    if (localStorage.OpenFromTaskBar == 1) {
                        background.SelectEntity("duetodaytasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    }
                    else {
                        background.SelectEntity("todayandoverduetasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    }
                } else {
                    $("#homepageTaskInnerDiv").empty();
                    $(".btHomePageAdd").attr('disabled', 'disabled');
                    loaderImage = '';
                }

                html = html + '<div id="homepageTaskInnerDiv" class="homepageTaskInnerDiv homeTaskDiv"><img src="../images/ajax-loader.gif" alt="loading tasks" /></div>';
                html = html + '<div id="homepageEventInnerDiv" class="homepageEventInnerDiv homeEventDiv"><img src="../images/ajax-loader.gif" alt="loading tasks" /></div><br>';
                html = html + '</div> ';
                        
                html = html + '</div>';

                // Call recent Item List so we bind to it. 
                background.GetRecentlist();
                
                return html;
            }

            if (tagName == "contactdropdown") {
                var id = getParameterByName("id");
                if (getParameterByName("company") == 'true') {
                    background.SelectEntity("companyContacts2", "", background.GenerateBHKeyField(id), localTabId.innerText);
                    return '<div id="contactdropdown"><img src="../images/ajax-loader.gif" alt="loading contacts" /> </div';
                } else {
                    return '<input type="text" value="' + getParameterByName("title") + '" name="contactname" class="shortInput" style="width:200px;margin-left:90px;" disabled />';

                }
            }

            return '';

        }
        
        // Each SF locale has a certain format and this basically returns the date in a format which respects how SF show the date for a particular user locale
        // inputDate format = "yyyy-mm-dd"
        function FormatDateLocal(inputDate)
        {
            var locale = localStorage.Locale;
            var dateFormat = GetDateFormatFromLocale(locale);


            if (inputDate != null && inputDate.length > 0 && locale != null && typeof locale != "undefined")
            {

                //Need to include a time and 'Z' so the browser takes the PC's timezone into affect and applies an offset
                var returnDate = new Date(inputDate.trim() + "T00:00:00Z");

                if (returnDate.toString().indexOf("Invalid") != -1)
                {
                    var dateSplit = inputDate.split("/");
                    if (dateSplit.length > 1)
                    {
                        var splitYear = '';

                        if (dateSplit[2].length > 3)
                        {
                            splitYear = dateSplit[2].substring(0, 4);
                        }

                        if (splitYear.length > 3)
                        {
                            returnDate = new Date(splitYear + "-" + dateSplit[1] + "-" + dateSplit[0]);
                        }
                    } else {
                        //If we can't do anything with the date then feedback a blank
                        return "";
                    }
                } else {
                    // Add a day to -UTC timezones to catch the offset as creating a Date object will apply
                    // the machine's timezone offset and put any -UTC timezone a day behind
                    if (returnDate.getTimezoneOffset() > 0) {
                        returnDate.addHours(24);
                    }
                }

                returnDate = $.datepicker.formatDate(dateFormat, returnDate);

                return returnDate;
            }

            return inputDate;
        }

        //This function 'unformats' dates back into into SF format before passing up to the API.  
        //This is to counter an issue with date formats when editing activities (tasks, events).
        //If you edit an event, the format is changed to be a user friendly format (e.g. dd-mm-yyyy), 
        //but if you do not pick a new date, the data sent back to the SF API is in the incorrect format, 
        //hence the need for this function.    
        function unFormatDateLocal(inputDate)
        {
            var returnDate = inputDate;
            var locale = localStorage.Locale;
            var dateFormat = GetDateFormatFromLocale(localStorage.Locale);

            if (inputDate.length > 0 && locale != null && typeof locale != "undefined" && dateFormat.length > 0)
            {
                //Remove some spaces so it follows a general format eg dd/m/yy or d/mm/yy
                inputDate = inputDate.split(' ').join('');
                dateFormat = dateFormat.split(' ').join('');

                //Lets split the values of the date
                var dateSplit = inputDate.split(/[.|\/|-]/);

                //Lets split the format up so we can find what section is the day/month/year
                var dateFormatSplit = dateFormat.split(/[.|\/|-]/);

                var year, month, day;

                //Find the day, month and year
                if (dateSplit && dateFormatSplit) {
                    if (dateSplit.length > 1 && dateFormatSplit.length > 1) {
                        if (dateFormatSplit.indexOf("d") != -1) {
                            day = dateSplit[dateFormatSplit.indexOf("d")];
                        }

                        if (dateFormatSplit.indexOf("dd") != -1) {
                            day = dateSplit[dateFormatSplit.indexOf("dd")];
                        }

                        if (dateFormatSplit.indexOf("m") != -1) {
                            month = dateSplit[dateFormatSplit.indexOf("m")];
                        }

                        if (dateFormatSplit.indexOf("mm") != -1) {
                            month = dateSplit[dateFormatSplit.indexOf("mm")];
                        }

                        if (dateFormatSplit.indexOf("y") != -1) {
                            year = dateSplit[dateFormatSplit.indexOf("y")];
                        }

                        if (dateFormatSplit.indexOf("yy") != -1) {
                            year = dateSplit[dateFormatSplit.indexOf("yy")];
                        }
                    }
                }

                returnDate = year + "-" + month + "-" + day;
                return returnDate;
            }
            return inputDate;
        }

        // Returns the date format for Date time fields which replicates the same look and feel of salesforce
        // https://help.salesforce.com/apex/HTViewHelpDoc?id=admin_supported_locales.htm&language=en_US
        function GetDateFormatFromLocale(locale) {
            switch (locale) {
                case "ar":
                case "ar_AE":
                case "ar_BH":
                case "ar_EG":
                case "ar_JO":
                case "ar_KW":
                case "ar_LB":
                case "ar_QA":
                case "ar_SA":
                case "ca":
                case "ca_ES":
                case "cy_GB":
                case "el":
                case "el_GR":
                case "en_AU":
                case "en_CA":
                case "en_GB":
                case "en_IE":
                case "en_IE_EURO":
                case "en_IN":
                case "en_NZ":
                case "en_ZA":
                case "es":
                case "es_AR":
                case "es_CO":
                case "es_CR":
                case "es_EC":
                case "es_ES":
                case "es_GT":
                case "es_MX":
                case "es_PE":
                case "es_PY":
                case "es_UY":
                case "es_VE":
                case "fr":
                case "fr_BE":    
                case "fr_FR":
                case "fr_LU":
                case "fr_MC":
                case "ga_IE":
                case "in":
                case "in_ID":
                case "it":
                case "it_IT":
                case "iw":
                case "iw_IL":
                case "ja":
                case "ja_JP":
                case "ms_BN":
                case "ms_MY":
                case "mt_MT":
                case "nl":
                case "nl_BE":
                case "nl_NL":
                case "nl_SR":
                case "pt_BR":
                case "pt_PT":
                case "vi":
                case "vi_VN":
                case "zh_SG":

                    return "dd/mm/yy";

                case "da":
                case "da_DK":
                case "es_BO":
                case "es_CL":
                case "pt":
                case "pt_AO":
                case "pt_PT":

                    return "dd-mm-yy";

                case "en_BB":
                case "en_BM":
                case "en_GH":
                case "en_ID":
                case "en_MY":
                case "en_NG":
                case "en_PH":
                case "en_PK":
                case "en_SG":
                case "en_US":
                case "es_DO":
                case "es_PR":
                case "es_SVUS":
                case "hy_AM":
                case "ka":
                case "ka_GE":
                case "kk_KZ":
                case "km_KH":
                case "ky_KG":
                case "lb_LU":
                case "tg_TJ":
                case "tl":
                case "tl_PH":
                case "ur_PK":

                    return "mm/dd/yy";

                case "es_HN":
                case "es_PR":
                case "es_SVUS":

                    return "mm-dd-yy";

                case "bs_BA":
                case "de":
                case "de_AT":
                case "de_CH":
                case "de_DE":
                case "de_LU":
                case "fr_CH":
                case "hr_HR":
                case "it_CH":
                case "no":
                case "no_NO":
                case "pl_PL":
                case "rm_CH":
                case "ro":
                case "ro_MD":
                case "ro_RO":
                case "ru":
                case "ru_RU":
                case "sh":
                case "sh_BA":
                case "sh_ME":
                case "tr":
                case "tr_TR":
                case "uk":
                case "uk_UA":

                    return "dd.mm.yy";

                case "be_BY":
                case "cs":
                case "cs_CZ":
                case "fi":
                case "fi_FI":
                case "is_IS":
                case "mk_MK":
                case "sk":
                case "sk_SK":
                case "sl_SI":
                case "sr":

                    return "d.m.yy";

                case "et_EE":
                case "sr_CS":

                    return "d.mm.yy";

                case "th":
                case "th_TH":

                    return "d/m/yy";

                case "hu":
                case "hu_HU":

                    return "yy.mm.dd";

                case "zh_TW":
                case "zh_TW_STROKE":

                    return "yy/m/d";

                case "ko":
                case "ko_KR":

                    return "yy .m .d";

                case "lt_LT":

                    return "yy.m.d";

                case "lv_LV":
                    return "yy.d.m";

                case "sq_AL":
                case "sr_BA":
                case "sv":
                case "sv_SE":
                case "pl":
                case "fr_CA":
                case "eu_ES":
                case "az_AZ":

                    return "yy-mm-dd";

                case "bg":
                case "bg_BG":
                case "zh":
                case "zh_CN":
                case "zh_CN_PINYIN":
                case "zh_CN_STROKE":

                    return "yy-m-d";
            }

            return "mm-dd-yy";
        }


        function MoveMe(url) {
            //fixes back links after link jumper page...
            if (!moveFromLinkJumper) {                                               
                localStorage.lastKnown = window.location;
            }

            window.location = url;
        }

        function SelectCompany(id, name) {
            document.getElementById("entityfields").style.display = 'block';
            document.getElementById("CompanyId").value = name;
            document.getElementById("CoId").value = id;
            document.getElementById("pageTitle").innerHTML = "Add Contact";
            document.getElementById("companyLookup").style.display = 'none';
            CheckCompanyLookup();
            $('.save').show();
        }

        function RecoverOutofError() {

            // Fixes the Saving not going away
            $('.save').text('Save');
            $('#messageSuccess').hide();
            $('#messageName').text('Saving');
            if (localStorage != null) {
                localStorage.DoubleTap = '';
            }
        }

        //api disabled - we should log the user out.
        function ShowApiErrorWithMessage() {
            //commented out - we are logging out chatter disabled users!
            //background.ClearCacheAndLogout();
        }

        /**
         * Shows an error dialog when there has been an error in searching
         * @param {string} stringToDisplay - What string to display in the error
         */
        function ShowSearchError(stringToDisplay) {     
            $('#messageName').text(stringToDisplay);
            $('#messageSuccess').show();
            $('#messageSuccess').fadeOut(5000);
            var listOl = document.createElement('ol');
            listOl.id = "allLogins1";
            listOl.setAttribute("class","itemlist");

            var liItem = document.createElement('li');
            liItem.setAttribute("role", "listitem");
            liItem.setAttribute("class", "showMe");
            liItem.setAttribute("id", "failureMessage");
            liItem.innerText = "There are no results. Please search again."; 
            listOl.appendChild(liItem);

            var searchResplaceHolder = document.getElementById('searchResultClient');
            if (searchResplaceHolder !== null) {
                searchResplaceHolder.innerHTML = '';
                searchResplaceHolder.appendChild(listOl);
            }
        }

        function SelectError(entityName) {

            $('#messageName').text('Failed to get ' + entityName + ' this is maybe a temporary error, please retry.');
            $('#messageSuccess').show();
            $('#messageSuccess').fadeOut(1000);
        }

        //this function is used to clear date input values (currently used when you enter an activity with a negative time span).
        function ClearTimesFromDates() {

            if ($("#txt-Event-StartDateTime").length > 0) {
                var startDate = $("#txt-Event-StartDateTime").val();
                $("#txt-Event-StartDateTime").val(startDate.split("T")[0]);
            }
            if ($("#txt-Event-StartDateTime").length > 0) {
                var endDate = $("#txt-Event-EndDateTime").val();
                $("#txt-Event-EndDateTime").val(endDate.split("T")[0]);
            }
            if ($("#txt-Event-ReminderDateTime").length) {
                var reminderDate = $("#txt-Event-ReminderDateTime").val();
                $("#txt-Event-ReminderDateTime").val(reminderDate.split("T")[0]);
            }
        }

        // Save Forms Data.
        addEventListener("unload", function(event) {
            var action = localAction.innerText;
            background = chrome.extension.getBackgroundPage();
            if (action.toString() == "WelcomeChatter") {
                var unPostChatterMess = $("#chatterWidget1").val();
                //if (unPostChatterMess.length > 0) {
                localStorage.UnpostedChatter = unPostChatterMess;
                //}
            }
            var searchTerm = $("#txt_search").val();
            var tabId = '' + localTabId.innerText;
            var currentAction = '' + window.location;
            currentAction = currentAction.replace('?chk=1', '');
            currentAction = currentAction.replace('message=', 'oldmessage=');
            var tabUrl = '' + localTabUrl.innerHTML;
            background.AddUpdateCache(searchTerm, GetFormsData(), currentAction, tabId, tabUrl);
        }, true);


        

        function ShowNoLic() {
            document.getElementById("nolicensefound").innerHTML = "<a class='extlink' href='https://console.ebsta.com/converttrials.aspx?s=" + localStorage.SessionCode + "&u=" + localStorage.WebUserId + "'> No licence found. Please contact your administrator or click here to purchase a licence</a>";

        }

        function DisplayWidgetTasks(db, lgm) {
            
            var count = db.d.Values.length;
            var now = new Date();
            if (count > 10) {
                count = '10+';
            }

            var accordionText = document.createTextNode('Open Activities (' + count + ')');
            var accordionSpan = document.createElement('span');
            accordionSpan.className = "ui-accordion-header-icon ui-icon ui-icon-triangle-1-s";

            
            if (db.d.EntityType == "taskaccountopen") {                            
                var accordionObject = document.getElementById('activitySFCounter');
                accordionObject.innerHTML = '';
                accordionObject.appendChild(accordionSpan);
                accordionObject.appendChild(accordionText);
            } else {
                if (db.d.EntityType == "alltaskscontact" || db.d.EntityType == "alltasksaccount") {

                    accordionText.nodeValue = 'Activities (' + count + ')';

                    var accordionObject = document.getElementById('allTaskCounter');
                    if (accordionObject != null) {
                        accordionObject.innerHTML = '';
                        accordionObject.appendChild(accordionSpan);
                        accordionObject.appendChild(accordionText);
                    }
                } else {

                    var accordionObject = document.getElementById('openTaskCounter');
                    accordionObject.innerHTML = '';
                    accordionObject.appendChild(accordionSpan);
                    accordionObject.appendChild(accordionText);
                }
            }

            //var buildView = '<dl>';
            var buildView = document.createElement('dl');

            
            for (var i = 0; i < db.d.Values.length; i++) {

                var fld = db.d.Values[i];

                var noteList = JSON.parse(fld);

                //var buildLink = 'Main.html?action=Task&id=' + noteList.Id;
                var buildLink = lgm.d.DataUrl + "/" + noteList.Id;

                var subject = noteList.Subject;

                if (subject == '') {
                    subject = 'View Activity';
                }

                //get activity date
                var listItemDate = noteList.ActivityDate;

                if (listItemDate == null) {
                    listItemDate = '';
                }

                var FormattedlistItemDate = document.createTextNode('' + FormatDateLocal(listItemDate)); //format date depending on location

                //put date in date for date comparison
                var taskDate = new Date(listItemDate);
                
                //build div with date in it
                //var dateDiv = '<div';
                var dateDiv = document.createElement('div');

                now.setHours(0);
                now.setMinutes(0);
                now.setSeconds(0);
                now.setMilliseconds(0);

                if (taskDate < now && noteList.Status != "Completed") { //if overdue add overdue class
                    //dateDiv = dateDiv + ' class="overduetask"';
                    dateDiv.className = 'overduetask';
                }

                
                //dateDiv = dateDiv + '>' + FormattedlistItemDate + '</div>';
                dateDiv.appendChild(FormattedlistItemDate);

                //build High priority "!" span
                //var prioritySpan = '';
                
                var prioritySpan = document.createElement('span');
                if (noteList.Priority == "High") {
                    //prioritySpan = '<span class="hiPriTask"><b>&nbsp;!</b></span>';
                    
                    prioritySpan.className = 'hiPriTask';

                    var boldText = document.createElement('b');
                    boldText.appendChild(document.createTextNode('!'));

                    prioritySpan.appendChild(boldText);
                }

                var status = '';
                
                var lineBreak = document.createElement('br');
                var lineBreak2 = document.createElement('br');

                var buildDiv = document.createElement('div');
                buildDiv.className = 'homepagetaskdiv taskListDiv';

                var leftSpanDiv = document.createElement('span');
                leftSpanDiv.className = 'leftSpanBlock';

                var restrainDiv = document.createElement('div');
                restrainDiv.className = 'restrainDiv';

                var restrainDivRight = document.createElement('div');
                restrainDivRight.className = 'restrainDiv';

                var objectLink = document.createElement('a');
                objectLink.href = 'Main.html?action=LinkJumper&ObjectName=' + noteList.attributes.type + '&id=' + noteList.Id;
                objectLink.className = 'setLastKnown';
                objectLink.appendChild(document.createTextNode('' + TrimTaskSubject(subject)));
                
                
                var ownerName = document.createTextNode('' + noteList.Owner.Name);

                var rightSpanDiv = document.createElement('span');
                rightSpanDiv.className = 'rightSpanBlock accordianEventDate';             

                var midSpan = document.createElement('span');
                midSpan.className = 'homepagemidspan';

                var taskStatusDiv = document.createElement('div');
                taskStatusDiv.appendChild(document.createTextNode(noteList.Status));
                taskStatusDiv.appendChild(lineBreak);
                taskStatusDiv.appendChild(dateDiv);

                var taskRightSpan = document.createElement('span');
                taskRightSpan.className = 'homepagerightspan';

                var closeLink = document.createElement('a');
                closeLink.href = 'Main.html?action=Task-Edit&id=' + noteList.Id + '&RecordTypeId=Master&SetClosed=1';
                
                var closeIcon = document.createElement('div');
                closeIcon.className = 'homepageclosetaskdiv';
                closeIcon.id = noteList.Id;
                closeIcon.title = 'Mark ' + subject + ' Complete';

                if (noteList.attributes.type == "Event") {

                    var rightDateDiv = document.createElement('div');
                    rightDateDiv.className = 'restrainDiv';
                    rightDateDiv.appendChild(FormattedlistItemDate);

                    var eventTime = '';

                    //Get time information for Event
                    if (noteList.StartDateTime != null && noteList.EndDateTime != null)
                    {
                        //Create the time values using the data given as the hard work has been done in the backend
                        var timeString = GetTimeFromDateTimeValue(noteList.StartDateTime) + "-" + GetTimeFromDateTimeValue(noteList.EndDateTime);
                        eventTime = document.createTextNode(timeString);
                    }
                    
                    //buildDiv.appendChild(leftSpanDiv.appendChild(restrainDiv.appendChild(objectLink).appendChild(document.createTextNode(prioritySpan)).appendChild(lineBreak).appendChild(document.createTextNode(noteList.Owner.Name)))).appendChild(rightSpanDiv.appendChild(rightDateDiv).appendChild(lineBreak).appendChild(eventTime));

                    //left block...
                    restrainDiv.appendChild(objectLink);
                    restrainDiv.appendChild(lineBreak2);
                    restrainDiv.appendChild(document.createTextNode(noteList.Owner.Name));
                    //restrainDiv.appendChild(document.createTextNode('' + noteList.Owner.Name));
                    leftSpanDiv.appendChild(restrainDiv);
                    //restrainDiv.innerHTML = '';
                    //right block...
                    rightDateDiv.appendChild(lineBreak);
                    rightDateDiv.appendChild(eventTime);
                    rightSpanDiv.appendChild(rightDateDiv);
                    buildDiv.appendChild(leftSpanDiv);
                    buildDiv.appendChild(rightSpanDiv);

                    //buildView = buildView + '<div class="homepagetaskdiv taskListDiv"><span class="leftSpanBlock"><div class="restrainDiv"><a href="Main.html?action=LinkJumper&ObjectName=Event&id=' + noteList.Id + '" class="setLastKnown">' + TrimTaskSubject(subject) + '</a>' + prioritySpan + '<br />' + noteList.Owner.Name + '</div></span><span class="rightSpanBlock accordianEventDate"><div class="restrainDiv">' + FormattedlistItemDate + '<br />' + startSplit[0] + ':' + startSplit[1] + '-' + endSplit[0] + ':' + endSplit[1] + '</div></span></div>';
                } else {

                    restrainDiv.appendChild(objectLink);
                    restrainDiv.appendChild(prioritySpan);
                    restrainDiv.appendChild(lineBreak);
                    restrainDiv.appendChild(document.createTextNode('' + noteList.Owner.Name));
                    leftSpanDiv.appendChild(restrainDiv);
                    //restrainDiv.innerHTML = '';
                    //right block...
                    restrainDivRight.appendChild(taskStatusDiv);
                    midSpan.appendChild(restrainDivRight);
                    //close block...
                    
                    buildDiv.appendChild(leftSpanDiv);
                    buildDiv.appendChild(midSpan);

                    buildDiv.appendChild(taskRightSpan);

                    taskRightSpan.appendChild(closeLink);
                    closeLink.appendChild(closeIcon); 
                }

                buildView.appendChild(buildDiv);
            }

            
            return buildView;
        }

        //This function assembles a dash delimited string consisting of todays date and a 'StartTime' and 'EndTime', the start time being the nearest half hour in the future and the end time being one hour after that
        //e.g. if now is 12:15 the start time will be set to 12:30 and the end time to 13:30.  This is used when creating events, and follows how Salesforce sets default time vaules in time pickers. 
        function GetDateTimeStartEnd() {

            var returnVal = "";

            //get the day
            var date = new Date();
            var dateToday = date.getFullYear() + "-" + ('0' + (date.getMonth()+1)).slice(-2) + "-" + date.getDate();

            //this section deals with the default time:
            var currentHour = date.getHours();
            var currentMinute = date.getMinutes();

            if (currentMinute < 30) {
                currentMinute = "30";
            }
            else{
                currentMinute = "00";
                if (currentHour != 23)
                {
                    currentHour ++;
                }
            }
            if (currentHour < 10)
            {
                currentHour = "0" + currentHour;
            }
            var startTime = currentHour + ":" + currentMinute;

            //now lets get the end time from the start time
            endHour = currentHour;

            if (currentHour != 23) {
                endHour++;
            }
            else {
                endHour = 23;
            }

            if (endHour < 10) {
                endHour = "0" + endHour;
            }

            if (currentHour != 23) {
                var endTime = endHour + ":" + currentMinute;
            }
            else {
                var endTime = endHour + ":" + "30";
            }

            returnVal = dateToday + "?" + startTime + "?" + endTime;

            
            return returnVal;
        }

        //Takes a datetime value in the format of 2015-06-15T15:30:00+00:00 and returns the time
        function GetTimeFromDateTimeValue(dateTimeValue)
        {
            //Date format e.g. 2015-06-15T15:30:00+00:00
            var regexPattern = new RegExp("T(\\d{2}):(\\d{2}):(\\d{2})");
            var timeRegexMatches = dateTimeValue.match(regexPattern);

            if (timeRegexMatches) {
                if (timeRegexMatches[1] && timeRegexMatches[2]) {
                    return timeString = timeRegexMatches[1] + ":" + timeRegexMatches[2];
                }
            }

            return "";
        }

        function RenderHomePageTasks(index) {
            AssignLoaderWithText("#homepageTaskInnerDiv", "Loading Tasks... ");
            if (index == -2) {
                index = $("#taskFilterDropdown").val();
            }            

            var id;

            if (typeof localStorage.UserId != "undefined" && localStorage.UserId != null)
            {
                id = localStorage.UserId;
            } else {
                var lgmObj = JSON.parse(localStorage.LayoutManager);
                id = lgmObj.d.SaleforceUserId;
            }             

            if (index == -1) {
                background.SelectEntity("todayandoverduetasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 2) {
                background.SelectEntity("overduetasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 3) {
                background.SelectEntity("duetodaytasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 4) {
                background.SelectEntity("allopentasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 5) {
                background.SelectEntity("duetomorrowtasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 6) {
                background.SelectEntity("next7tasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 7) {
                background.SelectEntity("next7andoverduetasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
            if (index == 8) {
                background.SelectEntity("thismonthtasks", "", background.GenerateBHKeyField(id), localTabId.innerText);
            }
        }

        HideElementsForAbtesting();

        //Hide elements based on users AbTesting
        function HideElementsForAbtesting() {
            var strAbRules = GetAbTestingRules(localStorage.ABTester);
            var jsonRules = JSON.parse(strAbRules);

            if (jsonRules.EnableGmailEmailTracking + "" == "1") {
                $('#EmailTrackingSF').show();
                $('#btEmailTracking').next('br').show();
                $('#btEmailTracking').show();
            }

            if(jsonRules.EnableContactSync + "" === "0"){
                $('#btContactSync').hide().next().hide();
            }
        }

        // we need to communicate with bar.js in order to show the bar
        function ShowEmailTrackingSummaryFromMain() {
            background.ShowEmailTrackingSummaryBackground(localTabId.innerText);
        }

        function CalendarStateTokenResult(stateToken) {
            openURLNewTab('https://console.ebsta.com/Google/CalendarSettingsAll.aspx?state=' + stateToken);
        }


        function CheckForTypeFieldsByIndex(testTypeOfField) {
            if (testTypeOfField.indexOf('url') != -1 || testTypeOfField.indexOf('currency') != -1 || testTypeOfField.indexOf('percent') != -1 ||
                testTypeOfField.indexOf('double') != -1 || testTypeOfField.indexOf('boolean') != -1 || testTypeOfField.indexOf('int') != -1) {
                return true;
            }
            else {
                return false;
            }
}

/**
 * Creates an eye icon element which is used to pop up the hover over functionality when hovered over
 * @param {any} recordId - Id of the Salesforce record
 * @param {any} entityName - Entity type of record i.e. Contact/Lead etc etc
 * @param {any} recordName - Name of record
 */
function CreateIconForHoverOver(recordId, entityName, recordName) {
    var eyeIcon = CreateElement("i", "fa fa-eye ebsta-quick-view");
    eyeIcon.setAttribute("sfid", recordId);
    eyeIcon.setAttribute("entity", entityName);
    eyeIcon.setAttribute("recordname", recordName);
    CreateHoverOverEvent(eyeIcon, HoverOverStates.BubbleSearch);
    return eyeIcon;
}

//Add messaging listener
chrome.extension.onMessage.addListener(
    function (request, sender, sendResponse) {
        if (request.MessageType === "ParseInfoToPage") {
            if (request.Url != null && request.OverrideValues != null) {
                ParseInfoToPage(request.Url, request.OverrideValues);
            }
        }

        //Calls the RenderPage function
        if (request.Action === "TriggerMainRenderPage") {
            RenderPage();
            return true;
        }

        //Shows the recently viewed list
        if (request.Action === "ShowRecentlyViewedList") {
            if (request.RecentObject) {
                GetRecentlistBuild(request.RecentObject);
            }
            return true;
        }
    });


/**
 * Sets up the click events for the settings page in the bubble
 * @returns {} 
 */
function SettingsPageClickEvents() {
    var haveEventsBeenSet = false;

    function Run() {
        //Setups up the Refresh Settings Button
        var reloadButton = document.getElementById("btReloadSettings");
        if (reloadButton != null) {
            reloadButton.addEventListener("click", function() {
                AssignLoaderWithText(".settingsLoader", "Loading Settings... ");
                background.LogEventShort("Refresh Settings - Manual");
                ReloadLayoutSetup();

                if (background.GLOBAL_EBSTA_CAMPAIGNMANAGERVALUES) {
                    if (typeof background.GLOBAL_EBSTA_CAMPAIGNMANAGERVALUES.GetAllValues === 'function') {
                        background.GLOBAL_EBSTA_CAMPAIGNMANAGERVALUES.GetAllValues();
                    }
                }
            });
        }
    }

    return {
        EnableClickEvents: function () {
            if (!haveEventsBeenSet) {
                Run();
                haveEventsBeenSet = true;
            }
        }
    }
}
